(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 23))
(assert (= (f1 (g1 (- 4))) 60))
(assert (= (f1 (f2 4)) (- 16)))
(assert (= (f1 (g2 8)) (- 72)))
(assert (= (f1 (f3 (- 8))) 23))
(assert (= (f1 (g3 4)) (- 72)))
(assert (= (g1 (f3 (- 4))) (- 173)))
(assert (= (f1 (g4 (- 8))) 60))
(assert (= (g1 (f4 8)) (- 173)))
(assert (= (f2 (f1 4)) (- 16)))
(assert (= (f2 (g1 8)) 124))
(assert (= (f2 (f2 (- 8))) (- 16)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 4))) 60))
(assert (= (f2 (g3 (- 8))) 124))
(assert (= (g2 (f3 8)) 128))
(assert (= (g2 (f4 4)) 60))
(assert (= (f2 (f4 (- 4))) 11))
(assert (= (g2 (g4 (- 4))) 196))
(assert (= (f3 (f1 (- 8))) 23))
(assert (= (f3 (g1 4)) 68))
(assert (= (g3 (f1 (- 4))) 176))
(assert (= (f3 (g2 (- 8))) 68))
(assert (= (g3 (f2 8)) 192))
(assert (= (g3 (f3 4)) 192))
(assert (= (f3 (f3 (- 4))) (- 20)))
(assert (= (g3 (g3 (- 4))) 896))
(assert (= (g3 (f4 (- 8))) 176))
(assert (= (f3 (f4 8)) (- 20)))
(assert (= (g3 (g4 8)) 896))
(assert (= (f4 (g1 (- 8))) 116))
(assert (= (g4 (f1 8)) (- 109)))
(assert (= (g4 (f2 4)) 56))
(assert (= (f4 (f2 (- 4))) 11))
(assert (= (g4 (g2 (- 4))) 196))
(assert (= (g4 (f3 (- 8))) (- 109)))
(assert (= (f4 (f3 8)) (- 20)))
(assert (= (g4 (g3 8)) 896))
(assert (= (f4 (f4 4)) 11))
(assert (= (g4 (g4 4)) 196))
(check-sat)
