(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 3))) (- 5)))
(assert (= (f1 (g1 (- 8))) 16))
(assert (= (f1 (f2 4)) 9))
(assert (= (f1 (g2 (- 3))) 21))
(assert (= (f1 (f3 1)) (- 5)))
(assert (= (f1 (g3 4)) 21))
(assert (= (g1 (f3 (- 8))) 20))
(assert (= (f1 (g4 1)) 16))
(assert (= (g1 (f4 (- 3))) 20))
(assert (= (f2 (f1 4)) 9))
(assert (= (f2 (g1 (- 3))) 9))
(assert (= (f2 (f2 1)) 9))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 8))) 92))
(assert (= (f2 (g3 1)) 9))
(assert (= (g2 (f3 (- 3))) 40))
(assert (= (g2 (f4 4)) 92))
(assert (= (f2 (f4 (- 8))) 19))
(assert (= (g2 (g4 (- 8))) 900))
(assert (= (f3 (f1 1)) (- 5)))
(assert (= (f3 (g1 4)) (- 11)))
(assert (= (g3 (f1 (- 8))) (- 43)))
(assert (= (f3 (g2 1)) (- 11)))
(assert (= (g3 (f2 (- 3))) (- 33)))
(assert (= (g3 (f3 4)) (- 33)))
(assert (= (f3 (f3 (- 8))) (- 13)))
(assert (= (g3 (g3 (- 8))) (- 188)))
(assert (= (g3 (f4 1)) (- 43)))
(assert (= (f3 (f4 (- 3))) (- 13)))
(assert (= (g3 (g4 (- 3))) (- 188)))
(assert (= (f4 (g1 1)) (- 10)))
(assert (= (g4 (f1 (- 3))) (- 53)))
(assert (= (g4 (f2 4)) 120))
(assert (= (f4 (f2 (- 8))) 19))
(assert (= (g4 (g2 (- 8))) 900))
(assert (= (g4 (f3 1)) (- 53)))
(assert (= (f4 (f3 (- 3))) (- 13)))
(assert (= (g4 (g3 (- 3))) (- 188)))
(assert (= (f4 (f4 4)) 19))
(assert (= (g4 (g4 4)) 900))
(check-sat)
