(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 11)))
(assert (= (f1 (g1 (- 3))) 6))
(assert (= (f1 (f2 5)) 11))
(assert (= (f1 (g2 (- 9))) 86))
(assert (= (f1 (f3 1)) (- 11)))
(assert (= (f1 (g3 5)) 86))
(assert (= (g1 (f3 (- 3))) 22))
(assert (= (f1 (g4 1)) 6))
(assert (= (g1 (f4 (- 9))) 22))
(assert (= (f2 (f1 5)) 11))
(assert (= (f2 (g1 (- 9))) 22))
(assert (= (f2 (f2 1)) 11))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 3))) 75))
(assert (= (f2 (g3 1)) 22))
(assert (= (g2 (f3 (- 9))) 170))
(assert (= (g2 (f4 5)) 75))
(assert (= (f2 (f4 (- 3))) 10))
(assert (= (g2 (g4 (- 3))) 125))
(assert (= (f3 (f1 1)) (- 11)))
(assert (= (f3 (g1 5)) (- 19)))
(assert (= (g3 (f1 (- 3))) (- 60)))
(assert (= (f3 (g2 1)) (- 19)))
(assert (= (g3 (f2 (- 9))) (- 230)))
(assert (= (g3 (f3 5)) (- 230)))
(assert (= (f3 (f3 (- 3))) (- 20)))
(assert (= (g3 (g3 (- 3))) (- 723)))
(assert (= (g3 (f4 1)) (- 60)))
(assert (= (f3 (f4 (- 9))) (- 20)))
(assert (= (g3 (g4 (- 9))) (- 723)))
(assert (= (f4 (g1 1)) (- 5)))
(assert (= (g4 (f1 (- 9))) (- 48)))
(assert (= (g4 (f2 5)) 50))
(assert (= (f4 (f2 (- 3))) 10))
(assert (= (g4 (g2 (- 3))) 125))
(assert (= (g4 (f3 1)) (- 48)))
(assert (= (f4 (f3 (- 9))) (- 20)))
(assert (= (g4 (g3 (- 9))) (- 723)))
(assert (= (f4 (f4 5)) 10))
(assert (= (g4 (g4 5)) 125))
(check-sat)
