(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 4))) (- 6)))
(assert (= (f1 (g1 (- 9))) 18))
(assert (= (f1 (f2 5)) 11))
(assert (= (f1 (g2 (- 4))) 36))
(assert (= (f1 (f3 1)) (- 6)))
(assert (= (f1 (g3 5)) 36))
(assert (= (g1 (f3 (- 9))) 24))
(assert (= (f1 (g4 1)) 18))
(assert (= (g1 (f4 (- 4))) 24))
(assert (= (f2 (f1 5)) 11))
(assert (= (f2 (g1 (- 4))) 12))
(assert (= (f2 (f2 1)) 11))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 9))) 135))
(assert (= (f2 (g3 1)) 12))
(assert (= (g2 (f3 (- 4))) 70))
(assert (= (g2 (f4 5)) 135))
(assert (= (f2 (f4 (- 9))) 22))
(assert (= (g2 (g4 (- 9))) 1445))
(assert (= (f3 (f1 1)) (- 6)))
(assert (= (f3 (g1 5)) (- 14)))
(assert (= (g3 (f1 (- 9))) (- 67)))
(assert (= (f3 (g2 1)) (- 14)))
(assert (= (g3 (f2 (- 4))) (- 60)))
(assert (= (g3 (f3 5)) (- 60)))
(assert (= (f3 (f3 (- 9))) (- 16)))
(assert (= (g3 (g3 (- 9))) (- 417)))
(assert (= (g3 (f4 1)) (- 67)))
(assert (= (f3 (f4 (- 4))) (- 16)))
(assert (= (g3 (g4 (- 4))) (- 417)))
(assert (= (f4 (g1 1)) (- 11)))
(assert (= (g4 (f1 (- 4))) (- 77)))
(assert (= (g4 (f2 5)) 170))
(assert (= (f4 (f2 (- 9))) 22))
(assert (= (g4 (g2 (- 9))) 1445))
(assert (= (g4 (f3 1)) (- 77)))
(assert (= (f4 (f3 (- 4))) (- 16)))
(assert (= (g4 (g3 (- 4))) (- 417)))
(assert (= (f4 (f4 5)) 22))
(assert (= (g4 (g4 5)) 1445))
(check-sat)
