(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 8)) 10))
(assert (= (f1 (g1 7)) 15))
(assert (= (f1 (f2 5)) 11))
(assert (= (f1 (g2 8)) 81))
(assert (= (f1 (f3 1)) 10))
(assert (= (f1 (g3 5)) 81))
(assert (= (g1 (f3 7)) 30))
(assert (= (f1 (g4 1)) 15))
(assert (= (g1 (f4 8)) 30))
(assert (= (f2 (f1 5)) 11))
(assert (= (f2 (g1 8)) 21))
(assert (= (f2 (f2 1)) 11))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 7)) 120))
(assert (= (f2 (g3 1)) 21))
(assert (= (g2 (f3 8)) 160))
(assert (= (g2 (f4 5)) 120))
(assert (= (f2 (f4 7)) 19))
(assert (= (g2 (g4 7)) 980))
(assert (= (f3 (f1 1)) 10))
(assert (= (f3 (g1 5)) 18))
(assert (= (g3 (f1 7)) 128))
(assert (= (f3 (g2 1)) 18))
(assert (= (g3 (f2 8)) 208))
(assert (= (g3 (f3 5)) 208))
(assert (= (f3 (f3 7)) 23))
(assert (= (g3 (g3 7)) 1792))
(assert (= (g3 (f4 1)) 128))
(assert (= (f3 (f4 8)) 23))
(assert (= (g3 (g4 8)) 1792))
(assert (= (f4 (g1 1)) 9))
(assert (= (g4 (f1 8)) 126))
(assert (= (g4 (f2 5)) 140))
(assert (= (f4 (f2 7)) 19))
(assert (= (g4 (g2 7)) 980))
(assert (= (g4 (f3 1)) 126))
(assert (= (f4 (f3 8)) 23))
(assert (= (g4 (g3 8)) 1792))
(assert (= (f4 (f4 5)) 19))
(assert (= (g4 (g4 5)) 980))
(check-sat)
