(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 4))) (- 6)))
(assert (= (f1 (g1 7)) 15))
(assert (= (f1 (f2 6)) 13))
(assert (= (f1 (g2 (- 4))) 43))
(assert (= (f1 (f3 1)) (- 6)))
(assert (= (f1 (g3 6)) 43))
(assert (= (g1 (f3 7)) 21))
(assert (= (f1 (g4 1)) 15))
(assert (= (g1 (f4 (- 4))) 21))
(assert (= (f2 (f1 6)) 13))
(assert (= (f2 (g1 (- 4))) 13))
(assert (= (f2 (f2 1)) 13))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 7)) 156))
(assert (= (f2 (g3 1)) 13))
(assert (= (g2 (f3 (- 4))) 84))
(assert (= (g2 (f4 6)) 156))
(assert (= (f2 (f4 7)) 20))
(assert (= (g2 (g4 7)) 1176))
(assert (= (f3 (f1 1)) (- 6)))
(assert (= (f3 (g1 6)) (- 16)))
(assert (= (g3 (f1 7)) 56))
(assert (= (f3 (g2 1)) (- 16)))
(assert (= (g3 (f2 (- 4))) (- 67)))
(assert (= (g3 (f3 6)) (- 67)))
(assert (= (f3 (f3 7)) 14))
(assert (= (g3 (g3 7)) 343))
(assert (= (g3 (f4 1)) 56))
(assert (= (f3 (f4 (- 4))) 14))
(assert (= (g3 (g4 (- 4))) 343))
(assert (= (f4 (g1 1)) 9))
(assert (= (g4 (f1 (- 4))) 63))
(assert (= (g4 (f2 6)) 168))
(assert (= (f4 (f2 7)) 20))
(assert (= (g4 (g2 7)) 1176))
(assert (= (g4 (f3 1)) 63))
(assert (= (f4 (f3 (- 4))) 14))
(assert (= (g4 (g3 (- 4))) 343))
(assert (= (f4 (f4 6)) 20))
(assert (= (g4 (g4 6)) 1176))
(check-sat)
