(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 (- 2))) (- 4)))
(assert (= (f1 (g1 8)) 17))
(assert (= (f1 (f2 6)) 13))
(assert (= (f1 (g2 (- 2))) 19))
(assert (= (f1 (f3 1)) (- 4)))
(assert (= (f1 (g3 6)) 19))
(assert (= (g1 (f3 8)) 19))
(assert (= (f1 (g4 1)) 17))
(assert (= (g1 (f4 (- 2))) 19))
(assert (= (f2 (f1 6)) 13))
(assert (= (f2 (g1 (- 2))) 9))
(assert (= (f2 (f2 1)) 13))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 8)) 168))
(assert (= (f2 (g3 1)) 9))
(assert (= (g2 (f3 (- 2))) 36))
(assert (= (g2 (f4 6)) 168))
(assert (= (f2 (f4 8)) 22))
(assert (= (g2 (g4 8)) 1536))
(assert (= (f3 (f1 1)) (- 4)))
(assert (= (f3 (g1 6)) (- 14)))
(assert (= (g3 (f1 8)) 27))
(assert (= (f3 (g2 1)) (- 14)))
(assert (= (g3 (f2 (- 2))) (- 23)))
(assert (= (g3 (f3 6)) (- 23)))
(assert (= (f3 (f3 8)) 11))
(assert (= (g3 (g3 8)) 72))
(assert (= (g3 (f4 1)) 27))
(assert (= (f3 (f4 (- 2))) 11))
(assert (= (g3 (g4 (- 2))) 72))
(assert (= (f4 (g1 1)) 10))
(assert (= (g4 (f1 (- 2))) 40))
(assert (= (g4 (f2 6)) 192))
(assert (= (f4 (f2 8)) 22))
(assert (= (g4 (g2 8)) 1536))
(assert (= (g4 (f3 1)) 40))
(assert (= (f4 (f3 (- 2))) 11))
(assert (= (g4 (g3 (- 2))) 72))
(assert (= (f4 (f4 6)) 22))
(assert (= (g4 (g4 6)) 1536))
(check-sat)
