(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 4)) 6))
(assert (= (f1 (g1 2)) 5))
(assert (= (f1 (f2 6)) 13))
(assert (= (f1 (g2 4)) 49))
(assert (= (f1 (f3 1)) 6))
(assert (= (f1 (g3 6)) 49))
(assert (= (g1 (f3 2)) 12))
(assert (= (f1 (g4 1)) 5))
(assert (= (g1 (f4 4)) 12))
(assert (= (f2 (f1 6)) 13))
(assert (= (f2 (g1 4)) 14))
(assert (= (f2 (f2 1)) 13))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 2)) 96))
(assert (= (f2 (g3 1)) 14))
(assert (= (g2 (f3 4)) 96))
(assert (= (g2 (f4 6)) 96))
(assert (= (f2 (f4 2)) 10))
(assert (= (g2 (g4 2)) 96))
(assert (= (f3 (f1 1)) 6))
(assert (= (f3 (g1 6)) 16))
(assert (= (g3 (f1 2)) 24))
(assert (= (f3 (g2 1)) 16))
(assert (= (g3 (f2 4)) 80))
(assert (= (g3 (f3 6)) 80))
(assert (= (f3 (f3 2)) 10))
(assert (= (g3 (g3 2)) 128))
(assert (= (g3 (f4 1)) 24))
(assert (= (f3 (f4 4)) 10))
(assert (= (g3 (g4 4)) 128))
(assert (= (f4 (g1 1)) 4))
(assert (= (g4 (f1 4)) 20))
(assert (= (g4 (f2 6)) 48))
(assert (= (f4 (f2 2)) 10))
(assert (= (g4 (g2 2)) 96))
(assert (= (g4 (f3 1)) 20))
(assert (= (f4 (f3 4)) 10))
(assert (= (g4 (g3 4)) 128))
(assert (= (f4 (f4 6)) 10))
(assert (= (g4 (g4 6)) 96))
(check-sat)
