(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 7))
(assert (= (f1 (g1 2)) 5))
(assert (= (f1 (f2 8)) 17))
(assert (= (f1 (g2 5)) 81))
(assert (= (f1 (f3 1)) 7))
(assert (= (f1 (g3 8)) 81))
(assert (= (g1 (f3 2)) 14))
(assert (= (f1 (g4 1)) 5))
(assert (= (g1 (f4 5)) 14))
(assert (= (f2 (f1 8)) 17))
(assert (= (f2 (g1 5)) 18))
(assert (= (f2 (f2 1)) 17))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 2)) 160))
(assert (= (f2 (g3 1)) 18))
(assert (= (g2 (f3 5)) 160))
(assert (= (g2 (f4 8)) 160))
(assert (= (f2 (f4 2)) 12))
(assert (= (g2 (g4 2)) 128))
(assert (= (f3 (f1 1)) 7))
(assert (= (f3 (g1 8)) 21))
(assert (= (g3 (f1 2)) 30))
(assert (= (f3 (g2 1)) 21))
(assert (= (g3 (f2 5)) 130))
(assert (= (g3 (f3 8)) 130))
(assert (= (f3 (f3 2)) 12))
(assert (= (g3 (g3 2)) 200))
(assert (= (g3 (f4 1)) 30))
(assert (= (f3 (f4 5)) 12))
(assert (= (g3 (g4 5)) 200))
(assert (= (f4 (g1 1)) 4))
(assert (= (g4 (f1 5)) 24))
(assert (= (g4 (f2 8)) 64))
(assert (= (f4 (f2 2)) 12))
(assert (= (g4 (g2 2)) 128))
(assert (= (g4 (f3 1)) 24))
(assert (= (f4 (f3 5)) 12))
(assert (= (g4 (g3 5)) 200))
(assert (= (f4 (f4 8)) 12))
(assert (= (g4 (g4 8)) 128))
(check-sat)
