(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 8)))
(assert (= (f1 (g1 (- 8))) 16))
(assert (= (f1 (f2 9)) 19))
(assert (= (f1 (g2 (- 6))) 100))
(assert (= (f1 (f3 1)) (- 8)))
(assert (= (f1 (g3 9)) 100))
(assert (= (g1 (f3 (- 8))) 26))
(assert (= (f1 (g4 1)) 16))
(assert (= (g1 (f4 (- 6))) 26))
(assert (= (f2 (f1 9)) 19))
(assert (= (f2 (g1 (- 6))) 20))
(assert (= (f2 (f2 1)) 19))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 1)) 20))
(assert (= (g2 (f3 (- 6))) 198))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 1)) (- 8)))
(assert (= (f3 (g1 9)) (- 24)))
(assert (= (g3 (f1 (- 8))) (- 94)))
(assert (= (f3 (g2 1)) (- 24)))
(assert (= (g3 (f2 (- 6))) (- 160)))
(assert (= (g3 (f3 9)) (- 160)))
(assert (= (f3 (f3 (- 8))) (- 19)))
(assert (= (g3 (g3 (- 8))) (- 908)))
(assert (= (g3 (f4 1)) (- 94)))
(assert (= (f3 (f4 (- 6))) (- 19)))
(assert (= (g3 (g4 (- 6))) (- 908)))
(assert (= (f4 (g1 1)) (- 10)))
(assert (= (g4 (f1 (- 6))) (- 98)))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 1)) (- 98)))
(assert (= (f4 (f3 (- 6))) (- 19)))
(assert (= (g4 (g3 (- 6))) (- 908)))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
