(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g3 x)))))
(assert (= (f1 (f1 3)) 5))
(assert (= (f1 (g1 (- 8))) 16))
(assert (= (f1 (f2 9)) 19))
(assert (= (f1 (g2 3)) 55))
(assert (= (f1 (f3 1)) 5))
(assert (= (f1 (g3 9)) 55))
(assert (= (g1 (f3 (- 8))) 21))
(assert (= (f1 (g4 1)) 16))
(assert (= (g1 (f4 3)) 21))
(assert (= (f2 (f1 9)) 19))
(assert (= (f2 (g1 3)) 15))
(assert (= (f2 (f2 1)) 19))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 1)) 15))
(assert (= (g2 (f3 3)) 108))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 1)) 5))
(assert (= (f3 (g1 9)) 21))
(assert (= (g3 (f1 (- 8))) 51))
(assert (= (f3 (g2 1)) 21))
(assert (= (g3 (f2 3)) 72))
(assert (= (g3 (f3 9)) 72))
(assert (= (f3 (f3 (- 8))) (- 14)))
(assert (= (g3 (g3 (- 8))) 270))
(assert (= (g3 (f4 1)) 51))
(assert (= (f3 (f4 3)) (- 14)))
(assert (= (g3 (g4 3)) 270))
(assert (= (f4 (g1 1)) (- 10)))
(assert (= (g4 (f1 3)) 60))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 1)) 60))
(assert (= (f4 (f3 3)) (- 14)))
(assert (= (g4 (g3 3)) 270))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
