(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 13)))
(assert (= (f1 (g1 0)) 2))
(assert (= (f1 (f2 (- 7))) 15))
(assert (= (f1 (g2 (- 9))) (- 113)))
(assert (= (f1 (f3 2)) (- 13)))
(assert (= (f1 (g3 (- 7))) (- 113)))
(assert (= (g1 (f3 0)) 34))
(assert (= (f1 (g4 2)) 2))
(assert (= (g1 (f4 (- 9))) 34))
(assert (= (f2 (f1 (- 7))) 15))
(assert (= (f2 (g1 (- 9))) (- 41)))
(assert (= (f2 (f2 2)) 15))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 0)) (- 85)))
(assert (= (f2 (g3 2)) (- 41)))
(assert (= (g2 (f3 (- 9))) 221))
(assert (= (g2 (f4 (- 7))) (- 85)))
(assert (= (f2 (f4 0)) (- 7)))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 2)) (- 13)))
(assert (= (f3 (g1 (- 7))) (- 35)))
(assert (= (g3 (f1 0)) 34))
(assert (= (f3 (g2 2)) (- 35)))
(assert (= (g3 (f2 (- 9))) 255))
(assert (= (g3 (f3 (- 7))) 255))
(assert (= (f3 (f3 0)) 17))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 2)) 34))
(assert (= (f3 (f4 (- 9))) 17))
(assert (= (g3 (g4 (- 9))) 0))
(assert (= (f4 (g1 2)) 8))
(assert (= (g4 (f1 (- 9))) 0))
(assert (= (g4 (f2 (- 7))) 0))
(assert (= (f4 (f2 0)) (- 7)))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 2)) 0))
(assert (= (f4 (f3 (- 9))) 17))
(assert (= (g4 (g3 (- 9))) 0))
(assert (= (f4 (f4 (- 7))) (- 7)))
(assert (= (g4 (g4 (- 7))) 0))
(check-sat)
