(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 1)) 5))
(assert (= (f1 (g1 8)) 34))
(assert (= (f1 (f2 (- 4))) 9))
(assert (= (f1 (g2 1)) 9))
(assert (= (f1 (f3 2)) 5))
(assert (= (f1 (g3 (- 4))) 9))
(assert (= (g1 (f3 8)) 36))
(assert (= (f1 (g4 2)) 34))
(assert (= (g1 (f4 1)) 36))
(assert (= (f2 (f1 (- 4))) 9))
(assert (= (f2 (g1 1)) (- 8)))
(assert (= (f2 (f2 2)) 9))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 8)) (- 81)))
(assert (= (f2 (g3 2)) (- 8)))
(assert (= (g2 (f3 1)) 14))
(assert (= (g2 (f4 (- 4))) (- 81)))
(assert (= (f2 (f4 8)) (- 20)))
(assert (= (g2 (g4 8)) 896))
(assert (= (f3 (f1 2)) 5))
(assert (= (f3 (g1 (- 4))) 15))
(assert (= (g3 (f1 8)) 20))
(assert (= (f3 (g2 2)) 15))
(assert (= (g3 (f2 1)) 9))
(assert (= (g3 (f3 (- 4))) 9))
(assert (= (f3 (f3 8)) 10))
(assert (= (g3 (g3 8)) 32))
(assert (= (g3 (f4 2)) 20))
(assert (= (f3 (f4 1)) 10))
(assert (= (g3 (g4 1)) 32))
(assert (= (f4 (g1 2)) 16))
(assert (= (g4 (f1 1)) 48))
(assert (= (g4 (f2 (- 4))) 112))
(assert (= (f4 (f2 8)) (- 20)))
(assert (= (g4 (g2 8)) 896))
(assert (= (g4 (f3 2)) 48))
(assert (= (f4 (f3 1)) 10))
(assert (= (g4 (g3 1)) 32))
(assert (= (f4 (f4 (- 4))) (- 20)))
(assert (= (g4 (g4 (- 4))) 896))
(check-sat)
