(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (g1 (g2 (g2 x))) (g3 (g3 x)))))
(assert (= (f1 (f1 5)) 9))
(assert (= (f1 (g1 8)) 34))
(assert (= (f1 (f2 (- 3))) 7))
(assert (= (f1 (g2 5)) 27))
(assert (= (f1 (f3 2)) 9))
(assert (= (f1 (g3 (- 3))) 27))
(assert (= (g1 (f3 8)) 52))
(assert (= (f1 (g4 2)) 34))
(assert (= (g1 (f4 5)) 52))
(assert (= (f2 (f1 (- 3))) 7))
(assert (= (f2 (g1 5)) (- 23)))
(assert (= (f2 (f2 2)) 7))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 8)) (- 53)))
(assert (= (f2 (g3 2)) (- 23)))
(assert (= (g2 (f3 5)) 50))
(assert (= (g2 (f4 (- 3))) (- 53)))
(assert (= (f2 (f4 8)) (- 19)))
(assert (= (g2 (g4 8)) 640))
(assert (= (f3 (f1 2)) 9))
(assert (= (f3 (g1 (- 3))) 15))
(assert (= (g3 (f1 8)) 100))
(assert (= (f3 (g2 2)) 15))
(assert (= (g3 (f2 5)) 75))
(assert (= (g3 (f3 (- 3))) 75))
(assert (= (f3 (f3 8)) 18))
(assert (= (g3 (g3 8)) 800))
(assert (= (g3 (f4 2)) 100))
(assert (= (f3 (f4 5)) 18))
(assert (= (g3 (g4 5)) 800))
(assert (= (f4 (g1 2)) 16))
(assert (= (g4 (f1 5)) 112))
(assert (= (g4 (f2 (- 3))) 80))
(assert (= (f4 (f2 8)) (- 19)))
(assert (= (g4 (g2 8)) 640))
(assert (= (g4 (f3 2)) 112))
(assert (= (f4 (f3 5)) 18))
(assert (= (g4 (g3 5)) 800))
(assert (= (f4 (f4 (- 3))) (- 19)))
(assert (= (g4 (g4 (- 3))) 640))
(check-sat)
