(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 10)))
(assert (= (f1 (g1 (- 9))) 36))
(assert (= (f1 (f2 (- 1))) 3))
(assert (= (f1 (g2 (- 6))) (- 8)))
(assert (= (f1 (f3 2)) (- 10)))
(assert (= (f1 (g3 (- 1))) (- 8)))
(assert (= (g1 (f3 (- 9))) 56))
(assert (= (f1 (g4 2)) 36))
(assert (= (g1 (f4 (- 6))) 56))
(assert (= (f2 (f1 (- 1))) 3))
(assert (= (f2 (g1 (- 6))) (- 23)))
(assert (= (f2 (f2 2)) 3))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 9))) 9))
(assert (= (f2 (g3 2)) (- 23)))
(assert (= (g2 (f3 (- 6))) 11))
(assert (= (g2 (f4 (- 1))) 9))
(assert (= (f2 (f4 (- 9))) (- 18)))
(assert (= (g2 (g4 (- 9))) (- 145)))
(assert (= (f3 (f1 2)) (- 10)))
(assert (= (f3 (g1 (- 1))) (- 8)))
(assert (= (g3 (f1 (- 9))) (- 116)))
(assert (= (f3 (g2 2)) (- 8)))
(assert (= (g3 (f2 (- 6))) 66))
(assert (= (g3 (f3 (- 1))) 66))
(assert (= (f3 (f3 (- 9))) (- 20)))
(assert (= (g3 (g3 (- 9))) (- 1029)))
(assert (= (g3 (f4 2)) (- 116)))
(assert (= (f3 (f4 (- 6))) (- 20)))
(assert (= (g3 (g4 (- 6))) (- 1029)))
(assert (= (f4 (g1 2)) (- 17)))
(assert (= (g4 (f1 (- 6))) (- 128)))
(assert (= (g4 (f2 (- 1))) 17))
(assert (= (f4 (f2 (- 9))) (- 18)))
(assert (= (g4 (g2 (- 9))) (- 145)))
(assert (= (g4 (f3 2)) (- 128)))
(assert (= (f4 (f3 (- 6))) (- 20)))
(assert (= (g4 (g3 (- 6))) (- 1029)))
(assert (= (f4 (f4 (- 1))) (- 18)))
(assert (= (g4 (g4 (- 1))) (- 145)))
(check-sat)
