(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 18)))
(assert (= (f1 (g1 (- 8))) 104))
(assert (= (f1 (f2 (- 9))) (- 24)))
(assert (= (f1 (g2 (- 5))) 83))
(assert (= (f1 (f3 (- 7))) (- 18)))
(assert (= (f1 (g3 (- 9))) 83))
(assert (= (g1 (f3 (- 8))) 156))
(assert (= (f1 (g4 (- 7))) 104))
(assert (= (g1 (f4 (- 5))) 156))
(assert (= (f2 (f1 (- 9))) (- 24)))
(assert (= (f2 (g1 (- 5))) 67))
(assert (= (f2 (f2 (- 7))) (- 24)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 8))) 272))
(assert (= (f2 (g3 (- 7))) 67))
(assert (= (g2 (f3 (- 5))) 153))
(assert (= (g2 (f4 (- 9))) 272))
(assert (= (f2 (f4 (- 8))) (- 24)))
(assert (= (g2 (g4 (- 8))) (- 1913)))
(assert (= (f3 (f1 (- 7))) (- 18)))
(assert (= (f3 (g1 (- 9))) 115))
(assert (= (g3 (f1 (- 8))) 126))
(assert (= (f3 (g2 (- 7))) 115))
(assert (= (g3 (f2 (- 5))) 117))
(assert (= (g3 (f3 (- 9))) 117))
(assert (= (f3 (f3 (- 8))) (- 17)))
(assert (= (g3 (g3 (- 8))) (- 608)))
(assert (= (g3 (f4 (- 7))) 126))
(assert (= (f3 (f4 (- 5))) (- 17)))
(assert (= (g3 (g4 (- 5))) (- 608)))
(assert (= (f4 (g1 (- 7))) 92))
(assert (= (g4 (f1 (- 5))) 165))
(assert (= (g4 (f2 (- 9))) 255))
(assert (= (f4 (f2 (- 8))) (- 24)))
(assert (= (g4 (g2 (- 8))) (- 1913)))
(assert (= (g4 (f3 (- 7))) 165))
(assert (= (f4 (f3 (- 5))) (- 17)))
(assert (= (g4 (g3 (- 5))) (- 608)))
(assert (= (f4 (f4 (- 9))) (- 24)))
(assert (= (g4 (g4 (- 9))) (- 1913)))
(check-sat)
