(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (g1 (g1 (g1 x))) (g2 (g2 x)))))
(assert (= (f1 (f1 (- 9))) (- 13)))
(assert (= (f1 (g1 3)) 14))
(assert (= (f1 (f2 4)) 10))
(assert (= (f1 (g2 (- 9))) 70))
(assert (= (f1 (f3 2)) (- 13)))
(assert (= (f1 (g3 4)) 70))
(assert (= (g1 (f3 3)) 46))
(assert (= (f1 (g4 2)) 14))
(assert (= (g1 (f4 (- 9))) 46))
(assert (= (f2 (f1 4)) 10))
(assert (= (f2 (g1 (- 9))) 38))
(assert (= (f2 (f2 2)) 10))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 3)) 56))
(assert (= (f2 (g3 2)) 38))
(assert (= (g2 (f3 (- 9))) 136))
(assert (= (g2 (f4 4)) 56))
(assert (= (f2 (f4 3)) 10))
(assert (= (g2 (g4 3)) 144))
(assert (= (f3 (f1 2)) (- 13)))
(assert (= (f3 (g1 4)) (- 25)))
(assert (= (g3 (f1 3)) 85))
(assert (= (f3 (g2 2)) (- 25)))
(assert (= (g3 (f2 (- 9))) (- 213)))
(assert (= (g3 (f3 4)) (- 213)))
(assert (= (f3 (f3 3)) 20))
(assert (= (g3 (g3 3)) 867))
(assert (= (g3 (f4 2)) 85))
(assert (= (f3 (f4 (- 9))) 20))
(assert (= (g3 (g4 (- 9))) 867))
(assert (= (f4 (g1 2)) 11))
(assert (= (g4 (f1 (- 9))) 63))
(assert (= (g4 (f2 4)) 48))
(assert (= (f4 (f2 3)) 10))
(assert (= (g4 (g2 3)) 144))
(assert (= (g4 (f3 2)) 63))
(assert (= (f4 (f3 (- 9))) 20))
(assert (= (g4 (g3 (- 9))) 867))
(assert (= (f4 (f4 4)) 10))
(assert (= (g4 (g4 4)) 144))
(check-sat)
