(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 19)))
(assert (= (f1 (g1 4)) (- 59)))
(assert (= (f1 (f2 (- 8))) (- 22)))
(assert (= (f1 (g2 (- 6))) 89))
(assert (= (f1 (f3 (- 7))) (- 19)))
(assert (= (f1 (g3 (- 8))) 89))
(assert (= (g1 (f3 4)) (- 124)))
(assert (= (f1 (g4 (- 7))) (- 59)))
(assert (= (g1 (f4 (- 6))) (- 124)))
(assert (= (f2 (f1 (- 8))) (- 22)))
(assert (= (f2 (g1 (- 6))) 79))
(assert (= (f2 (f2 (- 7))) (- 22)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 4)) (- 173)))
(assert (= (f2 (g3 (- 7))) 79))
(assert (= (g2 (f3 (- 6))) 165))
(assert (= (g2 (f4 (- 8))) (- 173)))
(assert (= (f2 (f4 4)) (- 16)))
(assert (= (g2 (g4 4)) 480))
(assert (= (f3 (f1 (- 7))) (- 19)))
(assert (= (f3 (g1 (- 8))) 103))
(assert (= (g3 (f1 4)) (- 116)))
(assert (= (f3 (g2 (- 7))) 103))
(assert (= (g3 (f2 (- 6))) 143))
(assert (= (g3 (f3 (- 8))) 143))
(assert (= (f3 (f3 4)) 15))
(assert (= (g3 (g3 4)) 484))
(assert (= (g3 (f4 (- 7))) (- 116)))
(assert (= (f3 (f4 (- 6))) 15))
(assert (= (g3 (g4 (- 6))) 484))
(assert (= (f4 (g1 (- 7))) (- 89)))
(assert (= (g4 (f1 (- 6))) 96))
(assert (= (g4 (f2 (- 8))) 120))
(assert (= (f4 (f2 4)) (- 16)))
(assert (= (g4 (g2 4)) 480))
(assert (= (g4 (f3 (- 7))) 96))
(assert (= (f4 (f3 (- 6))) 15))
(assert (= (g4 (g3 (- 6))) 484))
(assert (= (f4 (f4 (- 8))) (- 16)))
(assert (= (g4 (g4 (- 8))) 480))
(check-sat)
