(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 8))) (- 21)))
(assert (= (f1 (g1 (- 4))) 52))
(assert (= (f1 (f2 (- 6))) (- 18)))
(assert (= (f1 (g2 (- 8))) 89))
(assert (= (f1 (f3 (- 7))) (- 21)))
(assert (= (f1 (g3 (- 6))) 89))
(assert (= (g1 (f3 (- 4))) 143))
(assert (= (f1 (g4 (- 7))) 52))
(assert (= (g1 (f4 (- 8))) 143))
(assert (= (f2 (f1 (- 6))) (- 18)))
(assert (= (f2 (g1 (- 8))) 103))
(assert (= (f2 (f2 (- 7))) (- 18)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 4))) 99))
(assert (= (f2 (g3 (- 7))) 103))
(assert (= (g2 (f3 (- 8))) 165))
(assert (= (g2 (f4 (- 6))) 99))
(assert (= (f2 (f4 (- 4))) (- 13)))
(assert (= (g2 (g4 (- 4))) (- 270)))
(assert (= (f3 (f1 (- 7))) (- 21)))
(assert (= (f3 (g1 (- 6))) 79))
(assert (= (g3 (f1 (- 4))) 150))
(assert (= (f3 (g2 (- 7))) 79))
(assert (= (g3 (f2 (- 8))) 195))
(assert (= (g3 (f3 (- 6))) 195))
(assert (= (f3 (f3 (- 4))) (- 19)))
(assert (= (g3 (g3 (- 4))) (- 788)))
(assert (= (g3 (f4 (- 7))) 150))
(assert (= (f3 (f4 (- 8))) (- 19)))
(assert (= (g3 (g4 (- 8))) (- 788)))
(assert (= (f4 (g1 (- 7))) 88))
(assert (= (g4 (f1 (- 8))) 98))
(assert (= (g4 (f2 (- 6))) 77))
(assert (= (f4 (f2 (- 4))) (- 13)))
(assert (= (g4 (g2 (- 4))) (- 270)))
(assert (= (g4 (f3 (- 7))) 98))
(assert (= (f4 (f3 (- 8))) (- 19)))
(assert (= (g4 (g3 (- 8))) (- 788)))
(assert (= (f4 (f4 (- 6))) (- 13)))
(assert (= (g4 (g4 (- 6))) (- 270)))
(check-sat)
