(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 12))
(assert (= (f1 (g1 (- 2))) 8))
(assert (= (f1 (f2 7)) 16))
(assert (= (f1 (g2 8)) 114))
(assert (= (f1 (f3 2)) 12))
(assert (= (f1 (g3 7)) 114))
(assert (= (g1 (f3 (- 2))) 38))
(assert (= (f1 (g4 2)) 8))
(assert (= (g1 (f4 8)) 38))
(assert (= (f2 (f1 7)) 16))
(assert (= (f2 (g1 8)) 39))
(assert (= (f2 (f2 2)) 16))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 2))) 119))
(assert (= (f2 (g3 2)) 39))
(assert (= (g2 (f3 8)) 224))
(assert (= (g2 (f4 7)) 119))
(assert (= (f2 (f4 (- 2))) 10))
(assert (= (g2 (g4 (- 2))) 63))
(assert (= (f3 (f1 2)) 12))
(assert (= (f3 (g1 7)) 36))
(assert (= (g3 (f1 (- 2))) 56))
(assert (= (f3 (g2 2)) 36))
(assert (= (g3 (f2 8)) 240))
(assert (= (g3 (f3 7)) 240))
(assert (= (f3 (f3 (- 2))) (- 18)))
(assert (= (g3 (g3 (- 2))) 384))
(assert (= (g3 (f4 2)) 56))
(assert (= (f3 (f4 8)) (- 18)))
(assert (= (g3 (g4 8)) 384))
(assert (= (f4 (g1 2)) (- 10)))
(assert (= (g4 (f1 8)) 30))
(assert (= (g4 (f2 7)) 42))
(assert (= (f4 (f2 (- 2))) 10))
(assert (= (g4 (g2 (- 2))) 63))
(assert (= (g4 (f3 2)) 30))
(assert (= (f4 (f3 8)) (- 18)))
(assert (= (g4 (g3 8)) 384))
(assert (= (f4 (f4 7)) 10))
(assert (= (g4 (g4 7)) 63))
(check-sat)
