(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g3 x)))))
(assert (= (f1 (f1 4)) 8))
(assert (= (f1 (g1 5)) 22))
(assert (= (f1 (f2 8)) 18))
(assert (= (f1 (g2 4)) 66))
(assert (= (f1 (f3 2)) 8))
(assert (= (f1 (g3 8)) 66))
(assert (= (g1 (f3 5)) 36))
(assert (= (f1 (g4 2)) 22))
(assert (= (g1 (f4 4)) 36))
(assert (= (f2 (f1 8)) 18))
(assert (= (f2 (g1 4)) 24))
(assert (= (f2 (f2 2)) 18))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 5)) 208))
(assert (= (f2 (g3 2)) 24))
(assert (= (g2 (f3 4)) 128))
(assert (= (g2 (f4 8)) 208))
(assert (= (f2 (f4 5)) 18))
(assert (= (g2 (g4 5)) 800))
(assert (= (f3 (f1 2)) 8))
(assert (= (f3 (g1 8)) 36))
(assert (= (g3 (f1 5)) 56))
(assert (= (f3 (g2 2)) 36))
(assert (= (g3 (f2 4)) 96))
(assert (= (g3 (f3 8)) 96))
(assert (= (f3 (f3 5)) 13))
(assert (= (g3 (g3 5)) 320))
(assert (= (g3 (f4 2)) 56))
(assert (= (f3 (f4 4)) 13))
(assert (= (g3 (g4 4)) 320))
(assert (= (f4 (g1 2)) 13))
(assert (= (g4 (f1 4)) 60))
(assert (= (g4 (f2 8)) 160))
(assert (= (f4 (f2 5)) 18))
(assert (= (g4 (g2 5)) 800))
(assert (= (g4 (f3 2)) 60))
(assert (= (f4 (f3 4)) 13))
(assert (= (g4 (g3 4)) 320))
(assert (= (f4 (f4 8)) 18))
(assert (= (g4 (g4 8)) 800))
(check-sat)
