(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 8)))
(assert (= (f1 (g1 (- 8))) 32))
(assert (= (f1 (f2 9)) 20))
(assert (= (f1 (g2 (- 4))) 65))
(assert (= (f1 (f3 2)) (- 8)))
(assert (= (f1 (g3 9)) 65))
(assert (= (g1 (f3 (- 8))) 44))
(assert (= (f1 (g4 2)) 32))
(assert (= (g1 (f4 (- 4))) 44))
(assert (= (f2 (f1 9)) 20))
(assert (= (f2 (g1 (- 4))) 23))
(assert (= (f2 (f2 2)) 20))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 2)) 23))
(assert (= (g2 (f3 (- 4))) 126))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 2)) (- 8)))
(assert (= (f3 (g1 9)) (- 40)))
(assert (= (g3 (f1 (- 8))) (- 67)))
(assert (= (f3 (g2 2)) (- 40)))
(assert (= (g3 (f2 (- 4))) (- 88)))
(assert (= (g3 (f3 9)) (- 88)))
(assert (= (f3 (f3 (- 8))) (- 15)))
(assert (= (g3 (g3 (- 8))) (- 368)))
(assert (= (g3 (f4 2)) (- 67)))
(assert (= (f3 (f4 (- 4))) (- 15)))
(assert (= (g3 (g4 (- 4))) (- 368)))
(assert (= (f4 (g1 2)) (- 16)))
(assert (= (g4 (f1 (- 4))) (- 83)))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 2)) (- 83)))
(assert (= (f4 (f3 (- 4))) (- 15)))
(assert (= (g4 (g3 (- 4))) (- 368)))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
