(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 11))
(assert (= (f1 (g1 4)) 18))
(assert (= (f1 (f2 9)) 20))
(assert (= (f1 (g2 7)) 128))
(assert (= (f1 (f3 2)) 11))
(assert (= (f1 (g3 9)) 128))
(assert (= (g1 (f3 4)) 44))
(assert (= (f1 (g4 2)) 18))
(assert (= (g1 (f4 7)) 44))
(assert (= (f2 (f1 9)) 20))
(assert (= (f2 (g1 7)) 37))
(assert (= (f2 (f2 2)) 20))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 4)) 234))
(assert (= (f2 (g3 2)) 37))
(assert (= (g2 (f3 7)) 252))
(assert (= (g2 (f4 9)) 234))
(assert (= (f2 (f4 4)) 17))
(assert (= (g2 (g4 4)) 576))
(assert (= (f3 (f1 2)) 11))
(assert (= (f3 (g1 9)) 43))
(assert (= (g3 (f1 4)) 84))
(assert (= (f3 (g2 2)) 43))
(assert (= (g3 (f2 7)) 224))
(assert (= (g3 (f3 9)) 224))
(assert (= (f3 (f3 4)) 18))
(assert (= (g3 (g3 4)) 784))
(assert (= (g3 (f4 2)) 84))
(assert (= (f3 (f4 7)) 18))
(assert (= (g3 (g4 7)) 784))
(assert (= (f4 (g1 2)) 12))
(assert (= (g4 (f1 7)) 72))
(assert (= (g4 (f2 9)) 144))
(assert (= (f4 (f2 4)) 17))
(assert (= (g4 (g2 4)) 576))
(assert (= (g4 (f3 2)) 72))
(assert (= (f4 (f3 7)) 18))
(assert (= (g4 (g3 7)) 784))
(assert (= (f4 (f4 9)) 17))
(assert (= (g4 (g4 9)) 576))
(check-sat)
