(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 (- 5))) (- 11)))
(assert (= (f1 (g1 5)) 33))
(assert (= (f1 (f2 (- 8))) 18))
(assert (= (f1 (g2 (- 5))) (- 71)))
(assert (= (f1 (f3 3)) (- 11)))
(assert (= (f1 (g3 (- 8))) (- 71)))
(assert (= (g1 (f3 5)) 57))
(assert (= (f1 (g4 3)) 33))
(assert (= (g1 (f4 (- 5))) 57))
(assert (= (f2 (f1 (- 8))) 18))
(assert (= (f2 (g1 (- 5))) (- 35)))
(assert (= (f2 (f2 3)) 18))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 5)) (- 188)))
(assert (= (f2 (g3 3)) (- 35)))
(assert (= (g2 (f3 (- 5))) 135))
(assert (= (g2 (f4 (- 8))) (- 188)))
(assert (= (f2 (f4 5)) (- 18)))
(assert (= (g2 (g4 5)) 750))
(assert (= (f3 (f1 3)) (- 11)))
(assert (= (f3 (g1 (- 8))) (- 50)))
(assert (= (g3 (f1 5)) 72))
(assert (= (f3 (g2 3)) (- 50)))
(assert (= (g3 (f2 (- 5))) 108))
(assert (= (g3 (f3 (- 8))) 108))
(assert (= (f3 (f3 5)) 14))
(assert (= (g3 (g3 5)) 405))
(assert (= (g3 (f4 3)) 72))
(assert (= (f3 (f4 (- 5))) 14))
(assert (= (g3 (g4 (- 5))) 405))
(assert (= (f4 (g1 3)) 23))
(assert (= (g4 (f1 (- 5))) 75))
(assert (= (g4 (f2 (- 8))) 150))
(assert (= (f4 (f2 5)) (- 18)))
(assert (= (g4 (g2 5)) 750))
(assert (= (g4 (f3 3)) 75))
(assert (= (f4 (f3 (- 5))) 14))
(assert (= (g4 (g3 (- 5))) 405))
(assert (= (f4 (f4 (- 8))) (- 18)))
(assert (= (g4 (g4 (- 8))) 750))
(check-sat)
