(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 13)))
(assert (= (f1 (g1 0)) 3))
(assert (= (f1 (f2 (- 4))) 10))
(assert (= (f1 (g2 (- 7))) (- 49)))
(assert (= (f1 (f3 3)) (- 13)))
(assert (= (f1 (g3 (- 4))) (- 49)))
(assert (= (g1 (f3 0)) 39))
(assert (= (f1 (g4 3)) 3))
(assert (= (g1 (f4 (- 7))) 39))
(assert (= (f2 (f1 (- 4))) 10))
(assert (= (f2 (g1 (- 7))) (- 43)))
(assert (= (f2 (f2 3)) 10))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 0)) (- 25)))
(assert (= (f2 (g3 3)) (- 43)))
(assert (= (g2 (f3 (- 7))) 91))
(assert (= (g2 (f4 (- 4))) (- 25)))
(assert (= (f2 (f4 0)) (- 4)))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 3)) (- 13)))
(assert (= (f3 (g1 (- 4))) (- 28)))
(assert (= (g3 (f1 0)) 39))
(assert (= (f3 (g2 3)) (- 28)))
(assert (= (g3 (f2 (- 7))) 130))
(assert (= (g3 (f3 (- 4))) 130))
(assert (= (f3 (f3 0)) 13))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 3)) 39))
(assert (= (f3 (f4 (- 7))) 13))
(assert (= (g3 (g4 (- 7))) 0))
(assert (= (f4 (g1 3)) 18))
(assert (= (g4 (f1 (- 7))) 0))
(assert (= (g4 (f2 (- 4))) 0))
(assert (= (f4 (f2 0)) (- 4)))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 3)) 0))
(assert (= (f4 (f3 (- 7))) 13))
(assert (= (g4 (g3 (- 7))) 0))
(assert (= (f4 (f4 (- 4))) (- 4)))
(assert (= (g4 (g4 (- 4))) 0))
(check-sat)
