(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 7)) 13))
(assert (= (f1 (g1 9)) 57))
(assert (= (f1 (f2 (- 4))) 10))
(assert (= (f1 (g2 7)) 52))
(assert (= (f1 (f3 3)) 13))
(assert (= (f1 (g3 (- 4))) 52))
(assert (= (g1 (f3 9)) 96))
(assert (= (f1 (g4 3)) 57))
(assert (= (g1 (f4 7)) 96))
(assert (= (f2 (f1 (- 4))) 10))
(assert (= (f2 (g1 7)) (- 46)))
(assert (= (f2 (f2 3)) 10))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 9)) (- 88)))
(assert (= (f2 (g3 3)) (- 46)))
(assert (= (g2 (f3 7)) 98))
(assert (= (g2 (f4 (- 4))) (- 88)))
(assert (= (f2 (f4 9)) (- 22)))
(assert (= (g2 (g4 9)) 1134))
(assert (= (f3 (f1 3)) 13))
(assert (= (f3 (g1 (- 4))) 28))
(assert (= (g3 (f1 9)) 168))
(assert (= (f3 (g2 3)) 28))
(assert (= (g3 (f2 7)) 147))
(assert (= (g3 (f3 (- 4))) 147))
(assert (= (f3 (f3 9)) 23))
(assert (= (g3 (g3 9)) 1764))
(assert (= (g3 (f4 3)) 168))
(assert (= (f3 (f4 7)) 23))
(assert (= (g3 (g4 7)) 1764))
(assert (= (f4 (g1 3)) 27))
(assert (= (g4 (f1 7)) 180))
(assert (= (g4 (f2 (- 4))) 126))
(assert (= (f4 (f2 9)) (- 22)))
(assert (= (g4 (g2 9)) 1134))
(assert (= (g4 (f3 3)) 180))
(assert (= (f4 (f3 7)) 23))
(assert (= (g4 (g3 7)) 1764))
(assert (= (f4 (f4 (- 4))) (- 22)))
(assert (= (g4 (g4 (- 4))) 1134))
(check-sat)
