(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 6)) 12))
(assert (= (f1 (g1 (- 8))) 48))
(assert (= (f1 (f2 (- 3))) 8))
(assert (= (f1 (g2 6)) 33))
(assert (= (f1 (f3 3)) 12))
(assert (= (f1 (g3 (- 3))) 33))
(assert (= (g1 (f3 (- 8))) 81))
(assert (= (f1 (g4 3)) 48))
(assert (= (g1 (f4 6)) 81))
(assert (= (f2 (f1 (- 3))) 8))
(assert (= (f2 (g1 6)) (- 39)))
(assert (= (f2 (f2 3)) 8))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 8))) 50))
(assert (= (f2 (g3 3)) (- 39)))
(assert (= (g2 (f3 6)) 60))
(assert (= (g2 (f4 (- 3))) 50))
(assert (= (f2 (f4 (- 8))) (- 18)))
(assert (= (g2 (g4 (- 8))) (- 563)))
(assert (= (f3 (f1 3)) 12))
(assert (= (f3 (g1 (- 3))) 21))
(assert (= (g3 (f1 (- 8))) 126))
(assert (= (f3 (g2 3)) 21))
(assert (= (g3 (f2 6)) 102))
(assert (= (g3 (f3 (- 3))) 102))
(assert (= (f3 (f3 (- 8))) (- 20)))
(assert (= (g3 (g3 (- 8))) 1080))
(assert (= (g3 (f4 3)) 126))
(assert (= (f3 (f4 6)) (- 20)))
(assert (= (g3 (g4 6)) 1080))
(assert (= (f4 (g1 3)) (- 26)))
(assert (= (g4 (f1 6)) 135))
(assert (= (g4 (f2 (- 3))) 75))
(assert (= (f4 (f2 (- 8))) (- 18)))
(assert (= (g4 (g2 (- 8))) (- 563)))
(assert (= (g4 (f3 3)) 135))
(assert (= (f4 (f3 6)) (- 20)))
(assert (= (g4 (g3 6)) 1080))
(assert (= (f4 (f4 (- 3))) (- 18)))
(assert (= (g4 (g4 (- 3))) (- 563)))
(check-sat)
