(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 8))) (- 14)))
(assert (= (f1 (g1 (- 7))) 42))
(assert (= (f1 (f2 (- 2))) 6))
(assert (= (f1 (g2 (- 8))) (- 26)))
(assert (= (f1 (f3 3)) (- 14)))
(assert (= (f1 (g3 (- 2))) (- 26)))
(assert (= (g1 (f3 (- 7))) 84))
(assert (= (f1 (g4 3)) 42))
(assert (= (g1 (f4 (- 8))) 84))
(assert (= (f2 (f1 (- 2))) 6))
(assert (= (f2 (g1 (- 8))) (- 47)))
(assert (= (f2 (f2 3)) 6))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 7))) 24))
(assert (= (f2 (g3 3)) (- 47)))
(assert (= (g2 (f3 (- 8))) 45))
(assert (= (g2 (f4 (- 2))) 24))
(assert (= (f2 (f4 (- 7))) (- 15)))
(assert (= (g2 (g4 (- 7))) (- 254)))
(assert (= (f3 (f1 3)) (- 14)))
(assert (= (f3 (g1 (- 2))) (- 17)))
(assert (= (g3 (f1 (- 7))) (- 143)))
(assert (= (f3 (g2 3)) (- 17)))
(assert (= (g3 (f2 (- 8))) 135))
(assert (= (g3 (f3 (- 2))) 135))
(assert (= (f3 (f3 (- 7))) (- 22)))
(assert (= (g3 (g3 (- 7))) (- 1463)))
(assert (= (g3 (f4 3)) (- 143)))
(assert (= (f3 (f4 (- 8))) (- 22)))
(assert (= (g3 (g4 (- 8))) (- 1463)))
(assert (= (f4 (g1 3)) (- 25)))
(assert (= (g4 (f1 (- 8))) (- 137)))
(assert (= (g4 (f2 (- 2))) 39))
(assert (= (f4 (f2 (- 7))) (- 15)))
(assert (= (g4 (g2 (- 7))) (- 254)))
(assert (= (g4 (f3 3)) (- 137)))
(assert (= (f4 (f3 (- 8))) (- 22)))
(assert (= (g4 (g3 (- 8))) (- 1463)))
(assert (= (f4 (f4 (- 2))) (- 15)))
(assert (= (g4 (g4 (- 2))) (- 254)))
(check-sat)
