(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 1) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 1) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 (- 1))) (- 7)))
(assert (= (f1 (g1 6)) 39))
(assert (= (f1 (f2 1)) 5))
(assert (= (f1 (g2 (- 1))) 4))
(assert (= (f1 (f3 3)) (- 7)))
(assert (= (f1 (g3 1)) 4))
(assert (= (g1 (f3 6)) 39))
(assert (= (f1 (g4 3)) 39))
(assert (= (g1 (f4 (- 1))) 39))
(assert (= (f2 (f1 1)) 5))
(assert (= (f2 (g1 (- 1))) 4))
(assert (= (f2 (f2 3)) 5))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 6)) 14))
(assert (= (f2 (g3 3)) 4))
(assert (= (g2 (f3 (- 1))) 2))
(assert (= (g2 (f4 1)) 14))
(assert (= (f2 (f4 6)) 13))
(assert (= (g2 (g4 6)) 144))
(assert (= (f3 (f1 3)) (- 7)))
(assert (= (f3 (g1 1)) (- 7)))
(assert (= (g3 (f1 6)) 9))
(assert (= (f3 (g2 3)) (- 7)))
(assert (= (g3 (f2 (- 1))) (- 2)))
(assert (= (g3 (f3 1)) (- 2)))
(assert (= (f3 (f3 6)) 7))
(assert (= (g3 (g3 6)) 6))
(assert (= (g3 (f4 3)) 9))
(assert (= (f3 (f4 (- 1))) 7))
(assert (= (g3 (g4 (- 1))) 6))
(assert (= (f4 (g1 3)) 24))
(assert (= (g4 (f1 (- 1))) 42))
(assert (= (g4 (f2 1)) 24))
(assert (= (f4 (f2 6)) 13))
(assert (= (g4 (g2 6)) 144))
(assert (= (g4 (f3 3)) 42))
(assert (= (f4 (f3 (- 1))) 7))
(assert (= (g4 (g3 (- 1))) 6))
(assert (= (f4 (f4 1)) 13))
(assert (= (g4 (g4 1)) 144))
(check-sat)
