(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 19))
(assert (= (f1 (g1 4)) (- 59)))
(assert (= (f1 (f2 (- 4))) (- 14)))
(assert (= (f1 (g2 6)) (- 49)))
(assert (= (f1 (f3 (- 7))) 19))
(assert (= (f1 (g3 (- 4))) (- 49)))
(assert (= (g1 (f3 4)) 130))
(assert (= (f1 (g4 (- 7))) (- 59)))
(assert (= (g1 (f4 6)) 130))
(assert (= (f2 (f1 (- 4))) (- 14)))
(assert (= (f2 (g1 6)) (- 82)))
(assert (= (f2 (f2 (- 7))) (- 14)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 4)) (- 53)))
(assert (= (f2 (g3 (- 7))) (- 82)))
(assert (= (g2 (f3 6)) 84))
(assert (= (g2 (f4 (- 4))) (- 53)))
(assert (= (f2 (f4 4)) (- 12)))
(assert (= (g2 (g4 4)) 224))
(assert (= (f3 (f1 (- 7))) 19))
(assert (= (f3 (g1 (- 4))) (- 52)))
(assert (= (g3 (f1 4)) 126))
(assert (= (f3 (g2 (- 7))) (- 52)))
(assert (= (g3 (f2 6)) 114))
(assert (= (g3 (f3 (- 4))) 114))
(assert (= (f3 (f3 4)) 16))
(assert (= (g3 (g3 4)) 576))
(assert (= (g3 (f4 (- 7))) 126))
(assert (= (f3 (f4 6)) 16))
(assert (= (g3 (g4 6)) 576))
(assert (= (f4 (g1 (- 7))) (- 89)))
(assert (= (g4 (f1 6)) 100))
(assert (= (g4 (f2 (- 4))) 56))
(assert (= (f4 (f2 4)) (- 12)))
(assert (= (g4 (g2 4)) 224))
(assert (= (g4 (f3 (- 7))) 100))
(assert (= (f4 (f3 6)) 16))
(assert (= (g4 (g3 6)) 576))
(assert (= (f4 (f4 (- 4))) (- 12)))
(assert (= (g4 (g4 (- 4))) 224))
(check-sat)
