(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 0 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 0 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 0)) 13))
(assert (= (f1 (g1 9)) (- 124)))
(assert (= (f1 (f2 (- 3))) (- 12)))
(assert (= (f1 (g2 0)) (- 7)))
(assert (= (f1 (f3 (- 7))) 13))
(assert (= (f1 (g3 (- 3))) (- 7)))
(assert (= (g1 (f3 9)) 117))
(assert (= (f1 (g4 (- 7))) (- 124)))
(assert (= (g1 (f4 0)) 117))
(assert (= (f2 (f1 (- 3))) (- 12)))
(assert (= (f2 (g1 0)) (- 3)))
(assert (= (f2 (f2 (- 7))) (- 12)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 9)) (- 58)))
(assert (= (f2 (g3 (- 7))) (- 3)))
(assert (= (g2 (f3 0)) 0))
(assert (= (g2 (f4 (- 3))) (- 58)))
(assert (= (f2 (f4 9)) (- 21)))
(assert (= (g2 (g4 9)) 810))
(assert (= (f3 (f1 (- 7))) 13))
(assert (= (f3 (g1 (- 3))) (- 33)))
(assert (= (g3 (f1 9)) 0))
(assert (= (f3 (g2 (- 7))) (- 33)))
(assert (= (g3 (f2 0)) 0))
(assert (= (g3 (f3 (- 3))) 0))
(assert (= (f3 (f3 9)) 9))
(assert (= (g3 (g3 9)) 0))
(assert (= (g3 (f4 (- 7))) 0))
(assert (= (f3 (f4 0)) 9))
(assert (= (g3 (g4 0)) 0))
(assert (= (f4 (g1 (- 7))) (- 94)))
(assert (= (g4 (f1 0)) 117))
(assert (= (g4 (f2 (- 3))) 90))
(assert (= (f4 (f2 9)) (- 21)))
(assert (= (g4 (g2 9)) 810))
(assert (= (g4 (f3 (- 7))) 117))
(assert (= (f4 (f3 0)) 9))
(assert (= (g4 (g3 0)) 0))
(assert (= (f4 (f4 (- 3))) (- 21)))
(assert (= (g4 (g4 (- 3))) 810))
(check-sat)
