(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 0 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 0 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 0)) 6))
(assert (= (f1 (g1 7)) 45))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 0)) 3))
(assert (= (f1 (f3 3)) 6))
(assert (= (f1 (g3 6)) 3))
(assert (= (g1 (f3 7)) 42))
(assert (= (f1 (g4 3)) 45))
(assert (= (g1 (f4 0)) 42))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 0)) 6))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 7)) 156))
(assert (= (f2 (g3 3)) 6))
(assert (= (g2 (f3 0)) 0))
(assert (= (g2 (f4 6)) 156))
(assert (= (f2 (f4 7)) 20))
(assert (= (g2 (g4 7)) 1176))
(assert (= (f3 (f1 3)) 6))
(assert (= (f3 (g1 6)) 36))
(assert (= (g3 (f1 7)) 0))
(assert (= (f3 (g2 3)) 36))
(assert (= (g3 (f2 0)) 0))
(assert (= (g3 (f3 6)) 0))
(assert (= (f3 (f3 7)) 7))
(assert (= (g3 (g3 7)) 0))
(assert (= (g3 (f4 3)) 0))
(assert (= (f3 (f4 0)) 7))
(assert (= (g3 (g4 0)) 0))
(assert (= (f4 (g1 3)) 25))
(assert (= (g4 (f1 0)) 42))
(assert (= (g4 (f2 6)) 168))
(assert (= (f4 (f2 7)) 20))
(assert (= (g4 (g2 7)) 1176))
(assert (= (g4 (f3 3)) 42))
(assert (= (f4 (f3 0)) 7))
(assert (= (g4 (g3 0)) 0))
(assert (= (f4 (f4 6)) 20))
(assert (= (g4 (g4 6)) 1176))
(check-sat)
