(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 13))
(assert (= (f1 (g1 2)) 15))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 7)) 87))
(assert (= (f1 (f3 3)) 13))
(assert (= (f1 (g3 6)) 87))
(assert (= (g1 (f3 2)) 54))
(assert (= (f1 (g4 3)) 15))
(assert (= (g1 (f4 7)) 54))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 7)) 48))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 2)) 96))
(assert (= (f2 (g3 3)) 48))
(assert (= (g2 (f3 7)) 168))
(assert (= (g2 (f4 6)) 96))
(assert (= (f2 (f4 2)) 10))
(assert (= (g2 (g4 2)) 96))
(assert (= (f3 (f1 3)) 13))
(assert (= (f3 (g1 6)) 43))
(assert (= (g3 (f1 2)) 70))
(assert (= (f3 (g2 3)) 43))
(assert (= (g3 (f2 7)) 182))
(assert (= (g3 (f3 6)) 182))
(assert (= (f3 (f3 2)) 16))
(assert (= (g3 (g3 2)) 392))
(assert (= (g3 (f4 3)) 70))
(assert (= (f3 (f4 7)) 16))
(assert (= (g3 (g4 7)) 392))
(assert (= (f4 (g1 3)) 20))
(assert (= (g4 (f1 7)) 40))
(assert (= (g4 (f2 6)) 48))
(assert (= (f4 (f2 2)) 10))
(assert (= (g4 (g2 2)) 96))
(assert (= (g4 (f3 3)) 40))
(assert (= (f4 (f3 7)) 16))
(assert (= (g4 (g3 7)) 392))
(assert (= (f4 (f4 6)) 10))
(assert (= (g4 (g4 6)) 96))
(check-sat)
