(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 17))
(assert (= (f1 (g1 5)) (- 72)))
(assert (= (f1 (f2 (- 3))) (- 12)))
(assert (= (f1 (g2 4)) (- 27)))
(assert (= (f1 (f3 (- 7))) 17))
(assert (= (f1 (g3 (- 3))) (- 27)))
(assert (= (g1 (f3 5)) 117))
(assert (= (f1 (g4 (- 7))) (- 72)))
(assert (= (g1 (f4 4)) 117))
(assert (= (f2 (f1 (- 3))) (- 12)))
(assert (= (f2 (g1 4)) (- 55)))
(assert (= (f2 (f2 (- 7))) (- 12)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 5)) (- 38)))
(assert (= (f2 (g3 (- 7))) (- 55)))
(assert (= (g2 (f3 4)) 40))
(assert (= (g2 (f4 (- 3))) (- 38)))
(assert (= (f2 (f4 5)) (- 13)))
(assert (= (g2 (g4 5)) 250))
(assert (= (f3 (f1 (- 7))) 17))
(assert (= (f3 (g1 (- 3))) (- 37)))
(assert (= (g3 (f1 5)) 92))
(assert (= (f3 (g2 (- 7))) (- 37)))
(assert (= (g3 (f2 4)) 52))
(assert (= (g3 (f3 (- 3))) 52))
(assert (= (f3 (f3 5)) 13))
(assert (= (g3 (g3 5)) 320))
(assert (= (g3 (f4 (- 7))) 92))
(assert (= (f3 (f4 4)) 13))
(assert (= (g3 (g4 4)) 320))
(assert (= (f4 (g1 (- 7))) (- 90)))
(assert (= (g4 (f1 4)) 105))
(assert (= (g4 (f2 (- 3))) 50))
(assert (= (f4 (f2 5)) (- 13)))
(assert (= (g4 (g2 5)) 250))
(assert (= (g4 (f3 (- 7))) 105))
(assert (= (f4 (f3 4)) 13))
(assert (= (g4 (g3 4)) 320))
(assert (= (f4 (f4 (- 3))) (- 13)))
(assert (= (g4 (g4 (- 3))) 250))
(check-sat)
