(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 11))
(assert (= (f1 (g1 (- 7))) 42))
(assert (= (f1 (f2 7)) 17))
(assert (= (f1 (g2 5)) 73))
(assert (= (f1 (f3 3)) 11))
(assert (= (f1 (g3 7)) 73))
(assert (= (g1 (f3 (- 7))) 69))
(assert (= (f1 (g4 3)) 42))
(assert (= (g1 (f4 5)) 69))
(assert (= (f2 (f1 7)) 17))
(assert (= (f2 (g1 5)) 37))
(assert (= (f2 (f2 3)) 17))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 7))) 189))
(assert (= (f2 (g3 3)) 37))
(assert (= (g2 (f3 5)) 140))
(assert (= (g2 (f4 7)) 189))
(assert (= (f2 (f4 (- 7))) 20))
(assert (= (g2 (g4 (- 7))) 1183))
(assert (= (f3 (f1 3)) 11))
(assert (= (f3 (g1 7)) 47))
(assert (= (g3 (f1 (- 7))) 95))
(assert (= (f3 (g2 3)) 47))
(assert (= (g3 (f2 5)) 120))
(assert (= (g3 (f3 7)) 120))
(assert (= (f3 (f3 (- 7))) (- 17)))
(assert (= (g3 (g3 (- 7))) 650))
(assert (= (g3 (f4 3)) 95))
(assert (= (f3 (f4 5)) (- 17)))
(assert (= (g3 (g4 5)) 650))
(assert (= (f4 (g1 3)) (- 25)))
(assert (= (g4 (f1 5)) 104))
(assert (= (g4 (f2 7)) 182))
(assert (= (f4 (f2 (- 7))) 20))
(assert (= (g4 (g2 (- 7))) 1183))
(assert (= (g4 (f3 3)) 104))
(assert (= (f4 (f3 5)) (- 17)))
(assert (= (g4 (g3 5)) 650))
(assert (= (f4 (f4 7)) 20))
(assert (= (g4 (g4 7)) 1183))
(check-sat)
