(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 11)))
(assert (= (f1 (g1 (- 7))) 42))
(assert (= (f1 (f2 8)) 19))
(assert (= (f1 (g2 (- 5))) 75))
(assert (= (f1 (f3 3)) (- 11)))
(assert (= (f1 (g3 8)) 75))
(assert (= (g1 (f3 (- 7))) 66))
(assert (= (f1 (g4 3)) 42))
(assert (= (g1 (f4 (- 5))) 66))
(assert (= (f2 (f1 8)) 19))
(assert (= (f2 (g1 (- 5))) 35))
(assert (= (f2 (f2 3)) 19))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 7))) 232))
(assert (= (f2 (g3 3)) 35))
(assert (= (g2 (f3 (- 5))) 144))
(assert (= (g2 (f4 8)) 232))
(assert (= (f2 (f4 (- 7))) 21))
(assert (= (g2 (g4 (- 7))) 1352))
(assert (= (f3 (f1 3)) (- 11)))
(assert (= (f3 (g1 8)) (- 53)))
(assert (= (g3 (f1 (- 7))) (- 86)))
(assert (= (f3 (g2 3)) (- 53)))
(assert (= (g3 (f2 (- 5))) (- 113)))
(assert (= (g3 (f3 8)) (- 113)))
(assert (= (f3 (f3 (- 7))) (- 16)))
(assert (= (g3 (g3 (- 7))) (- 527)))
(assert (= (g3 (f4 3)) (- 86)))
(assert (= (f3 (f4 (- 5))) (- 16)))
(assert (= (g3 (g4 (- 5))) (- 527)))
(assert (= (f4 (g1 3)) (- 25)))
(assert (= (g4 (f1 (- 5))) (- 98)))
(assert (= (g4 (f2 8)) 208))
(assert (= (f4 (f2 (- 7))) 21))
(assert (= (g4 (g2 (- 7))) 1352))
(assert (= (g4 (f3 3)) (- 98)))
(assert (= (f4 (f3 (- 5))) (- 16)))
(assert (= (g4 (g3 (- 5))) (- 527)))
(assert (= (f4 (f4 8)) 21))
(assert (= (g4 (g4 8)) 1352))
(check-sat)
