(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 23)))
(assert (= (f1 (g1 (- 1))) 17))
(assert (= (f1 (f2 (- 3))) (- 14)))
(assert (= (f1 (g2 (- 6))) 36))
(assert (= (f1 (f3 (- 9))) (- 23)))
(assert (= (f1 (g3 (- 3))) 36))
(assert (= (g1 (f3 (- 1))) 102))
(assert (= (f1 (g4 (- 9))) 17))
(assert (= (g1 (f4 (- 6))) 102))
(assert (= (f2 (f1 (- 3))) (- 14)))
(assert (= (f2 (g1 (- 6))) 96))
(assert (= (f2 (f2 (- 9))) (- 14)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 1))) 15))
(assert (= (f2 (g3 (- 9))) 96))
(assert (= (g2 (f3 (- 6))) 55))
(assert (= (g2 (f4 (- 3))) 15))
(assert (= (f2 (f4 (- 1))) (- 4)))
(assert (= (g2 (g4 (- 1))) (- 3)))
(assert (= (f3 (f1 (- 9))) (- 23)))
(assert (= (f3 (g1 (- 3))) 48))
(assert (= (g3 (f1 (- 1))) 99))
(assert (= (f3 (g2 (- 9))) 48))
(assert (= (g3 (f2 (- 6))) 88))
(assert (= (g3 (f3 (- 3))) 88))
(assert (= (f3 (f3 (- 1))) (- 12)))
(assert (= (g3 (g3 (- 1))) (- 61)))
(assert (= (g3 (f4 (- 9))) 99))
(assert (= (f3 (f4 (- 6))) (- 12)))
(assert (= (g3 (g4 (- 6))) (- 61)))
(assert (= (f4 (g1 (- 9))) 145))
(assert (= (g4 (f1 (- 6))) 14))
(assert (= (g4 (f2 (- 3))) 5))
(assert (= (f4 (f2 (- 1))) (- 4)))
(assert (= (g4 (g2 (- 1))) (- 3)))
(assert (= (g4 (f3 (- 9))) 14))
(assert (= (f4 (f3 (- 6))) (- 12)))
(assert (= (g4 (g3 (- 6))) (- 61)))
(assert (= (f4 (f4 (- 3))) (- 4)))
(assert (= (g4 (g4 (- 3))) (- 3)))
(check-sat)
