(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 14)))
(assert (= (f1 (g1 6)) 52))
(assert (= (f1 (f2 (- 8))) 19))
(assert (= (f1 (g2 (- 6))) (- 87)))
(assert (= (f1 (f3 4)) (- 14)))
(assert (= (f1 (g3 (- 8))) (- 87)))
(assert (= (g1 (f3 6)) 92))
(assert (= (f1 (g4 4)) 52))
(assert (= (g1 (f4 (- 6))) 92))
(assert (= (f2 (f1 (- 8))) 19))
(assert (= (f2 (g1 (- 6))) (- 52)))
(assert (= (f2 (f2 4)) 19))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 6)) (- 203)))
(assert (= (f2 (g3 4)) (- 52)))
(assert (= (g2 (f3 (- 6))) 165))
(assert (= (g2 (f4 (- 8))) (- 203)))
(assert (= (f2 (f4 6)) (- 20)))
(assert (= (g2 (g4 6)) 1080))
(assert (= (f3 (f1 4)) (- 14)))
(assert (= (f3 (g1 (- 8))) (- 66)))
(assert (= (g3 (f1 6)) 110))
(assert (= (f3 (g2 4)) (- 66)))
(assert (= (g3 (f2 (- 6))) 143))
(assert (= (g3 (f3 (- 8))) 143))
(assert (= (f3 (f3 6)) 17))
(assert (= (g3 (g3 6)) 726))
(assert (= (g3 (f4 4)) 110))
(assert (= (f3 (f4 (- 6))) 17))
(assert (= (g3 (g4 (- 6))) 726))
(assert (= (f4 (g1 4)) 38))
(assert (= (g4 (f1 (- 6))) 114))
(assert (= (g4 (f2 (- 8))) 180))
(assert (= (f4 (f2 6)) (- 20)))
(assert (= (g4 (g2 6)) 1080))
(assert (= (g4 (f3 4)) 114))
(assert (= (f4 (f3 (- 6))) 17))
(assert (= (g4 (g3 (- 6))) 726))
(assert (= (f4 (f4 (- 8))) (- 20)))
(assert (= (g4 (g4 (- 8))) 1080))
(check-sat)
