(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 10)))
(assert (= (f1 (g1 (- 7))) 56))
(assert (= (f1 (f2 (- 8))) 19))
(assert (= (f1 (g2 (- 2))) (- 27)))
(assert (= (f1 (f3 4)) (- 10)))
(assert (= (f1 (g3 (- 8))) (- 27)))
(assert (= (g1 (f3 (- 7))) 64))
(assert (= (f1 (g4 4)) 56))
(assert (= (g1 (f4 (- 2))) 64))
(assert (= (f2 (f1 (- 8))) 19))
(assert (= (f2 (g1 (- 2))) (- 20)))
(assert (= (f2 (f2 4)) 19))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 7))) 210))
(assert (= (f2 (g3 4)) (- 20)))
(assert (= (g2 (f3 (- 2))) 45))
(assert (= (g2 (f4 (- 8))) 210))
(assert (= (f2 (f4 (- 7))) (- 21)))
(assert (= (g2 (g4 (- 7))) (- 1268)))
(assert (= (f3 (f1 4)) (- 10)))
(assert (= (f3 (g1 (- 8))) (- 62)))
(assert (= (g3 (f1 (- 7))) (- 32)))
(assert (= (f3 (g2 4)) (- 62)))
(assert (= (g3 (f2 (- 2))) 27))
(assert (= (g3 (f3 (- 8))) 27))
(assert (= (f3 (f3 (- 7))) (- 10)))
(assert (= (g3 (g3 (- 7))) (- 59)))
(assert (= (g3 (f4 4)) (- 32)))
(assert (= (f3 (f4 (- 2))) (- 10)))
(assert (= (g3 (g4 (- 2))) (- 59)))
(assert (= (f4 (g1 4)) (- 39)))
(assert (= (g4 (f1 (- 2))) (- 72)))
(assert (= (g4 (f2 (- 8))) 195))
(assert (= (f4 (f2 (- 7))) (- 21)))
(assert (= (g4 (g2 (- 7))) (- 1268)))
(assert (= (g4 (f3 4)) (- 72)))
(assert (= (f4 (f3 (- 2))) (- 10)))
(assert (= (g4 (g3 (- 2))) (- 59)))
(assert (= (f4 (f4 (- 8))) (- 21)))
(assert (= (g4 (g4 (- 8))) (- 1268)))
(check-sat)
