(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 11))
(assert (= (f1 (g1 (- 8))) 64))
(assert (= (f1 (f2 (- 7))) 17))
(assert (= (f1 (g2 3)) 43))
(assert (= (f1 (f3 4)) 11))
(assert (= (f1 (g3 (- 7))) 43))
(assert (= (g1 (f3 (- 8))) 84))
(assert (= (f1 (g4 4)) 64))
(assert (= (g1 (f4 3)) 84))
(assert (= (f2 (f1 (- 7))) 17))
(assert (= (f2 (g1 3)) (- 31)))
(assert (= (f2 (f2 4)) 17))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 8))) 182))
(assert (= (f2 (g3 4)) (- 31)))
(assert (= (g2 (f3 3)) 78))
(assert (= (g2 (f4 (- 7))) 182))
(assert (= (f2 (f4 (- 8))) (- 22)))
(assert (= (g2 (g4 (- 8))) (- 1463)))
(assert (= (f3 (f1 4)) 11))
(assert (= (f3 (g1 (- 7))) 55))
(assert (= (g3 (f1 (- 8))) 69))
(assert (= (f3 (g2 4)) 55))
(assert (= (g3 (f2 3)) 57))
(assert (= (g3 (f3 (- 7))) 57))
(assert (= (f3 (f3 (- 8))) (- 14)))
(assert (= (g3 (g3 (- 8))) 270))
(assert (= (g3 (f4 4)) 69))
(assert (= (f3 (f4 3)) (- 14)))
(assert (= (g3 (g4 3)) 270))
(assert (= (f4 (g1 4)) (- 40)))
(assert (= (g4 (f1 3)) 105))
(assert (= (g4 (f2 (- 7))) 195))
(assert (= (f4 (f2 (- 8))) (- 22)))
(assert (= (g4 (g2 (- 8))) (- 1463)))
(assert (= (g4 (f3 4)) 105))
(assert (= (f4 (f3 3)) (- 14)))
(assert (= (g4 (g3 3)) 270))
(assert (= (f4 (f4 (- 7))) (- 22)))
(assert (= (g4 (g4 (- 7))) (- 1463)))
(check-sat)
