(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 16))
(assert (= (f1 (g1 (- 3))) 24))
(assert (= (f1 (f2 (- 7))) 17))
(assert (= (f1 (g2 8)) 108))
(assert (= (f1 (f3 4)) 16))
(assert (= (f1 (g3 (- 7))) 108))
(assert (= (g1 (f3 (- 3))) 84))
(assert (= (f1 (g4 4)) 24))
(assert (= (g1 (f4 8)) 84))
(assert (= (f2 (f1 (- 7))) 17))
(assert (= (f2 (g1 8)) (- 71)))
(assert (= (f2 (f2 4)) 17))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 3))) 117))
(assert (= (f2 (g3 4)) (- 71)))
(assert (= (g2 (f3 8)) 208))
(assert (= (g2 (f4 (- 7))) 117))
(assert (= (f2 (f4 (- 3))) (- 12)))
(assert (= (g2 (g4 (- 3))) (- 163)))
(assert (= (f3 (f1 4)) 16))
(assert (= (f3 (g1 (- 7))) 60))
(assert (= (g3 (f1 (- 3))) 104))
(assert (= (f3 (g2 4)) 60))
(assert (= (g3 (f2 8)) 232))
(assert (= (g3 (f3 (- 7))) 232))
(assert (= (f3 (f3 (- 3))) (- 19)))
(assert (= (g3 (g3 (- 3))) 640))
(assert (= (g3 (f4 4)) 104))
(assert (= (f3 (f4 8)) (- 19)))
(assert (= (g3 (g4 8)) 640))
(assert (= (f4 (g1 4)) (- 35)))
(assert (= (g4 (f1 8)) 60))
(assert (= (g4 (f2 (- 7))) 65))
(assert (= (f4 (f2 (- 3))) (- 12)))
(assert (= (g4 (g2 (- 3))) (- 163)))
(assert (= (g4 (f3 4)) 60))
(assert (= (f4 (f3 8)) (- 19)))
(assert (= (g4 (g3 8)) 640))
(assert (= (f4 (f4 (- 7))) (- 12)))
(assert (= (g4 (g4 (- 7))) (- 163)))
(check-sat)
