(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 4))) (- 12)))
(assert (= (f1 (g1 (- 6))) 48))
(assert (= (f1 (f2 (- 5))) 13))
(assert (= (f1 (g2 (- 4))) (- 36)))
(assert (= (f1 (f3 4)) (- 12)))
(assert (= (f1 (g3 (- 5))) (- 36)))
(assert (= (g1 (f3 (- 6))) 72))
(assert (= (f1 (g4 4)) 48))
(assert (= (g1 (f4 (- 4))) 72))
(assert (= (f2 (f1 (- 5))) 13))
(assert (= (f2 (g1 (- 4))) (- 33)))
(assert (= (f2 (f2 4)) 13))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 6))) 90))
(assert (= (f2 (g3 4)) (- 33)))
(assert (= (g2 (f3 (- 4))) 63))
(assert (= (g2 (f4 (- 5))) 90))
(assert (= (f2 (f4 (- 6))) (- 16)))
(assert (= (g2 (g4 (- 6))) (- 545)))
(assert (= (f3 (f1 4)) (- 12)))
(assert (= (f3 (g1 (- 5))) (- 40)))
(assert (= (g3 (f1 (- 6))) (- 67)))
(assert (= (f3 (g2 4)) (- 40)))
(assert (= (g3 (f2 (- 4))) 56))
(assert (= (g3 (f3 (- 5))) 56))
(assert (= (f3 (f3 (- 6))) (- 13)))
(assert (= (g3 (g3 (- 6))) (- 270)))
(assert (= (g3 (f4 4)) (- 67)))
(assert (= (f3 (f4 (- 4))) (- 13)))
(assert (= (g3 (g4 (- 4))) (- 270)))
(assert (= (f4 (g1 4)) (- 38)))
(assert (= (g4 (f1 (- 4))) (- 83)))
(assert (= (g4 (f2 (- 5))) 99))
(assert (= (f4 (f2 (- 6))) (- 16)))
(assert (= (g4 (g2 (- 6))) (- 545)))
(assert (= (g4 (f3 4)) (- 83)))
(assert (= (f4 (f3 (- 4))) (- 13)))
(assert (= (g4 (g3 (- 4))) (- 270)))
(assert (= (f4 (f4 (- 5))) (- 16)))
(assert (= (g4 (g4 (- 5))) (- 545)))
(check-sat)
