(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 23)))
(assert (= (f1 (g1 2)) (- 43)))
(assert (= (f1 (f2 (- 3))) (- 14)))
(assert (= (f1 (g2 (- 6))) 36))
(assert (= (f1 (f3 (- 9))) (- 23)))
(assert (= (f1 (g3 (- 3))) 36))
(assert (= (g1 (f3 2)) (- 128)))
(assert (= (f1 (g4 (- 9))) (- 43)))
(assert (= (g1 (f4 (- 6))) (- 128)))
(assert (= (f2 (f1 (- 3))) (- 14)))
(assert (= (f2 (g1 (- 6))) 96))
(assert (= (f2 (f2 (- 9))) (- 14)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 2)) (- 23)))
(assert (= (f2 (g3 (- 9))) 96))
(assert (= (g2 (f3 (- 6))) 55))
(assert (= (g2 (f4 (- 3))) (- 23)))
(assert (= (f2 (f4 2)) (- 7)))
(assert (= (g2 (g4 2)) 40))
(assert (= (f3 (f1 (- 9))) (- 23)))
(assert (= (f3 (g1 (- 3))) 48))
(assert (= (g3 (f1 2)) (- 116)))
(assert (= (f3 (g2 (- 9))) 48))
(assert (= (g3 (f2 (- 6))) 88))
(assert (= (g3 (f3 (- 3))) 88))
(assert (= (f3 (f3 2)) 13))
(assert (= (g3 (g3 2)) 242))
(assert (= (g3 (f4 (- 9))) (- 116)))
(assert (= (f3 (f4 (- 6))) 13))
(assert (= (g3 (g4 (- 6))) 242))
(assert (= (f4 (g1 (- 9))) (- 147)))
(assert (= (g4 (f1 (- 6))) 56))
(assert (= (g4 (f2 (- 3))) 20))
(assert (= (f4 (f2 2)) (- 7)))
(assert (= (g4 (g2 2)) 40))
(assert (= (g4 (f3 (- 9))) 56))
(assert (= (f4 (f3 (- 6))) 13))
(assert (= (g4 (g3 (- 6))) 242))
(assert (= (f4 (f4 (- 3))) (- 7)))
(assert (= (g4 (g4 (- 3))) 40))
(check-sat)
