(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 8)) 16))
(assert (= (f1 (g1 (- 1))) 8))
(assert (= (f1 (f2 1)) 6))
(assert (= (f1 (g2 8)) 20))
(assert (= (f1 (f3 4)) 16))
(assert (= (f1 (g3 1)) 20))
(assert (= (g1 (f3 (- 1))) 68))
(assert (= (f1 (g4 4)) 8))
(assert (= (g1 (f4 8)) 68))
(assert (= (f2 (f1 1)) 6))
(assert (= (f2 (g1 8)) 65))
(assert (= (f2 (f2 4)) 6))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 1))) 3))
(assert (= (f2 (g3 4)) 65))
(assert (= (g2 (f3 8)) 32))
(assert (= (g2 (f4 1)) 3))
(assert (= (f2 (f4 (- 1))) 2))
(assert (= (g2 (g4 (- 1))) 1))
(assert (= (f3 (f1 4)) 16))
(assert (= (f3 (g1 1)) 16))
(assert (= (g3 (f1 (- 1))) 72))
(assert (= (f3 (g2 4)) 16))
(assert (= (g3 (f2 8)) 144))
(assert (= (g3 (f3 1)) 144))
(assert (= (f3 (f3 (- 1))) (- 17)))
(assert (= (g3 (g3 (- 1))) 128))
(assert (= (g3 (f4 4)) 72))
(assert (= (f3 (f4 8)) (- 17)))
(assert (= (g3 (g4 8)) 128))
(assert (= (f4 (g1 4)) (- 33)))
(assert (= (g4 (f1 8)) 12))
(assert (= (g4 (f2 1)) 2))
(assert (= (f4 (f2 (- 1))) 2))
(assert (= (g4 (g2 (- 1))) 1))
(assert (= (g4 (f3 4)) 12))
(assert (= (f4 (f3 8)) (- 17)))
(assert (= (g4 (g3 8)) 128))
(assert (= (f4 (f4 1)) 2))
(assert (= (g4 (g4 1)) 1))
(check-sat)
