(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 15))
(assert (= (f1 (g1 (- 6))) 78))
(assert (= (f1 (f2 (- 1))) (- 8)))
(assert (= (f1 (g2 2)) (- 9)))
(assert (= (f1 (f3 (- 7))) 15))
(assert (= (f1 (g3 (- 1))) (- 9)))
(assert (= (g1 (f3 (- 6))) (- 98)))
(assert (= (f1 (g4 (- 7))) 78))
(assert (= (g1 (f4 2)) (- 98)))
(assert (= (f2 (f1 (- 1))) (- 8)))
(assert (= (f2 (g1 2)) (- 27)))
(assert (= (f2 (f2 (- 7))) (- 8)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 6))) 6))
(assert (= (f2 (g3 (- 7))) (- 27)))
(assert (= (g2 (f3 2)) 4))
(assert (= (g2 (f4 (- 1))) 6))
(assert (= (f2 (f4 (- 6))) (- 12)))
(assert (= (g2 (g4 (- 6))) (- 61)))
(assert (= (f3 (f1 (- 7))) 15))
(assert (= (f3 (g1 (- 1))) (- 9)))
(assert (= (g3 (f1 (- 6))) 48))
(assert (= (f3 (g2 (- 7))) (- 9)))
(assert (= (g3 (f2 2)) 10))
(assert (= (g3 (f3 (- 1))) 10))
(assert (= (f3 (f3 (- 6))) (- 10)))
(assert (= (g3 (g3 (- 6))) 88))
(assert (= (g3 (f4 (- 7))) 48))
(assert (= (f3 (f4 2)) (- 10)))
(assert (= (g3 (g4 2)) 88))
(assert (= (f4 (g1 (- 7))) 90))
(assert (= (g4 (f1 2)) (- 94)))
(assert (= (g4 (f2 (- 1))) 11))
(assert (= (f4 (f2 (- 6))) (- 12)))
(assert (= (g4 (g2 (- 6))) (- 61)))
(assert (= (g4 (f3 (- 7))) (- 94)))
(assert (= (f4 (f3 2)) (- 10)))
(assert (= (g4 (g3 2)) 88))
(assert (= (f4 (f4 (- 1))) (- 12)))
(assert (= (g4 (g4 (- 1))) (- 61)))
(check-sat)
