(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 17)))
(assert (= (f1 (g1 (- 5))) 40))
(assert (= (f1 (f2 5)) 14))
(assert (= (f1 (g2 (- 9))) 89))
(assert (= (f1 (f3 4)) (- 17)))
(assert (= (f1 (g3 5)) 89))
(assert (= (g1 (f3 (- 5))) 104))
(assert (= (f1 (g4 4)) 40))
(assert (= (g1 (f4 (- 9))) 104))
(assert (= (f2 (f1 5)) 14))
(assert (= (f2 (g1 (- 9))) 73))
(assert (= (f2 (f2 4)) 14))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 5))) 95))
(assert (= (f2 (g3 4)) 73))
(assert (= (g2 (f3 (- 9))) 170))
(assert (= (g2 (f4 5)) 95))
(assert (= (f2 (f4 (- 5))) 14))
(assert (= (g2 (g4 (- 5))) 405))
(assert (= (f3 (f1 4)) (- 17)))
(assert (= (f3 (g1 5)) (- 49)))
(assert (= (g3 (f1 (- 5))) (- 145)))
(assert (= (f3 (g2 4)) (- 49)))
(assert (= (g3 (f2 (- 9))) (- 230)))
(assert (= (g3 (f3 5)) (- 230)))
(assert (= (f3 (f3 (- 5))) (- 22)))
(assert (= (g3 (g3 (- 5))) (- 1301)))
(assert (= (g3 (f4 4)) (- 145)))
(assert (= (f3 (f4 (- 9))) (- 22)))
(assert (= (g3 (g4 (- 9))) (- 1301)))
(assert (= (f4 (g1 4)) (- 37)))
(assert (= (g4 (f1 (- 9))) (- 113)))
(assert (= (g4 (f2 5)) 90))
(assert (= (f4 (f2 (- 5))) 14))
(assert (= (g4 (g2 (- 5))) 405))
(assert (= (g4 (f3 4)) (- 113)))
(assert (= (f4 (f3 (- 9))) (- 22)))
(assert (= (g4 (g3 (- 9))) (- 1301)))
(assert (= (f4 (f4 5)) 14))
(assert (= (g4 (g4 5)) 405))
(check-sat)
