(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 13)))
(assert (= (f1 (g1 2)) 20))
(assert (= (f1 (f2 5)) 14))
(assert (= (f1 (g2 (- 5))) 49))
(assert (= (f1 (f3 4)) (- 13)))
(assert (= (f1 (g3 5)) 49))
(assert (= (g1 (f3 2)) 52))
(assert (= (f1 (g4 4)) 20))
(assert (= (g1 (f4 (- 5))) 52))
(assert (= (f2 (f1 5)) 14))
(assert (= (f2 (g1 (- 5))) 41))
(assert (= (f2 (f2 4)) 14))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 2)) 70))
(assert (= (f2 (g3 4)) 41))
(assert (= (g2 (f3 (- 5))) 90))
(assert (= (g2 (f4 5)) 70))
(assert (= (f2 (f4 2)) 9))
(assert (= (g2 (g4 2)) 80))
(assert (= (f3 (f1 4)) (- 13)))
(assert (= (f3 (g1 5)) (- 45)))
(assert (= (g3 (f1 2)) 54))
(assert (= (f3 (g2 4)) (- 45)))
(assert (= (g3 (f2 (- 5))) (- 86)))
(assert (= (g3 (f3 5)) (- 86)))
(assert (= (f3 (f3 2)) 11))
(assert (= (g3 (g3 2)) 162))
(assert (= (g3 (f4 4)) 54))
(assert (= (f3 (f4 (- 5))) 11))
(assert (= (g3 (g4 (- 5))) 162))
(assert (= (f4 (g1 4)) 34))
(assert (= (g4 (f1 (- 5))) 34))
(assert (= (g4 (f2 5)) 40))
(assert (= (f4 (f2 2)) 9))
(assert (= (g4 (g2 2)) 80))
(assert (= (g4 (f3 4)) 34))
(assert (= (f4 (f3 (- 5))) 11))
(assert (= (g4 (g3 (- 5))) 162))
(assert (= (f4 (f4 5)) 9))
(assert (= (g4 (g4 5)) 80))
(check-sat)
