(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 1) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 1) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 1))) (- 9)))
(assert (= (f1 (g1 (- 5))) 40))
(assert (= (f1 (f2 6)) 16))
(assert (= (f1 (g2 (- 1))) 10))
(assert (= (f1 (f3 4)) (- 9)))
(assert (= (f1 (g3 6)) 10))
(assert (= (g1 (f3 (- 5))) 40))
(assert (= (f1 (g4 4)) 40))
(assert (= (g1 (f4 (- 1))) 40))
(assert (= (f2 (f1 6)) 16))
(assert (= (f2 (g1 (- 1))) 10))
(assert (= (f2 (f2 4)) 16))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 5))) 126))
(assert (= (f2 (g3 4)) 10))
(assert (= (g2 (f3 (- 1))) 12))
(assert (= (g2 (f4 6)) 126))
(assert (= (f2 (f4 (- 5))) 15))
(assert (= (g2 (g4 (- 5))) 486))
(assert (= (f3 (f1 4)) (- 9)))
(assert (= (f3 (g1 6)) (- 49)))
(assert (= (g3 (f1 (- 5))) (- 9)))
(assert (= (f3 (g2 4)) (- 49)))
(assert (= (g3 (f2 (- 1))) (- 7)))
(assert (= (g3 (f3 6)) (- 7)))
(assert (= (f3 (f3 (- 5))) (- 6)))
(assert (= (g3 (g3 (- 5))) (- 5)))
(assert (= (g3 (f4 4)) (- 9)))
(assert (= (f3 (f4 (- 1))) (- 6)))
(assert (= (g3 (g4 (- 1))) (- 5)))
(assert (= (f4 (g1 4)) (- 37)))
(assert (= (g4 (f1 (- 1))) (- 41)))
(assert (= (g4 (f2 6)) 108))
(assert (= (f4 (f2 (- 5))) 15))
(assert (= (g4 (g2 (- 5))) 486))
(assert (= (g4 (f3 4)) (- 41)))
(assert (= (f4 (f3 (- 1))) (- 6)))
(assert (= (g4 (g3 (- 1))) (- 5)))
(assert (= (f4 (f4 6)) 15))
(assert (= (g4 (g4 6)) 486))
(check-sat)
