(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 11))
(assert (= (f1 (g1 8)) 68))
(assert (= (f1 (f2 7)) 18))
(assert (= (f1 (g2 3)) 46))
(assert (= (f1 (f3 4)) 11))
(assert (= (f1 (g3 7)) 46))
(assert (= (g1 (f3 8)) 88))
(assert (= (f1 (g4 4)) 68))
(assert (= (g1 (f4 3)) 88))
(assert (= (f2 (f1 7)) 18))
(assert (= (f2 (g1 3)) 31))
(assert (= (f2 (f2 4)) 18))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 8)) 210))
(assert (= (f2 (g3 4)) 31))
(assert (= (g2 (f3 3)) 84))
(assert (= (g2 (f4 7)) 210))
(assert (= (f2 (f4 8)) 23))
(assert (= (g2 (g4 8)) 1792))
(assert (= (f3 (f1 4)) 11))
(assert (= (f3 (g1 7)) 59))
(assert (= (g3 (f1 8)) 72))
(assert (= (f3 (g2 4)) 59))
(assert (= (g3 (f2 3)) 60))
(assert (= (g3 (f3 7)) 60))
(assert (= (f3 (f3 8)) 14))
(assert (= (g3 (g3 8)) 288))
(assert (= (g3 (f4 4)) 72))
(assert (= (f3 (f4 3)) 14))
(assert (= (g3 (g4 3)) 288))
(assert (= (f4 (g1 4)) 40))
(assert (= (g4 (f1 3)) 112))
(assert (= (g4 (f2 7)) 224))
(assert (= (f4 (f2 8)) 23))
(assert (= (g4 (g2 8)) 1792))
(assert (= (g4 (f3 4)) 112))
(assert (= (f4 (f3 3)) 14))
(assert (= (g4 (g3 3)) 288))
(assert (= (f4 (f4 7)) 23))
(assert (= (g4 (g4 7)) 1792))
(check-sat)
