(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 15)))
(assert (= (f1 (g1 (- 6))) 48))
(assert (= (f1 (f2 8)) 20))
(assert (= (f1 (g2 (- 7))) 108))
(assert (= (f1 (f3 4)) (- 15)))
(assert (= (f1 (g3 8)) 108))
(assert (= (g1 (f3 (- 6))) 96))
(assert (= (f1 (g4 4)) 48))
(assert (= (g1 (f4 (- 7))) 96))
(assert (= (f2 (f1 8)) 20))
(assert (= (f2 (g1 (- 7))) 60))
(assert (= (f2 (f2 4)) 20))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 6))) 216))
(assert (= (f2 (g3 4)) 60))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 216))
(assert (= (f2 (f4 (- 6))) 19))
(assert (= (g2 (g4 (- 6))) 968))
(assert (= (f3 (f1 4)) (- 15)))
(assert (= (f3 (g1 8)) (- 71)))
(assert (= (g3 (f1 (- 6))) (- 124)))
(assert (= (f3 (g2 4)) (- 71)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 (- 6))) (- 19)))
(assert (= (g3 (g3 (- 6))) (- 930)))
(assert (= (g3 (f4 4)) (- 124)))
(assert (= (f3 (f4 (- 7))) (- 19)))
(assert (= (g3 (g4 (- 7))) (- 930)))
(assert (= (f4 (g1 4)) (- 38)))
(assert (= (g4 (f1 (- 7))) (- 116)))
(assert (= (g4 (f2 8)) 176))
(assert (= (f4 (f2 (- 6))) 19))
(assert (= (g4 (g2 (- 6))) 968))
(assert (= (g4 (f3 4)) (- 116)))
(assert (= (f4 (f3 (- 7))) (- 19)))
(assert (= (g4 (g3 (- 7))) (- 930)))
(assert (= (f4 (f4 8)) 19))
(assert (= (g4 (g4 8)) 968))
(check-sat)
