(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 17)))
(assert (= (f1 (g1 5)) 44))
(assert (= (f1 (f2 9)) 22))
(assert (= (f1 (g2 (- 9))) 157))
(assert (= (f1 (f3 4)) (- 17)))
(assert (= (f1 (g3 9)) 157))
(assert (= (g1 (f3 5)) 108))
(assert (= (f1 (g4 4)) 44))
(assert (= (g1 (f4 (- 9))) 108))
(assert (= (f2 (f1 9)) 22))
(assert (= (f2 (g1 (- 9))) 77))
(assert (= (f2 (f2 4)) 22))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 5)) 252))
(assert (= (f2 (g3 4)) 77))
(assert (= (g2 (f3 (- 9))) 306))
(assert (= (g2 (f4 9)) 252))
(assert (= (f2 (f4 5)) 19))
(assert (= (g2 (g4 5)) 900))
(assert (= (f3 (f1 4)) (- 17)))
(assert (= (f3 (g1 9)) (- 81)))
(assert (= (g3 (f1 5)) 153))
(assert (= (f3 (g2 4)) (- 81)))
(assert (= (g3 (f2 (- 9))) (- 298)))
(assert (= (g3 (f3 9)) (- 298)))
(assert (= (f3 (f3 5)) 22))
(assert (= (g3 (g3 5)) 1445))
(assert (= (g3 (f4 4)) 153))
(assert (= (f3 (f4 (- 9))) 22))
(assert (= (g3 (g4 (- 9))) 1445))
(assert (= (f4 (g1 4)) 37))
(assert (= (g4 (f1 (- 9))) 125))
(assert (= (g4 (f2 9)) 180))
(assert (= (f4 (f2 5)) 19))
(assert (= (g4 (g2 5)) 900))
(assert (= (g4 (f3 4)) 125))
(assert (= (f4 (f3 (- 9))) 22))
(assert (= (g4 (g3 (- 9))) 1445))
(assert (= (f4 (f4 9)) 19))
(assert (= (g4 (g4 9)) 900))
(check-sat)
