(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 15)))
(assert (= (f1 (g1 (- 9))) 72))
(assert (= (f1 (f2 9)) 22))
(assert (= (f1 (g2 (- 7))) 121))
(assert (= (f1 (f3 4)) (- 15)))
(assert (= (f1 (g3 9)) 121))
(assert (= (g1 (f3 (- 9))) 120))
(assert (= (f1 (g4 4)) 72))
(assert (= (g1 (f4 (- 7))) 120))
(assert (= (f2 (f1 9)) 22))
(assert (= (f2 (g1 (- 7))) 61))
(assert (= (f2 (f2 4)) 22))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 9))) 315))
(assert (= (f2 (g3 4)) 61))
(assert (= (g2 (f3 (- 7))) 234))
(assert (= (g2 (f4 9)) 315))
(assert (= (f2 (f4 (- 9))) 26))
(assert (= (g2 (g4 (- 9))) 2601))
(assert (= (f3 (f1 4)) (- 15)))
(assert (= (f3 (g1 9)) (- 79)))
(assert (= (g3 (f1 (- 9))) (- 163)))
(assert (= (f3 (g2 4)) (- 79)))
(assert (= (g3 (f2 (- 7))) (- 202)))
(assert (= (g3 (f3 9)) (- 202)))
(assert (= (f3 (f3 (- 9))) (- 22)))
(assert (= (g3 (g3 (- 9))) (- 1437)))
(assert (= (g3 (f4 4)) (- 163)))
(assert (= (f3 (f4 (- 7))) (- 22)))
(assert (= (g3 (g4 (- 7))) (- 1437)))
(assert (= (f4 (g1 4)) (- 41)))
(assert (= (g4 (f1 (- 7))) (- 179)))
(assert (= (g4 (f2 9)) 306))
(assert (= (f4 (f2 (- 9))) 26))
(assert (= (g4 (g2 (- 9))) 2601))
(assert (= (g4 (f3 4)) (- 179)))
(assert (= (f4 (f3 (- 7))) (- 22)))
(assert (= (g4 (g3 (- 7))) (- 1437)))
(assert (= (f4 (f4 9)) 26))
(assert (= (g4 (g4 9)) 2601))
(check-sat)
