(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 15)))
(assert (= (f1 (g1 3)) 28))
(assert (= (f1 (f2 9)) 22))
(assert (= (f1 (g2 (- 7))) 121))
(assert (= (f1 (f3 4)) (- 15)))
(assert (= (f1 (g3 9)) 121))
(assert (= (g1 (f3 3)) 76))
(assert (= (f1 (g4 4)) 28))
(assert (= (g1 (f4 (- 7))) 76))
(assert (= (f2 (f1 9)) 22))
(assert (= (f2 (g1 (- 7))) 61))
(assert (= (f2 (f2 4)) 22))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 3)) 216))
(assert (= (f2 (g3 4)) 61))
(assert (= (g2 (f3 (- 7))) 234))
(assert (= (g2 (f4 9)) 216))
(assert (= (f2 (f4 3)) 15))
(assert (= (g2 (g4 3)) 324))
(assert (= (f3 (f1 4)) (- 15)))
(assert (= (f3 (g1 9)) (- 79)))
(assert (= (g3 (f1 3)) 91))
(assert (= (f3 (g2 4)) (- 79)))
(assert (= (g3 (f2 (- 7))) (- 202)))
(assert (= (g3 (f3 9)) (- 202)))
(assert (= (f3 (f3 3)) 16))
(assert (= (g3 (g3 3)) 507))
(assert (= (g3 (f4 4)) 91))
(assert (= (f3 (f4 (- 7))) 16))
(assert (= (g3 (g4 (- 7))) 507))
(assert (= (f4 (g1 4)) 35))
(assert (= (g4 (f1 (- 7))) 63))
(assert (= (g4 (f2 9)) 108))
(assert (= (f4 (f2 3)) 15))
(assert (= (g4 (g2 3)) 324))
(assert (= (g4 (f3 4)) 63))
(assert (= (f4 (f3 (- 7))) 16))
(assert (= (g4 (g3 (- 7))) 507))
(assert (= (f4 (f4 9)) 15))
(assert (= (g4 (g4 9)) 324))
(check-sat)
