(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 4)) 14))
(assert (= (f1 (g1 (- 5))) 50))
(assert (= (f1 (f2 (- 8))) 20))
(assert (= (f1 (g2 4)) 65))
(assert (= (f1 (f3 5)) 14))
(assert (= (f1 (g3 (- 8))) 65))
(assert (= (g1 (f3 (- 5))) 85))
(assert (= (f1 (g4 5)) 50))
(assert (= (g1 (f4 4)) 85))
(assert (= (f2 (f1 (- 8))) 20))
(assert (= (f2 (g1 4)) (- 48)))
(assert (= (f2 (f2 5)) 20))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 5))) 180))
(assert (= (f2 (g3 5)) (- 48)))
(assert (= (g2 (f3 4)) 120))
(assert (= (g2 (f4 (- 8))) 180))
(assert (= (f2 (f4 (- 5))) (- 17)))
(assert (= (g2 (g4 (- 5))) (- 608)))
(assert (= (f3 (f1 5)) 14))
(assert (= (f3 (g1 (- 8))) 79))
(assert (= (g3 (f1 (- 5))) 76))
(assert (= (f3 (g2 5)) 79))
(assert (= (g3 (f2 4)) 92))
(assert (= (g3 (f3 (- 8))) 92))
(assert (= (f3 (f3 (- 5))) (- 13)))
(assert (= (g3 (g3 (- 5))) 288))
(assert (= (g3 (f4 5)) 76))
(assert (= (f3 (f4 4)) (- 13)))
(assert (= (g3 (g4 4)) 288))
(assert (= (f4 (g1 5)) (- 55)))
(assert (= (g4 (f1 4)) 81))
(assert (= (g4 (f2 (- 8))) 135))
(assert (= (f4 (f2 (- 5))) (- 17)))
(assert (= (g4 (g2 (- 5))) (- 608)))
(assert (= (g4 (f3 5)) 81))
(assert (= (f4 (f3 4)) (- 13)))
(assert (= (g4 (g3 4)) 288))
(assert (= (f4 (f4 (- 8))) (- 17)))
(assert (= (g4 (g4 (- 8))) (- 608)))
(check-sat)
