(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 7)) 17))
(assert (= (f1 (g1 (- 5))) 50))
(assert (= (f1 (f2 (- 8))) 20))
(assert (= (f1 (g2 7)) 110))
(assert (= (f1 (f3 5)) 17))
(assert (= (f1 (g3 (- 8))) 110))
(assert (= (g1 (f3 (- 5))) 115))
(assert (= (f1 (g4 5)) 50))
(assert (= (g1 (f4 7)) 115))
(assert (= (f2 (f1 (- 8))) 20))
(assert (= (f2 (g1 7)) (- 78)))
(assert (= (f2 (f2 5)) 20))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 5))) 180))
(assert (= (f2 (g3 5)) (- 78)))
(assert (= (g2 (f3 7)) 210))
(assert (= (g2 (f4 (- 8))) 180))
(assert (= (f2 (f4 (- 5))) (- 17)))
(assert (= (g2 (g4 (- 5))) (- 608)))
(assert (= (f3 (f1 5)) 17))
(assert (= (f3 (g1 (- 8))) 82))
(assert (= (g3 (f1 (- 5))) 133))
(assert (= (f3 (g2 5)) 82))
(assert (= (g3 (f2 7)) 203))
(assert (= (g3 (f3 (- 8))) 203))
(assert (= (f3 (f3 (- 5))) (- 19)))
(assert (= (g3 (g3 (- 5))) 882))
(assert (= (g3 (f4 5)) 133))
(assert (= (f3 (f4 7)) (- 19)))
(assert (= (g3 (g4 7)) 882))
(assert (= (f4 (g1 5)) (- 55)))
(assert (= (g4 (f1 7)) 108))
(assert (= (g4 (f2 (- 8))) 135))
(assert (= (f4 (f2 (- 5))) (- 17)))
(assert (= (g4 (g2 (- 5))) (- 608)))
(assert (= (g4 (f3 5)) 108))
(assert (= (f4 (f3 7)) (- 19)))
(assert (= (g4 (g3 7)) 882))
(assert (= (f4 (f4 (- 8))) (- 17)))
(assert (= (g4 (g4 (- 8))) (- 608)))
(check-sat)
