(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 18)))
(assert (= (f1 (g1 (- 7))) 70))
(assert (= (f1 (f2 (- 5))) 14))
(assert (= (f1 (g2 (- 8))) (- 73)))
(assert (= (f1 (f3 5)) (- 18)))
(assert (= (f1 (g3 (- 5))) (- 73)))
(assert (= (g1 (f3 (- 7))) 140))
(assert (= (f1 (g4 5)) 70))
(assert (= (g1 (f4 (- 8))) 140))
(assert (= (f2 (f1 (- 5))) 14))
(assert (= (f2 (g1 (- 8))) (- 80)))
(assert (= (f2 (f2 5)) 14))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 7))) 99))
(assert (= (f2 (g3 5)) (- 80)))
(assert (= (g2 (f3 (- 8))) 135))
(assert (= (g2 (f4 (- 5))) 99))
(assert (= (f2 (f4 (- 7))) (- 18)))
(assert (= (g2 (g4 (- 7))) (- 761)))
(assert (= (f3 (f1 5)) (- 18)))
(assert (= (f3 (g1 (- 5))) (- 53)))
(assert (= (g3 (f1 (- 7))) (- 173)))
(assert (= (f3 (g2 5)) (- 53)))
(assert (= (g3 (f2 (- 8))) 180))
(assert (= (g3 (f3 (- 5))) 180))
(assert (= (f3 (f3 (- 7))) (- 22)))
(assert (= (g3 (g3 (- 7))) (- 1463)))
(assert (= (g3 (f4 5)) (- 173)))
(assert (= (f3 (f4 (- 8))) (- 22)))
(assert (= (g3 (g4 (- 8))) (- 1463)))
(assert (= (f4 (g1 5)) (- 57)))
(assert (= (g4 (f1 (- 8))) (- 163)))
(assert (= (g4 (f2 (- 5))) 117))
(assert (= (f4 (f2 (- 7))) (- 18)))
(assert (= (g4 (g2 (- 7))) (- 761)))
(assert (= (g4 (f3 5)) (- 163)))
(assert (= (f4 (f3 (- 8))) (- 22)))
(assert (= (g4 (g3 (- 8))) (- 1463)))
(assert (= (f4 (f4 (- 5))) (- 18)))
(assert (= (g4 (g4 (- 5))) (- 761)))
(check-sat)
