(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 12)))
(assert (= (f1 (g1 7)) 75))
(assert (= (f1 (f2 (- 4))) 12))
(assert (= (f1 (g2 (- 2))) (- 16)))
(assert (= (f1 (f3 5)) (- 12)))
(assert (= (f1 (g3 (- 4))) (- 16)))
(assert (= (g1 (f3 7)) 85))
(assert (= (f1 (g4 5)) 75))
(assert (= (g1 (f4 (- 2))) 85))
(assert (= (f2 (f1 (- 4))) 12))
(assert (= (f2 (g1 (- 2))) (- 19)))
(assert (= (f2 (f2 5)) 12))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 7)) (- 74)))
(assert (= (f2 (g3 5)) (- 19)))
(assert (= (g2 (f3 (- 2))) 21))
(assert (= (g2 (f4 (- 4))) (- 74)))
(assert (= (f2 (f4 7)) (- 18)))
(assert (= (g2 (g4 7)) 686))
(assert (= (f3 (f1 5)) (- 12)))
(assert (= (f3 (g1 (- 4))) (- 37)))
(assert (= (g3 (f1 7)) 36))
(assert (= (f3 (g2 5)) (- 37)))
(assert (= (g3 (f2 (- 2))) 15))
(assert (= (g3 (f3 (- 4))) 15))
(assert (= (f3 (f3 7)) 10))
(assert (= (g3 (g3 7)) 63))
(assert (= (g3 (f4 5)) 36))
(assert (= (f3 (f4 (- 2))) 10))
(assert (= (g3 (g4 (- 2))) 63))
(assert (= (f4 (g1 5)) 57))
(assert (= (g4 (f1 (- 2))) 91))
(assert (= (g4 (f2 (- 4))) 98))
(assert (= (f4 (f2 7)) (- 18)))
(assert (= (g4 (g2 7)) 686))
(assert (= (g4 (f3 5)) 91))
(assert (= (f4 (f3 (- 2))) 10))
(assert (= (g4 (g3 (- 2))) 63))
(assert (= (f4 (f4 (- 4))) (- 18)))
(assert (= (g4 (g4 (- 4))) 686))
(check-sat)
