(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 15)))
(assert (= (f1 (g1 7)) (- 98)))
(assert (= (f1 (f2 2)) (- 11)))
(assert (= (f1 (g2 (- 2))) (- 13)))
(assert (= (f1 (f3 (- 7))) (- 15)))
(assert (= (f1 (g3 2)) (- 13)))
(assert (= (g1 (f3 7)) (- 111)))
(assert (= (f1 (g4 (- 7))) (- 98)))
(assert (= (g1 (f4 (- 2))) (- 111)))
(assert (= (f2 (f1 2)) (- 11)))
(assert (= (f2 (g1 (- 2))) (- 22)))
(assert (= (f2 (f2 (- 7))) (- 11)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 7)) 36))
(assert (= (f2 (g3 (- 7))) (- 22)))
(assert (= (g2 (f3 (- 2))) 12))
(assert (= (g2 (f4 2)) 36))
(assert (= (f2 (f4 7)) 16))
(assert (= (g2 (g4 7)) 392))
(assert (= (f3 (f1 (- 7))) (- 15)))
(assert (= (f3 (g1 2)) (- 28)))
(assert (= (g3 (f1 7)) (- 41)))
(assert (= (f3 (g2 (- 7))) (- 28)))
(assert (= (g3 (f2 (- 2))) (- 11)))
(assert (= (g3 (f3 2)) (- 11)))
(assert (= (f3 (f3 7)) 10))
(assert (= (g3 (g3 7)) 63))
(assert (= (g3 (f4 (- 7))) (- 41)))
(assert (= (f3 (f4 (- 2))) 10))
(assert (= (g3 (g4 (- 2))) 63))
(assert (= (f4 (g1 (- 7))) (- 92)))
(assert (= (g4 (f1 (- 2))) 112))
(assert (= (g4 (f2 2)) 56))
(assert (= (f4 (f2 7)) 16))
(assert (= (g4 (g2 7)) 392))
(assert (= (g4 (f3 (- 7))) 112))
(assert (= (f4 (f3 (- 2))) 10))
(assert (= (g4 (g3 (- 2))) 63))
(assert (= (f4 (f4 2)) 16))
(assert (= (g4 (g4 2)) 392))
(check-sat)
