(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 19)))
(assert (= (f1 (g1 (- 5))) 50))
(assert (= (f1 (f2 (- 2))) 8))
(assert (= (f1 (g2 (- 9))) (- 31)))
(assert (= (f1 (f3 5)) (- 19)))
(assert (= (f1 (g3 (- 2))) (- 31)))
(assert (= (g1 (f3 (- 5))) 130))
(assert (= (f1 (g4 5)) 50))
(assert (= (g1 (f4 (- 9))) 130))
(assert (= (f2 (f1 (- 2))) 8))
(assert (= (f2 (g1 (- 9))) (- 87)))
(assert (= (f2 (f2 5)) 8))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 5))) 18))
(assert (= (f2 (g3 5)) (- 87)))
(assert (= (g2 (f3 (- 9))) 51))
(assert (= (g2 (f4 (- 2))) 18))
(assert (= (f2 (f4 (- 5))) (- 11)))
(assert (= (g2 (g4 (- 5))) (- 122)))
(assert (= (f3 (f1 5)) (- 19)))
(assert (= (f3 (g1 (- 2))) (- 24)))
(assert (= (g3 (f1 (- 5))) (- 162)))
(assert (= (f3 (g2 5)) (- 24)))
(assert (= (g3 (f2 (- 9))) 170))
(assert (= (g3 (f3 (- 2))) 170))
(assert (= (f3 (f3 (- 5))) (- 22)))
(assert (= (g3 (g3 (- 5))) (- 1301)))
(assert (= (g3 (f4 5)) (- 162)))
(assert (= (f3 (f4 (- 9))) (- 22)))
(assert (= (g3 (g4 (- 9))) (- 1301)))
(assert (= (f4 (g1 5)) (- 55)))
(assert (= (g4 (f1 (- 9))) (- 122)))
(assert (= (g4 (f2 (- 2))) 27))
(assert (= (f4 (f2 (- 5))) (- 11)))
(assert (= (g4 (g2 (- 5))) (- 122)))
(assert (= (g4 (f3 5)) (- 122)))
(assert (= (f4 (f3 (- 9))) (- 22)))
(assert (= (g4 (g3 (- 9))) (- 1301)))
(assert (= (f4 (f4 (- 2))) (- 11)))
(assert (= (g4 (g4 (- 2))) (- 122)))
(check-sat)
