(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 14))
(assert (= (f1 (g1 3)) 35))
(assert (= (f1 (f2 2)) 9))
(assert (= (f1 (g2 4)) 21))
(assert (= (f1 (f3 5)) 14))
(assert (= (f1 (g3 2)) 21))
(assert (= (g1 (f3 3)) 70))
(assert (= (f1 (g4 5)) 35))
(assert (= (g1 (f4 4)) 70))
(assert (= (f2 (f1 2)) 9))
(assert (= (f2 (g1 4)) 42))
(assert (= (f2 (f2 5)) 9))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 3)) 20))
(assert (= (f2 (g3 5)) 42))
(assert (= (g2 (f3 4)) 32))
(assert (= (g2 (f4 2)) 20))
(assert (= (f2 (f4 3)) 8))
(assert (= (g2 (g4 3)) 72))
(assert (= (f3 (f1 5)) 14))
(assert (= (f3 (g1 2)) 24))
(assert (= (g3 (f1 3)) 64))
(assert (= (f3 (g2 5)) 24))
(assert (= (g3 (f2 4)) 48))
(assert (= (g3 (f3 2)) 48))
(assert (= (f3 (f3 3)) 11))
(assert (= (g3 (g3 3)) 192))
(assert (= (g3 (f4 5)) 64))
(assert (= (f3 (f4 4)) 11))
(assert (= (g3 (g4 4)) 192))
(assert (= (f4 (g1 5)) 53))
(assert (= (g4 (f1 4)) 54))
(assert (= (g4 (f2 2)) 24))
(assert (= (f4 (f2 3)) 8))
(assert (= (g4 (g2 3)) 72))
(assert (= (g4 (f3 5)) 54))
(assert (= (f4 (f3 4)) 11))
(assert (= (g4 (g3 4)) 192))
(assert (= (f4 (f4 2)) 8))
(assert (= (g4 (g4 2)) 72))
(check-sat)
