(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 15))
(assert (= (f1 (g1 (- 8))) 104))
(assert (= (f1 (f2 3)) (- 13)))
(assert (= (f1 (g2 2)) (- 19)))
(assert (= (f1 (f3 (- 7))) 15))
(assert (= (f1 (g3 3)) (- 19)))
(assert (= (g1 (f3 (- 8))) (- 124)))
(assert (= (f1 (g4 (- 7))) 104))
(assert (= (g1 (f4 2)) (- 124)))
(assert (= (f2 (f1 3)) (- 13)))
(assert (= (f2 (g1 2)) 29))
(assert (= (f2 (f2 (- 7))) (- 13)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 8))) 63))
(assert (= (f2 (g3 (- 7))) 29))
(assert (= (g2 (f3 2)) 24))
(assert (= (g2 (f4 3)) 63))
(assert (= (f2 (f4 (- 8))) 18))
(assert (= (g2 (g4 (- 8))) 675))
(assert (= (f3 (f1 (- 7))) 15))
(assert (= (f3 (g1 3)) 41))
(assert (= (g3 (f1 (- 8))) 56))
(assert (= (f3 (g2 (- 7))) 41))
(assert (= (g3 (f2 2)) 20))
(assert (= (g3 (f3 3)) 20))
(assert (= (f3 (f3 (- 8))) (- 12)))
(assert (= (g3 (g3 (- 8))) 120))
(assert (= (g3 (f4 (- 7))) 56))
(assert (= (f3 (f4 2)) (- 12)))
(assert (= (g3 (g4 2)) 120))
(assert (= (f4 (g1 (- 7))) 92))
(assert (= (g4 (f1 2)) (- 128)))
(assert (= (g4 (f2 3)) 90))
(assert (= (f4 (f2 (- 8))) 18))
(assert (= (g4 (g2 (- 8))) 675))
(assert (= (g4 (f3 (- 7))) (- 128)))
(assert (= (f4 (f3 2)) (- 12)))
(assert (= (g4 (g3 2)) 120))
(assert (= (f4 (f4 3)) 18))
(assert (= (g4 (g4 3)) 675))
(check-sat)
