(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 4)) 14))
(assert (= (f1 (g1 8)) 85))
(assert (= (f1 (f2 3)) 11))
(assert (= (f1 (g2 4)) 29))
(assert (= (f1 (f3 5)) 14))
(assert (= (f1 (g3 3)) 29))
(assert (= (g1 (f3 8)) 120))
(assert (= (f1 (g4 5)) 85))
(assert (= (g1 (f4 4)) 120))
(assert (= (f2 (f1 3)) 11))
(assert (= (f2 (g1 4)) 43))
(assert (= (f2 (f2 5)) 11))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 8)) 66))
(assert (= (f2 (g3 5)) 43))
(assert (= (g2 (f3 4)) 48))
(assert (= (g2 (f4 3)) 66))
(assert (= (f2 (f4 8)) 19))
(assert (= (g2 (g4 8)) 768))
(assert (= (f3 (f1 5)) 14))
(assert (= (f3 (g1 3)) 34))
(assert (= (g3 (f1 8)) 104))
(assert (= (f3 (g2 5)) 34))
(assert (= (g3 (f2 4)) 56))
(assert (= (g3 (f3 3)) 56))
(assert (= (f3 (f3 8)) 16))
(assert (= (g3 (g3 8)) 512))
(assert (= (g3 (f4 5)) 104))
(assert (= (f3 (f4 4)) 16))
(assert (= (g3 (g4 4)) 512))
(assert (= (f4 (g1 5)) 58))
(assert (= (g4 (f1 4)) 144))
(assert (= (g4 (f2 3)) 96))
(assert (= (f4 (f2 8)) 19))
(assert (= (g4 (g2 8)) 768))
(assert (= (g4 (f3 5)) 144))
(assert (= (f4 (f3 4)) 16))
(assert (= (g4 (g3 4)) 512))
(assert (= (f4 (f4 3)) 19))
(assert (= (g4 (g4 3)) 768))
(check-sat)
