(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 16)))
(assert (= (f1 (g1 (- 1))) 10))
(assert (= (f1 (f2 6)) 17))
(assert (= (f1 (g2 (- 6))) 71))
(assert (= (f1 (f3 5)) (- 16)))
(assert (= (f1 (g3 6)) 71))
(assert (= (g1 (f3 (- 1))) 60))
(assert (= (f1 (g4 5)) 10))
(assert (= (g1 (f4 (- 6))) 60))
(assert (= (f2 (f1 6)) 17))
(assert (= (f2 (g1 (- 6))) 61))
(assert (= (f2 (f2 5)) 17))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 1))) 78))
(assert (= (f2 (g3 5)) 61))
(assert (= (g2 (f3 (- 6))) 132))
(assert (= (g2 (f4 6)) 78))
(assert (= (f2 (f4 (- 1))) 7))
(assert (= (g2 (g4 (- 1))) 6))
(assert (= (f3 (f1 5)) (- 16)))
(assert (= (f3 (g1 6)) (- 66)))
(assert (= (g3 (f1 (- 1))) (- 61)))
(assert (= (f3 (g2 5)) (- 66)))
(assert (= (g3 (f2 (- 6))) (- 127)))
(assert (= (g3 (f3 6)) (- 127)))
(assert (= (f3 (f3 (- 1))) (- 12)))
(assert (= (g3 (g3 (- 1))) (- 61)))
(assert (= (g3 (f4 5)) (- 61)))
(assert (= (f3 (f4 (- 6))) (- 12)))
(assert (= (g3 (g4 (- 6))) (- 61)))
(assert (= (f4 (g1 5)) (- 51)))
(assert (= (g4 (f1 (- 6))) (- 11)))
(assert (= (g4 (f2 6)) 12))
(assert (= (f4 (f2 (- 1))) 7))
(assert (= (g4 (g2 (- 1))) 6))
(assert (= (g4 (f3 5)) (- 11)))
(assert (= (f4 (f3 (- 6))) (- 12)))
(assert (= (g4 (g3 (- 6))) (- 61)))
(assert (= (f4 (f4 6)) 7))
(assert (= (g4 (g4 6)) 6))
(check-sat)
