(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 18)))
(assert (= (f1 (g1 (- 7))) 70))
(assert (= (f1 (f2 9)) 23))
(assert (= (f1 (g2 (- 8))) 140))
(assert (= (f1 (f3 5)) (- 18)))
(assert (= (f1 (g3 9)) 140))
(assert (= (g1 (f3 (- 7))) 140))
(assert (= (f1 (g4 5)) 70))
(assert (= (g1 (f4 (- 8))) 140))
(assert (= (f2 (f1 9)) 23))
(assert (= (f2 (g1 (- 8))) 84))
(assert (= (f2 (f2 5)) 23))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 7))) 279))
(assert (= (f2 (g3 5)) 84))
(assert (= (g2 (f3 (- 8))) 270))
(assert (= (g2 (f4 9)) 279))
(assert (= (f2 (f4 (- 7))) 22))
(assert (= (g2 (g4 (- 7))) 1521))
(assert (= (f3 (f1 5)) (- 18)))
(assert (= (f3 (g1 9)) (- 98)))
(assert (= (g3 (f1 (- 7))) (- 173)))
(assert (= (f3 (g2 5)) (- 98)))
(assert (= (g3 (f2 (- 8))) (- 248)))
(assert (= (g3 (f3 9)) (- 248)))
(assert (= (f3 (f3 (- 7))) (- 22)))
(assert (= (g3 (g3 (- 7))) (- 1463)))
(assert (= (g3 (f4 5)) (- 173)))
(assert (= (f3 (f4 (- 8))) (- 22)))
(assert (= (g3 (g4 (- 8))) (- 1463)))
(assert (= (f4 (g1 5)) (- 57)))
(assert (= (g4 (f1 (- 8))) (- 163)))
(assert (= (g4 (f2 9)) 234))
(assert (= (f4 (f2 (- 7))) 22))
(assert (= (g4 (g2 (- 7))) 1521))
(assert (= (g4 (f3 5)) (- 163)))
(assert (= (f4 (f3 (- 8))) (- 22)))
(assert (= (g4 (g3 (- 8))) (- 1463)))
(assert (= (f4 (f4 9)) 22))
(assert (= (g4 (g4 9)) 1521))
(check-sat)
