(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 16)))
(assert (= (f1 (g1 8)) (- 111)))
(assert (= (f1 (f2 4)) (- 15)))
(assert (= (f1 (g2 (- 3))) (- 27)))
(assert (= (f1 (f3 (- 7))) (- 16)))
(assert (= (f1 (g3 4)) (- 27)))
(assert (= (g1 (f3 8)) (- 137)))
(assert (= (f1 (g4 (- 7))) (- 111)))
(assert (= (g1 (f4 (- 3))) (- 137)))
(assert (= (f2 (f1 4)) (- 15)))
(assert (= (f2 (g1 (- 3))) (- 37)))
(assert (= (f2 (f2 (- 7))) (- 15)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 8)) 96))
(assert (= (f2 (g3 (- 7))) (- 37)))
(assert (= (g2 (f3 (- 3))) 40))
(assert (= (g2 (f4 4)) 96))
(assert (= (f2 (f4 8)) 20))
(assert (= (g2 (g4 8)) 1024))
(assert (= (f3 (f1 (- 7))) (- 16)))
(assert (= (f3 (g1 4)) (- 55)))
(assert (= (g3 (f1 8)) (- 73)))
(assert (= (f3 (g2 (- 7))) (- 55)))
(assert (= (g3 (f2 (- 3))) (- 33)))
(assert (= (g3 (f3 4)) (- 33)))
(assert (= (f3 (f3 8)) 13))
(assert (= (g3 (g3 8)) 200))
(assert (= (g3 (f4 (- 7))) (- 73)))
(assert (= (f3 (f4 (- 3))) 13))
(assert (= (g3 (g4 (- 3))) 200))
(assert (= (f4 (g1 (- 7))) (- 93)))
(assert (= (g4 (f1 (- 3))) 144))
(assert (= (g4 (f2 4)) 128))
(assert (= (f4 (f2 8)) 20))
(assert (= (g4 (g2 8)) 1024))
(assert (= (g4 (f3 (- 7))) 144))
(assert (= (f4 (f3 (- 3))) 13))
(assert (= (g4 (g3 (- 3))) 200))
(assert (= (f4 (f4 4)) 20))
(assert (= (g4 (g4 4)) 1024))
(check-sat)
