(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 15))
(assert (= (f1 (g1 (- 7))) 84))
(assert (= (f1 (f2 (- 4))) 13))
(assert (= (f1 (g2 3)) 27))
(assert (= (f1 (f3 6)) 15))
(assert (= (f1 (g3 (- 4))) 27))
(assert (= (g1 (f3 (- 7))) 114))
(assert (= (f1 (g4 6)) 84))
(assert (= (g1 (f4 3)) 114))
(assert (= (f2 (f1 (- 4))) 13))
(assert (= (f2 (g1 3)) (- 40)))
(assert (= (f2 (f2 6)) 13))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 7))) 70))
(assert (= (f2 (g3 6)) (- 40)))
(assert (= (g2 (f3 3)) 42))
(assert (= (g2 (f4 (- 4))) 70))
(assert (= (f2 (f4 (- 7))) (- 17)))
(assert (= (g2 (g4 (- 7))) (- 592)))
(assert (= (f3 (f1 6)) 15))
(assert (= (f3 (g1 (- 4))) 45))
(assert (= (g3 (f1 (- 7))) 75))
(assert (= (f3 (g2 6)) 45))
(assert (= (g3 (f2 3)) 39))
(assert (= (g3 (f3 (- 4))) 39))
(assert (= (f3 (f3 (- 7))) (- 13)))
(assert (= (g3 (g3 (- 7))) 234))
(assert (= (g3 (f4 6)) 75))
(assert (= (f3 (f4 3)) (- 13)))
(assert (= (g3 (g4 3)) 234))
(assert (= (f4 (g1 6)) (- 79)))
(assert (= (g4 (f1 3)) 117))
(assert (= (g4 (f2 (- 4))) 91))
(assert (= (f4 (f2 (- 7))) (- 17)))
(assert (= (g4 (g2 (- 7))) (- 592)))
(assert (= (g4 (f3 6)) 117))
(assert (= (f4 (f3 3)) (- 13)))
(assert (= (g4 (g3 3)) 234))
(assert (= (f4 (f4 (- 4))) (- 17)))
(assert (= (g4 (g4 (- 4))) (- 592)))
(check-sat)
