(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 16))
(assert (= (f1 (g1 (- 6))) 72))
(assert (= (f1 (f2 (- 4))) 13))
(assert (= (f1 (g2 4)) 34))
(assert (= (f1 (f3 6)) 16))
(assert (= (f1 (g3 (- 4))) 34))
(assert (= (g1 (f3 (- 6))) 114))
(assert (= (f1 (g4 6)) 72))
(assert (= (g1 (f4 4)) 114))
(assert (= (f2 (f1 (- 4))) 13))
(assert (= (f2 (g1 4)) (- 52)))
(assert (= (f2 (f2 6)) 13))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 6))) 63))
(assert (= (f2 (g3 6)) (- 52)))
(assert (= (g2 (f3 4)) 56))
(assert (= (g2 (f4 (- 4))) 63))
(assert (= (f2 (f4 (- 6))) (- 15)))
(assert (= (g2 (g4 (- 6))) (- 424)))
(assert (= (f3 (f1 6)) 16))
(assert (= (f3 (g1 (- 4))) 46))
(assert (= (g3 (f1 (- 6))) 92))
(assert (= (f3 (g2 6)) 46))
(assert (= (g3 (f2 4)) 60))
(assert (= (g3 (f3 (- 4))) 60))
(assert (= (f3 (f3 (- 6))) (- 14)))
(assert (= (g3 (g3 (- 6))) 352))
(assert (= (g3 (f4 6)) 92))
(assert (= (f3 (f4 4)) (- 14)))
(assert (= (g3 (g4 4)) 352))
(assert (= (f4 (g1 6)) (- 78)))
(assert (= (g4 (f1 4)) 110))
(assert (= (g4 (f2 (- 4))) 77))
(assert (= (f4 (f2 (- 6))) (- 15)))
(assert (= (g4 (g2 (- 6))) (- 424)))
(assert (= (g4 (f3 6)) 110))
(assert (= (f4 (f3 4)) (- 14)))
(assert (= (g4 (g3 4)) 352))
(assert (= (f4 (f4 (- 4))) (- 15)))
(assert (= (g4 (g4 (- 4))) (- 424)))
(check-sat)
