(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 9)) 21))
(assert (= (f1 (g1 (- 1))) 12))
(assert (= (f1 (f2 (- 4))) 13))
(assert (= (f1 (g2 9)) 69))
(assert (= (f1 (f3 6)) 21))
(assert (= (f1 (g3 (- 4))) 69))
(assert (= (g1 (f3 (- 1))) 114))
(assert (= (f1 (g4 6)) 12))
(assert (= (g1 (f4 9)) 114))
(assert (= (f2 (f1 (- 4))) 13))
(assert (= (f2 (g1 9)) (- 112)))
(assert (= (f2 (f2 6)) 13))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 1))) 28))
(assert (= (f2 (g3 6)) (- 112)))
(assert (= (g2 (f3 9)) 126))
(assert (= (g2 (f4 (- 4))) 28))
(assert (= (f2 (f4 (- 1))) (- 5)))
(assert (= (g2 (g4 (- 1))) (- 4)))
(assert (= (f3 (f1 6)) 21))
(assert (= (f3 (g1 (- 4))) 51))
(assert (= (g3 (f1 (- 1))) 117))
(assert (= (f3 (g2 6)) 51))
(assert (= (g3 (f2 9)) 225))
(assert (= (g3 (f3 (- 4))) 225))
(assert (= (f3 (f3 (- 1))) (- 19)))
(assert (= (g3 (g3 (- 1))) 162))
(assert (= (g3 (f4 6)) 117))
(assert (= (f3 (f4 9)) (- 19)))
(assert (= (g3 (g4 9)) 162))
(assert (= (f4 (g1 6)) (- 73)))
(assert (= (g4 (f1 9)) 15))
(assert (= (g4 (f2 (- 4))) 7))
(assert (= (f4 (f2 (- 1))) (- 5)))
(assert (= (g4 (g2 (- 1))) (- 4)))
(assert (= (g4 (f3 6)) 15))
(assert (= (f4 (f3 9)) (- 19)))
(assert (= (g4 (g3 9)) 162))
(assert (= (f4 (f4 (- 4))) (- 5)))
(assert (= (g4 (g4 (- 4))) (- 4)))
(check-sat)
