(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 16)))
(assert (= (f1 (g1 5)) 66))
(assert (= (f1 (f2 (- 3))) 11))
(assert (= (f1 (g2 (- 4))) (- 24)))
(assert (= (f1 (f3 6)) (- 16)))
(assert (= (f1 (g3 (- 3))) (- 24)))
(assert (= (g1 (f3 5)) 102))
(assert (= (f1 (g4 6)) 66))
(assert (= (g1 (f4 (- 4))) 102))
(assert (= (f2 (f1 (- 3))) 11))
(assert (= (f2 (g1 (- 4))) (- 45)))
(assert (= (f2 (f2 6)) 11))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 5)) (- 38)))
(assert (= (f2 (g3 6)) (- 45)))
(assert (= (g2 (f3 (- 4))) 35))
(assert (= (g2 (f4 (- 3))) (- 38)))
(assert (= (f2 (f4 5)) (- 13)))
(assert (= (g2 (g4 5)) 250))
(assert (= (f3 (f1 6)) (- 16)))
(assert (= (f3 (g1 (- 3))) (- 34)))
(assert (= (g3 (f1 5)) 77))
(assert (= (f3 (g2 6)) (- 34)))
(assert (= (g3 (f2 (- 4))) 42))
(assert (= (g3 (f3 (- 3))) 42))
(assert (= (f3 (f3 5)) 12))
(assert (= (g3 (g3 5)) 245))
(assert (= (g3 (f4 6)) 77))
(assert (= (f3 (f4 (- 4))) 12))
(assert (= (g3 (g4 (- 4))) 245))
(assert (= (f4 (g1 6)) 77))
(assert (= (g4 (f1 (- 4))) 95))
(assert (= (g4 (f2 (- 3))) 50))
(assert (= (f4 (f2 5)) (- 13)))
(assert (= (g4 (g2 5)) 250))
(assert (= (g4 (f3 6)) 95))
(assert (= (f4 (f3 (- 4))) 12))
(assert (= (g4 (g3 (- 4))) 245))
(assert (= (f4 (f4 (- 3))) (- 13)))
(assert (= (g4 (g4 (- 3))) 250))
(check-sat)
