(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 17)))
(assert (= (f1 (g1 5)) 66))
(assert (= (f1 (f2 (- 2))) 9))
(assert (= (f1 (g2 (- 5))) (- 20)))
(assert (= (f1 (f3 6)) (- 17)))
(assert (= (f1 (g3 (- 2))) (- 20)))
(assert (= (g1 (f3 5)) 114))
(assert (= (f1 (g4 6)) 66))
(assert (= (g1 (f4 (- 5))) 114))
(assert (= (f2 (f1 (- 2))) 9))
(assert (= (f2 (g1 (- 5))) (- 56)))
(assert (= (f2 (f2 6)) 9))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 5)) (- 20)))
(assert (= (f2 (g3 6)) (- 56)))
(assert (= (g2 (f3 (- 5))) 27))
(assert (= (g2 (f4 (- 2))) (- 20)))
(assert (= (f2 (f4 5)) (- 12)))
(assert (= (g2 (g4 5)) 150))
(assert (= (f3 (f1 6)) (- 17)))
(assert (= (f3 (g1 (- 2))) (- 23)))
(assert (= (g3 (f1 5)) 99))
(assert (= (f3 (g2 6)) (- 23)))
(assert (= (g3 (f2 (- 5))) 54))
(assert (= (g3 (f3 (- 2))) 54))
(assert (= (f3 (f3 5)) 14))
(assert (= (g3 (g3 5)) 405))
(assert (= (g3 (f4 6)) 99))
(assert (= (f3 (f4 (- 5))) 14))
(assert (= (g3 (g4 (- 5))) 405))
(assert (= (f4 (g1 6)) 77))
(assert (= (g4 (f1 (- 5))) 105))
(assert (= (g4 (f2 (- 2))) 30))
(assert (= (f4 (f2 5)) (- 12)))
(assert (= (g4 (g2 5)) 150))
(assert (= (g4 (f3 6)) 105))
(assert (= (f4 (f3 (- 5))) 14))
(assert (= (g4 (g3 (- 5))) 405))
(assert (= (f4 (f4 (- 2))) (- 12)))
(assert (= (g4 (g4 (- 2))) 150))
(check-sat)
