(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g3 x)))))
(assert (= (f1 (f1 3)) 15))
(assert (= (f1 (g1 7)) 90))
(assert (= (f1 (f2 (- 2))) 9))
(assert (= (f1 (g2 3)) 15))
(assert (= (f1 (f3 6)) 15))
(assert (= (f1 (g3 (- 2))) 15))
(assert (= (g1 (f3 7)) 120))
(assert (= (f1 (g4 6)) 90))
(assert (= (g1 (f4 3)) 120))
(assert (= (f2 (f1 (- 2))) 9))
(assert (= (f2 (g1 3)) (- 38)))
(assert (= (f2 (f2 6)) 9))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 7)) (- 26)))
(assert (= (f2 (g3 6)) (- 38)))
(assert (= (g2 (f3 3)) 18))
(assert (= (g2 (f4 (- 2))) (- 26)))
(assert (= (f2 (f4 7)) (- 16)))
(assert (= (g2 (g4 7)) 294))
(assert (= (f3 (f1 6)) 15))
(assert (= (f3 (g1 (- 2))) 21))
(assert (= (g3 (f1 7)) 78))
(assert (= (f3 (g2 6)) 21))
(assert (= (g3 (f2 3)) 27))
(assert (= (g3 (f3 (- 2))) 27))
(assert (= (f3 (f3 7)) 13))
(assert (= (g3 (g3 7)) 252))
(assert (= (g3 (f4 6)) 78))
(assert (= (f3 (f4 3)) 13))
(assert (= (g3 (g4 3)) 252))
(assert (= (f4 (g1 6)) 79))
(assert (= (g4 (f1 3)) 126))
(assert (= (g4 (f2 (- 2))) 42))
(assert (= (f4 (f2 7)) (- 16)))
(assert (= (g4 (g2 7)) 294))
(assert (= (g4 (f3 6)) 126))
(assert (= (f4 (f3 3)) 13))
(assert (= (g4 (g3 3)) 252))
(assert (= (f4 (f4 (- 2))) (- 16)))
(assert (= (g4 (g4 (- 2))) 294))
(check-sat)
