(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 8)) 21))
(assert (= (f1 (g1 0)) (- 7)))
(assert (= (f1 (f2 5)) (- 17)))
(assert (= (f1 (g2 8)) (- 87)))
(assert (= (f1 (f3 (- 7))) 21))
(assert (= (f1 (g3 5)) (- 87)))
(assert (= (g1 (f3 0)) 104))
(assert (= (f1 (g4 (- 7))) (- 7)))
(assert (= (g1 (f4 8)) 104))
(assert (= (f2 (f1 5)) (- 17)))
(assert (= (f2 (g1 8)) 109))
(assert (= (f2 (f2 (- 7))) (- 17)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 0)) 50))
(assert (= (f2 (g3 (- 7))) 109))
(assert (= (g2 (f3 8)) 160))
(assert (= (g2 (f4 5)) 50))
(assert (= (f2 (f4 0)) 5))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 (- 7))) 21))
(assert (= (f3 (g1 5)) 73))
(assert (= (g3 (f1 0)) 104))
(assert (= (f3 (g2 (- 7))) 73))
(assert (= (g3 (f2 8)) 208))
(assert (= (g3 (f3 5)) 208))
(assert (= (f3 (f3 0)) 16))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 (- 7))) 104))
(assert (= (f3 (f4 8)) 16))
(assert (= (g3 (g4 8)) 0))
(assert (= (f4 (g1 (- 7))) (- 85)))
(assert (= (g4 (f1 8)) 0))
(assert (= (g4 (f2 5)) 0))
(assert (= (f4 (f2 0)) 5))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 (- 7))) 0))
(assert (= (f4 (f3 8)) 16))
(assert (= (g4 (g3 8)) 0))
(assert (= (f4 (f4 5)) 5))
(assert (= (g4 (g4 5)) 0))
(check-sat)
