(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 17)))
(assert (= (f1 (g1 9)) 114))
(assert (= (f1 (f2 3)) 12))
(assert (= (f1 (g2 (- 5))) 33))
(assert (= (f1 (f3 6)) (- 17)))
(assert (= (f1 (g3 3)) 33))
(assert (= (g1 (f3 9)) 162))
(assert (= (f1 (g4 6)) 114))
(assert (= (g1 (f4 (- 5))) 162))
(assert (= (f2 (f1 3)) 12))
(assert (= (f2 (g1 (- 5))) 57))
(assert (= (f2 (f2 6)) 12))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 9)) 72))
(assert (= (f2 (g3 6)) 57))
(assert (= (g2 (f3 (- 5))) 54))
(assert (= (g2 (f4 3)) 72))
(assert (= (f2 (f4 9)) 21))
(assert (= (g2 (g4 9)) 972))
(assert (= (f3 (f1 6)) (- 17)))
(assert (= (f3 (g1 3)) (- 41)))
(assert (= (g3 (f1 9)) 135))
(assert (= (f3 (g2 6)) (- 41)))
(assert (= (g3 (f2 (- 5))) (- 68)))
(assert (= (g3 (f3 3)) (- 68)))
(assert (= (f3 (f3 9)) 18))
(assert (= (g3 (g3 9)) 729))
(assert (= (g3 (f4 6)) 135))
(assert (= (f3 (f4 (- 5))) 18))
(assert (= (g3 (g4 (- 5))) 729))
(assert (= (f4 (g1 6)) 81))
(assert (= (g4 (f1 (- 5))) 189))
(assert (= (g4 (f2 3)) 108))
(assert (= (f4 (f2 9)) 21))
(assert (= (g4 (g2 9)) 972))
(assert (= (g4 (f3 6)) 189))
(assert (= (f4 (f3 (- 5))) 18))
(assert (= (g4 (g3 (- 5))) 729))
(assert (= (f4 (f4 3)) 21))
(assert (= (g4 (g4 3)) 972))
(check-sat)
