(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 4)) 16))
(assert (= (f1 (g1 (- 5))) 60))
(assert (= (f1 (f2 3)) 12))
(assert (= (f1 (g2 4)) 30))
(assert (= (f1 (f3 6)) 16))
(assert (= (f1 (g3 3)) 30))
(assert (= (g1 (f3 (- 5))) 102))
(assert (= (f1 (g4 6)) 60))
(assert (= (g1 (f4 4)) 102))
(assert (= (f2 (f1 3)) 12))
(assert (= (f2 (g1 4)) 51))
(assert (= (f2 (f2 6)) 12))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 5))) 45))
(assert (= (f2 (g3 6)) 51))
(assert (= (g2 (f3 4)) 48))
(assert (= (g2 (f4 3)) 45))
(assert (= (f2 (f4 (- 5))) 12))
(assert (= (g2 (g4 (- 5))) 243))
(assert (= (f3 (f1 6)) 16))
(assert (= (f3 (g1 3)) 40))
(assert (= (g3 (f1 (- 5))) 84))
(assert (= (f3 (g2 6)) 40))
(assert (= (g3 (f2 4)) 56))
(assert (= (g3 (f3 3)) 56))
(assert (= (f3 (f3 (- 5))) (- 13)))
(assert (= (g3 (g3 (- 5))) 288))
(assert (= (g3 (f4 6)) 84))
(assert (= (f3 (f4 4)) (- 13)))
(assert (= (g3 (g4 4)) 288))
(assert (= (f4 (g1 6)) (- 77)))
(assert (= (g4 (f1 4)) 90))
(assert (= (g4 (f2 3)) 54))
(assert (= (f4 (f2 (- 5))) 12))
(assert (= (g4 (g2 (- 5))) 243))
(assert (= (g4 (f3 6)) 90))
(assert (= (f4 (f3 4)) (- 13)))
(assert (= (g4 (g3 4)) 288))
(assert (= (f4 (f4 3)) 12))
(assert (= (g4 (g4 3)) 243))
(check-sat)
