(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 19))
(assert (= (f1 (g1 (- 1))) 12))
(assert (= (f1 (f2 4)) 14))
(assert (= (f1 (g2 7)) 62))
(assert (= (f1 (f3 6)) 19))
(assert (= (f1 (g3 4)) 62))
(assert (= (g1 (f3 (- 1))) 90))
(assert (= (f1 (g4 6)) 12))
(assert (= (g1 (f4 7)) 90))
(assert (= (f2 (f1 4)) 14))
(assert (= (f2 (g1 7)) 88))
(assert (= (f2 (f2 6)) 14))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 1))) 36))
(assert (= (f2 (g3 6)) 88))
(assert (= (g2 (f3 7)) 112))
(assert (= (g2 (f4 4)) 36))
(assert (= (f2 (f4 (- 1))) 5))
(assert (= (g2 (g4 (- 1))) 4))
(assert (= (f3 (f1 6)) 19))
(assert (= (f3 (g1 4)) 55))
(assert (= (g3 (f1 (- 1))) 91))
(assert (= (f3 (g2 6)) 55))
(assert (= (g3 (f2 7)) 154))
(assert (= (g3 (f3 4)) 154))
(assert (= (f3 (f3 (- 1))) (- 15)))
(assert (= (g3 (g3 (- 1))) 98))
(assert (= (g3 (f4 6)) 91))
(assert (= (f3 (f4 7)) (- 15)))
(assert (= (g3 (g4 7)) 98))
(assert (= (f4 (g1 6)) (- 73)))
(assert (= (g4 (f1 7)) 13))
(assert (= (g4 (f2 4)) 8))
(assert (= (f4 (f2 (- 1))) 5))
(assert (= (g4 (g2 (- 1))) 4))
(assert (= (g4 (f3 6)) 13))
(assert (= (f4 (f3 7)) (- 15)))
(assert (= (g4 (g3 7)) 98))
(assert (= (f4 (f4 4)) 5))
(assert (= (g4 (g4 4)) 4))
(check-sat)
