(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (g1 (g1 x)) (g2 (g3 x)))))
(assert (= (f1 (f1 9)) 21))
(assert (= (f1 (g1 (- 4))) 48))
(assert (= (f1 (f2 4)) 14))
(assert (= (f1 (g2 9)) 78))
(assert (= (f1 (f3 6)) 21))
(assert (= (f1 (g3 4)) 78))
(assert (= (g1 (f3 (- 4))) 150))
(assert (= (f1 (g4 6)) 48))
(assert (= (g1 (f4 9)) 150))
(assert (= (f2 (f1 4)) 14))
(assert (= (f2 (g1 9)) 112))
(assert (= (f2 (f2 6)) 14))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 4))) 60))
(assert (= (f2 (g3 6)) 112))
(assert (= (g2 (f3 9)) 144))
(assert (= (g2 (f4 4)) 60))
(assert (= (f2 (f4 (- 4))) 11))
(assert (= (g2 (g4 (- 4))) 196))
(assert (= (f3 (f1 6)) 21))
(assert (= (f3 (g1 4)) 57))
(assert (= (g3 (f1 (- 4))) 171))
(assert (= (f3 (g2 6)) 57))
(assert (= (g3 (f2 9)) 234))
(assert (= (g3 (f3 4)) 234))
(assert (= (f3 (f3 (- 4))) (- 22)))
(assert (= (g3 (g3 (- 4))) 1134))
(assert (= (g3 (f4 6)) 171))
(assert (= (f3 (f4 9)) (- 22)))
(assert (= (g3 (g4 9)) 1134))
(assert (= (f4 (g1 6)) (- 76)))
(assert (= (g4 (f1 9)) 105))
(assert (= (g4 (f2 4)) 56))
(assert (= (f4 (f2 (- 4))) 11))
(assert (= (g4 (g2 (- 4))) 196))
(assert (= (g4 (f3 6)) 105))
(assert (= (f4 (f3 9)) (- 22)))
(assert (= (g4 (g3 9)) 1134))
(assert (= (f4 (f4 4)) 11))
(assert (= (g4 (g4 4)) 196))
(check-sat)
