(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 21)))
(assert (= (f1 (g1 3)) 42))
(assert (= (f1 (f2 5)) 16))
(assert (= (f1 (g2 (- 9))) 91))
(assert (= (f1 (f3 6)) (- 21)))
(assert (= (f1 (g3 5)) 91))
(assert (= (g1 (f3 3)) 138))
(assert (= (f1 (g4 6)) 42))
(assert (= (g1 (f4 (- 9))) 138))
(assert (= (f2 (f1 5)) 16))
(assert (= (f2 (g1 (- 9))) 107))
(assert (= (f2 (f2 6)) 16))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 3)) 80))
(assert (= (f2 (g3 6)) 107))
(assert (= (g2 (f3 (- 9))) 170))
(assert (= (g2 (f4 5)) 80))
(assert (= (f2 (f4 3)) 11))
(assert (= (g2 (g4 3)) 180))
(assert (= (f3 (f1 6)) (- 21)))
(assert (= (f3 (g1 5)) (- 69)))
(assert (= (g3 (f1 3)) 153))
(assert (= (f3 (g2 6)) (- 69)))
(assert (= (g3 (f2 (- 9))) (- 230)))
(assert (= (g3 (f3 5)) (- 230)))
(assert (= (f3 (f3 3)) 20))
(assert (= (g3 (g3 3)) 867))
(assert (= (g3 (f4 6)) 153))
(assert (= (f3 (f4 (- 9))) 20))
(assert (= (g3 (g4 (- 9))) 867))
(assert (= (f4 (g1 6)) 75))
(assert (= (g4 (f1 (- 9))) 87))
(assert (= (g4 (f2 5)) 60))
(assert (= (f4 (f2 3)) 11))
(assert (= (g4 (g2 3)) 180))
(assert (= (g4 (f3 6)) 87))
(assert (= (f4 (f3 (- 9))) 20))
(assert (= (g4 (g3 (- 9))) 867))
(assert (= (f4 (f4 5)) 11))
(assert (= (g4 (g4 5)) 180))
(check-sat)
