(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 18)))
(assert (= (f1 (g1 (- 7))) 84))
(assert (= (f1 (f2 5)) 16))
(assert (= (f1 (g2 (- 6))) 61))
(assert (= (f1 (f3 6)) (- 18)))
(assert (= (f1 (g3 5)) 61))
(assert (= (g1 (f3 (- 7))) 144))
(assert (= (f1 (g4 6)) 84))
(assert (= (g1 (f4 (- 6))) 144))
(assert (= (f2 (f1 5)) 16))
(assert (= (f2 (g1 (- 6))) 71))
(assert (= (f2 (f2 6)) 16))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 7))) 115))
(assert (= (f2 (g3 6)) 71))
(assert (= (g2 (f3 (- 6))) 110))
(assert (= (g2 (f4 5)) 115))
(assert (= (f2 (f4 (- 7))) 18))
(assert (= (g2 (g4 (- 7))) 845))
(assert (= (f3 (f1 6)) (- 18)))
(assert (= (f3 (g1 5)) (- 66)))
(assert (= (g3 (f1 (- 7))) (- 138)))
(assert (= (f3 (g2 6)) (- 66)))
(assert (= (g3 (f2 (- 6))) (- 116)))
(assert (= (g3 (f3 5)) (- 116)))
(assert (= (f3 (f3 (- 7))) (- 18)))
(assert (= (g3 (g3 (- 7))) (- 787)))
(assert (= (g3 (f4 6)) (- 138)))
(assert (= (f3 (f4 (- 6))) (- 18)))
(assert (= (g3 (g4 (- 6))) (- 787)))
(assert (= (f4 (g1 6)) (- 79)))
(assert (= (g4 (f1 (- 6))) (- 150)))
(assert (= (g4 (f2 5)) 130))
(assert (= (f4 (f2 (- 7))) 18))
(assert (= (g4 (g2 (- 7))) 845))
(assert (= (g4 (f3 6)) (- 150)))
(assert (= (f4 (f3 (- 6))) (- 18)))
(assert (= (g4 (g3 (- 6))) (- 787)))
(assert (= (f4 (f4 5)) 18))
(assert (= (g4 (g4 5)) 845))
(check-sat)
