(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 21)))
(assert (= (f1 (g1 (- 6))) 72))
(assert (= (f1 (f2 8)) 22))
(assert (= (f1 (g2 (- 9))) 142))
(assert (= (f1 (f3 6)) (- 21)))
(assert (= (f1 (g3 8)) 142))
(assert (= (g1 (f3 (- 6))) 168))
(assert (= (f1 (g4 6)) 72))
(assert (= (g1 (f4 (- 9))) 168))
(assert (= (f2 (f1 8)) 22))
(assert (= (f2 (g1 (- 9))) 110))
(assert (= (f2 (f2 6)) 22))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 6))) 216))
(assert (= (f2 (g3 6)) 110))
(assert (= (g2 (f3 (- 9))) 272))
(assert (= (g2 (f4 8)) 216))
(assert (= (f2 (f4 (- 6))) 19))
(assert (= (g2 (g4 (- 6))) 968))
(assert (= (f3 (f1 6)) (- 21)))
(assert (= (f3 (g1 8)) (- 105)))
(assert (= (g3 (f1 (- 6))) (- 196)))
(assert (= (f3 (g2 6)) (- 105)))
(assert (= (g3 (f2 (- 9))) (- 281)))
(assert (= (g3 (f3 8)) (- 281)))
(assert (= (f3 (f3 (- 6))) (- 23)))
(assert (= (g3 (g3 (- 6))) (- 1590)))
(assert (= (g3 (f4 6)) (- 196)))
(assert (= (f3 (f4 (- 9))) (- 23)))
(assert (= (g3 (g4 (- 9))) (- 1590)))
(assert (= (f4 (g1 6)) (- 78)))
(assert (= (g4 (f1 (- 9))) (- 160)))
(assert (= (g4 (f2 8)) 176))
(assert (= (f4 (f2 (- 6))) 19))
(assert (= (g4 (g2 (- 6))) 968))
(assert (= (g4 (f3 6)) (- 160)))
(assert (= (f4 (f3 (- 9))) (- 23)))
(assert (= (g4 (g3 (- 9))) (- 1590)))
(assert (= (f4 (f4 8)) 19))
(assert (= (g4 (g4 8)) 968))
(check-sat)
