(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 5))) (- 17)))
(assert (= (f1 (g1 3)) 42))
(assert (= (f1 (f2 9)) 24))
(assert (= (f1 (g2 (- 5))) 87))
(assert (= (f1 (f3 6)) (- 17)))
(assert (= (f1 (g3 9)) 87))
(assert (= (g1 (f3 3)) 90))
(assert (= (f1 (g4 6)) 42))
(assert (= (g1 (f4 (- 5))) 90))
(assert (= (f2 (f1 9)) 24))
(assert (= (f2 (g1 (- 5))) 63))
(assert (= (f2 (f2 6)) 24))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 3)) 216))
(assert (= (f2 (g3 6)) 63))
(assert (= (g2 (f3 (- 5))) 162))
(assert (= (g2 (f4 9)) 216))
(assert (= (f2 (f4 3)) 15))
(assert (= (g2 (g4 3)) 324))
(assert (= (f3 (f1 6)) (- 17)))
(assert (= (f3 (g1 9)) (- 113)))
(assert (= (g3 (f1 3)) 81))
(assert (= (f3 (g2 6)) (- 113)))
(assert (= (g3 (f2 (- 5))) (- 122)))
(assert (= (g3 (f3 9)) (- 122)))
(assert (= (f3 (f3 3)) 12))
(assert (= (g3 (g3 3)) 243))
(assert (= (g3 (f4 6)) 81))
(assert (= (f3 (f4 (- 5))) 12))
(assert (= (g3 (g4 (- 5))) 243))
(assert (= (f4 (g1 6)) 75))
(assert (= (g4 (f1 (- 5))) 63))
(assert (= (g4 (f2 9)) 108))
(assert (= (f4 (f2 3)) 15))
(assert (= (g4 (g2 3)) 324))
(assert (= (g4 (f3 6)) 63))
(assert (= (f4 (f3 (- 5))) 12))
(assert (= (g4 (g3 (- 5))) 243))
(assert (= (f4 (f4 9)) 15))
(assert (= (g4 (g4 9)) 324))
(check-sat)
