(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 3))) (- 15)))
(assert (= (f1 (g1 (- 2))) 24))
(assert (= (f1 (f2 9)) 24))
(assert (= (f1 (g2 (- 3))) 51))
(assert (= (f1 (f3 6)) (- 15)))
(assert (= (f1 (g3 9)) 51))
(assert (= (g1 (f3 (- 2))) 48))
(assert (= (f1 (g4 6)) 24))
(assert (= (g1 (f4 (- 3))) 48))
(assert (= (f2 (f1 9)) 24))
(assert (= (f2 (g1 (- 3))) 39))
(assert (= (f2 (f2 6)) 24))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 2))) 189))
(assert (= (f2 (g3 6)) 39))
(assert (= (g2 (f3 (- 3))) 90))
(assert (= (g2 (f4 9)) 189))
(assert (= (f2 (f4 (- 2))) 12))
(assert (= (g2 (g4 (- 2))) 81))
(assert (= (f3 (f1 6)) (- 15)))
(assert (= (f3 (g1 9)) (- 111)))
(assert (= (g3 (f1 (- 2))) (- 38)))
(assert (= (f3 (g2 6)) (- 111)))
(assert (= (g3 (f2 (- 3))) (- 58)))
(assert (= (g3 (f3 9)) (- 58)))
(assert (= (f3 (f3 (- 2))) (- 7)))
(assert (= (g3 (g3 (- 2))) (- 38)))
(assert (= (g3 (f4 6)) (- 38)))
(assert (= (f3 (f4 (- 3))) (- 7)))
(assert (= (g3 (g4 (- 3))) (- 38)))
(assert (= (f4 (g1 6)) (- 74)))
(assert (= (g4 (f1 (- 3))) (- 26)))
(assert (= (g4 (f2 9)) 54))
(assert (= (f4 (f2 (- 2))) 12))
(assert (= (g4 (g2 (- 2))) 81))
(assert (= (g4 (f3 6)) (- 26)))
(assert (= (f4 (f3 (- 3))) (- 7)))
(assert (= (g4 (g3 (- 3))) (- 38)))
(assert (= (f4 (f4 9)) 12))
(assert (= (g4 (g4 9)) 81))
(check-sat)
