(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 2))) (- 14)))
(assert (= (f1 (g1 (- 8))) 96))
(assert (= (f1 (f2 9)) 24))
(assert (= (f1 (g2 (- 2))) 33))
(assert (= (f1 (f3 6)) (- 14)))
(assert (= (f1 (g3 9)) 33))
(assert (= (g1 (f3 (- 8))) 108))
(assert (= (f1 (g4 6)) 96))
(assert (= (g1 (f4 (- 2))) 108))
(assert (= (f2 (f1 9)) 24))
(assert (= (f2 (g1 (- 2))) 27))
(assert (= (f2 (f2 6)) 24))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 6)) 27))
(assert (= (g2 (f3 (- 2))) 54))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 6)) (- 14)))
(assert (= (f3 (g1 9)) (- 110)))
(assert (= (g3 (f1 (- 8))) (- 41)))
(assert (= (f3 (g2 6)) (- 110)))
(assert (= (g3 (f2 (- 2))) (- 32)))
(assert (= (g3 (f3 9)) (- 32)))
(assert (= (f3 (f3 (- 8))) (- 11)))
(assert (= (g3 (g3 (- 8))) (- 68)))
(assert (= (g3 (f4 6)) (- 41)))
(assert (= (f3 (f4 (- 2))) (- 11)))
(assert (= (g3 (g4 (- 2))) (- 68)))
(assert (= (f4 (g1 6)) (- 80)))
(assert (= (g4 (f1 (- 2))) (- 113)))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 6)) (- 113)))
(assert (= (f4 (f3 (- 2))) (- 11)))
(assert (= (g4 (g3 (- 2))) (- 68)))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
