(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 19))
(assert (= (f1 (g1 (- 9))) 126))
(assert (= (f1 (f2 (- 7))) 20))
(assert (= (f1 (g2 5)) 72))
(assert (= (f1 (f3 7)) 19))
(assert (= (f1 (g3 (- 7))) 72))
(assert (= (g1 (f3 (- 9))) 189))
(assert (= (f1 (g4 7)) 126))
(assert (= (g1 (f4 5)) 189))
(assert (= (f2 (f1 (- 7))) 20))
(assert (= (f2 (g1 5)) (- 77)))
(assert (= (f2 (f2 7)) 20))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 9))) 195))
(assert (= (f2 (g3 7)) (- 77)))
(assert (= (g2 (f3 5)) 130))
(assert (= (g2 (f4 (- 7))) 195))
(assert (= (f2 (f4 (- 9))) (- 24)))
(assert (= (g2 (g4 (- 9))) (- 1879)))
(assert (= (f3 (f1 7)) 19))
(assert (= (f3 (g1 (- 7))) 96))
(assert (= (g3 (f1 (- 9))) 155))
(assert (= (f3 (g2 7)) 96))
(assert (= (g3 (f2 5)) 115))
(assert (= (g3 (f3 (- 7))) 115))
(assert (= (f3 (f3 (- 9))) (- 19)))
(assert (= (g3 (g3 (- 9))) 850))
(assert (= (g3 (f4 7)) 155))
(assert (= (f3 (f4 5)) (- 19)))
(assert (= (g3 (g4 5)) 850))
(assert (= (f4 (g1 7)) (- 107)))
(assert (= (g4 (f1 5)) 204))
(assert (= (g4 (f2 (- 7))) 221))
(assert (= (f4 (f2 (- 9))) (- 24)))
(assert (= (g4 (g2 (- 9))) (- 1879)))
(assert (= (g4 (f3 7)) 204))
(assert (= (f4 (f3 5)) (- 19)))
(assert (= (g4 (g3 5)) 850))
(assert (= (f4 (f4 (- 7))) (- 24)))
(assert (= (g4 (g4 (- 7))) (- 1879)))
(check-sat)
