(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 9)) 23))
(assert (= (f1 (g1 3)) 49))
(assert (= (f1 (f2 (- 6))) 18))
(assert (= (f1 (g2 9)) 106))
(assert (= (f1 (f3 7)) 23))
(assert (= (f1 (g3 (- 6))) 106))
(assert (= (g1 (f3 3)) 168))
(assert (= (f1 (g4 7)) 49))
(assert (= (g1 (f4 9)) 168))
(assert (= (f2 (f1 (- 6))) 18))
(assert (= (f2 (g1 9)) (- 132)))
(assert (= (f2 (f2 7)) 18))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 3)) (- 94)))
(assert (= (f2 (g3 7)) (- 132)))
(assert (= (g2 (f3 9)) 198))
(assert (= (g2 (f4 (- 6))) (- 94)))
(assert (= (f2 (f4 3)) (- 12)))
(assert (= (g2 (g4 3)) 198))
(assert (= (f3 (f1 7)) 23))
(assert (= (f3 (g1 (- 6))) 86))
(assert (= (g3 (f1 3)) 180))
(assert (= (f3 (g2 7)) 86))
(assert (= (g3 (f2 9)) 261))
(assert (= (g3 (f3 (- 6))) 261))
(assert (= (f3 (f3 3)) 21))
(assert (= (g3 (g3 3)) 972))
(assert (= (g3 (f4 7)) 180))
(assert (= (f3 (f4 9)) 21))
(assert (= (g3 (g4 9)) 972))
(assert (= (f4 (g1 7)) 101))
(assert (= (g4 (f1 9)) 96))
(assert (= (g4 (f2 (- 6))) 66))
(assert (= (f4 (f2 3)) (- 12)))
(assert (= (g4 (g2 3)) 198))
(assert (= (g4 (f3 7)) 96))
(assert (= (f4 (f3 9)) 21))
(assert (= (g4 (g3 9)) 972))
(assert (= (f4 (f4 (- 6))) (- 12)))
(assert (= (g4 (g4 (- 6))) 198))
(check-sat)
