(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 22)))
(assert (= (f1 (g1 6)) (- 85)))
(assert (= (f1 (f2 8)) (- 23)))
(assert (= (f1 (g2 (- 9))) (- 143)))
(assert (= (f1 (f3 (- 7))) (- 22)))
(assert (= (f1 (g3 8)) (- 143)))
(assert (= (g1 (f3 6)) (- 189)))
(assert (= (f1 (g4 (- 7))) (- 85)))
(assert (= (g1 (f4 (- 9))) (- 189)))
(assert (= (f2 (f1 8)) (- 23)))
(assert (= (f2 (g1 (- 9))) (- 119)))
(assert (= (f2 (f2 (- 7))) (- 23)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 6)) 224))
(assert (= (f2 (g3 (- 7))) (- 119)))
(assert (= (g2 (f3 (- 9))) 272))
(assert (= (g2 (f4 8)) 224))
(assert (= (f2 (f4 6)) 20))
(assert (= (g2 (g4 6)) 1152))
(assert (= (f3 (f1 (- 7))) (- 22)))
(assert (= (f3 (g1 8)) (- 113)))
(assert (= (g3 (f1 6)) (- 213)))
(assert (= (f3 (g2 (- 7))) (- 113)))
(assert (= (g3 (f2 (- 9))) (- 281)))
(assert (= (g3 (f3 8)) (- 281)))
(assert (= (f3 (f3 6)) 23))
(assert (= (g3 (g3 6)) 1734))
(assert (= (g3 (f4 (- 7))) (- 213)))
(assert (= (f3 (f4 (- 9))) 23))
(assert (= (g3 (g4 (- 9))) 1734))
(assert (= (f4 (g1 (- 7))) (- 91)))
(assert (= (g4 (f1 (- 9))) 180))
(assert (= (g4 (f2 8)) 192))
(assert (= (f4 (f2 6)) 20))
(assert (= (g4 (g2 6)) 1152))
(assert (= (g4 (f3 (- 7))) 180))
(assert (= (f4 (f3 (- 9))) 23))
(assert (= (g4 (g3 (- 9))) 1734))
(assert (= (f4 (f4 8)) 20))
(assert (= (g4 (g4 8)) 1152))
(check-sat)
