(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 16)))
(assert (= (f1 (g1 (- 6))) 84))
(assert (= (f1 (f2 (- 3))) 12))
(assert (= (f1 (g2 (- 2))) (- 15)))
(assert (= (f1 (f3 7)) (- 16)))
(assert (= (f1 (g3 (- 3))) (- 15)))
(assert (= (g1 (f3 (- 6))) 98))
(assert (= (f1 (g4 7)) 84))
(assert (= (g1 (f4 (- 2))) 98))
(assert (= (f2 (f1 (- 3))) 12))
(assert (= (f2 (g1 (- 2))) (- 24)))
(assert (= (f2 (f2 7)) 12))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 6))) 40))
(assert (= (f2 (g3 7)) (- 24)))
(assert (= (g2 (f3 (- 2))) 15))
(assert (= (g2 (f4 (- 3))) 40))
(assert (= (f2 (f4 (- 6))) (- 14)))
(assert (= (g2 (g4 (- 6))) (- 303)))
(assert (= (f3 (f1 7)) (- 16)))
(assert (= (f3 (g1 (- 3))) (- 37)))
(assert (= (g3 (f1 (- 6))) (- 38)))
(assert (= (f3 (g2 7)) (- 37)))
(assert (= (g3 (f2 (- 2))) 12))
(assert (= (g3 (f3 (- 3))) 12))
(assert (= (f3 (f3 (- 6))) (- 9)))
(assert (= (g3 (g3 (- 6))) (- 50)))
(assert (= (g3 (f4 7)) (- 38)))
(assert (= (f3 (f4 (- 2))) (- 9)))
(assert (= (g3 (g4 (- 2))) (- 50)))
(assert (= (f4 (g1 7)) (- 104)))
(assert (= (g4 (f1 (- 2))) (- 94)))
(assert (= (g4 (f2 (- 3))) 55))
(assert (= (f4 (f2 (- 6))) (- 14)))
(assert (= (g4 (g2 (- 6))) (- 303)))
(assert (= (g4 (f3 7)) (- 94)))
(assert (= (f4 (f3 (- 2))) (- 9)))
(assert (= (g4 (g3 (- 2))) (- 50)))
(assert (= (f4 (f4 (- 3))) (- 14)))
(assert (= (g4 (g4 (- 3))) (- 303)))
(check-sat)
