(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 17))
(assert (= (f1 (g1 (- 7))) 98))
(assert (= (f1 (f2 (- 3))) 12))
(assert (= (f1 (g2 3)) 22))
(assert (= (f1 (f3 7)) 17))
(assert (= (f1 (g3 (- 3))) 22))
(assert (= (g1 (f3 (- 7))) 133))
(assert (= (f1 (g4 7)) 98))
(assert (= (g1 (f4 3)) 133))
(assert (= (f2 (f1 (- 3))) 12))
(assert (= (f2 (g1 3)) (- 45)))
(assert (= (f2 (f2 7)) 12))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 7))) 45))
(assert (= (f2 (g3 7)) (- 45)))
(assert (= (g2 (f3 3)) 30))
(assert (= (g2 (f4 (- 3))) 45))
(assert (= (f2 (f4 (- 7))) (- 16)))
(assert (= (g2 (g4 (- 7))) (- 423)))
(assert (= (f3 (f1 7)) 17))
(assert (= (f3 (g1 (- 3))) 38))
(assert (= (g3 (f1 (- 7))) 81))
(assert (= (f3 (g2 7)) 38))
(assert (= (g3 (f2 3)) 33))
(assert (= (g3 (f3 (- 3))) 33))
(assert (= (f3 (f3 (- 7))) (- 13)))
(assert (= (g3 (g3 (- 7))) 234))
(assert (= (g3 (f4 7)) 81))
(assert (= (f3 (f4 3)) (- 13)))
(assert (= (g3 (g4 3)) 234))
(assert (= (f4 (g1 7)) (- 105)))
(assert (= (g4 (f1 3)) 130))
(assert (= (g4 (f2 (- 3))) 65))
(assert (= (f4 (f2 (- 7))) (- 16)))
(assert (= (g4 (g2 (- 7))) (- 423)))
(assert (= (g4 (f3 7)) 130))
(assert (= (f4 (f3 3)) (- 13)))
(assert (= (g4 (g3 3)) 234))
(assert (= (f4 (f4 (- 3))) (- 16)))
(assert (= (g4 (g4 (- 3))) (- 423)))
(check-sat)
