(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 19))
(assert (= (f1 (g1 3)) 49))
(assert (= (f1 (f2 (- 2))) 10))
(assert (= (f1 (g2 5)) 22))
(assert (= (f1 (f3 7)) 19))
(assert (= (f1 (g3 (- 2))) 22))
(assert (= (g1 (f3 3)) 112))
(assert (= (f1 (g4 7)) 49))
(assert (= (g1 (f4 5)) 112))
(assert (= (f2 (f1 (- 2))) 10))
(assert (= (f2 (g1 5)) (- 72)))
(assert (= (f2 (f2 7)) 10))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 3)) (- 14)))
(assert (= (f2 (g3 7)) (- 72)))
(assert (= (g2 (f3 5)) 30))
(assert (= (g2 (f4 (- 2))) (- 14)))
(assert (= (f2 (f4 3)) (- 8)))
(assert (= (g2 (g4 3)) 54))
(assert (= (f3 (f1 7)) 19))
(assert (= (f3 (g1 (- 2))) 26))
(assert (= (g3 (f1 3)) 100))
(assert (= (f3 (g2 7)) 26))
(assert (= (g3 (f2 5)) 65))
(assert (= (g3 (f3 (- 2))) 65))
(assert (= (f3 (f3 3)) 13))
(assert (= (g3 (g3 3)) 300))
(assert (= (g3 (f4 7)) 100))
(assert (= (f3 (f4 5)) 13))
(assert (= (g3 (g4 5)) 300))
(assert (= (f4 (g1 7)) 101))
(assert (= (g4 (f1 5)) 72))
(assert (= (g4 (f2 (- 2))) 18))
(assert (= (f4 (f2 3)) (- 8)))
(assert (= (g4 (g2 3)) 54))
(assert (= (g4 (f3 7)) 72))
(assert (= (f4 (f3 5)) 13))
(assert (= (g4 (g3 5)) 300))
(assert (= (f4 (f4 (- 2))) (- 8)))
(assert (= (g4 (g4 (- 2))) 54))
(check-sat)
