(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 19)))
(assert (= (f1 (g1 (- 3))) 42))
(assert (= (f1 (f2 1)) 9))
(assert (= (f1 (g2 (- 5))) 16))
(assert (= (f1 (f3 7)) (- 19)))
(assert (= (f1 (g3 1)) 16))
(assert (= (g1 (f3 (- 3))) 98))
(assert (= (f1 (g4 7)) 42))
(assert (= (g1 (f4 (- 5))) 98))
(assert (= (f2 (f1 1)) 9))
(assert (= (f2 (g1 (- 5))) 64))
(assert (= (f2 (f2 7)) 9))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 3))) 7))
(assert (= (f2 (g3 7)) 64))
(assert (= (g2 (f3 (- 5))) 18))
(assert (= (g2 (f4 1)) 7))
(assert (= (f2 (f4 (- 3))) 6))
(assert (= (g2 (g4 (- 3))) 25))
(assert (= (f3 (f1 7)) (- 19)))
(assert (= (f3 (g1 1)) (- 19)))
(assert (= (g3 (f1 (- 3))) (- 86)))
(assert (= (f3 (g2 7)) (- 19)))
(assert (= (g3 (f2 (- 5))) (- 50)))
(assert (= (g3 (f3 1)) (- 50)))
(assert (= (f3 (f3 (- 3))) (- 12)))
(assert (= (g3 (g3 (- 3))) (- 203)))
(assert (= (g3 (f4 7)) (- 86)))
(assert (= (f3 (f4 (- 5))) (- 12)))
(assert (= (g3 (g4 (- 5))) (- 203)))
(assert (= (f4 (g1 7)) (- 101)))
(assert (= (g4 (f1 (- 5))) (- 58)))
(assert (= (g4 (f2 1)) 10))
(assert (= (f4 (f2 (- 3))) 6))
(assert (= (g4 (g2 (- 3))) 25))
(assert (= (g4 (f3 7)) (- 58)))
(assert (= (f4 (f3 (- 5))) (- 12)))
(assert (= (g4 (g3 (- 5))) (- 203)))
(assert (= (f4 (f4 1)) 6))
(assert (= (g4 (g4 1)) 25))
(check-sat)
