(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 22)))
(assert (= (f1 (g1 7)) (- 98)))
(assert (= (f1 (f2 9)) (- 25)))
(assert (= (f1 (g2 (- 9))) (- 160)))
(assert (= (f1 (f3 (- 7))) (- 22)))
(assert (= (f1 (g3 9)) (- 160)))
(assert (= (g1 (f3 7)) (- 202)))
(assert (= (f1 (g4 (- 7))) (- 98)))
(assert (= (g1 (f4 (- 9))) (- 202)))
(assert (= (f2 (f1 9)) (- 25)))
(assert (= (f2 (g1 (- 9))) (- 120)))
(assert (= (f2 (f2 (- 7))) (- 25)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 7)) 288))
(assert (= (f2 (g3 (- 7))) (- 120)))
(assert (= (g2 (f3 (- 9))) 306))
(assert (= (g2 (f4 9)) 288))
(assert (= (f2 (f4 7)) 23))
(assert (= (g2 (g4 7)) 1764))
(assert (= (f3 (f1 (- 7))) (- 22)))
(assert (= (f3 (g1 9)) (- 126)))
(assert (= (g3 (f1 7)) (- 230)))
(assert (= (f3 (g2 (- 7))) (- 126)))
(assert (= (g3 (f2 (- 9))) (- 298)))
(assert (= (g3 (f3 9)) (- 298)))
(assert (= (f3 (f3 7)) 24))
(assert (= (g3 (g3 7)) 2023))
(assert (= (g3 (f4 (- 7))) (- 230)))
(assert (= (f3 (f4 (- 9))) 24))
(assert (= (g3 (g4 (- 9))) 2023))
(assert (= (f4 (g1 (- 7))) (- 92)))
(assert (= (g4 (f1 (- 9))) 210))
(assert (= (g4 (f2 9)) 252))
(assert (= (f4 (f2 7)) 23))
(assert (= (g4 (g2 7)) 1764))
(assert (= (g4 (f3 (- 7))) 210))
(assert (= (f4 (f3 (- 9))) 24))
(assert (= (g4 (g3 (- 9))) 2023))
(assert (= (f4 (f4 9)) 23))
(assert (= (g4 (g4 9)) 1764))
(check-sat)
