(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 16)))
(assert (= (f1 (g1 (- 9))) 126))
(assert (= (f1 (f2 3)) 13))
(assert (= (f1 (g2 (- 2))) 16))
(assert (= (f1 (f3 7)) (- 16)))
(assert (= (f1 (g3 3)) 16))
(assert (= (g1 (f3 (- 9))) 140))
(assert (= (f1 (g4 7)) 126))
(assert (= (g1 (f4 (- 2))) 140))
(assert (= (f2 (f1 3)) 13))
(assert (= (f2 (g1 (- 2))) 24))
(assert (= (f2 (f2 7)) 13))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 9))) 69))
(assert (= (f2 (g3 7)) 24))
(assert (= (g2 (f3 (- 2))) 18))
(assert (= (g2 (f4 3)) 69))
(assert (= (f2 (f4 (- 9))) 20))
(assert (= (g2 (g4 (- 9))) 867))
(assert (= (f3 (f1 7)) (- 16)))
(assert (= (f3 (g1 3)) (- 44)))
(assert (= (g3 (f1 (- 9))) (- 47)))
(assert (= (f3 (g2 7)) (- 44)))
(assert (= (g3 (f2 (- 2))) (- 14)))
(assert (= (g3 (f3 3)) (- 14)))
(assert (= (f3 (f3 (- 9))) (- 12)))
(assert (= (g3 (g3 (- 9))) (- 77)))
(assert (= (g3 (f4 7)) (- 47)))
(assert (= (f3 (f4 (- 2))) (- 12)))
(assert (= (g3 (g4 (- 2))) (- 77)))
(assert (= (f4 (g1 7)) (- 107)))
(assert (= (g4 (f1 (- 2))) (- 145)))
(assert (= (g4 (f2 3)) 102))
(assert (= (f4 (f2 (- 9))) 20))
(assert (= (g4 (g2 (- 9))) 867))
(assert (= (g4 (f3 7)) (- 145)))
(assert (= (f4 (f3 (- 2))) (- 12)))
(assert (= (g4 (g3 (- 2))) (- 77)))
(assert (= (f4 (f4 3)) 20))
(assert (= (g4 (g4 3)) 867))
(check-sat)
