(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 21)))
(assert (= (f1 (g1 2)) 35))
(assert (= (f1 (f2 6)) 19))
(assert (= (f1 (g2 (- 7))) 85))
(assert (= (f1 (f3 7)) (- 21)))
(assert (= (f1 (g3 6)) 85))
(assert (= (g1 (f3 2)) 119))
(assert (= (f1 (g4 7)) 35))
(assert (= (g1 (f4 (- 7))) 119))
(assert (= (f2 (f1 6)) 19))
(assert (= (f2 (g1 (- 7))) 97))
(assert (= (f2 (f2 7)) 19))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 2)) 96))
(assert (= (f2 (g3 7)) 97))
(assert (= (g2 (f3 (- 7))) 156))
(assert (= (g2 (f4 6)) 96))
(assert (= (f2 (f4 2)) 10))
(assert (= (g2 (g4 2)) 96))
(assert (= (f3 (f1 7)) (- 21)))
(assert (= (f3 (g1 6)) (- 91)))
(assert (= (g3 (f1 2)) 117))
(assert (= (f3 (g2 7)) (- 91)))
(assert (= (g3 (f2 (- 7))) (- 163)))
(assert (= (g3 (f3 6)) (- 163)))
(assert (= (f3 (f3 2)) 15))
(assert (= (g3 (g3 2)) 338))
(assert (= (g3 (f4 7)) 117))
(assert (= (f3 (f4 (- 7))) 15))
(assert (= (g3 (g4 (- 7))) 338))
(assert (= (f4 (g1 7)) 100))
(assert (= (g4 (f1 (- 7))) 54))
(assert (= (g4 (f2 6)) 48))
(assert (= (f4 (f2 2)) 10))
(assert (= (g4 (g2 2)) 96))
(assert (= (g4 (f3 7)) 54))
(assert (= (f4 (f3 (- 7))) 15))
(assert (= (g4 (g3 (- 7))) 338))
(assert (= (f4 (f4 6)) 10))
(assert (= (g4 (g4 6)) 96))
(check-sat)
