(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 21)))
(assert (= (f1 (g1 (- 9))) 126))
(assert (= (f1 (f2 8)) 23))
(assert (= (f1 (g2 (- 7))) 111))
(assert (= (f1 (f3 7)) (- 21)))
(assert (= (f1 (g3 8)) 111))
(assert (= (g1 (f3 (- 9))) 210))
(assert (= (f1 (g4 7)) 126))
(assert (= (g1 (f4 (- 7))) 210))
(assert (= (f2 (f1 8)) 23))
(assert (= (f2 (g1 (- 7))) 99))
(assert (= (f2 (f2 7)) 23))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 9))) 264))
(assert (= (f2 (g3 7)) 99))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 264))
(assert (= (f2 (f4 (- 9))) 25))
(assert (= (g2 (g4 (- 9))) 2312))
(assert (= (f3 (f1 7)) (- 21)))
(assert (= (f3 (g1 8)) (- 119)))
(assert (= (g3 (f1 (- 9))) (- 202)))
(assert (= (f3 (g2 7)) (- 119)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 (- 9))) (- 22)))
(assert (= (g3 (g3 (- 9))) (- 1437)))
(assert (= (g3 (f4 7)) (- 202)))
(assert (= (f3 (f4 (- 7))) (- 22)))
(assert (= (g3 (g4 (- 7))) (- 1437)))
(assert (= (f4 (g1 7)) (- 107)))
(assert (= (g4 (f1 (- 7))) (- 230)))
(assert (= (g4 (f2 8)) 272))
(assert (= (f4 (f2 (- 9))) 25))
(assert (= (g4 (g2 (- 9))) 2312))
(assert (= (g4 (f3 7)) (- 230)))
(assert (= (f4 (f3 (- 7))) (- 22)))
(assert (= (g4 (g3 (- 7))) (- 1437)))
(assert (= (f4 (f4 8)) 25))
(assert (= (g4 (g4 8)) 2312))
(check-sat)
