(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 5)) 19))
(assert (= (f1 (g1 (- 6))) 84))
(assert (= (f1 (f2 9)) 25))
(assert (= (f1 (g2 5)) 97))
(assert (= (f1 (f3 7)) 19))
(assert (= (f1 (g3 9)) 97))
(assert (= (g1 (f3 (- 6))) 147))
(assert (= (f1 (g4 7)) 84))
(assert (= (g1 (f4 5)) 147))
(assert (= (f2 (f1 9)) 25))
(assert (= (f2 (g1 5)) 79))
(assert (= (f2 (f2 7)) 25))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 6))) 261))
(assert (= (f2 (g3 7)) 79))
(assert (= (g2 (f3 5)) 180))
(assert (= (g2 (f4 9)) 261))
(assert (= (f2 (f4 (- 6))) 20))
(assert (= (g2 (g4 (- 6))) 1089))
(assert (= (f3 (f1 7)) 19))
(assert (= (f3 (g1 9)) 131))
(assert (= (g3 (f1 (- 6))) 125))
(assert (= (f3 (g2 7)) 131))
(assert (= (g3 (f2 5)) 140))
(assert (= (g3 (f3 9)) 140))
(assert (= (f3 (f3 (- 6))) (- 16)))
(assert (= (g3 (g3 (- 6))) 550))
(assert (= (g3 (f4 7)) 125))
(assert (= (f3 (f4 5)) (- 16)))
(assert (= (g3 (g4 5)) 550))
(assert (= (f4 (g1 7)) (- 104)))
(assert (= (g4 (f1 5)) 132))
(assert (= (g4 (f2 9)) 198))
(assert (= (f4 (f2 (- 6))) 20))
(assert (= (g4 (g2 (- 6))) 1089))
(assert (= (g4 (f3 7)) 132))
(assert (= (f4 (f3 5)) (- 16)))
(assert (= (g4 (g3 5)) 550))
(assert (= (f4 (f4 9)) 20))
(assert (= (g4 (g4 9)) 1089))
(check-sat)
