(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 22))
(assert (= (f1 (g1 (- 8))) 112))
(assert (= (f1 (f2 9)) 25))
(assert (= (f1 (g2 8)) 151))
(assert (= (f1 (f3 7)) 22))
(assert (= (f1 (g3 9)) 151))
(assert (= (g1 (f3 (- 8))) 217))
(assert (= (f1 (g4 7)) 112))
(assert (= (g1 (f4 8)) 217))
(assert (= (f2 (f1 9)) 25))
(assert (= (f2 (g1 8)) 121))
(assert (= (f2 (f2 7)) 25))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 7)) 121))
(assert (= (g2 (f3 8)) 288))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 7)) 22))
(assert (= (f3 (g1 9)) 134))
(assert (= (g3 (f1 (- 8))) 232))
(assert (= (f3 (g2 7)) 134))
(assert (= (g3 (f2 8)) 272))
(assert (= (g3 (f3 9)) 272))
(assert (= (f3 (f3 (- 8))) (- 24)))
(assert (= (g3 (g3 (- 8))) 1920))
(assert (= (g3 (f4 7)) 232))
(assert (= (f3 (f4 8)) (- 24)))
(assert (= (g3 (g4 8)) 1920))
(assert (= (f4 (g1 7)) (- 106)))
(assert (= (g4 (f1 8)) 225))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 7)) 225))
(assert (= (f4 (f3 8)) (- 24)))
(assert (= (g4 (g3 8)) 1920))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
