(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 8))) (- 24)))
(assert (= (f1 (g1 (- 2))) 32))
(assert (= (f1 (f2 (- 9))) 25))
(assert (= (f1 (g2 (- 8))) (- 136)))
(assert (= (f1 (f3 8)) (- 24)))
(assert (= (f1 (g3 (- 9))) (- 136)))
(assert (= (g1 (f3 (- 2))) 144))
(assert (= (f1 (g4 8)) 32))
(assert (= (g1 (f4 (- 8))) 144))
(assert (= (f2 (f1 (- 9))) 25))
(assert (= (f2 (g1 (- 8))) (- 129)))
(assert (= (f2 (f2 8)) 25))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 2))) 170))
(assert (= (f2 (g3 8)) (- 129)))
(assert (= (g2 (f3 (- 8))) 255))
(assert (= (g2 (f4 (- 9))) 170))
(assert (= (f2 (f4 (- 2))) (- 12)))
(assert (= (g2 (g4 (- 2))) (- 77)))
(assert (= (f3 (f1 8)) (- 24)))
(assert (= (f3 (g1 (- 9))) (- 144)))
(assert (= (g3 (f1 (- 2))) (- 143)))
(assert (= (f3 (g2 8)) (- 144)))
(assert (= (g3 (f2 (- 8))) 240))
(assert (= (g3 (f3 (- 9))) 240))
(assert (= (f3 (f3 (- 2))) (- 17)))
(assert (= (g3 (g3 (- 2))) (- 338)))
(assert (= (g3 (f4 8)) (- 143)))
(assert (= (f3 (f4 (- 8))) (- 17)))
(assert (= (g3 (g4 (- 8))) (- 338)))
(assert (= (f4 (g1 8)) (- 130)))
(assert (= (g4 (f1 (- 8))) (- 47)))
(assert (= (g4 (f2 (- 9))) 51))
(assert (= (f4 (f2 (- 2))) (- 12)))
(assert (= (g4 (g2 (- 2))) (- 77)))
(assert (= (g4 (f3 8)) (- 47)))
(assert (= (f4 (f3 (- 8))) (- 17)))
(assert (= (g4 (g3 (- 8))) (- 338)))
(assert (= (f4 (f4 (- 9))) (- 12)))
(assert (= (g4 (g4 (- 9))) (- 77)))
(check-sat)
