(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 9)) 25))
(assert (= (f1 (g1 (- 4))) 64))
(assert (= (f1 (f2 (- 5))) 17))
(assert (= (f1 (g2 9)) 89))
(assert (= (f1 (f3 8)) 25))
(assert (= (f1 (g3 (- 5))) 89))
(assert (= (g1 (f3 (- 4))) 200))
(assert (= (f1 (g4 8)) 64))
(assert (= (g1 (f4 9)) 200))
(assert (= (f2 (f1 (- 5))) 17))
(assert (= (f2 (g1 9)) (- 149)))
(assert (= (f2 (f2 8)) 17))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 4))) 72))
(assert (= (f2 (g3 8)) (- 149)))
(assert (= (g2 (f3 9)) 162))
(assert (= (g2 (f4 (- 5))) 72))
(assert (= (f2 (f4 (- 4))) (- 12)))
(assert (= (g2 (g4 (- 4))) (- 221)))
(assert (= (f3 (f1 8)) 25))
(assert (= (f3 (g1 (- 5))) 81))
(assert (= (g3 (f1 (- 4))) 207))
(assert (= (f3 (g2 8)) 81))
(assert (= (g3 (f2 9)) 243))
(assert (= (g3 (f3 (- 5))) 243))
(assert (= (f3 (f3 (- 4))) (- 22)))
(assert (= (g3 (g3 (- 4))) 1134))
(assert (= (g3 (f4 8)) 207))
(assert (= (f3 (f4 9)) (- 22)))
(assert (= (g3 (g4 9)) 1134))
(assert (= (f4 (g1 8)) (- 132)))
(assert (= (g4 (f1 9)) 119))
(assert (= (g4 (f2 (- 5))) 63))
(assert (= (f4 (f2 (- 4))) (- 12)))
(assert (= (g4 (g2 (- 4))) (- 221)))
(assert (= (g4 (f3 8)) 119))
(assert (= (f4 (f3 9)) (- 22)))
(assert (= (g4 (g3 9)) 1134))
(assert (= (f4 (f4 (- 5))) (- 12)))
(assert (= (g4 (g4 (- 5))) (- 221)))
(check-sat)
