(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 24)))
(assert (= (f1 (g1 3)) 56))
(assert (= (f1 (f2 (- 3))) 13))
(assert (= (f1 (g2 (- 8))) (- 46)))
(assert (= (f1 (f3 8)) (- 24)))
(assert (= (f1 (g3 (- 3))) (- 46)))
(assert (= (g1 (f3 3)) 168))
(assert (= (f1 (g4 8)) 56))
(assert (= (g1 (f4 (- 8))) 168))
(assert (= (f2 (f1 (- 3))) 13))
(assert (= (f2 (g1 (- 8))) (- 123)))
(assert (= (f2 (f2 8)) 13))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 3)) (- 28)))
(assert (= (f2 (g3 8)) (- 123)))
(assert (= (g2 (f3 (- 8))) 75))
(assert (= (g2 (f4 (- 3))) (- 28)))
(assert (= (f2 (f4 3)) (- 9)))
(assert (= (g2 (g4 3)) 90))
(assert (= (f3 (f1 8)) (- 24)))
(assert (= (f3 (g1 (- 3))) (- 48)))
(assert (= (g3 (f1 3)) 165))
(assert (= (f3 (g2 8)) (- 48)))
(assert (= (g3 (f2 (- 8))) 150))
(assert (= (g3 (f3 (- 3))) 150))
(assert (= (f3 (f3 3)) 18))
(assert (= (g3 (g3 3)) 675))
(assert (= (g3 (f4 8)) 165))
(assert (= (f3 (f4 (- 8))) 18))
(assert (= (g3 (g4 (- 8))) 675))
(assert (= (f4 (g1 8)) 131))
(assert (= (g4 (f1 (- 8))) 93))
(assert (= (g4 (f2 (- 3))) 30))
(assert (= (f4 (f2 3)) (- 9)))
(assert (= (g4 (g2 3)) 90))
(assert (= (g4 (f3 8)) 93))
(assert (= (f4 (f3 (- 8))) 18))
(assert (= (g4 (g3 (- 8))) 675))
(assert (= (f4 (f4 (- 3))) (- 9)))
(assert (= (g4 (g4 (- 3))) 90))
(check-sat)
