(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 20)))
(assert (= (f1 (g1 6)) 104))
(assert (= (f1 (f2 (- 2))) 11))
(assert (= (f1 (g2 (- 4))) (- 19)))
(assert (= (f1 (f3 8)) (- 20)))
(assert (= (f1 (g3 (- 2))) (- 19)))
(assert (= (g1 (f3 6)) 152))
(assert (= (f1 (g4 8)) 104))
(assert (= (g1 (f4 (- 4))) 152))
(assert (= (f2 (f1 (- 2))) 11))
(assert (= (f2 (g1 (- 4))) (- 58)))
(assert (= (f2 (f2 8)) 11))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 6)) (- 23)))
(assert (= (f2 (g3 8)) (- 58)))
(assert (= (g2 (f3 (- 4))) 21))
(assert (= (g2 (f4 (- 2))) (- 23)))
(assert (= (f2 (f4 6)) (- 14)))
(assert (= (g2 (g4 6)) 216))
(assert (= (f3 (f1 8)) (- 20)))
(assert (= (f3 (g1 (- 2))) (- 28)))
(assert (= (g3 (f1 6)) 98))
(assert (= (f3 (g2 8)) (- 28)))
(assert (= (g3 (f2 (- 4))) 35))
(assert (= (g3 (f3 (- 2))) 35))
(assert (= (f3 (f3 6)) 13))
(assert (= (g3 (g3 6)) 294))
(assert (= (g3 (f4 8)) 98))
(assert (= (f3 (f4 (- 4))) 13))
(assert (= (g3 (g4 (- 4))) 294))
(assert (= (f4 (g1 8)) 134))
(assert (= (g4 (f1 (- 4))) 138))
(assert (= (g4 (f2 (- 2))) 36))
(assert (= (f4 (f2 6)) (- 14)))
(assert (= (g4 (g2 6)) 216))
(assert (= (g4 (f3 8)) 138))
(assert (= (f4 (f3 (- 4))) 13))
(assert (= (g4 (g3 (- 4))) 294))
(assert (= (f4 (f4 (- 2))) (- 14)))
(assert (= (g4 (g4 (- 2))) 216))
(check-sat)
