(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 21))
(assert (= (f1 (g1 (- 5))) 80))
(assert (= (f1 (f2 (- 2))) 11))
(assert (= (f1 (g2 5)) 23))
(assert (= (f1 (f3 8)) 21))
(assert (= (f1 (g3 (- 2))) 23))
(assert (= (g1 (f3 (- 5))) 152))
(assert (= (f1 (g4 8)) 80))
(assert (= (g1 (f4 5)) 152))
(assert (= (f2 (f1 (- 2))) 11))
(assert (= (f2 (g1 5)) (- 82)))
(assert (= (f2 (f2 8)) 11))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 5))) 18))
(assert (= (f2 (g3 8)) (- 82)))
(assert (= (g2 (f3 5)) 30))
(assert (= (g2 (f4 (- 2))) 18))
(assert (= (f2 (f4 (- 5))) (- 11)))
(assert (= (g2 (g4 (- 5))) (- 122)))
(assert (= (f3 (f1 8)) 21))
(assert (= (f3 (g1 (- 2))) 29))
(assert (= (g3 (f1 (- 5))) 125))
(assert (= (f3 (g2 8)) 29))
(assert (= (g3 (f2 5)) 65))
(assert (= (g3 (f3 (- 2))) 65))
(assert (= (f3 (f3 (- 5))) (- 15)))
(assert (= (g3 (g3 (- 5))) 450))
(assert (= (g3 (f4 8)) 125))
(assert (= (f3 (f4 5)) (- 15)))
(assert (= (g3 (g4 5)) 450))
(assert (= (f4 (g1 8)) (- 133)))
(assert (= (g4 (f1 5)) 117))
(assert (= (g4 (f2 (- 2))) 27))
(assert (= (f4 (f2 (- 5))) (- 11)))
(assert (= (g4 (g2 (- 5))) (- 122)))
(assert (= (g4 (f3 8)) 117))
(assert (= (f4 (f3 5)) (- 15)))
(assert (= (g4 (g3 5)) 450))
(assert (= (f4 (f4 (- 2))) (- 11)))
(assert (= (g4 (g4 (- 2))) (- 122)))
(check-sat)
