(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 2)) 18))
(assert (= (f1 (g1 4)) 72))
(assert (= (f1 (f2 1)) 10))
(assert (= (f1 (g2 2)) 12))
(assert (= (f1 (f3 8)) 18))
(assert (= (f1 (g3 1)) 12))
(assert (= (g1 (f3 4)) 96))
(assert (= (f1 (g4 8)) 72))
(assert (= (g1 (f4 2)) 96))
(assert (= (f2 (f1 1)) 10))
(assert (= (f2 (g1 2)) 33))
(assert (= (f2 (f2 8)) 10))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 4)) 10))
(assert (= (f2 (g3 8)) 33))
(assert (= (g2 (f3 2)) 8))
(assert (= (g2 (f4 1)) 10))
(assert (= (f2 (f4 4)) 9))
(assert (= (g2 (g4 4)) 64))
(assert (= (f3 (f1 8)) 18))
(assert (= (f3 (g1 1)) 18))
(assert (= (g3 (f1 4)) 48))
(assert (= (f3 (g2 8)) 18))
(assert (= (g3 (f2 2)) 12))
(assert (= (g3 (f3 1)) 12))
(assert (= (f3 (f3 4)) 8))
(assert (= (g3 (g3 4)) 64))
(assert (= (g3 (f4 8)) 48))
(assert (= (f3 (f4 2)) 8))
(assert (= (g3 (g4 2)) 64))
(assert (= (f4 (g1 8)) 132))
(assert (= (g4 (f1 2)) 80))
(assert (= (g4 (f2 1)) 16))
(assert (= (f4 (f2 4)) 9))
(assert (= (g4 (g2 4)) 64))
(assert (= (g4 (f3 8)) 80))
(assert (= (f4 (f3 2)) 8))
(assert (= (g4 (g3 2)) 64))
(assert (= (f4 (f4 1)) 9))
(assert (= (g4 (g4 1)) 64))
(check-sat)
