(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 21))
(assert (= (f1 (g1 (- 9))) 144))
(assert (= (f1 (f2 2)) 12))
(assert (= (f1 (g2 5)) 28))
(assert (= (f1 (f3 8)) 21))
(assert (= (f1 (g3 2)) 28))
(assert (= (g1 (f3 (- 9))) 216))
(assert (= (f1 (g4 8)) 144))
(assert (= (g1 (f4 5)) 216))
(assert (= (f2 (f1 2)) 12))
(assert (= (f2 (g1 5)) 82))
(assert (= (f2 (f2 8)) 12))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 9))) 42))
(assert (= (f2 (g3 8)) 82))
(assert (= (g2 (f3 5)) 40))
(assert (= (g2 (f4 2)) 42))
(assert (= (f2 (f4 (- 9))) 19))
(assert (= (g2 (g4 (- 9))) 578))
(assert (= (f3 (f1 8)) 21))
(assert (= (f3 (g1 2)) 37))
(assert (= (g3 (f1 (- 9))) 165))
(assert (= (f3 (g2 8)) 37))
(assert (= (g3 (f2 5)) 70))
(assert (= (g3 (f3 2)) 70))
(assert (= (f3 (f3 (- 9))) (- 19)))
(assert (= (g3 (g3 (- 9))) 850))
(assert (= (g3 (f4 8)) 165))
(assert (= (f3 (f4 5)) (- 19)))
(assert (= (g3 (g4 5)) 850))
(assert (= (f4 (g1 8)) (- 137)))
(assert (= (g4 (f1 5)) 221))
(assert (= (g4 (f2 2)) 68))
(assert (= (f4 (f2 (- 9))) 19))
(assert (= (g4 (g2 (- 9))) 578))
(assert (= (g4 (f3 8)) 221))
(assert (= (f4 (f3 5)) (- 19)))
(assert (= (g4 (g3 5)) 850))
(assert (= (f4 (f4 2)) 19))
(assert (= (g4 (g4 2)) 578))
(check-sat)
