(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 21)))
(assert (= (f1 (g1 (- 7))) 112))
(assert (= (f1 (f2 3)) 14))
(assert (= (f1 (g2 (- 5))) 35))
(assert (= (f1 (f3 8)) (- 21)))
(assert (= (f1 (g3 3)) 35))
(assert (= (g1 (f3 (- 7))) 176))
(assert (= (f1 (g4 8)) 112))
(assert (= (g1 (f4 (- 5))) 176))
(assert (= (f2 (f1 3)) 14))
(assert (= (f2 (g1 (- 5))) 75))
(assert (= (f2 (f2 8)) 14))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 7))) 57))
(assert (= (f2 (g3 8)) 75))
(assert (= (g2 (f3 (- 5))) 54))
(assert (= (g2 (f4 3)) 57))
(assert (= (f2 (f4 (- 7))) 16))
(assert (= (g2 (g4 (- 7))) 507))
(assert (= (f3 (f1 8)) (- 21)))
(assert (= (f3 (g1 3)) (- 53)))
(assert (= (g3 (f1 (- 7))) (- 131)))
(assert (= (f3 (g2 8)) (- 53)))
(assert (= (g3 (f2 (- 5))) (- 68)))
(assert (= (g3 (f3 3)) (- 68)))
(assert (= (f3 (f3 (- 7))) (- 16)))
(assert (= (g3 (g3 (- 7))) (- 527)))
(assert (= (g3 (f4 8)) (- 131)))
(assert (= (f3 (f4 (- 5))) (- 16)))
(assert (= (g3 (g4 (- 5))) (- 527)))
(assert (= (f4 (g1 8)) (- 135)))
(assert (= (g4 (f1 (- 5))) (- 163)))
(assert (= (g4 (f2 3)) 78))
(assert (= (f4 (f2 (- 7))) 16))
(assert (= (g4 (g2 (- 7))) 507))
(assert (= (g4 (f3 8)) (- 163)))
(assert (= (f4 (f3 (- 5))) (- 16)))
(assert (= (g4 (g3 (- 5))) (- 527)))
(assert (= (f4 (f4 3)) 16))
(assert (= (g4 (g4 3)) 507))
(check-sat)
