(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 20)))
(assert (= (f1 (g1 (- 8))) 128))
(assert (= (f1 (f2 3)) 14))
(assert (= (f1 (g2 (- 4))) 29))
(assert (= (f1 (f3 8)) (- 20)))
(assert (= (f1 (g3 3)) 29))
(assert (= (g1 (f3 (- 8))) 176))
(assert (= (f1 (g4 8)) 128))
(assert (= (g1 (f4 (- 4))) 176))
(assert (= (f2 (f1 3)) 14))
(assert (= (f2 (g1 (- 4))) 59))
(assert (= (f2 (f2 8)) 14))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 8))) 63))
(assert (= (f2 (g3 8)) 59))
(assert (= (g2 (f3 (- 4))) 42))
(assert (= (g2 (f4 3)) 63))
(assert (= (f2 (f4 (- 8))) 18))
(assert (= (g2 (g4 (- 8))) 675))
(assert (= (f3 (f1 8)) (- 20)))
(assert (= (f3 (g1 3)) (- 52)))
(assert (= (g3 (f1 (- 8))) (- 109)))
(assert (= (f3 (g2 8)) (- 52)))
(assert (= (g3 (f2 (- 4))) (- 46)))
(assert (= (g3 (f3 3)) (- 46)))
(assert (= (f3 (f3 (- 8))) (- 15)))
(assert (= (g3 (g3 (- 8))) (- 368)))
(assert (= (g3 (f4 8)) (- 109)))
(assert (= (f3 (f4 (- 4))) (- 15)))
(assert (= (g3 (g4 (- 4))) (- 368)))
(assert (= (f4 (g1 8)) (- 136)))
(assert (= (g4 (f1 (- 4))) (- 173)))
(assert (= (g4 (f2 3)) 90))
(assert (= (f4 (f2 (- 8))) 18))
(assert (= (g4 (g2 (- 8))) 675))
(assert (= (g4 (f3 8)) (- 173)))
(assert (= (f4 (f3 (- 4))) (- 15)))
(assert (= (g4 (g3 (- 4))) (- 368)))
(assert (= (f4 (f4 3)) 18))
(assert (= (g4 (g4 3)) 675))
(check-sat)
