(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 23))
(assert (= (f1 (g1 0)) 8))
(assert (= (f1 (f2 6)) 20))
(assert (= (f1 (g2 7)) 92))
(assert (= (f1 (f3 8)) 23))
(assert (= (f1 (g3 6)) 92))
(assert (= (g1 (f3 0)) 112))
(assert (= (f1 (g4 8)) 8))
(assert (= (g1 (f4 7)) 112))
(assert (= (f2 (f1 6)) 20))
(assert (= (f2 (g1 7)) 118))
(assert (= (f2 (f2 8)) 20))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 0)) 72))
(assert (= (f2 (g3 8)) 118))
(assert (= (g2 (f3 7)) 168))
(assert (= (g2 (f4 6)) 72))
(assert (= (f2 (f4 0)) 6))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 8)) 23))
(assert (= (f3 (g1 6)) 103))
(assert (= (g3 (f1 0)) 112))
(assert (= (f3 (g2 8)) 103))
(assert (= (g3 (f2 7)) 182))
(assert (= (g3 (f3 6)) 182))
(assert (= (f3 (f3 0)) 14))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 8)) 112))
(assert (= (f3 (f4 7)) 14))
(assert (= (g3 (g4 7)) 0))
(assert (= (f4 (g1 8)) 128))
(assert (= (g4 (f1 7)) 0))
(assert (= (g4 (f2 6)) 0))
(assert (= (f4 (f2 0)) 6))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 8)) 0))
(assert (= (f4 (f3 7)) 14))
(assert (= (g4 (g3 7)) 0))
(assert (= (f4 (f4 6)) 6))
(assert (= (g4 (g4 6)) 0))
(check-sat)
