(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 9)) 25))
(assert (= (f1 (g1 3)) 56))
(assert (= (f1 (f2 7)) 22))
(assert (= (f1 (g2 9)) 134))
(assert (= (f1 (f3 8)) 25))
(assert (= (f1 (g3 7)) 134))
(assert (= (g1 (f3 3)) 192))
(assert (= (f1 (g4 8)) 56))
(assert (= (g1 (f4 9)) 192))
(assert (= (f2 (f1 7)) 22))
(assert (= (f2 (g1 9)) 151))
(assert (= (f2 (f2 8)) 22))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 3)) 140))
(assert (= (f2 (g3 8)) 151))
(assert (= (g2 (f3 9)) 252))
(assert (= (g2 (f4 7)) 140))
(assert (= (f2 (f4 3)) 13))
(assert (= (g2 (g4 3)) 252))
(assert (= (f3 (f1 8)) 25))
(assert (= (f3 (g1 7)) 121))
(assert (= (g3 (f1 3)) 198))
(assert (= (f3 (g2 8)) 121))
(assert (= (g3 (f2 9)) 288))
(assert (= (g3 (f3 7)) 288))
(assert (= (f3 (f3 3)) 21))
(assert (= (g3 (g3 3)) 972))
(assert (= (g3 (f4 8)) 198))
(assert (= (f3 (f4 9)) 21))
(assert (= (g3 (g4 9)) 972))
(assert (= (f4 (g1 8)) 131))
(assert (= (g4 (f1 9)) 102))
(assert (= (g4 (f2 7)) 84))
(assert (= (f4 (f2 3)) 13))
(assert (= (g4 (g2 3)) 252))
(assert (= (g4 (f3 8)) 102))
(assert (= (f4 (f3 9)) 21))
(assert (= (g4 (g3 9)) 972))
(assert (= (f4 (f4 7)) 13))
(assert (= (g4 (g4 7)) 252))
(check-sat)
