(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 7)) 23))
(assert (= (f1 (g1 6)) 104))
(assert (= (f1 (f2 9)) 26))
(assert (= (f1 (g2 7)) 134))
(assert (= (f1 (f3 8)) 23))
(assert (= (f1 (g3 9)) 134))
(assert (= (g1 (f3 6)) 208))
(assert (= (f1 (g4 8)) 104))
(assert (= (g1 (f4 7)) 208))
(assert (= (f2 (f1 9)) 26))
(assert (= (f2 (g1 7)) 121))
(assert (= (f2 (f2 8)) 26))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 6)) 270))
(assert (= (f2 (g3 8)) 121))
(assert (= (g2 (f3 7)) 252))
(assert (= (g2 (f4 9)) 270))
(assert (= (f2 (f4 6)) 21))
(assert (= (g2 (g4 6)) 1296))
(assert (= (f3 (f1 8)) 23))
(assert (= (f3 (g1 9)) 151))
(assert (= (g3 (f1 6)) 196))
(assert (= (f3 (g2 8)) 151))
(assert (= (g3 (f2 7)) 224))
(assert (= (g3 (f3 9)) 224))
(assert (= (f3 (f3 6)) 20))
(assert (= (g3 (g3 6)) 1176))
(assert (= (g3 (f4 8)) 196))
(assert (= (f3 (f4 7)) 20))
(assert (= (g3 (g4 7)) 1176))
(assert (= (f4 (g1 8)) 134))
(assert (= (g4 (f1 7)) 180))
(assert (= (g4 (f2 9)) 216))
(assert (= (f4 (f2 6)) 21))
(assert (= (g4 (g2 6)) 1296))
(assert (= (g4 (f3 8)) 180))
(assert (= (f4 (f3 7)) 20))
(assert (= (g4 (g3 7)) 1176))
(assert (= (f4 (f4 9)) 21))
(assert (= (g4 (g4 9)) 1296))
(check-sat)
