(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 25))
(assert (= (f1 (g1 1)) 27))
(assert (= (f1 (f2 (- 3))) 14))
(assert (= (f1 (g2 7)) 44))
(assert (= (f1 (f3 9)) 25))
(assert (= (f1 (g3 (- 3))) 44))
(assert (= (g1 (f3 1)) 144))
(assert (= (f1 (g4 9)) 27))
(assert (= (g1 (f4 7)) 144))
(assert (= (f2 (f1 (- 3))) 14))
(assert (= (f2 (g1 7)) (- 129)))
(assert (= (f2 (f2 9)) 14))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 1)) (- 18)))
(assert (= (f2 (g3 9)) (- 129)))
(assert (= (g2 (f3 7)) 70))
(assert (= (g2 (f4 (- 3))) (- 18)))
(assert (= (f2 (f4 1)) (- 5)))
(assert (= (g2 (g4 1)) 10))
(assert (= (f3 (f1 9)) 25))
(assert (= (f3 (g1 (- 3))) 52))
(assert (= (g3 (f1 1)) 140))
(assert (= (f3 (g2 9)) 52))
(assert (= (g3 (f2 7)) 133))
(assert (= (g3 (f3 (- 3))) 133))
(assert (= (f3 (f3 1)) 15))
(assert (= (g3 (g3 1)) 196))
(assert (= (g3 (f4 9)) 140))
(assert (= (f3 (f4 7)) 15))
(assert (= (g3 (g4 7)) 196))
(assert (= (f4 (g1 9)) 163))
(assert (= (g4 (f1 7)) 32))
(assert (= (g4 (f2 (- 3))) 10))
(assert (= (f4 (f2 1)) (- 5)))
(assert (= (g4 (g2 1)) 10))
(assert (= (g4 (f3 9)) 32))
(assert (= (f4 (f3 7)) 15))
(assert (= (g4 (g3 7)) 196))
(assert (= (f4 (f4 (- 3))) (- 5)))
(assert (= (g4 (g4 (- 3))) 10))
(check-sat)
