(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 25)))
(assert (= (f1 (g1 (- 6))) 108))
(assert (= (f1 (f2 (- 2))) 12))
(assert (= (f1 (g2 (- 7))) (- 29)))
(assert (= (f1 (f3 9)) (- 25)))
(assert (= (f1 (g3 (- 2))) (- 29)))
(assert (= (g1 (f3 (- 6))) 216))
(assert (= (f1 (g4 9)) 108))
(assert (= (g1 (f4 (- 7))) 216))
(assert (= (f2 (f1 (- 2))) 12))
(assert (= (f2 (g1 (- 7))) (- 119)))
(assert (= (f2 (f2 9)) 12))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 6))) 21))
(assert (= (f2 (g3 9)) (- 119)))
(assert (= (g2 (f3 (- 7))) 39))
(assert (= (g2 (f4 (- 2))) 21))
(assert (= (f2 (f4 (- 6))) (- 13)))
(assert (= (g2 (g4 (- 6))) (- 182)))
(assert (= (f3 (f1 9)) (- 25)))
(assert (= (f3 (g1 (- 2))) (- 34)))
(assert (= (g3 (f1 (- 6))) (- 189)))
(assert (= (f3 (g2 9)) (- 34)))
(assert (= (g3 (f2 (- 7))) 104))
(assert (= (g3 (f3 (- 2))) 104))
(assert (= (f3 (f3 (- 6))) (- 19)))
(assert (= (g3 (g3 (- 6))) (- 930)))
(assert (= (g3 (f4 9)) (- 189)))
(assert (= (f3 (f4 (- 7))) (- 19)))
(assert (= (g3 (g4 (- 7))) (- 930)))
(assert (= (f4 (g1 9)) (- 168)))
(assert (= (g4 (f1 (- 7))) (- 171)))
(assert (= (g4 (f2 (- 2))) 33))
(assert (= (f4 (f2 (- 6))) (- 13)))
(assert (= (g4 (g2 (- 6))) (- 182)))
(assert (= (g4 (f3 9)) (- 171)))
(assert (= (f4 (f3 (- 7))) (- 19)))
(assert (= (g4 (g3 (- 7))) (- 930)))
(assert (= (f4 (f4 (- 2))) (- 13)))
(assert (= (g4 (g4 (- 2))) (- 182)))
(check-sat)
