(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 6)) 24))
(assert (= (f1 (g1 8)) 153))
(assert (= (f1 (f2 (- 2))) 12))
(assert (= (f1 (g2 6)) 27))
(assert (= (f1 (f3 9)) 24))
(assert (= (f1 (g3 (- 2))) 27))
(assert (= (g1 (f3 8)) 252))
(assert (= (f1 (g4 9)) 153))
(assert (= (g1 (f4 6)) 252))
(assert (= (f2 (f1 (- 2))) 12))
(assert (= (f2 (g1 6)) (- 110)))
(assert (= (f2 (f2 9)) 12))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 8)) (- 29)))
(assert (= (f2 (g3 9)) (- 110)))
(assert (= (g2 (f3 6)) 36))
(assert (= (g2 (f4 (- 2))) (- 29)))
(assert (= (f2 (f4 8)) (- 18)))
(assert (= (g2 (g4 8)) 384))
(assert (= (f3 (f1 9)) 24))
(assert (= (f3 (g1 (- 2))) 33))
(assert (= (g3 (f1 8)) 204))
(assert (= (f3 (g2 9)) 33))
(assert (= (g3 (f2 6)) 90))
(assert (= (g3 (f3 (- 2))) 90))
(assert (= (f3 (f3 8)) 20))
(assert (= (g3 (g3 8)) 1152))
(assert (= (g3 (f4 9)) 204))
(assert (= (f3 (f4 6)) 20))
(assert (= (g3 (g4 6)) 1152))
(assert (= (f4 (g1 9)) 170))
(assert (= (g4 (f1 6)) 240))
(assert (= (g4 (f2 (- 2))) 48))
(assert (= (f4 (f2 8)) (- 18)))
(assert (= (g4 (g2 8)) 384))
(assert (= (g4 (f3 9)) 240))
(assert (= (f4 (f3 6)) 20))
(assert (= (g4 (g3 6)) 1152))
(assert (= (f4 (f4 (- 2))) (- 18)))
(assert (= (g4 (g4 (- 2))) 384))
(check-sat)
