(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 16)))
(assert (= (f1 (g1 (- 4))) 44))
(assert (= (f1 (f2 (- 7))) (- 19)))
(assert (= (f1 (g2 (- 5))) 64))
(assert (= (f1 (f3 (- 6))) (- 16)))
(assert (= (f1 (g3 (- 7))) 64))
(assert (= (g1 (f3 (- 4))) 88))
(assert (= (f1 (g4 (- 6))) 44))
(assert (= (g1 (f4 (- 5))) 88))
(assert (= (f2 (f1 (- 7))) (- 19)))
(assert (= (f2 (g1 (- 5))) 56))
(assert (= (f2 (f2 (- 6))) (- 19)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 4))) 130))
(assert (= (f2 (g3 (- 6))) 56))
(assert (= (g2 (f3 (- 5))) 117))
(assert (= (g2 (f4 (- 7))) 130))
(assert (= (f2 (f4 (- 4))) (- 14)))
(assert (= (g2 (g4 (- 4))) (- 319)))
(assert (= (f3 (f1 (- 6))) (- 16)))
(assert (= (f3 (g1 (- 7))) 76))
(assert (= (g3 (f1 (- 4))) 81))
(assert (= (f3 (g2 (- 6))) 76))
(assert (= (g3 (f2 (- 5))) 99))
(assert (= (g3 (f3 (- 7))) 99))
(assert (= (f3 (f3 (- 4))) (- 13)))
(assert (= (g3 (g3 (- 4))) (- 284)))
(assert (= (g3 (f4 (- 6))) 81))
(assert (= (f3 (f4 (- 5))) (- 13)))
(assert (= (g3 (g4 (- 5))) (- 284)))
(assert (= (f4 (g1 (- 6))) 64))
(assert (= (g4 (f1 (- 5))) 70))
(assert (= (g4 (f2 (- 7))) 91))
(assert (= (f4 (f2 (- 4))) (- 14)))
(assert (= (g4 (g2 (- 4))) (- 319)))
(assert (= (g4 (f3 (- 6))) 70))
(assert (= (f4 (f3 (- 5))) (- 13)))
(assert (= (g4 (g3 (- 5))) (- 284)))
(assert (= (f4 (f4 (- 7))) (- 14)))
(assert (= (g4 (g4 (- 7))) (- 319)))
(check-sat)
