(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 25))
(assert (= (f1 (g1 3)) 63))
(assert (= (f1 (f2 1)) 11))
(assert (= (f1 (g2 7)) 23))
(assert (= (f1 (f3 9)) 25))
(assert (= (f1 (g3 1)) 23))
(assert (= (g1 (f3 3)) 180))
(assert (= (f1 (g4 9)) 63))
(assert (= (g1 (f4 7)) 180))
(assert (= (f2 (f1 1)) 11))
(assert (= (f2 (g1 7)) 127))
(assert (= (f2 (f2 9)) 11))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 3)) 8))
(assert (= (f2 (g3 9)) 127))
(assert (= (g2 (f3 7)) 28))
(assert (= (g2 (f4 1)) 8))
(assert (= (f2 (f4 3)) 7))
(assert (= (g2 (g4 3)) 36))
(assert (= (f3 (f1 9)) 25))
(assert (= (f3 (g1 1)) 25))
(assert (= (g3 (f1 3)) 168))
(assert (= (f3 (g2 9)) 25))
(assert (= (g3 (f2 7)) 112))
(assert (= (g3 (f3 1)) 112))
(assert (= (f3 (f3 3)) 17))
(assert (= (g3 (g3 3)) 588))
(assert (= (g3 (f4 9)) 168))
(assert (= (f3 (f4 7)) 17))
(assert (= (g3 (g4 7)) 588))
(assert (= (f4 (g1 9)) 165))
(assert (= (g4 (f1 7)) 96))
(assert (= (g4 (f2 1)) 12))
(assert (= (f4 (f2 3)) 7))
(assert (= (g4 (g2 3)) 36))
(assert (= (g4 (f3 9)) 96))
(assert (= (f4 (f3 7)) 17))
(assert (= (g4 (g3 7)) 588))
(assert (= (f4 (f4 1)) 7))
(assert (= (g4 (g4 1)) 36))
(check-sat)
