(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 25)))
(assert (= (f1 (g1 (- 3))) 54))
(assert (= (f1 (f2 2)) 13))
(assert (= (f1 (g2 (- 7))) 35))
(assert (= (f1 (f3 9)) (- 25)))
(assert (= (f1 (g3 2)) 35))
(assert (= (g1 (f3 (- 3))) 162))
(assert (= (f1 (g4 9)) 54))
(assert (= (g1 (f4 (- 7))) 162))
(assert (= (f2 (f1 2)) 13))
(assert (= (f2 (g1 (- 7))) 119))
(assert (= (f2 (f2 9)) 13))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 3))) 18))
(assert (= (f2 (g3 9)) 119))
(assert (= (g2 (f3 (- 7))) 52))
(assert (= (g2 (f4 2)) 18))
(assert (= (f2 (f4 (- 3))) 7))
(assert (= (g2 (g4 (- 3))) 50))
(assert (= (f3 (f1 9)) (- 25)))
(assert (= (f3 (g1 2)) (- 43)))
(assert (= (g3 (f1 (- 3))) (- 150)))
(assert (= (f3 (g2 9)) (- 43)))
(assert (= (g3 (f2 (- 7))) (- 111)))
(assert (= (g3 (f3 2)) (- 111)))
(assert (= (f3 (f3 (- 3))) (- 16)))
(assert (= (g3 (g3 (- 3))) (- 423)))
(assert (= (g3 (f4 9)) (- 150)))
(assert (= (f3 (f4 (- 7))) (- 16)))
(assert (= (g3 (g4 (- 7))) (- 423)))
(assert (= (f4 (g1 9)) (- 165)))
(assert (= (g4 (f1 (- 7))) (- 78)))
(assert (= (g4 (f2 2)) 20))
(assert (= (f4 (f2 (- 3))) 7))
(assert (= (g4 (g2 (- 3))) 50))
(assert (= (g4 (f3 9)) (- 78)))
(assert (= (f4 (f3 (- 7))) (- 16)))
(assert (= (g4 (g3 (- 7))) (- 423)))
(assert (= (f4 (f4 2)) 7))
(assert (= (g4 (g4 2)) 50))
(check-sat)
