(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 23)))
(assert (= (f1 (g1 (- 7))) 126))
(assert (= (f1 (f2 2)) 13))
(assert (= (f1 (g2 (- 5))) 27))
(assert (= (f1 (f3 9)) (- 23)))
(assert (= (f1 (g3 2)) 27))
(assert (= (g1 (f3 (- 7))) 198))
(assert (= (f1 (g4 9)) 126))
(assert (= (g1 (f4 (- 5))) 198))
(assert (= (f2 (f1 2)) 13))
(assert (= (f2 (g1 (- 5))) 83))
(assert (= (f2 (f2 9)) 13))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 7))) 34))
(assert (= (f2 (g3 9)) 83))
(assert (= (g2 (f3 (- 5))) 36))
(assert (= (g2 (f4 2)) 34))
(assert (= (f2 (f4 (- 7))) 15))
(assert (= (g2 (g4 (- 7))) 338))
(assert (= (f3 (f1 9)) (- 23)))
(assert (= (f3 (g1 2)) (- 41)))
(assert (= (g3 (f1 (- 7))) (- 140)))
(assert (= (f3 (g2 9)) (- 41)))
(assert (= (g3 (f2 (- 5))) (- 59)))
(assert (= (g3 (f3 2)) (- 59)))
(assert (= (f3 (f3 (- 7))) (- 16)))
(assert (= (g3 (g3 (- 7))) (- 527)))
(assert (= (g3 (f4 9)) (- 140)))
(assert (= (f3 (f4 (- 5))) (- 16)))
(assert (= (g3 (g4 (- 5))) (- 527)))
(assert (= (f4 (g1 9)) (- 169)))
(assert (= (g4 (f1 (- 5))) (- 176)))
(assert (= (g4 (f2 2)) 52))
(assert (= (f4 (f2 (- 7))) 15))
(assert (= (g4 (g2 (- 7))) 338))
(assert (= (g4 (f3 9)) (- 176)))
(assert (= (f4 (f3 (- 5))) (- 16)))
(assert (= (g4 (g3 (- 5))) (- 527)))
(assert (= (f4 (f4 2)) 15))
(assert (= (g4 (g4 2)) 338))
(check-sat)
