(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 6)) 24))
(assert (= (f1 (g1 7)) 135))
(assert (= (f1 (f2 3)) 15))
(assert (= (f1 (g2 6)) 45))
(assert (= (f1 (f3 9)) 24))
(assert (= (f1 (g3 3)) 45))
(assert (= (g1 (f3 7)) 234))
(assert (= (f1 (g4 9)) 135))
(assert (= (g1 (f4 6)) 234))
(assert (= (f2 (f1 3)) 15))
(assert (= (f2 (g1 6)) 111))
(assert (= (f2 (f2 9)) 15))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 7)) 60))
(assert (= (f2 (g3 9)) 111))
(assert (= (g2 (f3 6)) 72))
(assert (= (g2 (f4 3)) 60))
(assert (= (f2 (f4 7)) 17))
(assert (= (g2 (g4 7)) 588))
(assert (= (f3 (f1 9)) 24))
(assert (= (f3 (g1 3)) 60))
(assert (= (g3 (f1 7)) 192))
(assert (= (f3 (g2 9)) 60))
(assert (= (g3 (f2 6)) 108))
(assert (= (g3 (f3 3)) 108))
(assert (= (f3 (f3 7)) 19))
(assert (= (g3 (g3 7)) 1008))
(assert (= (g3 (f4 9)) 192))
(assert (= (f3 (f4 6)) 19))
(assert (= (g3 (g4 6)) 1008))
(assert (= (f4 (g1 9)) 169))
(assert (= (g4 (f1 6)) 210))
(assert (= (g4 (f2 3)) 84))
(assert (= (f4 (f2 7)) 17))
(assert (= (g4 (g2 7)) 588))
(assert (= (g4 (f3 9)) 210))
(assert (= (f4 (f3 6)) 19))
(assert (= (g4 (g3 6)) 1008))
(assert (= (f4 (f4 3)) 17))
(assert (= (g4 (g4 3)) 588))
(check-sat)
