(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 26))
(assert (= (f1 (g1 4)) 81))
(assert (= (f1 (f2 3)) 15))
(assert (= (f1 (g2 8)) 57))
(assert (= (f1 (f3 9)) 26))
(assert (= (f1 (g3 3)) 57))
(assert (= (g1 (f3 4)) 216))
(assert (= (f1 (g4 9)) 81))
(assert (= (g1 (f4 8)) 216))
(assert (= (f2 (f1 3)) 15))
(assert (= (f2 (g1 8)) 147))
(assert (= (f2 (f2 9)) 15))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 4)) 42))
(assert (= (f2 (g3 9)) 147))
(assert (= (g2 (f3 8)) 96))
(assert (= (g2 (f4 3)) 42))
(assert (= (f2 (f4 4)) 11))
(assert (= (g2 (g4 4)) 192))
(assert (= (f3 (f1 9)) 26))
(assert (= (f3 (g1 3)) 62))
(assert (= (g3 (f1 4)) 208))
(assert (= (f3 (g2 9)) 62))
(assert (= (g3 (f2 8)) 176))
(assert (= (g3 (f3 3)) 176))
(assert (= (f3 (f3 4)) 20))
(assert (= (g3 (g3 4)) 1024))
(assert (= (g3 (f4 9)) 208))
(assert (= (f3 (f4 8)) 20))
(assert (= (g3 (g4 8)) 1024))
(assert (= (f4 (g1 9)) 166))
(assert (= (g4 (f1 8)) 136))
(assert (= (g4 (f2 3)) 48))
(assert (= (f4 (f2 4)) 11))
(assert (= (g4 (g2 4)) 192))
(assert (= (g4 (f3 9)) 136))
(assert (= (f4 (f3 8)) 20))
(assert (= (g4 (g3 8)) 1024))
(assert (= (f4 (f4 3)) 11))
(assert (= (g4 (g4 3)) 192))
(check-sat)
