(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 1)) 19))
(assert (= (f1 (g1 (- 8))) 144))
(assert (= (f1 (f2 5)) 19))
(assert (= (f1 (g2 1)) 19))
(assert (= (f1 (f3 9)) 19))
(assert (= (f1 (g3 5)) 19))
(assert (= (g1 (f3 (- 8))) 153))
(assert (= (f1 (g4 9)) 144))
(assert (= (g1 (f4 1)) 153))
(assert (= (f2 (f1 5)) 19))
(assert (= (f2 (g1 1)) 23))
(assert (= (f2 (f2 9)) 19))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 8))) 125))
(assert (= (f2 (g3 9)) 23))
(assert (= (g2 (f3 1)) 20))
(assert (= (g2 (f4 5)) 125))
(assert (= (f2 (f4 (- 8))) 20))
(assert (= (g2 (g4 (- 8))) 1125))
(assert (= (f3 (f1 9)) 19))
(assert (= (f3 (g1 5)) 91))
(assert (= (g3 (f1 (- 8))) 33))
(assert (= (f3 (g2 9)) 91))
(assert (= (g3 (f2 1)) 12))
(assert (= (g3 (f3 5)) 12))
(assert (= (f3 (f3 (- 8))) (- 10)))
(assert (= (g3 (g3 (- 8))) 30))
(assert (= (g3 (f4 9)) 33))
(assert (= (f3 (f4 1)) (- 10)))
(assert (= (g3 (g4 1)) 30))
(assert (= (f4 (g1 9)) (- 170)))
(assert (= (g4 (f1 1)) 150))
(assert (= (g4 (f2 5)) 150))
(assert (= (f4 (f2 (- 8))) 20))
(assert (= (g4 (g2 (- 8))) 1125))
(assert (= (g4 (f3 9)) 150))
(assert (= (f4 (f3 1)) (- 10)))
(assert (= (g4 (g3 1)) 30))
(assert (= (f4 (f4 5)) 20))
(assert (= (g4 (g4 5)) 1125))
(check-sat)
