(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 8))) (- 26)))
(assert (= (f1 (g1 (- 9))) 162))
(assert (= (f1 (f2 6)) 21))
(assert (= (f1 (g2 (- 8))) 99))
(assert (= (f1 (f3 9)) (- 26)))
(assert (= (f1 (g3 6)) 99))
(assert (= (g1 (f3 (- 9))) 288))
(assert (= (f1 (g4 9)) 162))
(assert (= (g1 (f4 (- 8))) 288))
(assert (= (f2 (f1 6)) 21))
(assert (= (f2 (g1 (- 8))) 141))
(assert (= (f2 (f2 9)) 21))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 9))) 174))
(assert (= (f2 (g3 9)) 141))
(assert (= (g2 (f3 (- 8))) 180))
(assert (= (g2 (f4 6)) 174))
(assert (= (f2 (f4 (- 9))) 23))
(assert (= (g2 (g4 (- 9))) 1734))
(assert (= (f3 (f1 9)) (- 26)))
(assert (= (f3 (g1 6)) (- 116)))
(assert (= (g3 (f1 (- 9))) (- 263)))
(assert (= (f3 (g2 9)) (- 116)))
(assert (= (g3 (f2 (- 8))) (- 203)))
(assert (= (g3 (f3 6)) (- 203)))
(assert (= (f3 (f3 (- 9))) (- 24)))
(assert (= (g3 (g3 (- 9))) (- 1913)))
(assert (= (g3 (f4 9)) (- 263)))
(assert (= (f3 (f4 (- 8))) (- 24)))
(assert (= (g3 (g4 (- 8))) (- 1913)))
(assert (= (f4 (g1 9)) (- 171)))
(assert (= (g4 (f1 (- 8))) (- 281)))
(assert (= (g4 (f2 6)) 204))
(assert (= (f4 (f2 (- 9))) 23))
(assert (= (g4 (g2 (- 9))) 1734))
(assert (= (g4 (f3 9)) (- 281)))
(assert (= (f4 (f3 (- 8))) (- 24)))
(assert (= (g4 (g3 (- 8))) (- 1913)))
(assert (= (f4 (f4 6)) 23))
(assert (= (g4 (g4 6)) 1734))
(check-sat)
