(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 26))
(assert (= (f1 (g1 (- 2))) 36))
(assert (= (f1 (f2 7)) 23))
(assert (= (f1 (g2 8)) 121))
(assert (= (f1 (f3 9)) 26))
(assert (= (f1 (g3 7)) 121))
(assert (= (g1 (f3 (- 2))) 171))
(assert (= (f1 (g4 9)) 36))
(assert (= (g1 (f4 8)) 171))
(assert (= (f2 (f1 7)) 23))
(assert (= (f2 (g1 8)) 151))
(assert (= (f2 (f2 9)) 23))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 2))) 119))
(assert (= (f2 (g3 9)) 151))
(assert (= (g2 (f3 8)) 224))
(assert (= (g2 (f4 7)) 119))
(assert (= (f2 (f4 (- 2))) 10))
(assert (= (g2 (g4 (- 2))) 63))
(assert (= (f3 (f1 9)) 26))
(assert (= (f3 (g1 7)) 134))
(assert (= (g3 (f1 (- 2))) 168))
(assert (= (f3 (g2 9)) 134))
(assert (= (g3 (f2 8)) 240))
(assert (= (g3 (f3 7)) 240))
(assert (= (f3 (f3 (- 2))) (- 18)))
(assert (= (g3 (g3 (- 2))) 384))
(assert (= (g3 (f4 9)) 168))
(assert (= (f3 (f4 8)) (- 18)))
(assert (= (g3 (g4 8)) 384))
(assert (= (f4 (g1 9)) (- 164)))
(assert (= (g4 (f1 8)) 51))
(assert (= (g4 (f2 7)) 42))
(assert (= (f4 (f2 (- 2))) 10))
(assert (= (g4 (g2 (- 2))) 63))
(assert (= (g4 (f3 9)) 51))
(assert (= (f4 (f3 8)) (- 18)))
(assert (= (g4 (g3 8)) 384))
(assert (= (f4 (f4 7)) 10))
(assert (= (g4 (g4 7)) 63))
(check-sat)
