(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 27)))
(assert (= (f1 (g1 (- 2))) 36))
(assert (= (f1 (f2 8)) 25))
(assert (= (f1 (g2 (- 9))) 145))
(assert (= (f1 (f3 9)) (- 27)))
(assert (= (f1 (g3 8)) 145))
(assert (= (g1 (f3 (- 2))) 180))
(assert (= (f1 (g4 9)) 36))
(assert (= (g1 (f4 (- 9))) 180))
(assert (= (f2 (f1 8)) 25))
(assert (= (f2 (g1 (- 9))) 161))
(assert (= (f2 (f2 9)) 25))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 2))) 152))
(assert (= (f2 (g3 9)) 161))
(assert (= (g2 (f3 (- 9))) 272))
(assert (= (g2 (f4 8)) 152))
(assert (= (f2 (f4 (- 2))) 11))
(assert (= (g2 (g4 (- 2))) 72))
(assert (= (f3 (f1 9)) (- 27)))
(assert (= (f3 (g1 8)) (- 153)))
(assert (= (g3 (f1 (- 2))) (- 179)))
(assert (= (f3 (g2 9)) (- 153)))
(assert (= (g3 (f2 (- 9))) (- 281)))
(assert (= (g3 (f3 8)) (- 281)))
(assert (= (f3 (f3 (- 2))) (- 19)))
(assert (= (g3 (g3 (- 2))) (- 434)))
(assert (= (g3 (f4 9)) (- 179)))
(assert (= (f3 (f4 (- 9))) (- 19)))
(assert (= (g3 (g4 (- 9))) (- 434)))
(assert (= (f4 (g1 9)) (- 164)))
(assert (= (g4 (f1 (- 9))) (- 53)))
(assert (= (g4 (f2 8)) 48))
(assert (= (f4 (f2 (- 2))) 11))
(assert (= (g4 (g2 (- 2))) 72))
(assert (= (g4 (f3 9)) (- 53)))
(assert (= (f4 (f3 (- 9))) (- 19)))
(assert (= (g4 (g3 (- 9))) (- 434)))
(assert (= (f4 (f4 8)) 11))
(assert (= (g4 (g4 8)) 72))
(check-sat)
