(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 19))
(assert (= (f1 (g1 2)) (- 28)))
(assert (= (f1 (f2 (- 5))) (- 15)))
(assert (= (f1 (g2 8)) (- 78)))
(assert (= (f1 (f3 (- 6))) 19))
(assert (= (f1 (g3 (- 5))) (- 78)))
(assert (= (g1 (f3 2)) 110))
(assert (= (f1 (g4 (- 6))) (- 28)))
(assert (= (g1 (f4 8)) 110))
(assert (= (f2 (f1 (- 5))) (- 15)))
(assert (= (f2 (g1 8)) (- 93)))
(assert (= (f2 (f2 (- 6))) (- 15)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 2)) (- 59)))
(assert (= (f2 (g3 (- 6))) (- 93)))
(assert (= (g2 (f3 8)) 144))
(assert (= (g2 (f4 (- 5))) (- 59)))
(assert (= (f2 (f4 2)) (- 9)))
(assert (= (g2 (g4 2)) 72))
(assert (= (f3 (f1 (- 6))) 19))
(assert (= (f3 (g1 (- 5))) (- 58)))
(assert (= (g3 (f1 2)) 120))
(assert (= (f3 (g2 (- 6))) (- 58)))
(assert (= (g3 (f2 8)) 200))
(assert (= (g3 (f3 (- 5))) 200))
(assert (= (f3 (f3 2)) 18))
(assert (= (g3 (g3 2)) 512))
(assert (= (g3 (f4 (- 6))) 120))
(assert (= (f3 (f4 8)) 18))
(assert (= (g3 (g4 8)) 512))
(assert (= (f4 (g1 (- 6))) (- 63)))
(assert (= (g4 (f1 8)) 54))
(assert (= (g4 (f2 (- 5))) 36))
(assert (= (f4 (f2 2)) (- 9)))
(assert (= (g4 (g2 2)) 72))
(assert (= (g4 (f3 (- 6))) 54))
(assert (= (f4 (f3 8)) 18))
(assert (= (g4 (g3 8)) 512))
(assert (= (f4 (f4 (- 5))) (- 9)))
(assert (= (g4 (g4 (- 5))) 72))
(check-sat)
