(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 19)))
(assert (= (f1 (g1 (- 5))) 55))
(assert (= (f1 (f2 1)) (- 8)))
(assert (= (f1 (g2 (- 8))) (- 21)))
(assert (= (f1 (f3 (- 6))) (- 19)))
(assert (= (f1 (g3 1)) (- 21)))
(assert (= (g1 (f3 (- 5))) 132))
(assert (= (f1 (g4 (- 6))) 55))
(assert (= (g1 (f4 (- 8))) 132))
(assert (= (f2 (f1 1)) (- 8)))
(assert (= (f2 (g1 (- 8))) (- 84)))
(assert (= (f2 (f2 (- 6))) (- 8)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 5))) 11))
(assert (= (f2 (g3 (- 6))) (- 84)))
(assert (= (g2 (f3 (- 8))) 30))
(assert (= (g2 (f4 1)) 11))
(assert (= (f2 (f4 (- 5))) 10))
(assert (= (g2 (g4 (- 5))) 81))
(assert (= (f3 (f1 (- 6))) (- 19)))
(assert (= (f3 (g1 1)) (- 19)))
(assert (= (g3 (f1 (- 5))) 150))
(assert (= (f3 (g2 (- 6))) (- 19)))
(assert (= (g3 (f2 (- 8))) (- 128)))
(assert (= (g3 (f3 1)) (- 128)))
(assert (= (f3 (f3 (- 5))) (- 20)))
(assert (= (g3 (g3 (- 5))) (- 1013)))
(assert (= (g3 (f4 (- 6))) 150))
(assert (= (f3 (f4 (- 8))) (- 20)))
(assert (= (g3 (g4 (- 8))) (- 1013)))
(assert (= (f4 (g1 (- 6))) 65))
(assert (= (g4 (f1 (- 8))) 117))
(assert (= (g4 (f2 1)) 18))
(assert (= (f4 (f2 (- 5))) 10))
(assert (= (g4 (g2 (- 5))) 81))
(assert (= (g4 (f3 (- 6))) 117))
(assert (= (f4 (f3 (- 8))) (- 20)))
(assert (= (g4 (g3 (- 8))) (- 1013)))
(assert (= (f4 (f4 1)) 10))
(assert (= (g4 (g4 1)) 81))
(check-sat)
