(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 9)) 20))
(assert (= (f1 (g1 7)) (- 83)))
(assert (= (f1 (f2 2)) (- 10)))
(assert (= (f1 (g2 9)) (- 42)))
(assert (= (f1 (f3 (- 6))) 20))
(assert (= (f1 (g3 2)) (- 42)))
(assert (= (g1 (f3 7)) 176))
(assert (= (f1 (g4 (- 6))) (- 83)))
(assert (= (g1 (f4 9)) 176))
(assert (= (f2 (f1 2)) (- 10)))
(assert (= (f2 (g1 9)) 101))
(assert (= (f2 (f2 (- 6))) (- 10)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 7)) 36))
(assert (= (f2 (g3 (- 6))) 101))
(assert (= (g2 (f3 9)) 72))
(assert (= (g2 (f4 2)) 36))
(assert (= (f2 (f4 7)) 16))
(assert (= (g2 (g4 7)) 392))
(assert (= (f3 (f1 (- 6))) 20))
(assert (= (f3 (g1 2)) 31))
(assert (= (g3 (f1 7)) 225))
(assert (= (f3 (g2 (- 6))) 31))
(assert (= (g3 (f2 9)) 198))
(assert (= (g3 (f3 2)) 198))
(assert (= (f3 (f3 7)) 25))
(assert (= (g3 (g3 7)) 2268))
(assert (= (g3 (f4 (- 6))) 225))
(assert (= (f3 (f4 9)) 25))
(assert (= (g3 (g4 9)) 2268))
(assert (= (f4 (g1 (- 6))) (- 68)))
(assert (= (g4 (f1 9)) 203))
(assert (= (g4 (f2 2)) 56))
(assert (= (f4 (f2 7)) 16))
(assert (= (g4 (g2 7)) 392))
(assert (= (g4 (f3 (- 6))) 203))
(assert (= (f4 (f3 9)) 25))
(assert (= (g4 (g3 9)) 2268))
(assert (= (f4 (f4 2)) 16))
(assert (= (g4 (g4 2)) 392))
(check-sat)
