(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 18)))
(assert (= (f1 (g1 4)) (- 50)))
(assert (= (f1 (f2 5)) (- 16)))
(assert (= (f1 (g2 (- 7))) (- 71)))
(assert (= (f1 (f3 (- 6))) (- 18)))
(assert (= (f1 (g3 5)) (- 71)))
(assert (= (g1 (f3 4)) (- 116)))
(assert (= (f1 (g4 (- 6))) (- 50)))
(assert (= (g1 (f4 (- 7))) (- 116)))
(assert (= (f2 (f1 5)) (- 16)))
(assert (= (f2 (g1 (- 7))) (- 77)))
(assert (= (f2 (f2 (- 6))) (- 16)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 4)) 90))
(assert (= (f2 (g3 (- 6))) (- 77)))
(assert (= (g2 (f3 (- 7))) 130))
(assert (= (g2 (f4 5)) 90))
(assert (= (f2 (f4 4)) 13))
(assert (= (g2 (g4 4)) 320))
(assert (= (f3 (f1 (- 6))) (- 18)))
(assert (= (f3 (g1 5)) (- 62)))
(assert (= (g3 (f1 4)) (- 124)))
(assert (= (f3 (g2 (- 6))) (- 62)))
(assert (= (g3 (f2 (- 7))) (- 150)))
(assert (= (g3 (f3 5)) (- 150)))
(assert (= (f3 (f3 4)) 17))
(assert (= (g3 (g3 4)) 676))
(assert (= (g3 (f4 (- 6))) (- 124)))
(assert (= (f3 (f4 (- 7))) 17))
(assert (= (g3 (g4 (- 7))) 676))
(assert (= (f4 (g1 (- 6))) (- 65)))
(assert (= (g4 (f1 (- 7))) 96))
(assert (= (g4 (f2 5)) 80))
(assert (= (f4 (f2 4)) 13))
(assert (= (g4 (g2 4)) 320))
(assert (= (g4 (f3 (- 6))) 96))
(assert (= (f4 (f3 (- 7))) 17))
(assert (= (g4 (g3 (- 7))) 676))
(assert (= (f4 (f4 5)) 13))
(assert (= (g4 (g4 5)) 320))
(check-sat)
