(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 19)))
(assert (= (f1 (g1 6)) (- 72)))
(assert (= (f1 (f2 8)) (- 22)))
(assert (= (f1 (g2 (- 8))) (- 126)))
(assert (= (f1 (f3 (- 6))) (- 19)))
(assert (= (f1 (g3 8)) (- 126)))
(assert (= (g1 (f3 6)) (- 149)))
(assert (= (f1 (g4 (- 6))) (- 72)))
(assert (= (g1 (f4 (- 8))) (- 149)))
(assert (= (f2 (f1 8)) (- 22)))
(assert (= (f2 (g1 (- 8))) (- 91)))
(assert (= (f2 (f2 (- 6))) (- 22)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 6)) 224))
(assert (= (f2 (g3 (- 6))) (- 91)))
(assert (= (g2 (f3 (- 8))) 240))
(assert (= (g2 (f4 8)) 224))
(assert (= (f2 (f4 6)) 20))
(assert (= (g2 (g4 6)) 1152))
(assert (= (f3 (f1 (- 6))) (- 19)))
(assert (= (f3 (g1 8)) (- 96)))
(assert (= (g3 (f1 6)) (- 173)))
(assert (= (f3 (g2 (- 6))) (- 96)))
(assert (= (g3 (f2 (- 8))) (- 233)))
(assert (= (g3 (f3 8)) (- 233)))
(assert (= (f3 (f3 6)) 21))
(assert (= (g3 (g3 6)) 1350))
(assert (= (g3 (f4 (- 6))) (- 173)))
(assert (= (f3 (f4 (- 8))) 21))
(assert (= (g3 (g4 (- 8))) 1350))
(assert (= (f4 (g1 (- 6))) (- 67)))
(assert (= (g4 (f1 (- 8))) 156))
(assert (= (g4 (f2 8)) 192))
(assert (= (f4 (f2 6)) 20))
(assert (= (g4 (g2 6)) 1152))
(assert (= (g4 (f3 (- 6))) 156))
(assert (= (f4 (f3 (- 8))) 21))
(assert (= (g4 (g3 (- 8))) 1350))
(assert (= (f4 (f4 8)) 20))
(assert (= (g4 (g4 8)) 1152))
(check-sat)
