(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 13)))
(assert (= (f1 (g1 (- 8))) 88))
(assert (= (f1 (f2 8)) (- 22)))
(assert (= (f1 (g2 (- 2))) (- 30)))
(assert (= (f1 (f3 (- 6))) (- 13)))
(assert (= (f1 (g3 8)) (- 30)))
(assert (= (g1 (f3 (- 8))) 99))
(assert (= (f1 (g4 (- 6))) 88))
(assert (= (g1 (f4 (- 2))) 99))
(assert (= (f2 (f1 8)) (- 22)))
(assert (= (f2 (g1 (- 2))) (- 25)))
(assert (= (f2 (f2 (- 6))) (- 22)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 8))) 248))
(assert (= (f2 (g3 (- 6))) (- 25)))
(assert (= (g2 (f3 (- 2))) 48))
(assert (= (g2 (f4 8)) 248))
(assert (= (f2 (f4 (- 8))) 23))
(assert (= (g2 (g4 (- 8))) 1800))
(assert (= (f3 (f1 (- 6))) (- 13)))
(assert (= (f3 (g1 8)) (- 90)))
(assert (= (g3 (f1 (- 8))) 39))
(assert (= (f3 (g2 (- 6))) (- 90)))
(assert (= (g3 (f2 (- 2))) (- 29)))
(assert (= (g3 (f3 8)) (- 29)))
(assert (= (f3 (f3 (- 8))) (- 11)))
(assert (= (g3 (g3 (- 8))) (- 68)))
(assert (= (g3 (f4 (- 6))) 39))
(assert (= (f3 (f4 (- 2))) (- 11)))
(assert (= (g3 (g4 (- 2))) (- 68)))
(assert (= (f4 (g1 (- 6))) 68))
(assert (= (g4 (f1 (- 2))) 105))
(assert (= (g4 (f2 8)) 240))
(assert (= (f4 (f2 (- 8))) 23))
(assert (= (g4 (g2 (- 8))) 1800))
(assert (= (g4 (f3 (- 6))) 105))
(assert (= (f4 (f3 (- 2))) (- 11)))
(assert (= (g4 (g3 (- 2))) (- 68)))
(assert (= (f4 (f4 8)) 23))
(assert (= (g4 (g4 8)) 1800))
(check-sat)
