(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 15)))
(assert (= (f1 (g1 (- 9))) 81))
(assert (= (f1 (f2 (- 7))) (- 18)))
(assert (= (f1 (g2 (- 6))) 76))
(assert (= (f1 (f3 (- 5))) (- 15)))
(assert (= (f1 (g3 (- 7))) 76))
(assert (= (g1 (f3 (- 9))) 126))
(assert (= (f1 (g4 (- 5))) 81))
(assert (= (g1 (f4 (- 6))) 126))
(assert (= (f2 (f1 (- 7))) (- 18)))
(assert (= (f2 (g1 (- 6))) 56))
(assert (= (f2 (f2 (- 5))) (- 18)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 9))) 195))
(assert (= (f2 (g3 (- 5))) 56))
(assert (= (g2 (f3 (- 6))) 143))
(assert (= (g2 (f4 (- 7))) 195))
(assert (= (f2 (f4 (- 9))) (- 24)))
(assert (= (g2 (g4 (- 9))) (- 1879)))
(assert (= (f3 (f1 (- 5))) (- 15)))
(assert (= (f3 (g1 (- 7))) 64))
(assert (= (g3 (f1 (- 9))) 143))
(assert (= (f3 (g2 (- 5))) 64))
(assert (= (g3 (f2 (- 6))) 132))
(assert (= (g3 (f3 (- 7))) 132))
(assert (= (f3 (f3 (- 9))) (- 20)))
(assert (= (g3 (g3 (- 9))) (- 1029)))
(assert (= (g3 (f4 (- 5))) 143))
(assert (= (f3 (f4 (- 6))) (- 20)))
(assert (= (g3 (g4 (- 6))) (- 1029)))
(assert (= (f4 (g1 (- 5))) 49))
(assert (= (g4 (f1 (- 6))) 170))
(assert (= (g4 (f2 (- 7))) 221))
(assert (= (f4 (f2 (- 9))) (- 24)))
(assert (= (g4 (g2 (- 9))) (- 1879)))
(assert (= (g4 (f3 (- 5))) 170))
(assert (= (f4 (f3 (- 6))) (- 20)))
(assert (= (g4 (g3 (- 6))) (- 1029)))
(assert (= (f4 (f4 (- 7))) (- 24)))
(assert (= (g4 (g4 (- 7))) (- 1879)))
(check-sat)
