(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 17))
(assert (= (f1 (g1 3)) (- 32)))
(assert (= (f1 (f2 (- 7))) (- 18)))
(assert (= (f1 (g2 8)) (- 109)))
(assert (= (f1 (f3 (- 5))) 17))
(assert (= (f1 (g3 (- 7))) (- 109)))
(assert (= (g1 (f3 3)) 99))
(assert (= (f1 (g4 (- 5))) (- 32)))
(assert (= (g1 (f4 8)) 99))
(assert (= (f2 (f1 (- 7))) (- 18)))
(assert (= (f2 (g1 8)) (- 79)))
(assert (= (f2 (f2 (- 5))) (- 18)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 3)) (- 124)))
(assert (= (f2 (g3 (- 5))) (- 79)))
(assert (= (g2 (f3 8)) 208))
(assert (= (g2 (f4 (- 7))) (- 124)))
(assert (= (f2 (f4 3)) (- 13)))
(assert (= (g2 (g4 3)) 234))
(assert (= (f3 (f1 (- 5))) 17))
(assert (= (f3 (g1 (- 7))) (- 67)))
(assert (= (g3 (f1 3)) 120))
(assert (= (f3 (g2 (- 5))) (- 67)))
(assert (= (g3 (f2 8)) 232))
(assert (= (g3 (f3 (- 7))) 232))
(assert (= (f3 (f3 3)) 19))
(assert (= (g3 (g3 3)) 768))
(assert (= (g3 (f4 (- 5))) 120))
(assert (= (f3 (f4 8)) 19))
(assert (= (g3 (g4 8)) 768))
(assert (= (f4 (g1 (- 5))) (- 44)))
(assert (= (g4 (f1 8)) 75))
(assert (= (g4 (f2 (- 7))) 78))
(assert (= (f4 (f2 3)) (- 13)))
(assert (= (g4 (g2 3)) 234))
(assert (= (g4 (f3 (- 5))) 75))
(assert (= (f4 (f3 8)) 19))
(assert (= (g4 (g3 8)) 768))
(assert (= (f4 (f4 (- 7))) (- 13)))
(assert (= (g4 (g4 (- 7))) 234))
(check-sat)
