(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 8)) 17))
(assert (= (f1 (g1 (- 3))) 27))
(assert (= (f1 (f2 (- 6))) (- 16)))
(assert (= (f1 (g2 8)) (- 93)))
(assert (= (f1 (f3 (- 5))) 17))
(assert (= (f1 (g3 (- 6))) (- 93)))
(assert (= (g1 (f3 (- 3))) (- 95)))
(assert (= (f1 (g4 (- 5))) 27))
(assert (= (g1 (f4 8)) (- 95)))
(assert (= (f2 (f1 (- 6))) (- 16)))
(assert (= (f2 (g1 8)) (- 78)))
(assert (= (f2 (f2 (- 5))) (- 16)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 3))) 88))
(assert (= (f2 (g3 (- 5))) (- 78)))
(assert (= (g2 (f3 8)) 176))
(assert (= (g2 (f4 (- 6))) 88))
(assert (= (f2 (f4 (- 3))) (- 11)))
(assert (= (g2 (g4 (- 3))) (- 138)))
(assert (= (f3 (f1 (- 5))) 17))
(assert (= (f3 (g1 (- 6))) (- 58)))
(assert (= (g3 (f1 (- 3))) 112))
(assert (= (f3 (g2 (- 5))) (- 58)))
(assert (= (g3 (f2 8)) 216))
(assert (= (g3 (f3 (- 6))) 216))
(assert (= (f3 (f3 (- 3))) (- 19)))
(assert (= (g3 (g3 (- 3))) 640))
(assert (= (g3 (f4 (- 5))) 112))
(assert (= (f3 (f4 8)) (- 19)))
(assert (= (g3 (g4 8)) 640))
(assert (= (f4 (g1 (- 5))) 43))
(assert (= (g4 (f1 8)) (- 63)))
(assert (= (g4 (f2 (- 6))) 55))
(assert (= (f4 (f2 (- 3))) (- 11)))
(assert (= (g4 (g2 (- 3))) (- 138)))
(assert (= (g4 (f3 (- 5))) (- 63)))
(assert (= (f4 (f3 8)) (- 19)))
(assert (= (g4 (g3 8)) 640))
(assert (= (f4 (f4 (- 6))) (- 11)))
(assert (= (g4 (g4 (- 6))) (- 138)))
(check-sat)
