(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 17)))
(assert (= (f1 (g1 4)) (- 41)))
(assert (= (f1 (f2 (- 4))) (- 12)))
(assert (= (f1 (g2 (- 8))) 57))
(assert (= (f1 (f3 (- 5))) (- 17)))
(assert (= (f1 (g3 (- 4))) 57))
(assert (= (g1 (f3 4)) (- 104)))
(assert (= (f1 (g4 (- 5))) (- 41)))
(assert (= (g1 (f4 (- 8))) (- 104)))
(assert (= (f2 (f1 (- 4))) (- 12)))
(assert (= (f2 (g1 (- 8))) 71))
(assert (= (f2 (f2 (- 5))) (- 12)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 4)) (- 53)))
(assert (= (f2 (g3 (- 5))) 71))
(assert (= (g2 (f3 (- 8))) 105))
(assert (= (g2 (f4 (- 4))) (- 53)))
(assert (= (f2 (f4 4)) (- 12)))
(assert (= (g2 (g4 4)) 224))
(assert (= (f3 (f1 (- 5))) (- 17)))
(assert (= (f3 (g1 (- 4))) 39))
(assert (= (g3 (f1 4)) (- 128)))
(assert (= (f3 (g2 (- 5))) 39))
(assert (= (g3 (f2 (- 8))) 165))
(assert (= (g3 (f3 (- 4))) 165))
(assert (= (f3 (f3 4)) 19))
(assert (= (g3 (g3 4)) 900))
(assert (= (g3 (f4 (- 5))) (- 128)))
(assert (= (f3 (f4 (- 8))) 19))
(assert (= (g3 (g4 (- 8))) 900))
(assert (= (f4 (g1 (- 5))) (- 45)))
(assert (= (g4 (f1 (- 8))) 96))
(assert (= (g4 (f2 (- 4))) 56))
(assert (= (f4 (f2 4)) (- 12)))
(assert (= (g4 (g2 4)) 224))
(assert (= (g4 (f3 (- 5))) 96))
(assert (= (f4 (f3 (- 8))) 19))
(assert (= (g4 (g3 (- 8))) 900))
(assert (= (f4 (f4 (- 4))) (- 12)))
(assert (= (g4 (g4 (- 4))) 224))
(check-sat)
