(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 1)) 10))
(assert (= (f1 (g1 7)) (- 68)))
(assert (= (f1 (f2 (- 4))) (- 12)))
(assert (= (f1 (g2 1)) (- 12)))
(assert (= (f1 (f3 (- 5))) 10))
(assert (= (f1 (g3 (- 4))) (- 12)))
(assert (= (g1 (f3 7)) 72))
(assert (= (f1 (g4 (- 5))) (- 68)))
(assert (= (g1 (f4 1)) 72))
(assert (= (f2 (f1 (- 4))) (- 12)))
(assert (= (f2 (g1 1)) (- 13)))
(assert (= (f2 (f2 (- 5))) (- 12)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 7)) (- 74)))
(assert (= (f2 (g3 (- 5))) (- 13)))
(assert (= (g2 (f3 1)) 14))
(assert (= (g2 (f4 (- 4))) (- 74)))
(assert (= (f2 (f4 7)) (- 18)))
(assert (= (g2 (g4 7)) 686))
(assert (= (f3 (f1 (- 5))) 10))
(assert (= (f3 (g1 (- 4))) (- 33)))
(assert (= (g3 (f1 7)) 23))
(assert (= (f3 (g2 (- 5))) (- 33)))
(assert (= (g3 (f2 1)) 9))
(assert (= (g3 (f3 (- 4))) 9))
(assert (= (f3 (f3 7)) 9))
(assert (= (g3 (g3 7)) 28))
(assert (= (g3 (f4 (- 5))) 23))
(assert (= (f3 (f4 1)) 9))
(assert (= (g3 (g4 1)) 28))
(assert (= (f4 (g1 (- 5))) (- 48)))
(assert (= (g4 (f1 1)) 77))
(assert (= (g4 (f2 (- 4))) 98))
(assert (= (f4 (f2 7)) (- 18)))
(assert (= (g4 (g2 7)) 686))
(assert (= (g4 (f3 (- 5))) 77))
(assert (= (f4 (f3 1)) 9))
(assert (= (g4 (g3 1)) 28))
(assert (= (f4 (f4 (- 4))) (- 18)))
(assert (= (g4 (g4 (- 4))) 686))
(check-sat)
