(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 4))) (- 13)))
(assert (= (f1 (g1 7)) (- 68)))
(assert (= (f1 (f2 (- 3))) (- 10)))
(assert (= (f1 (g2 (- 4))) 22))
(assert (= (f1 (f3 (- 5))) (- 13)))
(assert (= (f1 (g3 (- 3))) 22))
(assert (= (g1 (f3 7)) (- 95)))
(assert (= (f1 (g4 (- 5))) (- 68)))
(assert (= (g1 (f4 (- 4))) (- 95)))
(assert (= (f2 (f1 (- 3))) (- 10)))
(assert (= (f2 (g1 (- 4))) 34))
(assert (= (f2 (f2 (- 5))) (- 10)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 7)) (- 48)))
(assert (= (f2 (g3 (- 5))) 34))
(assert (= (g2 (f3 (- 4))) 35))
(assert (= (g2 (f4 (- 3))) (- 48)))
(assert (= (f2 (f4 7)) (- 17)))
(assert (= (g2 (g4 7)) 490))
(assert (= (f3 (f1 (- 5))) (- 13)))
(assert (= (f3 (g1 (- 3))) 26))
(assert (= (g3 (f1 7)) (- 81)))
(assert (= (f3 (g2 (- 5))) 26))
(assert (= (g3 (f2 (- 4))) 42))
(assert (= (g3 (f3 (- 3))) 42))
(assert (= (f3 (f3 7)) 14))
(assert (= (g3 (g3 7)) 343))
(assert (= (g3 (f4 (- 5))) (- 81)))
(assert (= (f3 (f4 (- 4))) 14))
(assert (= (g3 (g4 (- 4))) 343))
(assert (= (f4 (g1 (- 5))) (- 48)))
(assert (= (g4 (f1 (- 4))) 112))
(assert (= (g4 (f2 (- 3))) 70))
(assert (= (f4 (f2 7)) (- 17)))
(assert (= (g4 (g2 7)) 490))
(assert (= (g4 (f3 (- 5))) 112))
(assert (= (f4 (f3 (- 4))) 14))
(assert (= (g4 (g3 (- 4))) 343))
(assert (= (f4 (f4 (- 3))) (- 17)))
(assert (= (g4 (g4 (- 3))) 490))
(check-sat)
