(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 1)) 10))
(assert (= (f1 (g1 4)) (- 41)))
(assert (= (f1 (f2 (- 3))) (- 10)))
(assert (= (f1 (g2 1)) (- 10)))
(assert (= (f1 (f3 (- 5))) 10))
(assert (= (f1 (g3 (- 3))) (- 10)))
(assert (= (g1 (f3 4)) 45))
(assert (= (f1 (g4 (- 5))) (- 41)))
(assert (= (g1 (f4 1)) 45))
(assert (= (f2 (f1 (- 3))) (- 10)))
(assert (= (f2 (g1 1)) (- 12)))
(assert (= (f2 (f2 (- 5))) (- 10)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 4)) (- 33)))
(assert (= (f2 (g3 (- 5))) (- 12)))
(assert (= (g2 (f3 1)) 10))
(assert (= (g2 (f4 (- 3))) (- 33)))
(assert (= (f2 (f4 4)) (- 11)))
(assert (= (g2 (g4 4)) 160))
(assert (= (f3 (f1 (- 5))) 10))
(assert (= (f3 (g1 (- 3))) (- 24)))
(assert (= (g3 (f1 4)) 17))
(assert (= (f3 (g2 (- 5))) (- 24)))
(assert (= (g3 (f2 1)) 7))
(assert (= (g3 (f3 (- 3))) 7))
(assert (= (f3 (f3 4)) 6))
(assert (= (g3 (g3 4)) 16))
(assert (= (g3 (f4 (- 5))) 17))
(assert (= (f3 (f4 1)) 6))
(assert (= (g3 (g4 1)) 16))
(assert (= (f4 (g1 (- 5))) (- 45)))
(assert (= (g4 (f1 1)) 44))
(assert (= (g4 (f2 (- 3))) 40))
(assert (= (f4 (f2 4)) (- 11)))
(assert (= (g4 (g2 4)) 160))
(assert (= (g4 (f3 (- 5))) 44))
(assert (= (f4 (f3 1)) 6))
(assert (= (g4 (g3 1)) 16))
(assert (= (f4 (f4 (- 3))) (- 11)))
(assert (= (g4 (g4 (- 3))) 160))
(check-sat)
