(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 22))
(assert (= (f1 (g1 (- 5))) 85))
(assert (= (f1 (f2 1)) (- 11)))
(assert (= (f1 (g2 5)) (- 19)))
(assert (= (f1 (f3 (- 9))) 22))
(assert (= (f1 (g3 1)) (- 19)))
(assert (= (g1 (f3 (- 5))) (- 162)))
(assert (= (f1 (g4 (- 9))) 85))
(assert (= (g1 (f4 5)) (- 162)))
(assert (= (f2 (f1 1)) (- 11)))
(assert (= (f2 (g1 5)) 86))
(assert (= (f2 (f2 (- 9))) (- 11)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 5))) 11))
(assert (= (f2 (g3 (- 9))) 86))
(assert (= (g2 (f3 5)) 20))
(assert (= (g2 (f4 1)) 11))
(assert (= (f2 (f4 (- 5))) 10))
(assert (= (g2 (g4 (- 5))) 81))
(assert (= (f3 (f1 (- 9))) 22))
(assert (= (f3 (g1 1)) 22))
(assert (= (g3 (f1 (- 5))) 130))
(assert (= (f3 (g2 (- 9))) 22))
(assert (= (g3 (f2 5)) 60))
(assert (= (g3 (f3 1)) 60))
(assert (= (f3 (f3 (- 5))) (- 15)))
(assert (= (g3 (g3 (- 5))) 450))
(assert (= (g3 (f4 (- 9))) 130))
(assert (= (f3 (f4 5)) (- 15)))
(assert (= (g3 (g4 5)) 450))
(assert (= (f4 (g1 (- 9))) 149))
(assert (= (g4 (f1 5)) (- 122)))
(assert (= (g4 (f2 1)) 18))
(assert (= (f4 (f2 (- 5))) 10))
(assert (= (g4 (g2 (- 5))) 81))
(assert (= (g4 (f3 (- 9))) (- 122)))
(assert (= (f4 (f3 5)) (- 15)))
(assert (= (g4 (g3 5)) 450))
(assert (= (f4 (f4 1)) 10))
(assert (= (g4 (g4 1)) 81))
(check-sat)
