(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 12)))
(assert (= (f1 (g1 (- 4))) 36))
(assert (= (f1 (f2 (- 2))) (- 8)))
(assert (= (f1 (g2 (- 3))) 12))
(assert (= (f1 (f3 (- 5))) (- 12)))
(assert (= (f1 (g3 (- 2))) 12))
(assert (= (g1 (f3 (- 4))) 54))
(assert (= (f1 (g4 (- 5))) 36))
(assert (= (g1 (f4 (- 3))) 54))
(assert (= (f2 (f1 (- 2))) (- 8)))
(assert (= (f2 (g1 (- 3))) 24))
(assert (= (f2 (f2 (- 5))) (- 8)))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 4))) 15))
(assert (= (f2 (g3 (- 5))) 24))
(assert (= (g2 (f3 (- 3))) 15))
(assert (= (g2 (f4 (- 2))) 15))
(assert (= (f2 (f4 (- 4))) (- 9)))
(assert (= (g2 (g4 (- 4))) (- 74)))
(assert (= (f3 (f1 (- 5))) (- 12)))
(assert (= (f3 (g1 (- 2))) 16))
(assert (= (g3 (f1 (- 4))) 40))
(assert (= (f3 (g2 (- 5))) 16))
(assert (= (g3 (f2 (- 3))) 20))
(assert (= (g3 (f3 (- 2))) 20))
(assert (= (f3 (f3 (- 4))) (- 9)))
(assert (= (g3 (g3 (- 4))) (- 88)))
(assert (= (g3 (f4 (- 5))) 40))
(assert (= (f3 (f4 (- 3))) (- 9)))
(assert (= (g3 (g4 (- 3))) (- 88)))
(assert (= (f4 (g1 (- 5))) 44))
(assert (= (g4 (f1 (- 3))) 49))
(assert (= (g4 (f2 (- 2))) 21))
(assert (= (f4 (f2 (- 4))) (- 9)))
(assert (= (g4 (g2 (- 4))) (- 74)))
(assert (= (g4 (f3 (- 5))) 49))
(assert (= (f4 (f3 (- 3))) (- 9)))
(assert (= (g4 (g3 (- 3))) (- 88)))
(assert (= (f4 (f4 (- 2))) (- 9)))
(assert (= (g4 (g4 (- 2))) (- 74)))
(check-sat)
