(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 18)))
(assert (= (f1 (g1 2)) (- 23)))
(assert (= (f1 (f2 (- 1))) (- 6)))
(assert (= (f1 (g2 (- 9))) 13))
(assert (= (f1 (f3 (- 5))) (- 18)))
(assert (= (f1 (g3 (- 1))) 13))
(assert (= (g1 (f3 2)) (- 95)))
(assert (= (f1 (g4 (- 5))) (- 23)))
(assert (= (g1 (f4 (- 9))) (- 95)))
(assert (= (f2 (f1 (- 1))) (- 6)))
(assert (= (f2 (g1 (- 9))) 77))
(assert (= (f2 (f2 (- 5))) (- 6)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 2)) (- 3)))
(assert (= (f2 (g3 (- 5))) 77))
(assert (= (g2 (f3 (- 9))) 17))
(assert (= (g2 (f4 (- 1))) (- 3)))
(assert (= (f2 (f4 2)) (- 5)))
(assert (= (g2 (g4 2)) 8))
(assert (= (f3 (f1 (- 5))) (- 18)))
(assert (= (f3 (g1 (- 1))) 13))
(assert (= (g3 (f1 2)) (- 111)))
(assert (= (f3 (g2 (- 5))) 13))
(assert (= (g3 (f2 (- 9))) 153))
(assert (= (g3 (f3 (- 1))) 153))
(assert (= (f3 (f3 2)) 19))
(assert (= (g3 (g3 2)) 578))
(assert (= (g3 (f4 (- 5))) (- 111)))
(assert (= (f3 (f4 (- 9))) 19))
(assert (= (g3 (g4 (- 9))) 578))
(assert (= (f4 (g1 (- 5))) (- 43)))
(assert (= (g4 (f1 (- 9))) 52))
(assert (= (g4 (f2 (- 1))) 4))
(assert (= (f4 (f2 2)) (- 5)))
(assert (= (g4 (g2 2)) 8))
(assert (= (g4 (f3 (- 5))) 52))
(assert (= (f4 (f3 (- 9))) 19))
(assert (= (g4 (g3 (- 9))) 578))
(assert (= (f4 (f4 (- 1))) (- 5)))
(assert (= (g4 (g4 (- 1))) 8))
(check-sat)
