(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 1) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 1) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 1))) (- 10)))
(assert (= (f1 (g1 (- 4))) 36))
(assert (= (f1 (f2 2)) (- 9)))
(assert (= (f1 (g2 (- 1))) (- 7)))
(assert (= (f1 (f3 (- 5))) (- 10)))
(assert (= (f1 (g3 2)) (- 7)))
(assert (= (g1 (f3 (- 4))) 36))
(assert (= (f1 (g4 (- 5))) 36))
(assert (= (g1 (f4 (- 1))) 36))
(assert (= (f2 (f1 2)) (- 9)))
(assert (= (f2 (g1 (- 1))) (- 7)))
(assert (= (f2 (f2 (- 5))) (- 9)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 4))) 22))
(assert (= (f2 (g3 (- 5))) (- 7)))
(assert (= (g2 (f3 (- 1))) 4))
(assert (= (g2 (f4 2)) 22))
(assert (= (f2 (f4 (- 4))) 9))
(assert (= (g2 (g4 (- 4))) 98))
(assert (= (f3 (f1 (- 5))) (- 10)))
(assert (= (f3 (g1 2)) (- 19)))
(assert (= (g3 (f1 (- 4))) 8))
(assert (= (f3 (g2 (- 5))) (- 19)))
(assert (= (g3 (f2 (- 1))) (- 3)))
(assert (= (g3 (f3 2)) (- 3)))
(assert (= (f3 (f3 (- 4))) (- 5)))
(assert (= (g3 (g3 (- 4))) (- 4)))
(assert (= (g3 (f4 (- 5))) 8))
(assert (= (f3 (f4 (- 1))) (- 5)))
(assert (= (g3 (g4 (- 1))) (- 4)))
(assert (= (f4 (g1 (- 5))) 44))
(assert (= (g4 (f1 (- 1))) 35))
(assert (= (g4 (f2 2)) 28))
(assert (= (f4 (f2 (- 4))) 9))
(assert (= (g4 (g2 (- 4))) 98))
(assert (= (g4 (f3 (- 5))) 35))
(assert (= (f4 (f3 (- 1))) (- 5)))
(assert (= (g4 (g3 (- 1))) (- 4)))
(assert (= (f4 (f4 2)) 9))
(assert (= (g4 (g4 2)) 98))
(check-sat)
