(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g3 x)))))
(assert (= (f1 (f1 9)) 18))
(assert (= (f1 (g1 (- 6))) 54))
(assert (= (f1 (f2 2)) (- 9)))
(assert (= (f1 (g2 9)) (- 41)))
(assert (= (f1 (f3 (- 5))) 18))
(assert (= (f1 (g3 2)) (- 41)))
(assert (= (g1 (f3 (- 6))) (- 131)))
(assert (= (f1 (g4 (- 5))) 54))
(assert (= (g1 (f4 9)) (- 131)))
(assert (= (f2 (f1 2)) (- 9)))
(assert (= (f2 (g1 9)) 83))
(assert (= (f2 (f2 (- 5))) (- 9)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 6))) 30))
(assert (= (f2 (g3 (- 5))) 83))
(assert (= (g2 (f3 9)) 72))
(assert (= (g2 (f4 2)) 30))
(assert (= (f2 (f4 (- 6))) 13))
(assert (= (g2 (g4 (- 6))) 242))
(assert (= (f3 (f1 (- 5))) 18))
(assert (= (f3 (g1 2)) 27))
(assert (= (g3 (f1 (- 6))) 180))
(assert (= (f3 (g2 (- 5))) 27))
(assert (= (g3 (f2 9)) 198))
(assert (= (g3 (f3 2)) 198))
(assert (= (f3 (f3 (- 6))) (- 24)))
(assert (= (g3 (g3 (- 6))) 1782))
(assert (= (g3 (f4 (- 5))) 180))
(assert (= (f3 (f4 9)) (- 24)))
(assert (= (g3 (g4 9)) 1782))
(assert (= (f4 (g1 (- 5))) 46))
(assert (= (g4 (f1 9)) (- 149)))
(assert (= (g4 (f2 2)) 44))
(assert (= (f4 (f2 (- 6))) 13))
(assert (= (g4 (g2 (- 6))) 242))
(assert (= (g4 (f3 (- 5))) (- 149)))
(assert (= (f4 (f3 9)) (- 24)))
(assert (= (g4 (g3 9)) 1782))
(assert (= (f4 (f4 2)) 13))
(assert (= (g4 (g4 2)) 242))
(check-sat)
