(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 3)) 12))
(assert (= (f1 (g1 0)) (- 5)))
(assert (= (f1 (f2 6)) (- 17)))
(assert (= (f1 (g2 3)) (- 41)))
(assert (= (f1 (f3 (- 5))) 12))
(assert (= (f1 (g3 6)) (- 41)))
(assert (= (g1 (f3 0)) 27))
(assert (= (f1 (g4 (- 5))) (- 5)))
(assert (= (g1 (f4 3)) 27))
(assert (= (f2 (f1 6)) (- 17)))
(assert (= (f2 (g1 3)) 33))
(assert (= (f2 (f2 (- 5))) (- 17)))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 0)) 72))
(assert (= (f2 (g3 (- 5))) 33))
(assert (= (g2 (f3 3)) 72))
(assert (= (g2 (f4 6)) 72))
(assert (= (f2 (f4 0)) 6))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 (- 5))) 12))
(assert (= (f3 (g1 6)) 57))
(assert (= (g3 (f1 0)) 27))
(assert (= (f3 (g2 (- 5))) 57))
(assert (= (g3 (f2 3)) 54))
(assert (= (g3 (f3 6)) 54))
(assert (= (f3 (f3 0)) 6))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 (- 5))) 27))
(assert (= (f3 (f4 3)) 6))
(assert (= (g3 (g4 3)) 0))
(assert (= (f4 (g1 (- 5))) (- 41)))
(assert (= (g4 (f1 3)) 0))
(assert (= (g4 (f2 6)) 0))
(assert (= (f4 (f2 0)) 6))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 (- 5))) 0))
(assert (= (f4 (f3 3)) 6))
(assert (= (g4 (g3 3)) 0))
(assert (= (f4 (f4 6)) 6))
(assert (= (g4 (g4 6)) 0))
(check-sat)
