(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 15)))
(assert (= (f1 (g1 6)) (- 59)))
(assert (= (f1 (f2 7)) (- 19)))
(assert (= (f1 (g2 (- 6))) (- 82)))
(assert (= (f1 (f3 (- 5))) (- 15)))
(assert (= (f1 (g3 7)) (- 82)))
(assert (= (g1 (f3 6)) (- 104)))
(assert (= (f1 (g4 (- 5))) (- 59)))
(assert (= (g1 (f4 (- 6))) (- 104)))
(assert (= (f2 (f1 7)) (- 19)))
(assert (= (f2 (g1 (- 6))) (- 57)))
(assert (= (f2 (f2 (- 5))) (- 19)))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 6)) 182))
(assert (= (f2 (g3 (- 5))) (- 57)))
(assert (= (g2 (f3 (- 6))) 154))
(assert (= (g2 (f4 7)) 182))
(assert (= (f2 (f4 6)) 19))
(assert (= (g2 (g4 6)) 1008))
(assert (= (f3 (f1 (- 5))) (- 15)))
(assert (= (f3 (g1 7)) (- 69)))
(assert (= (g3 (f1 6)) (- 116)))
(assert (= (f3 (g2 (- 5))) (- 69)))
(assert (= (g3 (f2 (- 6))) (- 138)))
(assert (= (g3 (f3 7)) (- 138)))
(assert (= (f3 (f3 6)) 17))
(assert (= (g3 (g3 6)) 726))
(assert (= (g3 (f4 (- 5))) (- 116)))
(assert (= (f3 (f4 (- 6))) 17))
(assert (= (g3 (g4 (- 6))) 726))
(assert (= (f4 (g1 (- 5))) (- 47)))
(assert (= (g4 (f1 (- 6))) 120))
(assert (= (g4 (f2 7)) 168))
(assert (= (f4 (f2 6)) 19))
(assert (= (g4 (g2 6)) 1008))
(assert (= (g4 (f3 (- 5))) 120))
(assert (= (f4 (f3 (- 6))) 17))
(assert (= (g4 (g3 (- 6))) 726))
(assert (= (f4 (f4 7)) 19))
(assert (= (g4 (g4 7)) 1008))
(check-sat)
