(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 24))
(assert (= (f1 (g1 8)) (- 145)))
(assert (= (f1 (f2 (- 7))) (- 22)))
(assert (= (f1 (g2 7)) (- 100)))
(assert (= (f1 (f3 (- 9))) 24))
(assert (= (f1 (g3 (- 7))) (- 100)))
(assert (= (g1 (f3 8)) 255))
(assert (= (f1 (g4 (- 9))) (- 145)))
(assert (= (g1 (f4 7)) 255))
(assert (= (f2 (f1 (- 7))) (- 22)))
(assert (= (f2 (g1 7)) (- 126)))
(assert (= (f2 (f2 (- 9))) (- 22)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 8)) (- 189)))
(assert (= (f2 (g3 (- 9))) (- 126)))
(assert (= (g2 (f3 7)) 182))
(assert (= (g2 (f4 (- 7))) (- 189)))
(assert (= (f2 (f4 8)) (- 23)))
(assert (= (g2 (g4 8)) 1664))
(assert (= (f3 (f1 (- 9))) 24))
(assert (= (f3 (g1 (- 7))) (- 118)))
(assert (= (g3 (f1 8)) 231))
(assert (= (f3 (g2 (- 9))) (- 118)))
(assert (= (g3 (f2 7)) 189))
(assert (= (g3 (f3 (- 7))) 189))
(assert (= (f3 (f3 8)) 22))
(assert (= (g3 (g3 8)) 1568))
(assert (= (g3 (f4 (- 9))) 231))
(assert (= (f3 (f4 7)) 22))
(assert (= (g3 (g4 7)) 1568))
(assert (= (f4 (g1 (- 9))) (- 153)))
(assert (= (g4 (f1 7)) 248))
(assert (= (g4 (f2 (- 7))) 208))
(assert (= (f4 (f2 8)) (- 23)))
(assert (= (g4 (g2 8)) 1664))
(assert (= (g4 (f3 (- 9))) 248))
(assert (= (f4 (f3 7)) 22))
(assert (= (g4 (g3 7)) 1568))
(assert (= (f4 (f4 (- 7))) (- 23)))
(assert (= (g4 (g4 (- 7))) 1664))
(check-sat)
