(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 9)) 26))
(assert (= (f1 (g1 (- 3))) 51))
(assert (= (f1 (f2 3)) (- 15)))
(assert (= (f1 (g2 9)) (- 63)))
(assert (= (f1 (f3 (- 9))) 26))
(assert (= (f1 (g3 3)) (- 63)))
(assert (= (g1 (f3 (- 3))) (- 196)))
(assert (= (f1 (g4 (- 9))) 51))
(assert (= (g1 (f4 9)) (- 196)))
(assert (= (f2 (f1 3)) (- 15)))
(assert (= (f2 (g1 9)) 156))
(assert (= (f2 (f2 (- 9))) (- 15)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 3))) 33))
(assert (= (f2 (g3 (- 9))) 156))
(assert (= (g2 (f3 9)) 108))
(assert (= (g2 (f4 3)) 33))
(assert (= (f2 (f4 (- 3))) 8))
(assert (= (g2 (g4 (- 3))) 75))
(assert (= (f3 (f1 (- 9))) 26))
(assert (= (f3 (g1 3)) 60))
(assert (= (g3 (f1 (- 3))) 198))
(assert (= (f3 (g2 (- 9))) 60))
(assert (= (g3 (f2 9)) 216))
(assert (= (g3 (f3 3)) 216))
(assert (= (f3 (f3 (- 3))) (- 21)))
(assert (= (g3 (g3 (- 3))) 810))
(assert (= (g3 (f4 (- 9))) 198))
(assert (= (f3 (f4 9)) (- 21)))
(assert (= (g3 (g4 9)) 810))
(assert (= (f4 (g1 (- 9))) 147))
(assert (= (g4 (f1 9)) (- 88)))
(assert (= (g4 (f2 3)) 30))
(assert (= (f4 (f2 (- 3))) 8))
(assert (= (g4 (g2 (- 3))) 75))
(assert (= (g4 (f3 (- 9))) (- 88)))
(assert (= (f4 (f3 9)) (- 21)))
(assert (= (g4 (g3 9)) 810))
(assert (= (f4 (f4 3)) 8))
(assert (= (g4 (g4 3)) 75))
(check-sat)
