(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 13)))
(assert (= (f1 (g1 9)) (- 86)))
(assert (= (f1 (f2 8)) (- 21)))
(assert (= (f1 (g2 (- 4))) (- 61)))
(assert (= (f1 (f3 (- 5))) (- 13)))
(assert (= (f1 (g3 8)) (- 61)))
(assert (= (g1 (f3 9)) (- 113)))
(assert (= (f1 (g4 (- 5))) (- 86)))
(assert (= (g1 (f4 (- 4))) (- 113)))
(assert (= (f2 (f1 8)) (- 21)))
(assert (= (f2 (g1 (- 4))) (- 40)))
(assert (= (f2 (f2 (- 5))) (- 21)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 9)) 272))
(assert (= (f2 (g3 (- 5))) (- 40)))
(assert (= (g2 (f3 (- 4))) 112))
(assert (= (g2 (f4 8)) 272))
(assert (= (f2 (f4 9)) 26))
(assert (= (g2 (g4 9)) 2592))
(assert (= (f3 (f1 (- 5))) (- 13)))
(assert (= (f3 (g1 8)) (- 76)))
(assert (= (g3 (f1 9)) (- 95)))
(assert (= (f3 (g2 (- 5))) (- 76)))
(assert (= (g3 (f2 (- 4))) (- 81)))
(assert (= (g3 (f3 8)) (- 81)))
(assert (= (f3 (f3 9)) 16))
(assert (= (g3 (g3 9)) 441))
(assert (= (g3 (f4 (- 5))) (- 95)))
(assert (= (f3 (f4 (- 4))) 16))
(assert (= (g3 (g4 (- 4))) 441))
(assert (= (f4 (g1 (- 5))) (- 50)))
(assert (= (g4 (f1 (- 4))) 144))
(assert (= (g4 (f2 8)) 288))
(assert (= (f4 (f2 9)) 26))
(assert (= (g4 (g2 9)) 2592))
(assert (= (g4 (f3 (- 5))) 144))
(assert (= (f4 (f3 (- 4))) 16))
(assert (= (g4 (g3 (- 4))) 441))
(assert (= (f4 (f4 8)) 26))
(assert (= (g4 (g4 8)) 2592))
(check-sat)
