(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 13)))
(assert (= (f1 (g1 (- 7))) 49))
(assert (= (f1 (f2 (- 9))) (- 21)))
(assert (= (f1 (g2 (- 6))) 97))
(assert (= (f1 (f3 (- 4))) (- 13)))
(assert (= (f1 (g3 (- 9))) 97))
(assert (= (g1 (f3 (- 7))) 84))
(assert (= (f1 (g4 (- 4))) 49))
(assert (= (g1 (f4 (- 6))) 84))
(assert (= (f2 (f1 (- 9))) (- 21)))
(assert (= (f2 (g1 (- 6))) 47))
(assert (= (f2 (f2 (- 4))) (- 21)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 7))) 255))
(assert (= (f2 (g3 (- 4))) 47))
(assert (= (g2 (f3 (- 6))) 187))
(assert (= (g2 (f4 (- 9))) 255))
(assert (= (f2 (f4 (- 7))) (- 22)))
(assert (= (g2 (g4 (- 7))) (- 1437)))
(assert (= (f3 (f1 (- 4))) (- 13)))
(assert (= (f3 (g1 (- 9))) 65))
(assert (= (g3 (f1 (- 7))) 110))
(assert (= (f3 (g2 (- 4))) 65))
(assert (= (g3 (f2 (- 6))) 154))
(assert (= (g3 (f3 (- 9))) 154))
(assert (= (f3 (f3 (- 7))) (- 18)))
(assert (= (g3 (g3 (- 7))) (- 787)))
(assert (= (g3 (f4 (- 4))) 110))
(assert (= (f3 (f4 (- 6))) (- 18)))
(assert (= (g3 (g4 (- 6))) (- 787)))
(assert (= (f4 (g1 (- 4))) 31))
(assert (= (g4 (f1 (- 6))) 117))
(assert (= (g4 (f2 (- 9))) 221))
(assert (= (f4 (f2 (- 7))) (- 22)))
(assert (= (g4 (g2 (- 7))) (- 1437)))
(assert (= (g4 (f3 (- 4))) 117))
(assert (= (f4 (f3 (- 6))) (- 18)))
(assert (= (g4 (g3 (- 6))) (- 787)))
(assert (= (f4 (f4 (- 9))) (- 22)))
(assert (= (g4 (g4 (- 9))) (- 1437)))
(check-sat)
