(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 13)))
(assert (= (f1 (g1 (- 9))) 63))
(assert (= (f1 (f2 (- 8))) (- 19)))
(assert (= (f1 (g2 (- 6))) 86))
(assert (= (f1 (f3 (- 4))) (- 13)))
(assert (= (f1 (g3 (- 8))) 86))
(assert (= (g1 (f3 (- 9))) 98))
(assert (= (f1 (g4 (- 4))) 63))
(assert (= (g1 (f4 (- 6))) 98))
(assert (= (f2 (f1 (- 8))) (- 19)))
(assert (= (f2 (g1 (- 6))) 46))
(assert (= (f2 (f2 (- 4))) (- 19)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 9))) 240))
(assert (= (f2 (g3 (- 4))) 46))
(assert (= (g2 (f3 (- 6))) 165))
(assert (= (g2 (f4 (- 8))) 240))
(assert (= (f2 (f4 (- 9))) (- 25)))
(assert (= (g2 (g4 (- 9))) (- 2168)))
(assert (= (f3 (f1 (- 4))) (- 13)))
(assert (= (f3 (g1 (- 8))) 58))
(assert (= (g3 (f1 (- 9))) 132))
(assert (= (f3 (g2 (- 4))) 58))
(assert (= (g3 (f2 (- 6))) 143))
(assert (= (g3 (f3 (- 8))) 143))
(assert (= (f3 (f3 (- 9))) (- 20)))
(assert (= (g3 (g3 (- 9))) (- 1029)))
(assert (= (g3 (f4 (- 4))) 132))
(assert (= (f3 (f4 (- 6))) (- 20)))
(assert (= (g3 (g4 (- 6))) (- 1029)))
(assert (= (f4 (g1 (- 4))) 33))
(assert (= (g4 (f1 (- 6))) 153))
(assert (= (g4 (f2 (- 8))) 255))
(assert (= (f4 (f2 (- 9))) (- 25)))
(assert (= (g4 (g2 (- 9))) (- 2168)))
(assert (= (g4 (f3 (- 4))) 153))
(assert (= (f4 (f3 (- 6))) (- 20)))
(assert (= (g4 (g3 (- 6))) (- 1029)))
(assert (= (f4 (f4 (- 8))) (- 25)))
(assert (= (g4 (g4 (- 8))) (- 2168)))
(check-sat)
