(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 12)))
(assert (= (f1 (g1 (- 7))) 49))
(assert (= (f1 (f2 (- 8))) (- 19)))
(assert (= (f1 (g2 (- 5))) 71))
(assert (= (f1 (f3 (- 4))) (- 12)))
(assert (= (f1 (g3 (- 8))) 71))
(assert (= (g1 (f3 (- 7))) 77))
(assert (= (f1 (g4 (- 4))) 49))
(assert (= (g1 (f4 (- 5))) 77))
(assert (= (f2 (f1 (- 8))) (- 19)))
(assert (= (f2 (g1 (- 5))) 39))
(assert (= (f2 (f2 (- 4))) (- 19)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 7))) 210))
(assert (= (f2 (g3 (- 4))) 39))
(assert (= (g2 (f3 (- 5))) 135))
(assert (= (g2 (f4 (- 8))) 210))
(assert (= (f2 (f4 (- 7))) (- 21)))
(assert (= (g2 (g4 (- 7))) (- 1268)))
(assert (= (f3 (f1 (- 4))) (- 12)))
(assert (= (f3 (g1 (- 8))) 57))
(assert (= (g3 (f1 (- 7))) 90))
(assert (= (f3 (g2 (- 4))) 57))
(assert (= (g3 (f2 (- 5))) 108))
(assert (= (g3 (f3 (- 8))) 108))
(assert (= (f3 (f3 (- 7))) (- 16)))
(assert (= (g3 (g3 (- 7))) (- 527)))
(assert (= (g3 (f4 (- 4))) 90))
(assert (= (f3 (f4 (- 5))) (- 16)))
(assert (= (g3 (g4 (- 5))) (- 527)))
(assert (= (f4 (g1 (- 4))) 31))
(assert (= (g4 (f1 (- 5))) 104))
(assert (= (g4 (f2 (- 8))) 195))
(assert (= (f4 (f2 (- 7))) (- 21)))
(assert (= (g4 (g2 (- 7))) (- 1268)))
(assert (= (g4 (f3 (- 4))) 104))
(assert (= (f4 (f3 (- 5))) (- 16)))
(assert (= (g4 (g3 (- 5))) (- 527)))
(assert (= (f4 (f4 (- 8))) (- 21)))
(assert (= (g4 (g4 (- 8))) (- 1268)))
(check-sat)
