(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 24))
(assert (= (f1 (g1 (- 7))) 119))
(assert (= (f1 (f2 5)) (- 19)))
(assert (= (f1 (g2 7)) (- 79)))
(assert (= (f1 (f3 (- 9))) 24))
(assert (= (f1 (g3 5)) (- 79)))
(assert (= (g1 (f3 (- 7))) (- 230)))
(assert (= (f1 (g4 (- 9))) 119))
(assert (= (g1 (f4 7)) (- 230)))
(assert (= (f2 (f1 5)) (- 19)))
(assert (= (f2 (g1 7)) 124))
(assert (= (f2 (f2 (- 9))) (- 19)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 7))) 115))
(assert (= (f2 (g3 (- 9))) 124))
(assert (= (g2 (f3 7)) 140))
(assert (= (g2 (f4 5)) 115))
(assert (= (f2 (f4 (- 7))) 18))
(assert (= (g2 (g4 (- 7))) 845))
(assert (= (f3 (f1 (- 9))) 24))
(assert (= (f3 (g1 5)) 92))
(assert (= (g3 (f1 (- 7))) 210))
(assert (= (f3 (g2 (- 9))) 92))
(assert (= (g3 (f2 7)) 168))
(assert (= (g3 (f3 5)) 168))
(assert (= (f3 (f3 (- 7))) (- 21)))
(assert (= (g3 (g3 (- 7))) 1274))
(assert (= (g3 (f4 (- 9))) 210))
(assert (= (f3 (f4 7)) (- 21)))
(assert (= (g3 (g4 7)) 1274))
(assert (= (f4 (g1 (- 9))) 151))
(assert (= (g4 (f1 7)) (- 202)))
(assert (= (g4 (f2 5)) 130))
(assert (= (f4 (f2 (- 7))) 18))
(assert (= (g4 (g2 (- 7))) 845))
(assert (= (g4 (f3 (- 9))) (- 202)))
(assert (= (f4 (f3 7)) (- 21)))
(assert (= (g4 (g3 7)) 1274))
(assert (= (f4 (f4 5)) 18))
(assert (= (g4 (g4 5)) 845))
(check-sat)
