(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 0 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 0 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 0)) 7))
(assert (= (f1 (g1 9)) (- 67)))
(assert (= (f1 (f2 (- 6))) (- 15)))
(assert (= (f1 (g2 0)) (- 4)))
(assert (= (f1 (f3 (- 4))) 7))
(assert (= (f1 (g3 (- 6))) (- 4)))
(assert (= (g1 (f3 9)) 63))
(assert (= (f1 (g4 (- 4))) (- 67)))
(assert (= (g1 (f4 0)) 63))
(assert (= (f2 (f1 (- 6))) (- 15)))
(assert (= (f2 (g1 0)) (- 6)))
(assert (= (f2 (f2 (- 4))) (- 15)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 9)) (- 160)))
(assert (= (f2 (g3 (- 4))) (- 6)))
(assert (= (g2 (f3 0)) 0))
(assert (= (g2 (f4 (- 6))) (- 160)))
(assert (= (f2 (f4 9)) (- 24)))
(assert (= (g2 (g4 9)) 1782))
(assert (= (f3 (f1 (- 4))) 7))
(assert (= (f3 (g1 (- 6))) (- 39)))
(assert (= (g3 (f1 9)) 0))
(assert (= (f3 (g2 (- 4))) (- 39)))
(assert (= (g3 (f2 0)) 0))
(assert (= (g3 (f3 (- 6))) 0))
(assert (= (f3 (f3 9)) 9))
(assert (= (g3 (g3 9)) 0))
(assert (= (g3 (f4 (- 4))) 0))
(assert (= (f3 (f4 0)) 9))
(assert (= (g3 (g4 0)) 0))
(assert (= (f4 (g1 (- 4))) (- 34)))
(assert (= (g4 (f1 0)) 63))
(assert (= (g4 (f2 (- 6))) 198))
(assert (= (f4 (f2 9)) (- 24)))
(assert (= (g4 (g2 9)) 1782))
(assert (= (g4 (f3 (- 4))) 63))
(assert (= (f4 (f3 0)) 9))
(assert (= (g4 (g3 0)) 0))
(assert (= (f4 (f4 (- 6))) (- 24)))
(assert (= (g4 (g4 (- 6))) 1782))
(check-sat)
