(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 16)))
(assert (= (f1 (g1 1)) (- 11)))
(assert (= (f1 (f2 (- 3))) (- 9)))
(assert (= (f1 (g2 (- 9))) 46))
(assert (= (f1 (f3 (- 4))) (- 16)))
(assert (= (f1 (g3 (- 3))) 46))
(assert (= (g1 (f3 1)) (- 67)))
(assert (= (f1 (g4 (- 4))) (- 11)))
(assert (= (g1 (f4 (- 9))) (- 67)))
(assert (= (f2 (f1 (- 3))) (- 9)))
(assert (= (f2 (g1 (- 9))) 62))
(assert (= (f2 (f2 (- 4))) (- 9)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 1)) (- 18)))
(assert (= (f2 (g3 (- 4))) 62))
(assert (= (g2 (f3 (- 9))) 85))
(assert (= (g2 (f4 (- 3))) (- 18)))
(assert (= (f2 (f4 1)) (- 5)))
(assert (= (g2 (g4 1)) 10))
(assert (= (f3 (f1 (- 4))) (- 16)))
(assert (= (f3 (g1 (- 3))) 26))
(assert (= (g3 (f1 1)) (- 77)))
(assert (= (f3 (g2 (- 4))) 26))
(assert (= (g3 (f2 (- 9))) 187))
(assert (= (g3 (f3 (- 3))) 187))
(assert (= (f3 (f3 1)) 18))
(assert (= (g3 (g3 1)) 289))
(assert (= (g3 (f4 (- 4))) (- 77)))
(assert (= (f3 (f4 (- 9))) 18))
(assert (= (g3 (g4 (- 9))) 289))
(assert (= (f4 (g1 (- 4))) (- 26)))
(assert (= (g4 (f1 (- 9))) 24))
(assert (= (g4 (f2 (- 3))) 10))
(assert (= (f4 (f2 1)) (- 5)))
(assert (= (g4 (g2 1)) 10))
(assert (= (g4 (f3 (- 4))) 24))
(assert (= (f4 (f3 (- 9))) 18))
(assert (= (g4 (g3 (- 9))) 289))
(assert (= (f4 (f4 (- 3))) (- 5)))
(assert (= (g4 (g4 (- 3))) 10))
(check-sat)
