(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 3)) 10))
(assert (= (f1 (g1 5)) (- 39)))
(assert (= (f1 (f2 (- 3))) (- 9)))
(assert (= (f1 (g2 3)) (- 19)))
(assert (= (f1 (f3 (- 4))) 10))
(assert (= (f1 (g3 (- 3))) (- 19)))
(assert (= (g1 (f3 5)) 56))
(assert (= (f1 (g4 (- 4))) (- 39)))
(assert (= (g1 (f4 3)) 56))
(assert (= (f2 (f1 (- 3))) (- 9)))
(assert (= (f2 (g1 3)) (- 24)))
(assert (= (f2 (f2 (- 4))) (- 9)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 5)) (- 38)))
(assert (= (f2 (g3 (- 4))) (- 24)))
(assert (= (g2 (f3 3)) 30))
(assert (= (g2 (f4 (- 3))) (- 38)))
(assert (= (f2 (f4 5)) (- 13)))
(assert (= (g2 (g4 5)) 250))
(assert (= (f3 (f1 (- 4))) 10))
(assert (= (f3 (g1 (- 3))) (- 21)))
(assert (= (g3 (f1 5)) 51))
(assert (= (f3 (g2 (- 4))) (- 21)))
(assert (= (g3 (f2 3)) 33))
(assert (= (g3 (f3 (- 3))) 33))
(assert (= (f3 (f3 5)) 11))
(assert (= (g3 (g3 5)) 180))
(assert (= (g3 (f4 (- 4))) 51))
(assert (= (f3 (f4 3)) 11))
(assert (= (g3 (g4 3)) 180))
(assert (= (f4 (g1 (- 4))) (- 30)))
(assert (= (g4 (f1 3)) 65))
(assert (= (g4 (f2 (- 3))) 50))
(assert (= (f4 (f2 5)) (- 13)))
(assert (= (g4 (g2 5)) 250))
(assert (= (g4 (f3 (- 4))) 65))
(assert (= (f4 (f3 3)) 11))
(assert (= (g4 (g3 3)) 180))
(assert (= (f4 (f4 (- 3))) (- 13)))
(assert (= (g4 (g4 (- 3))) 250))
(check-sat)
