(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 9)) 16))
(assert (= (f1 (g1 (- 8))) 56))
(assert (= (f1 (f2 (- 2))) (- 7)))
(assert (= (f1 (g2 9)) (- 31)))
(assert (= (f1 (f3 (- 4))) 16))
(assert (= (f1 (g3 (- 2))) (- 31)))
(assert (= (g1 (f3 (- 8))) (- 116)))
(assert (= (f1 (g4 (- 4))) 56))
(assert (= (g1 (f4 9)) (- 116)))
(assert (= (f2 (f1 (- 2))) (- 7)))
(assert (= (f2 (g1 9)) (- 65)))
(assert (= (f2 (f2 (- 4))) (- 7)))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 8))) 27))
(assert (= (f2 (g3 (- 4))) (- 65)))
(assert (= (g2 (f3 9)) 54))
(assert (= (g2 (f4 (- 2))) 27))
(assert (= (f2 (f4 (- 8))) (- 17)))
(assert (= (g2 (g4 (- 8))) (- 338)))
(assert (= (f3 (f1 (- 4))) 16))
(assert (= (f3 (g1 (- 2))) (- 20)))
(assert (= (g3 (f1 (- 8))) 198))
(assert (= (f3 (g2 (- 4))) (- 20)))
(assert (= (g3 (f2 9)) 189))
(assert (= (g3 (f3 (- 2))) 189))
(assert (= (f3 (f3 (- 8))) (- 26)))
(assert (= (g3 (g3 (- 8))) 2430))
(assert (= (g3 (f4 (- 4))) 198))
(assert (= (f3 (f4 9)) (- 26)))
(assert (= (g3 (g4 9)) 2430))
(assert (= (f4 (g1 (- 4))) 32))
(assert (= (g4 (f1 9)) (- 188)))
(assert (= (g4 (f2 (- 2))) 45))
(assert (= (f4 (f2 (- 8))) (- 17)))
(assert (= (g4 (g2 (- 8))) (- 338)))
(assert (= (g4 (f3 (- 4))) (- 188)))
(assert (= (f4 (f3 9)) (- 26)))
(assert (= (g4 (g3 9)) 2430))
(assert (= (f4 (f4 (- 2))) (- 17)))
(assert (= (g4 (g4 (- 2))) (- 338)))
(check-sat)
