(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 10)))
(assert (= (f1 (g1 9)) (- 67)))
(assert (= (f1 (f2 4)) (- 12)))
(assert (= (f1 (g2 (- 3))) (- 24)))
(assert (= (f1 (f3 (- 4))) (- 10)))
(assert (= (f1 (g3 4)) (- 24)))
(assert (= (g1 (f3 9)) (- 81)))
(assert (= (f1 (g4 (- 4))) (- 67)))
(assert (= (g1 (f4 (- 3))) (- 81)))
(assert (= (f2 (f1 4)) (- 12)))
(assert (= (f2 (g1 (- 3))) (- 22)))
(assert (= (f2 (f2 (- 4))) (- 12)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 9)) 104))
(assert (= (f2 (g3 (- 4))) (- 22)))
(assert (= (g2 (f3 (- 3))) 40))
(assert (= (g2 (f4 4)) 104))
(assert (= (f2 (f4 9)) 22))
(assert (= (g2 (g4 9)) 1296))
(assert (= (f3 (f1 (- 4))) (- 10)))
(assert (= (f3 (g1 4)) (- 31)))
(assert (= (g3 (f1 9)) (- 63)))
(assert (= (f3 (g2 (- 4))) (- 31)))
(assert (= (g3 (f2 (- 3))) (- 33)))
(assert (= (g3 (f3 4)) (- 33)))
(assert (= (f3 (f3 9)) 14))
(assert (= (g3 (g3 9)) 225))
(assert (= (g3 (f4 (- 4))) (- 63)))
(assert (= (f3 (f4 (- 3))) 14))
(assert (= (g3 (g4 (- 3))) 225))
(assert (= (f4 (g1 (- 4))) (- 34)))
(assert (= (g4 (f1 (- 3))) 108))
(assert (= (g4 (f2 4)) 144))
(assert (= (f4 (f2 9)) 22))
(assert (= (g4 (g2 9)) 1296))
(assert (= (g4 (f3 (- 4))) 108))
(assert (= (f4 (f3 (- 3))) 14))
(assert (= (g4 (g3 (- 3))) 225))
(assert (= (f4 (f4 4)) 22))
(assert (= (g4 (g4 4)) 1296))
(check-sat)
