(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 23))
(assert (= (f1 (g1 3)) (- 53)))
(assert (= (f1 (f2 (- 9))) (- 25)))
(assert (= (f1 (g2 8)) (- 144)))
(assert (= (f1 (f3 (- 8))) 23))
(assert (= (f1 (g3 (- 9))) (- 144)))
(assert (= (g1 (f3 3)) 165))
(assert (= (f1 (g4 (- 8))) (- 53)))
(assert (= (g1 (f4 8)) 165))
(assert (= (f2 (f1 (- 9))) (- 25)))
(assert (= (f2 (g1 8)) (- 129)))
(assert (= (f2 (f2 (- 8))) (- 25)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 3)) (- 196)))
(assert (= (f2 (g3 (- 8))) (- 129)))
(assert (= (g2 (f3 8)) 272))
(assert (= (g2 (f4 (- 9))) (- 196)))
(assert (= (f2 (f4 3)) (- 15)))
(assert (= (g2 (g4 3)) 306))
(assert (= (f3 (f1 (- 8))) 23))
(assert (= (f3 (g1 (- 9))) (- 136)))
(assert (= (g3 (f1 3)) 168))
(assert (= (f3 (g2 (- 8))) (- 136)))
(assert (= (g3 (f2 8)) 264))
(assert (= (g3 (f3 (- 9))) 264))
(assert (= (f3 (f3 3)) 19))
(assert (= (g3 (g3 3)) 768))
(assert (= (g3 (f4 (- 8))) 168))
(assert (= (f3 (f4 8)) 19))
(assert (= (g3 (g4 8)) 768))
(assert (= (f4 (g1 (- 8))) (- 116)))
(assert (= (g4 (f1 8)) 93))
(assert (= (g4 (f2 (- 9))) 102))
(assert (= (f4 (f2 3)) (- 15)))
(assert (= (g4 (g2 3)) 306))
(assert (= (g4 (f3 (- 8))) 93))
(assert (= (f4 (f3 8)) 19))
(assert (= (g4 (g3 8)) 768))
(assert (= (f4 (f4 (- 9))) (- 15)))
(assert (= (g4 (g4 (- 9))) 306))
(check-sat)
