(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 7)) 14))
(assert (= (f1 (g1 4)) (- 32)))
(assert (= (f1 (f2 8)) (- 20)))
(assert (= (f1 (g2 7)) (- 116)))
(assert (= (f1 (f3 (- 4))) 14))
(assert (= (f1 (g3 8)) (- 116)))
(assert (= (g1 (f3 4)) 77))
(assert (= (f1 (g4 (- 4))) (- 32)))
(assert (= (g1 (f4 7)) 77))
(assert (= (f2 (f1 8)) (- 20)))
(assert (= (f2 (g1 7)) 57))
(assert (= (f2 (f2 (- 4))) (- 20)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 4)) 192))
(assert (= (f2 (g3 (- 4))) 57))
(assert (= (g2 (f3 7)) 224))
(assert (= (g2 (f4 8)) 192))
(assert (= (f2 (f4 4)) 16))
(assert (= (g2 (g4 4)) 512))
(assert (= (f3 (f1 (- 4))) 14))
(assert (= (f3 (g1 8)) 63))
(assert (= (g3 (f1 4)) 105))
(assert (= (f3 (g2 (- 4))) 63))
(assert (= (g3 (f2 7)) 210))
(assert (= (g3 (f3 8)) 210))
(assert (= (f3 (f3 4)) 18))
(assert (= (g3 (g3 4)) 784))
(assert (= (g3 (f4 (- 4))) 105))
(assert (= (f3 (f4 7)) 18))
(assert (= (g3 (g4 7)) 784))
(assert (= (f4 (g1 (- 4))) (- 29)))
(assert (= (g4 (f1 7)) 84))
(assert (= (g4 (f2 8)) 128))
(assert (= (f4 (f2 4)) 16))
(assert (= (g4 (g2 4)) 512))
(assert (= (g4 (f3 (- 4))) 84))
(assert (= (f4 (f3 7)) 18))
(assert (= (g4 (g3 7)) 784))
(assert (= (f4 (f4 8)) 16))
(assert (= (g4 (g4 8)) 512))
(check-sat)
