(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 14)))
(assert (= (f1 (g1 (- 1))) 5))
(assert (= (f1 (f2 (- 7))) (- 16)))
(assert (= (f1 (g2 (- 9))) 113))
(assert (= (f1 (f3 (- 3))) (- 14)))
(assert (= (f1 (g3 (- 7))) 113))
(assert (= (g1 (f3 (- 1))) 45))
(assert (= (f1 (g4 (- 3))) 5))
(assert (= (g1 (f4 (- 9))) 45))
(assert (= (f2 (f1 (- 7))) (- 16)))
(assert (= (f2 (g1 (- 9))) 49))
(assert (= (f2 (f2 (- 3))) (- 16)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 1))) 91))
(assert (= (f2 (g3 (- 3))) 49))
(assert (= (g2 (f3 (- 9))) 221))
(assert (= (g2 (f4 (- 7))) 91))
(assert (= (f2 (f4 (- 1))) (- 8)))
(assert (= (g2 (g4 (- 1))) (- 7)))
(assert (= (f3 (f1 (- 3))) (- 14)))
(assert (= (f3 (g1 (- 7))) 41))
(assert (= (g3 (f1 (- 1))) 51))
(assert (= (f3 (g2 (- 3))) 41))
(assert (= (g3 (f2 (- 9))) 255))
(assert (= (g3 (f3 (- 7))) 255))
(assert (= (f3 (f3 (- 1))) (- 18)))
(assert (= (g3 (g3 (- 1))) (- 145)))
(assert (= (g3 (f4 (- 3))) 51))
(assert (= (f3 (f4 (- 9))) (- 18)))
(assert (= (g3 (g4 (- 9))) (- 145)))
(assert (= (f4 (g1 (- 3))) 13))
(assert (= (g4 (f1 (- 9))) 11))
(assert (= (g4 (f2 (- 7))) 13))
(assert (= (f4 (f2 (- 1))) (- 8)))
(assert (= (g4 (g2 (- 1))) (- 7)))
(assert (= (g4 (f3 (- 3))) 11))
(assert (= (f4 (f3 (- 9))) (- 18)))
(assert (= (g4 (g3 (- 9))) (- 145)))
(assert (= (f4 (f4 (- 7))) (- 8)))
(assert (= (g4 (g4 (- 7))) (- 7)))
(check-sat)
