(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 22)))
(assert (= (f1 (g1 (- 9))) 135))
(assert (= (f1 (f2 (- 6))) (- 19)))
(assert (= (f1 (g2 (- 7))) 79))
(assert (= (f1 (f3 (- 8))) (- 22)))
(assert (= (f1 (g3 (- 6))) 79))
(assert (= (g1 (f3 (- 9))) 225))
(assert (= (f1 (g4 (- 8))) 135))
(assert (= (g1 (f4 (- 7))) 225))
(assert (= (f2 (f1 (- 6))) (- 19)))
(assert (= (f2 (g1 (- 7))) 103))
(assert (= (f2 (f2 (- 8))) (- 19)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 9))) 154))
(assert (= (f2 (g3 (- 8))) 103))
(assert (= (g2 (f3 (- 7))) 143))
(assert (= (g2 (f4 (- 6))) 154))
(assert (= (f2 (f4 (- 9))) (- 23)))
(assert (= (g2 (g4 (- 9))) (- 1590)))
(assert (= (f3 (f1 (- 8))) (- 22)))
(assert (= (f3 (g1 (- 6))) 89))
(assert (= (g3 (f1 (- 9))) 208))
(assert (= (f3 (g2 (- 8))) 89))
(assert (= (g3 (f2 (- 7))) 156))
(assert (= (g3 (f3 (- 6))) 156))
(assert (= (f3 (f3 (- 9))) (- 22)))
(assert (= (g3 (g3 (- 9))) (- 1437)))
(assert (= (g3 (f4 (- 8))) 208))
(assert (= (f3 (f4 (- 7))) (- 22)))
(assert (= (g3 (g4 (- 7))) (- 1437)))
(assert (= (f4 (g1 (- 8))) 121))
(assert (= (g4 (f1 (- 7))) 238))
(assert (= (g4 (f2 (- 6))) 187))
(assert (= (f4 (f2 (- 9))) (- 23)))
(assert (= (g4 (g2 (- 9))) (- 1590)))
(assert (= (g4 (f3 (- 8))) 238))
(assert (= (f4 (f3 (- 7))) (- 22)))
(assert (= (g4 (g3 (- 7))) (- 1437)))
(assert (= (f4 (f4 (- 6))) (- 23)))
(assert (= (g4 (g4 (- 6))) (- 1590)))
(check-sat)
