(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 7)) 12))
(assert (= (f1 (g1 (- 9))) 45))
(assert (= (f1 (f2 (- 1))) (- 4)))
(assert (= (f1 (g2 7)) (- 10)))
(assert (= (f1 (f3 (- 3))) 12))
(assert (= (f1 (g3 (- 1))) (- 10)))
(assert (= (g1 (f3 (- 9))) (- 78)))
(assert (= (f1 (g4 (- 3))) 45))
(assert (= (g1 (f4 7)) (- 78)))
(assert (= (f2 (f1 (- 1))) (- 4)))
(assert (= (f2 (g1 7)) (- 36)))
(assert (= (f2 (f2 (- 3))) (- 4)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 9))) 9))
(assert (= (f2 (g3 (- 3))) (- 36)))
(assert (= (g2 (f3 7)) 14))
(assert (= (g2 (f4 (- 1))) 9))
(assert (= (f2 (f4 (- 9))) (- 18)))
(assert (= (g2 (g4 (- 9))) (- 145)))
(assert (= (f3 (f1 (- 3))) 12))
(assert (= (f3 (g1 (- 1))) (- 10)))
(assert (= (g3 (f1 (- 9))) 154))
(assert (= (f3 (g2 (- 3))) (- 10)))
(assert (= (g3 (f2 7)) 105))
(assert (= (g3 (f3 (- 1))) 105))
(assert (= (f3 (f3 (- 9))) (- 23)))
(assert (= (g3 (g3 (- 9))) 1666))
(assert (= (g3 (f4 (- 3))) 154))
(assert (= (f3 (f4 7)) (- 23)))
(assert (= (g3 (g4 7)) 1666))
(assert (= (f4 (g1 (- 3))) 21))
(assert (= (g4 (f1 7)) (- 162)))
(assert (= (g4 (f2 (- 1))) 17))
(assert (= (f4 (f2 (- 9))) (- 18)))
(assert (= (g4 (g2 (- 9))) (- 145)))
(assert (= (g4 (f3 (- 3))) (- 162)))
(assert (= (f4 (f3 7)) (- 23)))
(assert (= (g4 (g3 7)) 1666))
(assert (= (f4 (f4 (- 1))) (- 18)))
(assert (= (g4 (g4 (- 1))) (- 145)))
(check-sat)
