(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 19)))
(assert (= (f1 (g1 (- 9))) 135))
(assert (= (f1 (f2 (- 5))) (- 17)))
(assert (= (f1 (g2 (- 4))) 39))
(assert (= (f1 (f3 (- 8))) (- 19)))
(assert (= (f1 (g3 (- 5))) 39))
(assert (= (g1 (f3 (- 9))) 180))
(assert (= (f1 (g4 (- 8))) 135))
(assert (= (g1 (f4 (- 4))) 180))
(assert (= (f2 (f1 (- 5))) (- 17)))
(assert (= (f2 (g1 (- 4))) 57))
(assert (= (f2 (f2 (- 8))) (- 17)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 9))) 117))
(assert (= (f2 (g3 (- 8))) 57))
(assert (= (g2 (f3 (- 4))) 63))
(assert (= (g2 (f4 (- 5))) 117))
(assert (= (f2 (f4 (- 9))) (- 22)))
(assert (= (g2 (g4 (- 9))) (- 1301)))
(assert (= (f3 (f1 (- 8))) (- 19)))
(assert (= (f3 (g1 (- 5))) 71))
(assert (= (g3 (f1 (- 9))) 112))
(assert (= (f3 (g2 (- 8))) 71))
(assert (= (g3 (f2 (- 4))) 56))
(assert (= (g3 (f3 (- 5))) 56))
(assert (= (f3 (f3 (- 9))) (- 16)))
(assert (= (g3 (g3 (- 9))) (- 417)))
(assert (= (g3 (f4 (- 8))) 112))
(assert (= (f3 (f4 (- 4))) (- 16)))
(assert (= (g3 (g4 (- 4))) (- 417)))
(assert (= (f4 (g1 (- 8))) 121))
(assert (= (g4 (f1 (- 4))) 187))
(assert (= (g4 (f2 (- 5))) 153))
(assert (= (f4 (f2 (- 9))) (- 22)))
(assert (= (g4 (g2 (- 9))) (- 1301)))
(assert (= (g4 (f3 (- 8))) 187))
(assert (= (f4 (f3 (- 4))) (- 16)))
(assert (= (g4 (g3 (- 4))) (- 417)))
(assert (= (f4 (f4 (- 5))) (- 22)))
(assert (= (g4 (g4 (- 5))) (- 1301)))
(check-sat)
