(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 12)))
(assert (= (f1 (g1 (- 8))) 40))
(assert (= (f1 (f2 1)) (- 5)))
(assert (= (f1 (g2 (- 7))) (- 16)))
(assert (= (f1 (f3 (- 3))) (- 12)))
(assert (= (f1 (g3 1)) (- 16)))
(assert (= (g1 (f3 (- 8))) 70))
(assert (= (f1 (g4 (- 3))) 40))
(assert (= (g1 (f4 (- 7))) 70))
(assert (= (f2 (f1 1)) (- 5)))
(assert (= (f2 (g1 (- 7))) (- 34)))
(assert (= (f2 (f2 (- 3))) (- 5)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 8))) 17))
(assert (= (f2 (g3 (- 3))) (- 34)))
(assert (= (g2 (f3 (- 7))) 26))
(assert (= (g2 (f4 1)) 17))
(assert (= (f2 (f4 (- 8))) 16))
(assert (= (g2 (g4 (- 8))) 225))
(assert (= (f3 (f1 (- 3))) (- 12)))
(assert (= (f3 (g1 1)) (- 12)))
(assert (= (g3 (f1 (- 8))) 130))
(assert (= (f3 (g2 (- 3))) (- 12)))
(assert (= (g3 (f2 (- 7))) (- 98)))
(assert (= (g3 (f3 1)) (- 98)))
(assert (= (f3 (f3 (- 8))) (- 21)))
(assert (= (g3 (g3 (- 8))) (- 1268)))
(assert (= (g3 (f4 (- 3))) 130))
(assert (= (f3 (f4 (- 7))) (- 21)))
(assert (= (g3 (g4 (- 7))) (- 1268)))
(assert (= (f4 (g1 (- 3))) 20))
(assert (= (g4 (f1 (- 7))) 135))
(assert (= (g4 (f2 1)) 30))
(assert (= (f4 (f2 (- 8))) 16))
(assert (= (g4 (g2 (- 8))) 225))
(assert (= (g4 (f3 (- 3))) 135))
(assert (= (f4 (f3 (- 7))) (- 21)))
(assert (= (g4 (g3 (- 7))) (- 1268)))
(assert (= (f4 (f4 1)) 16))
(assert (= (g4 (g4 1)) 225))
(check-sat)
