(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 12)))
(assert (= (f1 (g1 9)) (- 48)))
(assert (= (f1 (f2 1)) (- 5)))
(assert (= (f1 (g2 (- 7))) (- 16)))
(assert (= (f1 (f3 (- 3))) (- 12)))
(assert (= (f1 (g3 1)) (- 16)))
(assert (= (g1 (f3 9)) (- 78)))
(assert (= (f1 (g4 (- 3))) (- 48)))
(assert (= (g1 (f4 (- 7))) (- 78)))
(assert (= (f2 (f1 1)) (- 5)))
(assert (= (f2 (g1 (- 7))) (- 34)))
(assert (= (f2 (f2 (- 3))) (- 5)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 9)) 20))
(assert (= (f2 (g3 (- 3))) (- 34)))
(assert (= (g2 (f3 (- 7))) 26))
(assert (= (g2 (f4 1)) 20))
(assert (= (f2 (f4 9)) 19))
(assert (= (g2 (g4 9)) 324))
(assert (= (f3 (f1 (- 3))) (- 12)))
(assert (= (f3 (g1 1)) (- 12)))
(assert (= (g3 (f1 9)) (- 150)))
(assert (= (f3 (g2 (- 3))) (- 12)))
(assert (= (g3 (f2 (- 7))) (- 98)))
(assert (= (g3 (f3 1)) (- 98)))
(assert (= (f3 (f3 9)) 22))
(assert (= (g3 (g3 9)) 1521))
(assert (= (g3 (f4 (- 3))) (- 150)))
(assert (= (f3 (f4 (- 7))) 22))
(assert (= (g3 (g4 (- 7))) 1521))
(assert (= (f4 (g1 (- 3))) (- 22)))
(assert (= (g4 (f1 (- 7))) 162))
(assert (= (g4 (f2 1)) 36))
(assert (= (f4 (f2 9)) 19))
(assert (= (g4 (g2 9)) 324))
(assert (= (g4 (f3 (- 3))) 162))
(assert (= (f4 (f3 (- 7))) 22))
(assert (= (g4 (g3 (- 7))) 1521))
(assert (= (f4 (f4 1)) 19))
(assert (= (g4 (g4 1)) 324))
(check-sat)
