(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 1)) 6))
(assert (= (f1 (g1 5)) (- 28)))
(assert (= (f1 (f2 4)) (- 11)))
(assert (= (f1 (g2 1)) (- 11)))
(assert (= (f1 (f3 (- 3))) 6))
(assert (= (f1 (g3 4)) (- 11)))
(assert (= (g1 (f3 5)) 30))
(assert (= (f1 (g4 (- 3))) (- 28)))
(assert (= (g1 (f4 1)) 30))
(assert (= (f2 (f1 4)) (- 11)))
(assert (= (f2 (g1 1)) 9))
(assert (= (f2 (f2 (- 3))) (- 11)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 5)) 72))
(assert (= (f2 (g3 (- 3))) 9))
(assert (= (g2 (f3 1)) 16))
(assert (= (g2 (f4 4)) 72))
(assert (= (f2 (f4 5)) 14))
(assert (= (g2 (g4 5)) 400))
(assert (= (f3 (f1 (- 3))) 6))
(assert (= (f3 (g1 4)) 21))
(assert (= (g3 (f1 5)) 15))
(assert (= (f3 (g2 (- 3))) 21))
(assert (= (g3 (f2 1)) 10))
(assert (= (g3 (f3 4)) 10))
(assert (= (f3 (f3 5)) 7))
(assert (= (g3 (g3 5)) 20))
(assert (= (g3 (f4 (- 3))) 15))
(assert (= (f3 (f4 1)) 7))
(assert (= (g3 (g4 1)) 20))
(assert (= (f4 (g1 (- 3))) (- 18)))
(assert (= (g4 (f1 1)) 35))
(assert (= (g4 (f2 4)) 80))
(assert (= (f4 (f2 5)) 14))
(assert (= (g4 (g2 5)) 400))
(assert (= (g4 (f3 (- 3))) 35))
(assert (= (f4 (f3 1)) 7))
(assert (= (g4 (g3 1)) 20))
(assert (= (f4 (f4 4)) 14))
(assert (= (g4 (g4 4)) 400))
(check-sat)
