(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 9))
(assert (= (f1 (g1 (- 6))) 30))
(assert (= (f1 (f2 7)) (- 17)))
(assert (= (f1 (g2 4)) (- 59)))
(assert (= (f1 (f3 (- 3))) 9))
(assert (= (f1 (g3 7)) (- 59)))
(assert (= (g1 (f3 (- 6))) (- 48)))
(assert (= (f1 (g4 (- 3))) 30))
(assert (= (g1 (f4 4)) (- 48)))
(assert (= (f2 (f1 7)) (- 17)))
(assert (= (f2 (g1 4)) 27))
(assert (= (f2 (f2 (- 3))) (- 17)))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 6))) 175))
(assert (= (f2 (g3 (- 3))) 27))
(assert (= (g2 (f3 4)) 112))
(assert (= (g2 (f4 7)) 175))
(assert (= (f2 (f4 (- 6))) 18))
(assert (= (g2 (g4 (- 6))) 847))
(assert (= (f3 (f1 (- 3))) 9))
(assert (= (f3 (g1 7)) 39))
(assert (= (g3 (f1 (- 6))) 64))
(assert (= (f3 (g2 (- 3))) 39))
(assert (= (g3 (f2 4)) 88))
(assert (= (g3 (f3 7)) 88))
(assert (= (f3 (f3 (- 6))) (- 14)))
(assert (= (g3 (g3 (- 6))) 352))
(assert (= (g3 (f4 (- 3))) 64))
(assert (= (f3 (f4 4)) (- 14)))
(assert (= (g3 (g4 4)) 352))
(assert (= (f4 (g1 (- 3))) 18))
(assert (= (g4 (f1 4)) (- 72)))
(assert (= (g4 (f2 7)) 154))
(assert (= (f4 (f2 (- 6))) 18))
(assert (= (g4 (g2 (- 6))) 847))
(assert (= (g4 (f3 (- 3))) (- 72)))
(assert (= (f4 (f3 4)) (- 14)))
(assert (= (g4 (g3 4)) 352))
(assert (= (f4 (f4 7)) 18))
(assert (= (g4 (g4 7)) 847))
(check-sat)
