(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 12)))
(assert (= (f1 (g1 2)) (- 13)))
(assert (= (f1 (f2 8)) (- 19)))
(assert (= (f1 (g2 (- 7))) (- 107)))
(assert (= (f1 (f3 (- 3))) (- 12)))
(assert (= (f1 (g3 8)) (- 107)))
(assert (= (g1 (f3 2)) (- 43)))
(assert (= (f1 (g4 (- 3))) (- 13)))
(assert (= (g1 (f4 (- 7))) (- 43)))
(assert (= (f2 (f1 8)) (- 19)))
(assert (= (f2 (g1 (- 7))) (- 41)))
(assert (= (f2 (f2 (- 3))) (- 19)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 2)) 160))
(assert (= (f2 (g3 (- 3))) (- 41)))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 160))
(assert (= (f2 (f4 2)) 12))
(assert (= (g2 (g4 2)) 128))
(assert (= (f3 (f1 (- 3))) (- 12)))
(assert (= (f3 (g1 8)) (- 47)))
(assert (= (g3 (f1 2)) (- 59)))
(assert (= (f3 (g2 (- 3))) (- 47)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 2)) 15))
(assert (= (g3 (g3 2)) 338))
(assert (= (g3 (f4 (- 3))) (- 59)))
(assert (= (f3 (f4 (- 7))) 15))
(assert (= (g3 (g4 (- 7))) 338))
(assert (= (f4 (g1 (- 3))) (- 15)))
(assert (= (g4 (f1 (- 7))) 36))
(assert (= (g4 (f2 8)) 64))
(assert (= (f4 (f2 2)) 12))
(assert (= (g4 (g2 2)) 128))
(assert (= (g4 (f3 (- 3))) 36))
(assert (= (f4 (f3 (- 7))) 15))
(assert (= (g4 (g3 (- 7))) 338))
(assert (= (f4 (f4 8)) 12))
(assert (= (g4 (g4 8)) 128))
(check-sat)
