(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 6)))
(assert (= (f1 (g1 (- 8))) 24))
(assert (= (f1 (f2 (- 9))) (- 19)))
(assert (= (f1 (g2 (- 3))) 44))
(assert (= (f1 (f3 (- 2))) (- 6)))
(assert (= (f1 (g3 (- 9))) 44))
(assert (= (g1 (f3 (- 8))) 30))
(assert (= (f1 (g4 (- 2))) 24))
(assert (= (g1 (f4 (- 3))) 30))
(assert (= (f2 (f1 (- 9))) (- 19)))
(assert (= (f2 (g1 (- 3))) 16))
(assert (= (f2 (f2 (- 2))) (- 19)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 8))) 272))
(assert (= (f2 (g3 (- 2))) 16))
(assert (= (g2 (f3 (- 3))) 85))
(assert (= (g2 (f4 (- 9))) 272))
(assert (= (f2 (f4 (- 8))) (- 24)))
(assert (= (g2 (g4 (- 8))) (- 1913)))
(assert (= (f3 (f1 (- 2))) (- 6)))
(assert (= (f3 (g1 (- 9))) 28))
(assert (= (g3 (f1 (- 8))) 45))
(assert (= (f3 (g2 (- 2))) 28))
(assert (= (g3 (f2 (- 3))) 55))
(assert (= (g3 (f3 (- 9))) 55))
(assert (= (f3 (f3 (- 8))) (- 13)))
(assert (= (g3 (g3 (- 8))) (- 188)))
(assert (= (g3 (f4 (- 2))) 45))
(assert (= (f3 (f4 (- 3))) (- 13)))
(assert (= (g3 (g4 (- 3))) (- 188)))
(assert (= (f4 (g1 (- 2))) 12))
(assert (= (g4 (f1 (- 3))) 60))
(assert (= (g4 (f2 (- 9))) 255))
(assert (= (f4 (f2 (- 8))) (- 24)))
(assert (= (g4 (g2 (- 8))) (- 1913)))
(assert (= (g4 (f3 (- 2))) 60))
(assert (= (f4 (f3 (- 3))) (- 13)))
(assert (= (g4 (g3 (- 3))) (- 188)))
(assert (= (f4 (f4 (- 9))) (- 24)))
(assert (= (g4 (g4 (- 9))) (- 1913)))
(check-sat)
