(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 11))
(assert (= (f1 (g1 2)) (- 8)))
(assert (= (f1 (f2 (- 9))) (- 19)))
(assert (= (f1 (g2 8)) (- 138)))
(assert (= (f1 (f3 (- 2))) 11))
(assert (= (f1 (g3 (- 9))) (- 138)))
(assert (= (g1 (f3 2)) 30))
(assert (= (f1 (g4 (- 2))) (- 8)))
(assert (= (g1 (f4 8)) 30))
(assert (= (f2 (f1 (- 9))) (- 19)))
(assert (= (f2 (g1 8)) (- 33)))
(assert (= (f2 (f2 (- 2))) (- 19)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 2)) (- 179)))
(assert (= (f2 (g3 (- 2))) (- 33)))
(assert (= (g2 (f3 8)) 272))
(assert (= (g2 (f4 (- 9))) (- 179)))
(assert (= (f2 (f4 2)) (- 13)))
(assert (= (g2 (g4 2)) 136))
(assert (= (f3 (f1 (- 2))) 11))
(assert (= (f3 (g1 (- 9))) (- 34)))
(assert (= (g3 (f1 2)) 56))
(assert (= (f3 (g2 (- 2))) (- 34)))
(assert (= (g3 (f2 8)) 264))
(assert (= (g3 (f3 (- 9))) 264))
(assert (= (f3 (f3 2)) 18))
(assert (= (g3 (g3 2)) 512))
(assert (= (g3 (f4 (- 2))) 56))
(assert (= (f3 (f4 8)) 18))
(assert (= (g3 (g4 8)) 512))
(assert (= (f4 (g1 (- 2))) (- 7)))
(assert (= (g4 (f1 8)) 38))
(assert (= (g4 (f2 (- 9))) 68))
(assert (= (f4 (f2 2)) (- 13)))
(assert (= (g4 (g2 2)) 136))
(assert (= (g4 (f3 (- 2))) 38))
(assert (= (f4 (f3 8)) 18))
(assert (= (g4 (g3 8)) 512))
(assert (= (f4 (f4 (- 9))) (- 13)))
(assert (= (g4 (g4 (- 9))) 136))
(check-sat)
