(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 10)))
(assert (= (f1 (g1 (- 3))) 9))
(assert (= (f1 (f2 (- 8))) (- 17)))
(assert (= (f1 (g2 (- 7))) 99))
(assert (= (f1 (f3 (- 2))) (- 10)))
(assert (= (f1 (g3 (- 8))) 99))
(assert (= (g1 (f3 (- 3))) 27))
(assert (= (f1 (g4 (- 2))) 9))
(assert (= (g1 (f4 (- 7))) 27))
(assert (= (f2 (f1 (- 8))) (- 17)))
(assert (= (f2 (g1 (- 7))) 27))
(assert (= (f2 (f2 (- 2))) (- 17)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 3))) 150))
(assert (= (f2 (g3 (- 2))) 27))
(assert (= (g2 (f3 (- 7))) 195))
(assert (= (g2 (f4 (- 8))) 150))
(assert (= (f2 (f4 (- 3))) (- 13)))
(assert (= (g2 (g4 (- 3))) (- 188)))
(assert (= (f3 (f1 (- 2))) (- 10)))
(assert (= (f3 (g1 (- 8))) 29))
(assert (= (g3 (f1 (- 3))) 52))
(assert (= (f3 (g2 (- 2))) 29))
(assert (= (g3 (f2 (- 7))) 182))
(assert (= (g3 (f3 (- 8))) 182))
(assert (= (f3 (f3 (- 3))) (- 16)))
(assert (= (g3 (g3 (- 3))) (- 423)))
(assert (= (g3 (f4 (- 2))) 52))
(assert (= (f3 (f4 (- 7))) (- 16)))
(assert (= (g3 (g4 (- 7))) (- 423)))
(assert (= (f4 (g1 (- 2))) 7))
(assert (= (g4 (f1 (- 7))) 40))
(assert (= (g4 (f2 (- 8))) 75))
(assert (= (f4 (f2 (- 3))) (- 13)))
(assert (= (g4 (g2 (- 3))) (- 188)))
(assert (= (g4 (f3 (- 2))) 40))
(assert (= (f4 (f3 (- 7))) (- 16)))
(assert (= (g4 (g3 (- 7))) (- 423)))
(assert (= (f4 (f4 (- 8))) (- 13)))
(assert (= (g4 (g4 (- 8))) (- 188)))
(check-sat)
