(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 8)))
(assert (= (f1 (g1 8)) (- 26)))
(assert (= (f1 (f2 (- 8))) (- 17)))
(assert (= (f1 (g2 (- 5))) 69))
(assert (= (f1 (f3 (- 2))) (- 8)))
(assert (= (f1 (g3 (- 8))) 69))
(assert (= (g1 (f3 8)) (- 38)))
(assert (= (f1 (g4 (- 2))) (- 26)))
(assert (= (g1 (f4 (- 5))) (- 38)))
(assert (= (f2 (f1 (- 8))) (- 17)))
(assert (= (f2 (g1 (- 5))) 21))
(assert (= (f2 (f2 (- 2))) (- 17)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 8)) (- 233)))
(assert (= (f2 (g3 (- 2))) 21))
(assert (= (g2 (f3 (- 5))) 135))
(assert (= (g2 (f4 (- 8))) (- 233)))
(assert (= (f2 (f4 8)) (- 24)))
(assert (= (g2 (g4 8)) 1920))
(assert (= (f3 (f1 (- 2))) (- 8)))
(assert (= (f3 (g1 (- 8))) 27))
(assert (= (g3 (f1 8)) (- 86)))
(assert (= (f3 (g2 (- 2))) 27))
(assert (= (g3 (f2 (- 5))) 108))
(assert (= (g3 (f3 (- 8))) 108))
(assert (= (f3 (f3 8)) 17))
(assert (= (g3 (g3 8)) 648))
(assert (= (g3 (f4 (- 2))) (- 86)))
(assert (= (f3 (f4 (- 5))) 17))
(assert (= (g3 (g4 (- 5))) 648))
(assert (= (f4 (g1 (- 2))) (- 13)))
(assert (= (g4 (f1 (- 5))) 96))
(assert (= (g4 (f2 (- 8))) 240))
(assert (= (f4 (f2 8)) (- 24)))
(assert (= (g4 (g2 8)) 1920))
(assert (= (g4 (f3 (- 2))) 96))
(assert (= (f4 (f3 (- 5))) 17))
(assert (= (g4 (g3 (- 5))) 648))
(assert (= (f4 (f4 (- 8))) (- 24)))
(assert (= (g4 (g4 (- 8))) 1920))
(check-sat)
