(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 2)) 5))
(assert (= (f1 (g1 (- 6))) 18))
(assert (= (f1 (f2 (- 8))) (- 17)))
(assert (= (f1 (g2 2)) (- 32)))
(assert (= (f1 (f3 (- 2))) 5))
(assert (= (f1 (g3 (- 8))) (- 32)))
(assert (= (g1 (f3 (- 6))) (- 23)))
(assert (= (f1 (g4 (- 2))) 18))
(assert (= (g1 (f4 2)) (- 23)))
(assert (= (f2 (f1 (- 8))) (- 17)))
(assert (= (f2 (g1 2)) (- 14)))
(assert (= (f2 (f2 (- 2))) (- 17)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 6))) 195))
(assert (= (f2 (g3 (- 2))) (- 14)))
(assert (= (g2 (f3 2)) 60))
(assert (= (g2 (f4 (- 8))) 195))
(assert (= (f2 (f4 (- 6))) (- 19)))
(assert (= (g2 (g4 (- 6))) (- 908)))
(assert (= (f3 (f1 (- 2))) 5))
(assert (= (f3 (g1 (- 8))) (- 25)))
(assert (= (g3 (f1 (- 6))) 28))
(assert (= (f3 (g2 (- 2))) (- 25)))
(assert (= (g3 (f2 2)) 38))
(assert (= (g3 (f3 (- 8))) 38))
(assert (= (f3 (f3 (- 6))) (- 10)))
(assert (= (g3 (g3 (- 6))) 88))
(assert (= (g3 (f4 (- 2))) 28))
(assert (= (f3 (f4 2)) (- 10)))
(assert (= (g3 (g4 2)) 88))
(assert (= (f4 (g1 (- 2))) 10))
(assert (= (g4 (f1 2)) (- 39)))
(assert (= (g4 (f2 (- 8))) 165))
(assert (= (f4 (f2 (- 6))) (- 19)))
(assert (= (g4 (g2 (- 6))) (- 908)))
(assert (= (g4 (f3 (- 2))) (- 39)))
(assert (= (f4 (f3 2)) (- 10)))
(assert (= (g4 (g3 2)) 88))
(assert (= (f4 (f4 (- 8))) (- 19)))
(assert (= (g4 (g4 (- 8))) (- 908)))
(check-sat)
