(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 4)) 7))
(assert (= (f1 (g1 (- 9))) 27))
(assert (= (f1 (f2 (- 7))) (- 15)))
(assert (= (f1 (g2 4)) (- 54)))
(assert (= (f1 (f3 (- 2))) 7))
(assert (= (f1 (g3 (- 7))) (- 54)))
(assert (= (g1 (f3 (- 9))) (- 38)))
(assert (= (f1 (g4 (- 2))) 27))
(assert (= (g1 (f4 4)) (- 38)))
(assert (= (f2 (f1 (- 7))) (- 15)))
(assert (= (f2 (g1 4)) (- 19)))
(assert (= (f2 (f2 (- 2))) (- 15)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 9))) 195))
(assert (= (f2 (g3 (- 2))) (- 19)))
(assert (= (g2 (f3 4)) 104))
(assert (= (g2 (f4 (- 7))) 195))
(assert (= (f2 (f4 (- 9))) (- 24)))
(assert (= (g2 (g4 (- 9))) (- 1879)))
(assert (= (f3 (f1 (- 2))) 7))
(assert (= (f3 (g1 (- 7))) (- 24)))
(assert (= (g3 (f1 (- 9))) 80))
(assert (= (f3 (g2 (- 2))) (- 24)))
(assert (= (g3 (f2 4)) 84))
(assert (= (g3 (f3 (- 7))) 84))
(assert (= (f3 (f3 (- 9))) (- 17)))
(assert (= (g3 (g3 (- 9))) 544))
(assert (= (g3 (f4 (- 2))) 80))
(assert (= (f3 (f4 4)) (- 17)))
(assert (= (g3 (g4 4)) 544))
(assert (= (f4 (g1 (- 2))) 13))
(assert (= (g4 (f1 4)) (- 94)))
(assert (= (g4 (f2 (- 7))) 221))
(assert (= (f4 (f2 (- 9))) (- 24)))
(assert (= (g4 (g2 (- 9))) (- 1879)))
(assert (= (g4 (f3 (- 2))) (- 94)))
(assert (= (f4 (f3 4)) (- 17)))
(assert (= (g4 (g3 4)) 544))
(assert (= (f4 (f4 (- 7))) (- 24)))
(assert (= (g4 (g4 (- 7))) (- 1879)))
(check-sat)
