(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 7))
(assert (= (f1 (g1 (- 7))) 21))
(assert (= (f1 (f2 (- 5))) (- 11)))
(assert (= (f1 (g2 4)) (- 38)))
(assert (= (f1 (f3 (- 2))) 7))
(assert (= (f1 (g3 (- 5))) (- 38)))
(assert (= (g1 (f3 (- 7))) (- 32)))
(assert (= (f1 (g4 (- 2))) 21))
(assert (= (g1 (f4 4)) (- 32)))
(assert (= (f2 (f1 (- 5))) (- 11)))
(assert (= (f2 (g1 4)) (- 17)))
(assert (= (f2 (f2 (- 2))) (- 11)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 7))) 99))
(assert (= (f2 (g3 (- 2))) (- 17)))
(assert (= (g2 (f3 4)) 72))
(assert (= (g2 (f4 (- 5))) 99))
(assert (= (f2 (f4 (- 7))) (- 18)))
(assert (= (g2 (g4 (- 7))) (- 761)))
(assert (= (f3 (f1 (- 2))) 7))
(assert (= (f3 (g1 (- 5))) (- 18)))
(assert (= (g3 (f1 (- 7))) 64))
(assert (= (f3 (g2 (- 2))) (- 18)))
(assert (= (g3 (f2 4)) 68))
(assert (= (g3 (f3 (- 5))) 68))
(assert (= (f3 (f3 (- 7))) (- 15)))
(assert (= (g3 (g3 (- 7))) 416))
(assert (= (g3 (f4 (- 2))) 64))
(assert (= (f3 (f4 4)) (- 15)))
(assert (= (g3 (g4 4)) 416))
(assert (= (f4 (g1 (- 2))) 11))
(assert (= (g4 (f1 4)) (- 72)))
(assert (= (g4 (f2 (- 5))) 117))
(assert (= (f4 (f2 (- 7))) (- 18)))
(assert (= (g4 (g2 (- 7))) (- 761)))
(assert (= (g4 (f3 (- 2))) (- 72)))
(assert (= (f4 (f3 4)) (- 15)))
(assert (= (g4 (g3 4)) 416))
(assert (= (f4 (f4 (- 5))) (- 18)))
(assert (= (g4 (g4 (- 5))) (- 761)))
(check-sat)
