(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 24)))
(assert (= (f1 (g1 (- 6))) 102))
(assert (= (f1 (f2 (- 5))) (- 18)))
(assert (= (f1 (g2 (- 7))) 67))
(assert (= (f1 (f3 (- 9))) (- 24)))
(assert (= (f1 (g3 (- 5))) 67))
(assert (= (g1 (f3 (- 6))) 204))
(assert (= (f1 (g4 (- 9))) 102))
(assert (= (g1 (f4 (- 7))) 204))
(assert (= (f2 (f1 (- 5))) (- 18)))
(assert (= (f2 (g1 (- 7))) 115))
(assert (= (f2 (f2 (- 9))) (- 18)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 6))) 90))
(assert (= (f2 (g3 (- 9))) 115))
(assert (= (g2 (f3 (- 7))) 117))
(assert (= (g2 (f4 (- 5))) 90))
(assert (= (f2 (f4 (- 6))) (- 16)))
(assert (= (g2 (g4 (- 6))) (- 545)))
(assert (= (f3 (f1 (- 9))) (- 24)))
(assert (= (f3 (g1 (- 5))) 83))
(assert (= (g3 (f1 (- 6))) 182))
(assert (= (f3 (g2 (- 9))) 83))
(assert (= (g3 (f2 (- 7))) 143))
(assert (= (g3 (f3 (- 5))) 143))
(assert (= (f3 (f3 (- 6))) (- 19)))
(assert (= (g3 (g3 (- 6))) (- 930)))
(assert (= (g3 (f4 (- 9))) 182))
(assert (= (f3 (f4 (- 7))) (- 19)))
(assert (= (g3 (g4 (- 7))) (- 930)))
(assert (= (f4 (g1 (- 9))) 150))
(assert (= (g4 (f1 (- 7))) 165))
(assert (= (g4 (f2 (- 5))) 99))
(assert (= (f4 (f2 (- 6))) (- 16)))
(assert (= (g4 (g2 (- 6))) (- 545)))
(assert (= (g4 (f3 (- 9))) 165))
(assert (= (f4 (f3 (- 7))) (- 19)))
(assert (= (g4 (g3 (- 7))) (- 930)))
(assert (= (f4 (f4 (- 5))) (- 16)))
(assert (= (g4 (g4 (- 5))) (- 545)))
(check-sat)
