(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (g1 (g2 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 4)) 7))
(assert (= (f1 (g1 3)) (- 11)))
(assert (= (f1 (f2 2)) (- 6)))
(assert (= (f1 (g2 4)) (- 18)))
(assert (= (f1 (f3 (- 2))) 7))
(assert (= (f1 (g3 2)) (- 18)))
(assert (= (g1 (f3 3)) 21))
(assert (= (f1 (g4 (- 2))) (- 11)))
(assert (= (g1 (f4 4)) 21))
(assert (= (f2 (f1 2)) (- 6)))
(assert (= (f2 (g1 4)) 14))
(assert (= (f2 (f2 (- 2))) (- 6)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 3)) 20))
(assert (= (f2 (g3 (- 2))) 14))
(assert (= (g2 (f3 4)) 32))
(assert (= (g2 (f4 2)) 20))
(assert (= (f2 (f4 3)) 8))
(assert (= (g2 (g4 3)) 72))
(assert (= (f3 (f1 (- 2))) 7))
(assert (= (f3 (g1 2)) 10))
(assert (= (g3 (f1 3)) 36))
(assert (= (f3 (g2 (- 2))) 10))
(assert (= (g3 (f2 4)) 48))
(assert (= (g3 (f3 2)) 48))
(assert (= (f3 (f3 3)) 11))
(assert (= (g3 (g3 3)) 192))
(assert (= (g3 (f4 (- 2))) 36))
(assert (= (f3 (f4 4)) 11))
(assert (= (g3 (g4 4)) 192))
(assert (= (f4 (g1 (- 2))) (- 8)))
(assert (= (g4 (f1 4)) 33))
(assert (= (g4 (f2 2)) 24))
(assert (= (f4 (f2 3)) 8))
(assert (= (g4 (g2 3)) 72))
(assert (= (g4 (f3 (- 2))) 33))
(assert (= (f4 (f3 4)) 11))
(assert (= (g4 (g3 4)) 192))
(assert (= (f4 (f4 2)) 8))
(assert (= (g4 (g4 2)) 72))
(check-sat)
