(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 5))
(assert (= (f1 (g1 (- 6))) 18))
(assert (= (f1 (f2 3)) (- 8)))
(assert (= (f1 (g2 2)) (- 14)))
(assert (= (f1 (f3 (- 2))) 5))
(assert (= (f1 (g3 3)) (- 14)))
(assert (= (g1 (f3 (- 6))) (- 23)))
(assert (= (f1 (g4 (- 2))) 18))
(assert (= (g1 (f4 2)) (- 23)))
(assert (= (f2 (f1 3)) (- 8)))
(assert (= (f2 (g1 2)) 9))
(assert (= (f2 (f2 (- 2))) (- 8)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 6))) 51))
(assert (= (f2 (g3 (- 2))) 9))
(assert (= (g2 (f3 2)) 24))
(assert (= (g2 (f4 3)) 51))
(assert (= (f2 (f4 (- 6))) 14))
(assert (= (g2 (g4 (- 6))) 363))
(assert (= (f3 (f1 (- 2))) 5))
(assert (= (f3 (g1 3)) 11))
(assert (= (g3 (f1 (- 6))) 28))
(assert (= (f3 (g2 (- 2))) 11))
(assert (= (g3 (f2 2)) 20))
(assert (= (g3 (f3 3)) 20))
(assert (= (f3 (f3 (- 6))) (- 10)))
(assert (= (g3 (g3 (- 6))) 88))
(assert (= (g3 (f4 (- 2))) 28))
(assert (= (f3 (f4 2)) (- 10)))
(assert (= (g3 (g4 2)) 88))
(assert (= (f4 (g1 (- 2))) 10))
(assert (= (g4 (f1 2)) (- 39)))
(assert (= (g4 (f2 3)) 66))
(assert (= (f4 (f2 (- 6))) 14))
(assert (= (g4 (g2 (- 6))) 363))
(assert (= (g4 (f3 (- 2))) (- 39)))
(assert (= (f4 (f3 2)) (- 10)))
(assert (= (g4 (g3 2)) 88))
(assert (= (f4 (f4 3)) 14))
(assert (= (g4 (g4 3)) 363))
(check-sat)
