(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 8)))
(assert (= (f1 (g1 6)) (- 20)))
(assert (= (f1 (f2 9)) (- 20)))
(assert (= (f1 (g2 (- 5))) (- 83)))
(assert (= (f1 (f3 (- 2))) (- 8)))
(assert (= (f1 (g3 9)) (- 83)))
(assert (= (g1 (f3 6)) (- 32)))
(assert (= (f1 (g4 (- 2))) (- 20)))
(assert (= (g1 (f4 (- 5))) (- 32)))
(assert (= (f2 (f1 9)) (- 20)))
(assert (= (f2 (g1 (- 5))) (- 23)))
(assert (= (f2 (f2 (- 2))) (- 20)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 6)) 270))
(assert (= (f2 (g3 (- 2))) (- 23)))
(assert (= (g2 (f3 (- 5))) 162))
(assert (= (g2 (f4 9)) 270))
(assert (= (f2 (f4 6)) 21))
(assert (= (g2 (g4 6)) 1296))
(assert (= (f3 (f1 (- 2))) (- 8)))
(assert (= (f3 (g1 9)) (- 32)))
(assert (= (g3 (f1 6)) (- 68)))
(assert (= (f3 (g2 (- 2))) (- 32)))
(assert (= (g3 (f2 (- 5))) (- 122)))
(assert (= (g3 (f3 9)) (- 122)))
(assert (= (f3 (f3 6)) 15))
(assert (= (g3 (g3 6)) 486))
(assert (= (g3 (f4 (- 2))) (- 68)))
(assert (= (f3 (f4 (- 5))) 15))
(assert (= (g3 (g4 (- 5))) 486))
(assert (= (f4 (g1 (- 2))) (- 11)))
(assert (= (g4 (f1 (- 5))) 72))
(assert (= (g4 (f2 9)) 216))
(assert (= (f4 (f2 6)) 21))
(assert (= (g4 (g2 6)) 1296))
(assert (= (g4 (f3 (- 2))) 72))
(assert (= (f4 (f3 (- 5))) 15))
(assert (= (g4 (g3 (- 5))) 486))
(assert (= (f4 (f4 9)) 21))
(assert (= (g4 (g4 9)) 1296))
(check-sat)
