(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 5))
(assert (= (f1 (g1 (- 9))) 27))
(assert (= (f1 (f2 9)) (- 20)))
(assert (= (f1 (g2 2)) (- 38)))
(assert (= (f1 (f3 (- 2))) 5))
(assert (= (f1 (g3 9)) (- 38)))
(assert (= (g1 (f3 (- 9))) (- 32)))
(assert (= (f1 (g4 (- 2))) 27))
(assert (= (g1 (f4 2)) (- 32)))
(assert (= (f2 (f1 9)) (- 20)))
(assert (= (f2 (g1 2)) 15))
(assert (= (f2 (f2 (- 2))) (- 20)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 9))) 315))
(assert (= (f2 (g3 (- 2))) 15))
(assert (= (g2 (f3 2)) 72))
(assert (= (g2 (f4 9)) 315))
(assert (= (f2 (f4 (- 9))) 26))
(assert (= (g2 (g4 (- 9))) 2601))
(assert (= (f3 (f1 (- 2))) 5))
(assert (= (f3 (g1 9)) 29))
(assert (= (g3 (f1 (- 9))) 40))
(assert (= (f3 (g2 (- 2))) 29))
(assert (= (g3 (f2 2)) 44))
(assert (= (g3 (f3 9)) 44))
(assert (= (f3 (f3 (- 9))) (- 13)))
(assert (= (g3 (g3 (- 9))) 136))
(assert (= (g3 (f4 (- 2))) 40))
(assert (= (f3 (f4 2)) (- 13)))
(assert (= (g3 (g4 2)) 136))
(assert (= (f4 (g1 (- 2))) 13))
(assert (= (g4 (f1 2)) (- 60)))
(assert (= (g4 (f2 9)) 306))
(assert (= (f4 (f2 (- 9))) 26))
(assert (= (g4 (g2 (- 9))) 2601))
(assert (= (g4 (f3 (- 2))) (- 60)))
(assert (= (f4 (f3 2)) (- 13)))
(assert (= (g4 (g3 2)) 136))
(assert (= (f4 (f4 9)) 26))
(assert (= (g4 (g4 9)) 2601))
(check-sat)
