(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 9)))
(assert (= (f1 (g1 (- 2))) 2))
(assert (= (f1 (f2 (- 9))) (- 18)))
(assert (= (f1 (g2 (- 8))) 128))
(assert (= (f1 (f3 (- 1))) (- 9)))
(assert (= (f1 (g3 (- 9))) 128))
(assert (= (g1 (f3 (- 2))) 9))
(assert (= (f1 (g4 (- 1))) 2))
(assert (= (g1 (f4 (- 8))) 9))
(assert (= (f2 (f1 (- 9))) (- 18)))
(assert (= (f2 (g1 (- 8))) 16))
(assert (= (f2 (f2 (- 1))) (- 18)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 2))) 170))
(assert (= (f2 (g3 (- 1))) 16))
(assert (= (g2 (f3 (- 8))) 255))
(assert (= (g2 (f4 (- 9))) 170))
(assert (= (f2 (f4 (- 2))) (- 12)))
(assert (= (g2 (g4 (- 2))) (- 77)))
(assert (= (f3 (f1 (- 1))) (- 9)))
(assert (= (f3 (g1 (- 9))) 16))
(assert (= (g3 (f1 (- 2))) 30))
(assert (= (f3 (g2 (- 1))) 16))
(assert (= (g3 (f2 (- 8))) 240))
(assert (= (g3 (f3 (- 9))) 240))
(assert (= (f3 (f3 (- 2))) (- 17)))
(assert (= (g3 (g3 (- 2))) (- 338)))
(assert (= (g3 (f4 (- 1))) 30))
(assert (= (f3 (f4 (- 8))) (- 17)))
(assert (= (g3 (g4 (- 8))) (- 338)))
(assert (= (f4 (g1 (- 1))) 2))
(assert (= (g4 (f1 (- 8))) 24))
(assert (= (g4 (f2 (- 9))) 51))
(assert (= (f4 (f2 (- 2))) (- 12)))
(assert (= (g4 (g2 (- 2))) (- 77)))
(assert (= (g4 (f3 (- 1))) 24))
(assert (= (f4 (f3 (- 8))) (- 17)))
(assert (= (g4 (g3 (- 8))) (- 338)))
(assert (= (f4 (f4 (- 9))) (- 12)))
(assert (= (g4 (g4 (- 9))) (- 77)))
(check-sat)
