(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 6)))
(assert (= (f1 (g1 (- 7))) 7))
(assert (= (f1 (f2 (- 9))) (- 18)))
(assert (= (f1 (g2 (- 5))) 77))
(assert (= (f1 (f3 (- 1))) (- 6)))
(assert (= (f1 (g3 (- 9))) 77))
(assert (= (g1 (f3 (- 7))) 11))
(assert (= (f1 (g4 (- 1))) 7))
(assert (= (g1 (f4 (- 5))) 11))
(assert (= (f2 (f1 (- 9))) (- 18)))
(assert (= (f2 (g1 (- 5))) 13))
(assert (= (f2 (f2 (- 1))) (- 18)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 7))) 255))
(assert (= (f2 (g3 (- 1))) 13))
(assert (= (g2 (f3 (- 5))) 153))
(assert (= (g2 (f4 (- 9))) 255))
(assert (= (f2 (f4 (- 7))) (- 22)))
(assert (= (g2 (g4 (- 7))) (- 1437)))
(assert (= (f3 (f1 (- 1))) (- 6)))
(assert (= (f3 (g1 (- 9))) 13))
(assert (= (g3 (f1 (- 7))) 63))
(assert (= (f3 (g2 (- 1))) 13))
(assert (= (g3 (f2 (- 5))) 117))
(assert (= (g3 (f3 (- 9))) 117))
(assert (= (f3 (f3 (- 7))) (- 16)))
(assert (= (g3 (g3 (- 7))) (- 527)))
(assert (= (g3 (f4 (- 1))) 63))
(assert (= (f3 (f4 (- 5))) (- 16)))
(assert (= (g3 (g4 (- 5))) (- 527)))
(assert (= (f4 (g1 (- 1))) 7))
(assert (= (g4 (f1 (- 5))) 65))
(assert (= (g4 (f2 (- 9))) 221))
(assert (= (f4 (f2 (- 7))) (- 22)))
(assert (= (g4 (g2 (- 7))) (- 1437)))
(assert (= (g4 (f3 (- 1))) 65))
(assert (= (f4 (f3 (- 5))) (- 16)))
(assert (= (g4 (g3 (- 5))) (- 527)))
(assert (= (f4 (f4 (- 9))) (- 22)))
(assert (= (g4 (g4 (- 9))) (- 1437)))
(check-sat)
