(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 8))
(assert (= (f1 (g1 (- 5))) 5))
(assert (= (f1 (f2 (- 6))) (- 12)))
(assert (= (f1 (g2 7)) (- 78)))
(assert (= (f1 (f3 (- 1))) 8))
(assert (= (f1 (g3 (- 6))) (- 78)))
(assert (= (g1 (f3 (- 5))) (- 12)))
(assert (= (f1 (g4 (- 1))) 5))
(assert (= (g1 (f4 7)) (- 12)))
(assert (= (f2 (f1 (- 6))) (- 12)))
(assert (= (f2 (g1 7)) (- 13)))
(assert (= (f2 (f2 (- 1))) (- 12)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 5))) 110))
(assert (= (f2 (g3 (- 1))) (- 13)))
(assert (= (g2 (f3 7)) 154))
(assert (= (g2 (f4 (- 6))) 110))
(assert (= (f2 (f4 (- 5))) (- 15)))
(assert (= (g2 (g4 (- 5))) (- 446)))
(assert (= (f3 (f1 (- 1))) 8))
(assert (= (f3 (g1 (- 6))) (- 13)))
(assert (= (g3 (f1 (- 5))) 70))
(assert (= (f3 (g2 (- 1))) (- 13)))
(assert (= (g3 (f2 7)) 175))
(assert (= (g3 (f3 (- 6))) 175))
(assert (= (f3 (f3 (- 5))) (- 19)))
(assert (= (g3 (g3 (- 5))) 882))
(assert (= (g3 (f4 (- 1))) 70))
(assert (= (f3 (f4 7)) (- 19)))
(assert (= (g3 (g4 7)) 882))
(assert (= (f4 (g1 (- 1))) 5))
(assert (= (g4 (f1 7)) (- 68)))
(assert (= (g4 (f2 (- 6))) 99))
(assert (= (f4 (f2 (- 5))) (- 15)))
(assert (= (g4 (g2 (- 5))) (- 446)))
(assert (= (g4 (f3 (- 1))) (- 68)))
(assert (= (f4 (f3 7)) (- 19)))
(assert (= (g4 (g3 7)) 882))
(assert (= (f4 (f4 (- 6))) (- 15)))
(assert (= (g4 (g4 (- 6))) (- 446)))
(check-sat)
