(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 9)))
(assert (= (f1 (g1 1)) (- 2)))
(assert (= (f1 (f2 8)) (- 17)))
(assert (= (f1 (g2 (- 8))) (- 121)))
(assert (= (f1 (f3 (- 1))) (- 9)))
(assert (= (f1 (g3 8)) (- 121)))
(assert (= (g1 (f3 1)) (- 9)))
(assert (= (f1 (g4 (- 1))) (- 2)))
(assert (= (g1 (f4 (- 8))) (- 9)))
(assert (= (f2 (f1 8)) (- 17)))
(assert (= (f2 (g1 (- 8))) (- 16)))
(assert (= (f2 (f2 (- 1))) (- 17)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 1)) 144))
(assert (= (f2 (g3 (- 1))) (- 16)))
(assert (= (g2 (f3 (- 8))) 240))
(assert (= (g2 (f4 8)) 144))
(assert (= (f2 (f4 1)) 10))
(assert (= (g2 (g4 1)) 32))
(assert (= (f3 (f1 (- 1))) (- 9)))
(assert (= (f3 (g1 8)) (- 16)))
(assert (= (g3 (f1 1)) (- 23)))
(assert (= (f3 (g2 (- 1))) (- 16)))
(assert (= (g3 (f2 (- 8))) (- 233)))
(assert (= (g3 (f3 8)) (- 233)))
(assert (= (f3 (f3 1)) 16))
(assert (= (g3 (g3 1)) 225))
(assert (= (g3 (f4 (- 1))) (- 23)))
(assert (= (f3 (f4 (- 8))) 16))
(assert (= (g3 (g4 (- 8))) 225))
(assert (= (f4 (g1 (- 1))) (- 2)))
(assert (= (g4 (f1 (- 8))) 16))
(assert (= (g4 (f2 8)) 32))
(assert (= (f4 (f2 1)) 10))
(assert (= (g4 (g2 1)) 32))
(assert (= (g4 (f3 (- 1))) 16))
(assert (= (f4 (f3 (- 8))) 16))
(assert (= (g4 (g3 (- 8))) 225))
(assert (= (f4 (f4 8)) 10))
(assert (= (g4 (g4 8)) 32))
(check-sat)
