(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 19)))
(assert (= (f1 (g1 5)) (- 83)))
(assert (= (f1 (f2 1)) (- 10)))
(assert (= (f1 (g2 (- 4))) (- 15)))
(assert (= (f1 (f3 (- 8))) (- 19)))
(assert (= (f1 (g3 1)) (- 15)))
(assert (= (g1 (f3 5)) (- 128)))
(assert (= (f1 (g4 (- 8))) (- 83)))
(assert (= (g1 (f4 (- 4))) (- 128)))
(assert (= (f2 (f1 1)) (- 10)))
(assert (= (f2 (g1 (- 4))) (- 54)))
(assert (= (f2 (f2 (- 8))) (- 10)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 5)) 12))
(assert (= (f2 (g3 (- 8))) (- 54)))
(assert (= (g2 (f3 (- 4))) 14))
(assert (= (g2 (f4 1)) 12))
(assert (= (f2 (f4 5)) 11))
(assert (= (g2 (g4 5)) 100))
(assert (= (f3 (f1 (- 8))) (- 19)))
(assert (= (f3 (g1 1)) (- 19)))
(assert (= (g3 (f1 5)) (- 88)))
(assert (= (f3 (g2 (- 8))) (- 19)))
(assert (= (g3 (f2 (- 4))) (- 32)))
(assert (= (g3 (f3 1)) (- 32)))
(assert (= (f3 (f3 5)) 12))
(assert (= (g3 (g3 5)) 245))
(assert (= (g3 (f4 (- 8))) (- 88)))
(assert (= (f3 (f4 (- 4))) 12))
(assert (= (g3 (g4 (- 4))) 245))
(assert (= (f4 (g1 (- 8))) (- 118)))
(assert (= (g4 (f1 (- 4))) 110))
(assert (= (g4 (f2 1)) 20))
(assert (= (f4 (f2 5)) 11))
(assert (= (g4 (g2 5)) 100))
(assert (= (g4 (f3 (- 8))) 110))
(assert (= (f4 (f3 (- 4))) 12))
(assert (= (g4 (g3 (- 4))) 245))
(assert (= (f4 (f4 1)) 11))
(assert (= (g4 (g4 1)) 100))
(check-sat)
