(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 3))
(assert (= (f1 (g1 (- 8))) 8))
(assert (= (f1 (f2 9)) (- 19)))
(assert (= (f1 (g2 2)) (- 37)))
(assert (= (f1 (f3 (- 1))) 3))
(assert (= (f1 (g3 9)) (- 37)))
(assert (= (g1 (f3 (- 8))) (- 10)))
(assert (= (f1 (g4 (- 1))) 8))
(assert (= (g1 (f4 2)) (- 10)))
(assert (= (f2 (f1 9)) (- 19)))
(assert (= (f2 (g1 2)) 11))
(assert (= (f2 (f2 (- 1))) (- 19)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 8))) 297))
(assert (= (f2 (g3 (- 1))) 11))
(assert (= (g2 (f3 2)) 72))
(assert (= (g2 (f4 9)) 297))
(assert (= (f2 (f4 (- 8))) 24))
(assert (= (g2 (g4 (- 8))) 2025))
(assert (= (f3 (f1 (- 1))) 3))
(assert (= (f3 (g1 9)) 11))
(assert (= (g3 (f1 (- 8))) 32))
(assert (= (f3 (g2 (- 1))) 11))
(assert (= (g3 (f2 2)) 44))
(assert (= (g3 (f3 9)) 44))
(assert (= (f3 (f3 (- 8))) (- 12)))
(assert (= (g3 (g3 (- 8))) 120))
(assert (= (g3 (f4 (- 1))) 32))
(assert (= (f3 (f4 2)) (- 12)))
(assert (= (g3 (g4 2)) 120))
(assert (= (f4 (g1 (- 1))) 8))
(assert (= (g4 (f1 2)) (- 38)))
(assert (= (g4 (f2 9)) 270))
(assert (= (f4 (f2 (- 8))) 24))
(assert (= (g4 (g2 (- 8))) 2025))
(assert (= (g4 (f3 (- 1))) (- 38)))
(assert (= (f4 (f3 2)) (- 12)))
(assert (= (g4 (g3 2)) 120))
(assert (= (f4 (f4 9)) 24))
(assert (= (g4 (g4 9)) 2025))
(check-sat)
