(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 18)))
(assert (= (f1 (g1 9)) (- 143)))
(assert (= (f1 (f2 2)) (- 12)))
(assert (= (f1 (g2 (- 3))) (- 18)))
(assert (= (f1 (f3 (- 8))) (- 18)))
(assert (= (f1 (g3 2)) (- 18)))
(assert (= (g1 (f3 9)) (- 173)))
(assert (= (f1 (g4 (- 8))) (- 143)))
(assert (= (g1 (f4 (- 3))) (- 173)))
(assert (= (f2 (f1 2)) (- 12)))
(assert (= (f2 (g1 (- 3))) (- 40)))
(assert (= (f2 (f2 (- 8))) (- 12)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 9)) 44))
(assert (= (f2 (g3 (- 8))) (- 40)))
(assert (= (g2 (f3 (- 3))) 20))
(assert (= (g2 (f4 2)) 44))
(assert (= (f2 (f4 9)) 20))
(assert (= (g2 (g4 9)) 648))
(assert (= (f3 (f1 (- 8))) (- 18)))
(assert (= (f3 (g1 2)) (- 33)))
(assert (= (g3 (f1 9)) (- 83)))
(assert (= (f3 (g2 (- 8))) (- 33)))
(assert (= (g3 (f2 (- 3))) (- 23)))
(assert (= (g3 (f3 2)) (- 23)))
(assert (= (f3 (f3 9)) 14))
(assert (= (g3 (g3 9)) 225))
(assert (= (g3 (f4 (- 8))) (- 83)))
(assert (= (f3 (f4 (- 3))) 14))
(assert (= (g3 (g4 (- 3))) 225))
(assert (= (f4 (g1 (- 8))) (- 122)))
(assert (= (g4 (f1 (- 3))) 180))
(assert (= (g4 (f2 2)) 72))
(assert (= (f4 (f2 9)) 20))
(assert (= (g4 (g2 9)) 648))
(assert (= (g4 (f3 (- 8))) 180))
(assert (= (f4 (f3 (- 3))) 14))
(assert (= (g4 (g3 (- 3))) 225))
(assert (= (f4 (f4 2)) 20))
(assert (= (g4 (g4 2)) 648))
(check-sat)
