(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 6)))
(assert (= (f1 (g1 5)) 11))
(assert (= (f1 (f2 (- 7))) 14))
(assert (= (f1 (g2 (- 4))) (- 47)))
(assert (= (f1 (f3 1)) (- 6)))
(assert (= (f1 (g3 (- 7))) (- 47)))
(assert (= (g1 (f3 5)) 17))
(assert (= (f1 (g4 1)) 11))
(assert (= (g1 (f4 (- 4))) 17))
(assert (= (f2 (f1 (- 7))) 14))
(assert (= (f2 (g1 (- 4))) (- 14)))
(assert (= (f2 (f2 1)) 14))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 5)) (- 150)))
(assert (= (f2 (g3 1)) (- 14)))
(assert (= (g2 (f3 (- 4))) 91))
(assert (= (g2 (f4 (- 7))) (- 150)))
(assert (= (f2 (f4 5)) (- 17)))
(assert (= (g2 (g4 5)) 650))
(assert (= (f3 (f1 1)) (- 6)))
(assert (= (f3 (g1 (- 7))) (- 17)))
(assert (= (g3 (f1 5)) 42))
(assert (= (f3 (g2 1)) (- 17)))
(assert (= (g3 (f2 (- 4))) 70))
(assert (= (g3 (f3 (- 7))) 70))
(assert (= (f3 (f3 5)) 12))
(assert (= (g3 (g3 5)) 245))
(assert (= (g3 (f4 1)) 42))
(assert (= (f3 (f4 (- 4))) 12))
(assert (= (g3 (g4 (- 4))) 245))
(assert (= (f4 (g1 1)) 7))
(assert (= (g4 (f1 (- 4))) 45))
(assert (= (g4 (f2 (- 7))) 130))
(assert (= (f4 (f2 5)) (- 17)))
(assert (= (g4 (g2 5)) 650))
(assert (= (g4 (f3 1)) 45))
(assert (= (f4 (f3 (- 4))) 12))
(assert (= (g4 (g3 (- 4))) 245))
(assert (= (f4 (f4 (- 7))) (- 17)))
(assert (= (g4 (g4 (- 7))) 650))
(check-sat)
