(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g3 x)))))
(assert (= (f1 (f1 3)) 5))
(assert (= (f1 (g1 9)) 19))
(assert (= (f1 (f2 (- 5))) 10))
(assert (= (f1 (g2 3)) 28))
(assert (= (f1 (f3 1)) 5))
(assert (= (f1 (g3 (- 5))) 28))
(assert (= (g1 (f3 9)) 24))
(assert (= (f1 (g4 1)) 19))
(assert (= (g1 (f4 3)) 24))
(assert (= (f2 (f1 (- 5))) 10))
(assert (= (f2 (g1 3)) (- 11)))
(assert (= (f2 (f2 1)) 10))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 9)) (- 122)))
(assert (= (f2 (g3 1)) (- 11)))
(assert (= (g2 (f3 3)) 54))
(assert (= (g2 (f4 (- 5))) (- 122)))
(assert (= (f2 (f4 9)) (- 23)))
(assert (= (g2 (g4 9)) 1458))
(assert (= (f3 (f1 1)) 5))
(assert (= (f3 (g1 (- 5))) 12))
(assert (= (g3 (f1 9)) 60))
(assert (= (f3 (g2 1)) 12))
(assert (= (g3 (f2 3)) 45))
(assert (= (g3 (f3 (- 5))) 45))
(assert (= (f3 (f3 9)) 15))
(assert (= (g3 (g3 9)) 324))
(assert (= (g3 (f4 1)) 60))
(assert (= (f3 (f4 3)) 15))
(assert (= (g3 (g4 3)) 324))
(assert (= (f4 (g1 1)) 11))
(assert (= (g4 (f1 3)) 72))
(assert (= (g4 (f2 (- 5))) 162))
(assert (= (f4 (f2 9)) (- 23)))
(assert (= (g4 (g2 9)) 1458))
(assert (= (g4 (f3 1)) 72))
(assert (= (f4 (f3 3)) 15))
(assert (= (g4 (g3 3)) 324))
(assert (= (f4 (f4 (- 5))) (- 23)))
(assert (= (g4 (g4 (- 5))) 1458))
(check-sat)
