(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (g1 (g1 (g1 x))) (g2 (g3 x)))))
(assert (= (f1 (f1 4)) 6))
(assert (= (f1 (g1 (- 9))) 18))
(assert (= (f1 (f2 (- 1))) 2))
(assert (= (f1 (g2 4)) 5))
(assert (= (f1 (f3 1)) 6))
(assert (= (f1 (g3 (- 1))) 5))
(assert (= (g1 (f3 (- 9))) 25))
(assert (= (f1 (g4 1)) 18))
(assert (= (g1 (f4 4)) 25))
(assert (= (f2 (f1 (- 1))) 2))
(assert (= (f2 (g1 4)) (- 9)))
(assert (= (f2 (f2 1)) 2))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 9))) 9))
(assert (= (f2 (g3 1)) (- 9)))
(assert (= (g2 (f3 4)) 8))
(assert (= (g2 (f4 (- 1))) 9))
(assert (= (f2 (f4 (- 9))) (- 18)))
(assert (= (g2 (g4 (- 9))) (- 145)))
(assert (= (f3 (f1 1)) 6))
(assert (= (f3 (g1 (- 1))) 5))
(assert (= (g3 (f1 (- 9))) 76))
(assert (= (f3 (g2 1)) 5))
(assert (= (g3 (f2 4)) 36))
(assert (= (g3 (f3 (- 1))) 36))
(assert (= (f3 (f3 (- 9))) (- 17)))
(assert (= (g3 (g3 (- 9))) 544))
(assert (= (g3 (f4 1)) 76))
(assert (= (f3 (f4 4)) (- 17)))
(assert (= (g3 (g4 4)) 544))
(assert (= (f4 (g1 1)) (- 11)))
(assert (= (g4 (f1 4)) 85))
(assert (= (g4 (f2 (- 1))) 17))
(assert (= (f4 (f2 (- 9))) (- 18)))
(assert (= (g4 (g2 (- 9))) (- 145)))
(assert (= (g4 (f3 1)) 85))
(assert (= (f4 (f3 4)) (- 17)))
(assert (= (g4 (g3 4)) 544))
(assert (= (f4 (f4 (- 1))) (- 18)))
(assert (= (g4 (g4 (- 1))) (- 145)))
(check-sat)
