(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 0 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 0 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 2)) 4))
(assert (= (f1 (g1 (- 6))) 12))
(assert (= (f1 (f2 0)) 1))
(assert (= (f1 (g2 2)) 1))
(assert (= (f1 (f3 1)) 4))
(assert (= (f1 (g3 0)) 1))
(assert (= (g1 (f3 (- 6))) 15))
(assert (= (f1 (g4 1)) 12))
(assert (= (g1 (f4 2)) 15))
(assert (= (f2 (f1 0)) 1))
(assert (= (f2 (g1 2)) 4))
(assert (= (f2 (f2 1)) 1))
(assert (= (f2 (g2 0)) 0))
(assert (= (g2 (f2 (- 6))) 0))
(assert (= (f2 (g3 1)) 4))
(assert (= (g2 (f3 2)) 0))
(assert (= (g2 (f4 0)) 0))
(assert (= (f2 (f4 (- 6))) 11))
(assert (= (g2 (g4 (- 6))) 0))
(assert (= (f3 (f1 1)) 4))
(assert (= (f3 (g1 0)) 2))
(assert (= (g3 (f1 (- 6))) 26))
(assert (= (f3 (g2 1)) 2))
(assert (= (g3 (f2 2)) 8))
(assert (= (g3 (f3 0)) 8))
(assert (= (f3 (f3 (- 6))) (- 10)))
(assert (= (g3 (g3 (- 6))) 88))
(assert (= (g3 (f4 1)) 26))
(assert (= (f3 (f4 2)) (- 10)))
(assert (= (g3 (g4 2)) 88))
(assert (= (f4 (g1 1)) (- 8)))
(assert (= (g4 (f1 2)) 33))
(assert (= (g4 (f2 0)) 0))
(assert (= (f4 (f2 (- 6))) 11))
(assert (= (g4 (g2 (- 6))) 0))
(assert (= (g4 (f3 1)) 33))
(assert (= (f4 (f3 2)) (- 10)))
(assert (= (g4 (g3 2)) 88))
(assert (= (f4 (f4 0)) 11))
(assert (= (g4 (g4 0)) 0))
(check-sat)
