(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 5)) 20))
(assert (= (f1 (g1 6)) (- 98)))
(assert (= (f1 (f2 4)) (- 16)))
(assert (= (f1 (g2 5)) (- 48)))
(assert (= (f1 (f3 (- 8))) 20))
(assert (= (f1 (g3 4)) (- 48)))
(assert (= (g1 (f3 6)) 165))
(assert (= (f1 (g4 (- 8))) (- 98)))
(assert (= (g1 (f4 5)) 165))
(assert (= (f2 (f1 4)) (- 16)))
(assert (= (f2 (g1 5)) 79))
(assert (= (f2 (f2 (- 8))) (- 16)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 6)) 80))
(assert (= (f2 (g3 (- 8))) 79))
(assert (= (g2 (f3 5)) 80))
(assert (= (g2 (f4 4)) 80))
(assert (= (f2 (f4 6)) 16))
(assert (= (g2 (g4 6)) 576))
(assert (= (f3 (f1 (- 8))) 20))
(assert (= (f3 (g1 4)) 65))
(assert (= (g3 (f1 6)) 135))
(assert (= (f3 (g2 (- 8))) 65))
(assert (= (g3 (f2 5)) 90))
(assert (= (g3 (f3 4)) 90))
(assert (= (f3 (f3 6)) 16))
(assert (= (g3 (g3 6)) 600))
(assert (= (g3 (f4 (- 8))) 135))
(assert (= (f3 (f4 5)) 16))
(assert (= (g3 (g4 5)) 600))
(assert (= (f4 (g1 (- 8))) (- 119)))
(assert (= (g4 (f1 5)) 150))
(assert (= (g4 (f2 4)) 96))
(assert (= (f4 (f2 6)) 16))
(assert (= (g4 (g2 6)) 576))
(assert (= (g4 (f3 (- 8))) 150))
(assert (= (f4 (f3 5)) 16))
(assert (= (g4 (g3 5)) 600))
(assert (= (f4 (f4 4)) 16))
(assert (= (g4 (g4 4)) 576))
(check-sat)
