(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 21))
(assert (= (f1 (g1 (- 6))) 90))
(assert (= (f1 (f2 4)) (- 16)))
(assert (= (f1 (g2 6)) (- 56)))
(assert (= (f1 (f3 (- 8))) 21))
(assert (= (f1 (g3 4)) (- 56)))
(assert (= (g1 (f3 (- 6))) (- 173)))
(assert (= (f1 (g4 (- 8))) 90))
(assert (= (g1 (f4 6)) (- 173)))
(assert (= (f2 (f1 4)) (- 16)))
(assert (= (f2 (g1 6)) 94))
(assert (= (f2 (f2 (- 8))) (- 16)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 6))) 76))
(assert (= (f2 (g3 (- 8))) 94))
(assert (= (g2 (f3 6)) 96))
(assert (= (g2 (f4 4)) 76))
(assert (= (f2 (f4 (- 6))) 15))
(assert (= (g2 (g4 (- 6))) 484))
(assert (= (f3 (f1 (- 8))) 21))
(assert (= (f3 (g1 4)) 66))
(assert (= (g3 (f1 (- 6))) 156))
(assert (= (f3 (g2 (- 8))) 66))
(assert (= (g3 (f2 6)) 120))
(assert (= (g3 (f3 4)) 120))
(assert (= (f3 (f3 (- 6))) (- 18)))
(assert (= (g3 (g3 (- 6))) 792))
(assert (= (g3 (f4 (- 8))) 156))
(assert (= (f3 (f4 6)) (- 18)))
(assert (= (g3 (g4 6)) 792))
(assert (= (f4 (g1 (- 8))) 118))
(assert (= (g4 (f1 6)) (- 149)))
(assert (= (g4 (f2 4)) 88))
(assert (= (f4 (f2 (- 6))) 15))
(assert (= (g4 (g2 (- 6))) 484))
(assert (= (g4 (f3 (- 8))) (- 149)))
(assert (= (f4 (f3 6)) (- 18)))
(assert (= (g4 (g3 6)) 792))
(assert (= (f4 (f4 4)) 15))
(assert (= (g4 (g4 4)) 484))
(check-sat)
