(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 20)))
(assert (= (f1 (g1 8)) (- 128)))
(assert (= (f1 (f2 5)) (- 18)))
(assert (= (f1 (g2 (- 5))) (- 53)))
(assert (= (f1 (f3 (- 8))) (- 20)))
(assert (= (f1 (g3 5)) (- 53)))
(assert (= (g1 (f3 8)) (- 188)))
(assert (= (f1 (g4 (- 8))) (- 128)))
(assert (= (g1 (f4 (- 5))) (- 188)))
(assert (= (f2 (f1 5)) (- 18)))
(assert (= (f2 (g1 (- 5))) (- 73)))
(assert (= (f2 (f2 (- 8))) (- 18)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 8)) 130))
(assert (= (f2 (g3 (- 8))) (- 73)))
(assert (= (g2 (f3 (- 5))) 90))
(assert (= (g2 (f4 5)) 130))
(assert (= (f2 (f4 8)) 21))
(assert (= (g2 (g4 8)) 1280))
(assert (= (f3 (f1 (- 8))) (- 20)))
(assert (= (f3 (g1 5)) (- 80)))
(assert (= (g3 (f1 8)) (- 140)))
(assert (= (f3 (g2 (- 8))) (- 80)))
(assert (= (g3 (f2 (- 5))) (- 86)))
(assert (= (g3 (f3 5)) (- 86)))
(assert (= (f3 (f3 8)) 17))
(assert (= (g3 (g3 8)) 648))
(assert (= (g3 (f4 (- 8))) (- 140)))
(assert (= (f3 (f4 (- 5))) 17))
(assert (= (g3 (g4 (- 5))) 648))
(assert (= (f4 (g1 (- 8))) (- 121)))
(assert (= (g4 (f1 (- 5))) 192))
(assert (= (g4 (f2 5)) 160))
(assert (= (f4 (f2 8)) 21))
(assert (= (g4 (g2 8)) 1280))
(assert (= (g4 (f3 (- 8))) 192))
(assert (= (f4 (f3 (- 5))) 17))
(assert (= (g4 (g3 (- 5))) 648))
(assert (= (f4 (f4 5)) 21))
(assert (= (g4 (g4 5)) 1280))
(check-sat)
