(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 (- 4))) (- 6)))
(assert (= (f1 (g1 4)) 9))
(assert (= (f1 (f2 7)) 15))
(assert (= (f1 (g2 (- 4))) 50))
(assert (= (f1 (f3 1)) (- 6)))
(assert (= (f1 (g3 7)) 50))
(assert (= (g1 (f3 4)) 15))
(assert (= (f1 (g4 1)) 9))
(assert (= (g1 (f4 (- 4))) 15))
(assert (= (f2 (f1 7)) 15))
(assert (= (f2 (g1 (- 4))) 14))
(assert (= (f2 (f2 1)) 15))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 4)) 154))
(assert (= (f2 (g3 1)) 14))
(assert (= (g2 (f3 (- 4))) 98))
(assert (= (g2 (f4 7)) 154))
(assert (= (f2 (f4 4)) 15))
(assert (= (g2 (g4 4)) 448))
(assert (= (f3 (f1 1)) (- 6)))
(assert (= (f3 (g1 7)) (- 18)))
(assert (= (g3 (f1 4)) 35))
(assert (= (f3 (g2 1)) (- 18)))
(assert (= (g3 (f2 (- 4))) (- 74)))
(assert (= (g3 (f3 7)) (- 74)))
(assert (= (f3 (f3 4)) 11))
(assert (= (g3 (g3 4)) 196))
(assert (= (g3 (f4 1)) 35))
(assert (= (f3 (f4 (- 4))) 11))
(assert (= (g3 (g4 (- 4))) 196))
(assert (= (f4 (g1 1)) 6))
(assert (= (g4 (f1 (- 4))) 36))
(assert (= (g4 (f2 7)) 112))
(assert (= (f4 (f2 4)) 15))
(assert (= (g4 (g2 4)) 448))
(assert (= (g4 (f3 1)) 36))
(assert (= (f4 (f3 (- 4))) 11))
(assert (= (g4 (g3 (- 4))) 196))
(assert (= (f4 (f4 7)) 15))
(assert (= (g4 (g4 7)) 448))
(check-sat)
