(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 9)) 24))
(assert (= (f1 (g1 7)) (- 113)))
(assert (= (f1 (f2 6)) (- 20)))
(assert (= (f1 (g2 9)) (- 116)))
(assert (= (f1 (f3 (- 8))) 24))
(assert (= (f1 (g3 6)) (- 116)))
(assert (= (g1 (f3 7)) 240))
(assert (= (f1 (g4 (- 8))) (- 113)))
(assert (= (g1 (f4 9)) 240))
(assert (= (f2 (f1 6)) (- 20)))
(assert (= (f2 (g1 9)) 141))
(assert (= (f2 (f2 (- 8))) (- 20)))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 7)) 156))
(assert (= (f2 (g3 (- 8))) 141))
(assert (= (g2 (f3 9)) 216))
(assert (= (g2 (f4 6)) 156))
(assert (= (f2 (f4 7)) 20))
(assert (= (g2 (g4 7)) 1176))
(assert (= (f3 (f1 (- 8))) 24))
(assert (= (f3 (g1 6)) 99))
(assert (= (g3 (f1 7)) 261))
(assert (= (f3 (g2 (- 8))) 99))
(assert (= (g3 (f2 9)) 270))
(assert (= (g3 (f3 6)) 270))
(assert (= (f3 (f3 7)) 25))
(assert (= (g3 (g3 7)) 2268))
(assert (= (g3 (f4 (- 8))) 261))
(assert (= (f3 (f4 9)) 25))
(assert (= (g3 (g4 9)) 2268))
(assert (= (f4 (g1 (- 8))) (- 120)))
(assert (= (g4 (f1 9)) 231))
(assert (= (g4 (f2 6)) 168))
(assert (= (f4 (f2 7)) 20))
(assert (= (g4 (g2 7)) 1176))
(assert (= (g4 (f3 (- 8))) 231))
(assert (= (f4 (f3 9)) 25))
(assert (= (g4 (g3 9)) 2268))
(assert (= (f4 (f4 6)) 20))
(assert (= (g4 (g4 6)) 1176))
(check-sat)
