(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 7)) 11))
(assert (= (f1 (g1 (- 4))) 16))
(assert (= (f1 (f2 (- 9))) 19))
(assert (= (f1 (g2 7)) 121))
(assert (= (f1 (f3 2)) 11))
(assert (= (f1 (g3 (- 9))) 121))
(assert (= (g1 (f3 (- 4))) 42))
(assert (= (f1 (g4 2)) 16))
(assert (= (g1 (f4 7)) 42))
(assert (= (f2 (f1 (- 9))) 19))
(assert (= (f2 (g1 7)) (- 37)))
(assert (= (f2 (f2 2)) 19))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 4))) 204))
(assert (= (f2 (g3 2)) (- 37)))
(assert (= (g2 (f3 7)) 238))
(assert (= (g2 (f4 (- 9))) 204))
(assert (= (f2 (f4 (- 4))) (- 16)))
(assert (= (g2 (g4 (- 4))) (- 417)))
(assert (= (f3 (f1 2)) 11))
(assert (= (f3 (g1 (- 9))) 41))
(assert (= (g3 (f1 (- 4))) 77))
(assert (= (f3 (g2 2)) 41))
(assert (= (g3 (f2 7)) 217))
(assert (= (g3 (f3 (- 9))) 217))
(assert (= (f3 (f3 (- 4))) (- 18)))
(assert (= (g3 (g3 (- 4))) 686))
(assert (= (g3 (f4 2)) 77))
(assert (= (f3 (f4 7)) (- 18)))
(assert (= (g3 (g4 7)) 686))
(assert (= (f4 (g1 2)) (- 12)))
(assert (= (g4 (f1 7)) 63))
(assert (= (g4 (f2 (- 9))) 119))
(assert (= (f4 (f2 (- 4))) (- 16)))
(assert (= (g4 (g2 (- 4))) (- 417)))
(assert (= (g4 (f3 2)) 63))
(assert (= (f4 (f3 7)) (- 18)))
(assert (= (g4 (g3 7)) 686))
(assert (= (f4 (f4 (- 9))) (- 16)))
(assert (= (g4 (g4 (- 9))) (- 417)))
(check-sat)
