(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 22)))
(assert (= (f1 (g1 9)) (- 143)))
(assert (= (f1 (f2 8)) (- 24)))
(assert (= (f1 (g2 (- 7))) (- 112)))
(assert (= (f1 (f3 (- 8))) (- 22)))
(assert (= (f1 (g3 8)) (- 112)))
(assert (= (g1 (f3 9)) (- 233)))
(assert (= (f1 (g4 (- 8))) (- 143)))
(assert (= (g1 (f4 (- 7))) (- 233)))
(assert (= (f2 (f1 8)) (- 24)))
(assert (= (f2 (g1 (- 7))) (- 106)))
(assert (= (f2 (f2 (- 8))) (- 24)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 9)) 272))
(assert (= (f2 (g3 (- 8))) (- 106)))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 272))
(assert (= (f2 (f4 9)) 26))
(assert (= (g2 (g4 9)) 2592))
(assert (= (f3 (f1 (- 8))) (- 22)))
(assert (= (f3 (g1 8)) (- 127)))
(assert (= (g3 (f1 9)) (- 215)))
(assert (= (f3 (g2 (- 8))) (- 127)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 9)) 22))
(assert (= (g3 (g3 9)) 1521))
(assert (= (g3 (f4 (- 8))) (- 215)))
(assert (= (f3 (f4 (- 7))) 22))
(assert (= (g3 (g4 (- 7))) 1521))
(assert (= (f4 (g1 (- 8))) (- 122)))
(assert (= (g4 (f1 (- 7))) 252))
(assert (= (g4 (f2 8)) 288))
(assert (= (f4 (f2 9)) 26))
(assert (= (g4 (g2 9)) 2592))
(assert (= (g4 (f3 (- 8))) 252))
(assert (= (f4 (f3 (- 7))) 22))
(assert (= (g4 (g3 (- 7))) 1521))
(assert (= (f4 (f4 8)) 26))
(assert (= (g4 (g4 8)) 2592))
(check-sat)
