(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 22))
(assert (= (f1 (g1 7)) (- 128)))
(assert (= (f1 (f2 (- 4))) (- 16)))
(assert (= (f1 (g2 5)) (- 44)))
(assert (= (f1 (f3 (- 9))) 22))
(assert (= (f1 (g3 (- 4))) (- 44)))
(assert (= (g1 (f3 7)) 204))
(assert (= (f1 (g4 (- 9))) (- 128)))
(assert (= (g1 (f4 5)) 204))
(assert (= (f2 (f1 (- 4))) (- 16)))
(assert (= (f2 (g1 5)) (- 89)))
(assert (= (f2 (f2 (- 9))) (- 16)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 7)) (- 74)))
(assert (= (f2 (g3 (- 9))) (- 89)))
(assert (= (g2 (f3 5)) 70))
(assert (= (g2 (f4 (- 4))) (- 74)))
(assert (= (f2 (f4 7)) (- 18)))
(assert (= (g2 (g4 7)) 686))
(assert (= (f3 (f1 (- 9))) 22))
(assert (= (f3 (g1 (- 4))) (- 65)))
(assert (= (g3 (f1 7)) 155))
(assert (= (f3 (g2 (- 9))) (- 65)))
(assert (= (g3 (f2 5)) 85))
(assert (= (g3 (f3 (- 4))) 85))
(assert (= (f3 (f3 7)) 17))
(assert (= (g3 (g3 7)) 700))
(assert (= (g3 (f4 (- 9))) 155))
(assert (= (f3 (f4 5)) 17))
(assert (= (g3 (g4 5)) 700))
(assert (= (f4 (g1 (- 9))) (- 152)))
(assert (= (g4 (f1 5)) 189))
(assert (= (g4 (f2 (- 4))) 98))
(assert (= (f4 (f2 7)) (- 18)))
(assert (= (g4 (g2 7)) 686))
(assert (= (g4 (f3 (- 9))) 189))
(assert (= (f4 (f3 5)) 17))
(assert (= (g4 (g3 5)) 700))
(assert (= (f4 (f4 (- 4))) (- 18)))
(assert (= (g4 (g4 (- 4))) 686))
(check-sat)
