(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (g1 (g1 x)) (g2 (g3 x)))))
(assert (= (f1 (f1 8)) 12))
(assert (= (f1 (g1 (- 3))) 12))
(assert (= (f1 (f2 (- 1))) 3))
(assert (= (f1 (g2 8)) 10))
(assert (= (f1 (f3 2)) 12))
(assert (= (f1 (g3 (- 1))) 10))
(assert (= (g1 (f3 (- 3))) 42))
(assert (= (f1 (g4 2)) 12))
(assert (= (g1 (f4 8)) 42))
(assert (= (f2 (f1 (- 1))) 3))
(assert (= (f2 (g1 8)) (- 33)))
(assert (= (f2 (f2 2)) 3))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 3))) 3))
(assert (= (f2 (g3 2)) (- 33)))
(assert (= (g2 (f3 8)) 16))
(assert (= (g2 (f4 (- 1))) 3))
(assert (= (f2 (f4 (- 3))) (- 6)))
(assert (= (g2 (g4 (- 3))) (- 13)))
(assert (= (f3 (f1 2)) 12))
(assert (= (f3 (g1 (- 1))) 10))
(assert (= (g3 (f1 (- 3))) 72))
(assert (= (f3 (g2 2)) 10))
(assert (= (g3 (f2 8)) 136))
(assert (= (g3 (f3 (- 1))) 136))
(assert (= (f3 (f3 (- 3))) (- 19)))
(assert (= (g3 (g3 (- 3))) 640))
(assert (= (g3 (f4 2)) 72))
(assert (= (f3 (f4 8)) (- 19)))
(assert (= (g3 (g4 8)) 640))
(assert (= (f4 (g1 2)) (- 11)))
(assert (= (g4 (f1 8)) 50))
(assert (= (g4 (f2 (- 1))) 5))
(assert (= (f4 (f2 (- 3))) (- 6)))
(assert (= (g4 (g2 (- 3))) (- 13)))
(assert (= (g4 (f3 2)) 50))
(assert (= (f4 (f3 8)) (- 19)))
(assert (= (g4 (g3 8)) 640))
(assert (= (f4 (f4 (- 1))) (- 6)))
(assert (= (g4 (g4 (- 1))) (- 13)))
(check-sat)
