(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (g1 (g1 x)) (g2 (g3 x)))))
(assert (= (f1 (f1 8)) 12))
(assert (= (f1 (g1 7)) 30))
(assert (= (f1 (f2 (- 1))) 3))
(assert (= (f1 (g2 8)) 10))
(assert (= (f1 (f3 2)) 12))
(assert (= (f1 (g3 (- 1))) 10))
(assert (= (g1 (f3 7)) 60))
(assert (= (f1 (g4 2)) 30))
(assert (= (g1 (f4 8)) 60))
(assert (= (f2 (f1 (- 1))) 3))
(assert (= (f2 (g1 8)) (- 33)))
(assert (= (f2 (f2 2)) 3))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 7)) (- 8)))
(assert (= (f2 (g3 2)) (- 33)))
(assert (= (g2 (f3 8)) 16))
(assert (= (g2 (f4 (- 1))) (- 8)))
(assert (= (f2 (f4 7)) (- 15)))
(assert (= (g2 (g4 7)) 98))
(assert (= (f3 (f1 2)) 12))
(assert (= (f3 (g1 (- 1))) 10))
(assert (= (g3 (f1 7)) 144))
(assert (= (f3 (g2 2)) 10))
(assert (= (g3 (f2 8)) 136))
(assert (= (g3 (f3 (- 1))) 136))
(assert (= (f3 (f3 7)) 23))
(assert (= (g3 (g3 7)) 1792))
(assert (= (g3 (f4 2)) 144))
(assert (= (f3 (f4 8)) 23))
(assert (= (g3 (g4 8)) 1792))
(assert (= (f4 (g1 2)) 15))
(assert (= (g4 (f1 8)) 140))
(assert (= (g4 (f2 (- 1))) 14))
(assert (= (f4 (f2 7)) (- 15)))
(assert (= (g4 (g2 7)) 98))
(assert (= (g4 (f3 2)) 140))
(assert (= (f4 (f3 8)) 23))
(assert (= (g4 (g3 8)) 1792))
(assert (= (f4 (f4 (- 1))) (- 15)))
(assert (= (g4 (g4 (- 1))) 98))
(check-sat)
