(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 0 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 0 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 4)) 8))
(assert (= (f1 (g1 8)) 34))
(assert (= (f1 (f2 0)) 2))
(assert (= (f1 (g2 4)) 2))
(assert (= (f1 (f3 2)) 8))
(assert (= (f1 (g3 0)) 2))
(assert (= (g1 (f3 8)) 48))
(assert (= (f1 (g4 2)) 34))
(assert (= (g1 (f4 4)) 48))
(assert (= (f2 (f1 0)) 2))
(assert (= (f2 (g1 4)) 16))
(assert (= (f2 (f2 2)) 2))
(assert (= (f2 (g2 0)) 0))
(assert (= (g2 (f2 8)) 0))
(assert (= (f2 (g3 2)) 16))
(assert (= (g2 (f3 4)) 0))
(assert (= (g2 (f4 0)) 0))
(assert (= (f2 (f4 8)) 16))
(assert (= (g2 (g4 8)) 0))
(assert (= (f3 (f1 2)) 8))
(assert (= (f3 (g1 0)) 4))
(assert (= (g3 (f1 8)) 80))
(assert (= (f3 (g2 2)) 4))
(assert (= (g3 (f2 4)) 32))
(assert (= (g3 (f3 0)) 32))
(assert (= (f3 (f3 8)) 16))
(assert (= (g3 (g3 8)) 512))
(assert (= (g3 (f4 2)) 80))
(assert (= (f3 (f4 4)) 16))
(assert (= (g3 (g4 4)) 512))
(assert (= (f4 (g1 2)) 16))
(assert (= (g4 (f1 4)) 96))
(assert (= (g4 (f2 0)) 0))
(assert (= (f4 (f2 8)) 16))
(assert (= (g4 (g2 8)) 0))
(assert (= (g4 (f3 2)) 96))
(assert (= (f4 (f3 4)) 16))
(assert (= (g4 (g3 4)) 512))
(assert (= (f4 (f4 0)) 16))
(assert (= (g4 (g4 0)) 0))
(check-sat)
