(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 9))) (- 13)))
(assert (= (f1 (g1 (- 1))) 4))
(assert (= (f1 (f2 3)) 8))
(assert (= (f1 (g2 (- 9))) 53))
(assert (= (f1 (f3 2)) (- 13)))
(assert (= (f1 (g3 3)) 53))
(assert (= (g1 (f3 (- 1))) 36))
(assert (= (f1 (g4 2)) 4))
(assert (= (g1 (f4 (- 9))) 36))
(assert (= (f2 (f1 3)) 8))
(assert (= (f2 (g1 (- 9))) 37))
(assert (= (f2 (f2 2)) 8))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 1))) 21))
(assert (= (f2 (g3 2)) 37))
(assert (= (g2 (f3 (- 9))) 102))
(assert (= (g2 (f4 3)) 21))
(assert (= (f2 (f4 (- 1))) 4))
(assert (= (g2 (g4 (- 1))) 3))
(assert (= (f3 (f1 2)) (- 13)))
(assert (= (f3 (g1 3)) (- 21)))
(assert (= (g3 (f1 (- 1))) (- 43)))
(assert (= (f3 (g2 2)) (- 21)))
(assert (= (g3 (f2 (- 9))) (- 196)))
(assert (= (g3 (f3 3)) (- 196)))
(assert (= (f3 (f3 (- 1))) (- 18)))
(assert (= (g3 (g3 (- 1))) (- 145)))
(assert (= (g3 (f4 2)) (- 43)))
(assert (= (f3 (f4 (- 9))) (- 18)))
(assert (= (g3 (g4 (- 9))) (- 145)))
(assert (= (f4 (g1 2)) (- 9)))
(assert (= (g4 (f1 (- 9))) (- 11)))
(assert (= (g4 (f2 3)) 6))
(assert (= (f4 (f2 (- 1))) 4))
(assert (= (g4 (g2 (- 1))) 3))
(assert (= (g4 (f3 2)) (- 11)))
(assert (= (f4 (f3 (- 9))) (- 18)))
(assert (= (g4 (g3 (- 9))) (- 145)))
(assert (= (f4 (f4 3)) 4))
(assert (= (g4 (g4 3)) 3))
(check-sat)
