(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 19))
(assert (= (f1 (g1 9)) (- 124)))
(assert (= (f1 (f2 (- 9))) (- 24)))
(assert (= (f1 (g2 6)) (- 109)))
(assert (= (f1 (f3 (- 7))) 19))
(assert (= (f1 (g3 (- 9))) (- 109)))
(assert (= (g1 (f3 9)) 195))
(assert (= (f1 (g4 (- 7))) (- 124)))
(assert (= (g1 (f4 6)) 195))
(assert (= (f2 (f1 (- 9))) (- 24)))
(assert (= (f2 (g1 6)) (- 87)))
(assert (= (f2 (f2 (- 7))) (- 24)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 9)) (- 298)))
(assert (= (f2 (g3 (- 7))) (- 87)))
(assert (= (g2 (f3 6)) 204))
(assert (= (g2 (f4 (- 9))) (- 298)))
(assert (= (f2 (f4 9)) (- 27)))
(assert (= (g2 (g4 9)) 2754))
(assert (= (f3 (f1 (- 7))) 19))
(assert (= (f3 (g1 (- 9))) (- 117)))
(assert (= (g3 (f1 9)) 186))
(assert (= (f3 (g2 (- 7))) (- 117)))
(assert (= (g3 (f2 6)) 174))
(assert (= (g3 (f3 (- 9))) 174))
(assert (= (f3 (f3 9)) 21))
(assert (= (g3 (g3 9)) 1296))
(assert (= (g3 (f4 (- 7))) 186))
(assert (= (f3 (f4 6)) 21))
(assert (= (g3 (g4 6)) 1296))
(assert (= (f4 (g1 (- 7))) (- 94)))
(assert (= (g4 (f1 6)) 225))
(assert (= (g4 (f2 (- 9))) 306))
(assert (= (f4 (f2 9)) (- 27)))
(assert (= (g4 (g2 9)) 2754))
(assert (= (g4 (f3 (- 7))) 225))
(assert (= (f4 (f3 6)) 21))
(assert (= (g4 (g3 6)) 1296))
(assert (= (f4 (f4 (- 9))) (- 27)))
(assert (= (g4 (g4 (- 9))) 2754))
(check-sat)
