(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (g1 (g1 (g1 x))) (g2 (g2 x)))))
(assert (= (f1 (f1 (- 4))) (- 8)))
(assert (= (f1 (g1 (- 2))) 8))
(assert (= (f1 (f2 4)) 10))
(assert (= (f1 (g2 (- 4))) 30))
(assert (= (f1 (f3 2)) (- 8)))
(assert (= (f1 (g3 4)) 30))
(assert (= (g1 (f3 (- 2))) 20))
(assert (= (f1 (g4 2)) 8))
(assert (= (g1 (f4 (- 4))) 20))
(assert (= (f2 (f1 4)) 10))
(assert (= (f2 (g1 (- 4))) 18))
(assert (= (f2 (f2 2)) 10))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 2))) 44))
(assert (= (f2 (g3 2)) 18))
(assert (= (g2 (f3 (- 4))) 56))
(assert (= (g2 (f4 4)) 44))
(assert (= (f2 (f4 (- 2))) 7))
(assert (= (g2 (g4 (- 2))) 36))
(assert (= (f3 (f1 2)) (- 8)))
(assert (= (f3 (g1 4)) (- 20)))
(assert (= (g3 (f1 (- 2))) (- 25)))
(assert (= (f3 (g2 2)) (- 20)))
(assert (= (g3 (f2 (- 4))) (- 53)))
(assert (= (g3 (f3 4)) (- 53)))
(assert (= (f3 (f3 (- 2))) (- 9)))
(assert (= (g3 (g3 (- 2))) (- 74)))
(assert (= (g3 (f4 2)) (- 25)))
(assert (= (f3 (f4 (- 4))) (- 9)))
(assert (= (g3 (g4 (- 4))) (- 74)))
(assert (= (f4 (g1 2)) (- 10)))
(assert (= (g4 (f1 (- 4))) (- 17)))
(assert (= (g4 (f2 4)) 24))
(assert (= (f4 (f2 (- 2))) 7))
(assert (= (g4 (g2 (- 2))) 36))
(assert (= (g4 (f3 2)) (- 17)))
(assert (= (f4 (f3 (- 4))) (- 9)))
(assert (= (g4 (g3 (- 4))) (- 74)))
(assert (= (f4 (f4 4)) 7))
(assert (= (g4 (g4 4)) 36))
(check-sat)
