(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (g1 (g1 (g1 x))) (g2 (g2 x)))))
(assert (= (f1 (f1 6)) 10))
(assert (= (f1 (g1 9)) 38))
(assert (= (f1 (f2 4)) 10))
(assert (= (f1 (g2 6)) 50))
(assert (= (f1 (f3 2)) 10))
(assert (= (f1 (g3 4)) 50))
(assert (= (g1 (f3 9)) 60))
(assert (= (f1 (g4 2)) 38))
(assert (= (g1 (f4 6)) 60))
(assert (= (f2 (f1 4)) 10))
(assert (= (f2 (g1 6)) 28))
(assert (= (f2 (f2 2)) 10))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 9)) 104))
(assert (= (f2 (g3 2)) 28))
(assert (= (g2 (f3 6)) 96))
(assert (= (g2 (f4 4)) 104))
(assert (= (f2 (f4 9)) 22))
(assert (= (g2 (g4 9)) 1296))
(assert (= (f3 (f1 2)) 10))
(assert (= (f3 (g1 4)) 22))
(assert (= (g3 (f1 9)) 132))
(assert (= (f3 (g2 2)) 22))
(assert (= (g3 (f2 6)) 120))
(assert (= (g3 (f3 4)) 120))
(assert (= (f3 (f3 9)) 21))
(assert (= (g3 (g3 9)) 1296))
(assert (= (g3 (f4 2)) 132))
(assert (= (f3 (f4 6)) 21))
(assert (= (g3 (g4 6)) 1296))
(assert (= (f4 (g1 2)) 17))
(assert (= (g4 (f1 6)) 144))
(assert (= (g4 (f2 4)) 144))
(assert (= (f4 (f2 9)) 22))
(assert (= (g4 (g2 9)) 1296))
(assert (= (g4 (f3 2)) 144))
(assert (= (f4 (f3 6)) 21))
(assert (= (g4 (g3 6)) 1296))
(assert (= (f4 (f4 4)) 22))
(assert (= (g4 (g4 4)) 1296))
(check-sat)
