(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 2))) (- 6)))
(assert (= (f1 (g1 (- 8))) 32))
(assert (= (f1 (f2 5)) 12))
(assert (= (f1 (g2 (- 2))) 17))
(assert (= (f1 (f3 2)) (- 6)))
(assert (= (f1 (g3 5)) 17))
(assert (= (g1 (f3 (- 8))) 36))
(assert (= (f1 (g4 2)) 32))
(assert (= (g1 (f4 (- 2))) 36))
(assert (= (f2 (f1 5)) 12))
(assert (= (f2 (g1 (- 2))) 11))
(assert (= (f2 (f2 2)) 12))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 8))) 125))
(assert (= (f2 (g3 2)) 11))
(assert (= (g2 (f3 (- 2))) 30))
(assert (= (g2 (f4 5)) 125))
(assert (= (f2 (f4 (- 8))) 20))
(assert (= (g2 (g4 (- 8))) 1125))
(assert (= (f3 (f1 2)) (- 6)))
(assert (= (f3 (g1 5)) (- 22)))
(assert (= (g3 (f1 (- 8))) (- 29)))
(assert (= (f3 (g2 2)) (- 22)))
(assert (= (g3 (f2 (- 2))) (- 20)))
(assert (= (g3 (f3 5)) (- 20)))
(assert (= (f3 (f3 (- 8))) (- 11)))
(assert (= (g3 (g3 (- 8))) (- 68)))
(assert (= (g3 (f4 2)) (- 29)))
(assert (= (f3 (f4 (- 2))) (- 11)))
(assert (= (g3 (g4 (- 2))) (- 68)))
(assert (= (f4 (g1 2)) (- 16)))
(assert (= (g4 (f1 (- 2))) (- 53)))
(assert (= (g4 (f2 5)) 150))
(assert (= (f4 (f2 (- 8))) 20))
(assert (= (g4 (g2 (- 8))) 1125))
(assert (= (g4 (f3 2)) (- 53)))
(assert (= (f4 (f3 (- 2))) (- 11)))
(assert (= (g4 (g3 (- 2))) (- 68)))
(assert (= (f4 (f4 5)) 20))
(assert (= (g4 (g4 5)) 1125))
(check-sat)
