(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 11)))
(assert (= (f1 (g1 (- 4))) 16))
(assert (= (f1 (f2 8)) 18))
(assert (= (f1 (g2 (- 7))) 106))
(assert (= (f1 (f3 2)) (- 11)))
(assert (= (f1 (g3 8)) 106))
(assert (= (g1 (f3 (- 4))) 40))
(assert (= (f1 (g4 2)) 16))
(assert (= (g1 (f4 (- 7))) 40))
(assert (= (f2 (f1 8)) 18))
(assert (= (f2 (g1 (- 7))) 34))
(assert (= (f2 (f2 2)) 18))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 4))) 184))
(assert (= (f2 (g3 2)) 34))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 184))
(assert (= (f2 (f4 (- 4))) 15))
(assert (= (g2 (g4 (- 4))) 392))
(assert (= (f3 (f1 2)) (- 11)))
(assert (= (f3 (g1 8)) (- 39)))
(assert (= (g3 (f1 (- 4))) (- 72)))
(assert (= (f3 (g2 2)) (- 39)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 (- 4))) (- 17)))
(assert (= (g3 (g3 (- 4))) (- 592)))
(assert (= (g3 (f4 2)) (- 72)))
(assert (= (f3 (f4 (- 7))) (- 17)))
(assert (= (g3 (g4 (- 7))) (- 592)))
(assert (= (f4 (g1 2)) (- 12)))
(assert (= (g4 (f1 (- 7))) (- 60)))
(assert (= (g4 (f2 8)) 112))
(assert (= (f4 (f2 (- 4))) 15))
(assert (= (g4 (g2 (- 4))) 392))
(assert (= (g4 (f3 2)) (- 60)))
(assert (= (f4 (f3 (- 7))) (- 17)))
(assert (= (g4 (g3 (- 7))) (- 592)))
(assert (= (f4 (f4 8)) 15))
(assert (= (g4 (g4 8)) 392))
(check-sat)
