(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 2 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 2 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 10)))
(assert (= (f1 (g1 8)) 34))
(assert (= (f1 (f2 9)) 20))
(assert (= (f1 (g2 (- 6))) 101))
(assert (= (f1 (f3 2)) (- 10)))
(assert (= (f1 (g3 9)) 101))
(assert (= (g1 (f3 8)) 54))
(assert (= (f1 (g4 2)) 34))
(assert (= (g1 (f4 (- 6))) 54))
(assert (= (f2 (f1 9)) 20))
(assert (= (f2 (g1 (- 6))) 31))
(assert (= (f2 (f2 2)) 20))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 8)) 306))
(assert (= (f2 (g3 2)) 31))
(assert (= (g2 (f3 (- 6))) 198))
(assert (= (g2 (f4 9)) 306))
(assert (= (f2 (f4 8)) 25))
(assert (= (g2 (g4 8)) 2304))
(assert (= (f3 (f1 2)) (- 10)))
(assert (= (f3 (g1 9)) (- 42)))
(assert (= (g3 (f1 8)) 110))
(assert (= (f3 (g2 2)) (- 42)))
(assert (= (g3 (f2 (- 6))) (- 160)))
(assert (= (g3 (f3 9)) (- 160)))
(assert (= (f3 (f3 8)) 19))
(assert (= (g3 (g3 8)) 968))
(assert (= (g3 (f4 2)) 110))
(assert (= (f3 (f4 (- 6))) 19))
(assert (= (g3 (g4 (- 6))) 968))
(assert (= (f4 (g1 2)) 16))
(assert (= (g4 (f1 (- 6))) 120))
(assert (= (g4 (f2 9)) 288))
(assert (= (f4 (f2 8)) 25))
(assert (= (g4 (g2 8)) 2304))
(assert (= (g4 (f3 2)) 120))
(assert (= (f4 (f3 (- 6))) 19))
(assert (= (g4 (g3 (- 6))) 968))
(assert (= (f4 (f4 9)) 25))
(assert (= (g4 (g4 9)) 2304))
(check-sat)
