(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 14)))
(assert (= (f1 (g1 8)) 51))
(assert (= (f1 (f2 (- 6))) 14))
(assert (= (f1 (g2 (- 8))) (- 86)))
(assert (= (f1 (f3 3)) (- 14)))
(assert (= (f1 (g3 (- 6))) (- 86)))
(assert (= (g1 (f3 8)) 93))
(assert (= (f1 (g4 3)) 51))
(assert (= (g1 (f4 (- 8))) 93))
(assert (= (f2 (f1 (- 6))) 14))
(assert (= (f2 (g1 (- 8))) (- 51)))
(assert (= (f2 (f2 3)) 14))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 8)) (- 149)))
(assert (= (f2 (g3 3)) (- 51)))
(assert (= (g2 (f3 (- 8))) 165))
(assert (= (g2 (f4 (- 6))) (- 149)))
(assert (= (f2 (f4 8)) (- 22)))
(assert (= (g2 (g4 8)) 1408))
(assert (= (f3 (f1 3)) (- 14)))
(assert (= (f3 (g1 (- 6))) (- 41)))
(assert (= (g3 (f1 8)) 165))
(assert (= (f3 (g2 3)) (- 41)))
(assert (= (g3 (f2 (- 8))) 195))
(assert (= (g3 (f3 (- 6))) 195))
(assert (= (f3 (f3 8)) 23))
(assert (= (g3 (g3 8)) 1800))
(assert (= (g3 (f4 3)) 165))
(assert (= (f3 (f4 (- 8))) 23))
(assert (= (g3 (g4 (- 8))) 1800))
(assert (= (f4 (g1 3)) 26))
(assert (= (g4 (f1 (- 8))) 168))
(assert (= (g4 (f2 (- 6))) 176))
(assert (= (f4 (f2 8)) (- 22)))
(assert (= (g4 (g2 8)) 1408))
(assert (= (g4 (f3 3)) 168))
(assert (= (f4 (f3 (- 8))) 23))
(assert (= (g4 (g3 (- 8))) 1800))
(assert (= (f4 (f4 (- 6))) (- 22)))
(assert (= (g4 (g4 (- 6))) 1408))
(check-sat)
