(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 7))) (- 13)))
(assert (= (f1 (g1 (- 4))) 24))
(assert (= (f1 (f2 (- 5))) 12))
(assert (= (f1 (g2 (- 7))) (- 62)))
(assert (= (f1 (f3 3)) (- 13)))
(assert (= (f1 (g3 (- 5))) (- 62)))
(assert (= (g1 (f3 (- 4))) 60))
(assert (= (f1 (g4 3)) 24))
(assert (= (g1 (f4 (- 7))) 60))
(assert (= (f2 (f1 (- 5))) 12))
(assert (= (f2 (g1 (- 7))) (- 44)))
(assert (= (f2 (f2 3)) 12))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 4))) 72))
(assert (= (f2 (g3 3)) (- 44)))
(assert (= (g2 (f3 (- 7))) 117))
(assert (= (g2 (f4 (- 5))) 72))
(assert (= (f2 (f4 (- 4))) (- 12)))
(assert (= (g2 (g4 (- 4))) (- 221)))
(assert (= (f3 (f1 3)) (- 13)))
(assert (= (f3 (g1 (- 5))) (- 34)))
(assert (= (g3 (f1 (- 4))) (- 85)))
(assert (= (f3 (g2 3)) (- 34)))
(assert (= (g3 (f2 (- 7))) 143))
(assert (= (g3 (f3 (- 5))) 143))
(assert (= (f3 (f3 (- 4))) (- 17)))
(assert (= (g3 (g3 (- 4))) (- 592)))
(assert (= (g3 (f4 3)) (- 85)))
(assert (= (f3 (f4 (- 7))) (- 17)))
(assert (= (g3 (g4 (- 7))) (- 592)))
(assert (= (f4 (g1 3)) (- 22)))
(assert (= (g4 (f1 (- 7))) (- 67)))
(assert (= (g4 (f2 (- 5))) 63))
(assert (= (f4 (f2 (- 4))) (- 12)))
(assert (= (g4 (g2 (- 4))) (- 221)))
(assert (= (g4 (f3 3)) (- 67)))
(assert (= (f4 (f3 (- 7))) (- 17)))
(assert (= (g4 (g3 (- 7))) (- 592)))
(assert (= (f4 (f4 (- 5))) (- 12)))
(assert (= (g4 (g4 (- 5))) (- 221)))
(check-sat)
