(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 17)))
(assert (= (f1 (g1 (- 8))) 104))
(assert (= (f1 (f2 (- 5))) (- 16)))
(assert (= (f1 (g2 (- 4))) 38))
(assert (= (f1 (f3 (- 7))) (- 17)))
(assert (= (f1 (g3 (- 5))) 38))
(assert (= (g1 (f3 (- 8))) 143))
(assert (= (f1 (g4 (- 7))) 104))
(assert (= (g1 (f4 (- 4))) 143))
(assert (= (f2 (f1 (- 5))) (- 16)))
(assert (= (f2 (g1 (- 4))) 50))
(assert (= (f2 (f2 (- 7))) (- 16)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 8))) 108))
(assert (= (f2 (g3 (- 7))) 50))
(assert (= (g2 (f3 (- 4))) 63))
(assert (= (g2 (f4 (- 5))) 108))
(assert (= (f2 (f4 (- 8))) (- 20)))
(assert (= (g2 (g4 (- 8))) (- 1013)))
(assert (= (f3 (f1 (- 7))) (- 17)))
(assert (= (f3 (g1 (- 5))) 62))
(assert (= (g3 (f1 (- 8))) 98))
(assert (= (f3 (g2 (- 7))) 62))
(assert (= (g3 (f2 (- 4))) 56))
(assert (= (g3 (f3 (- 5))) 56))
(assert (= (f3 (f3 (- 8))) (- 15)))
(assert (= (g3 (g3 (- 8))) (- 368)))
(assert (= (g3 (f4 (- 7))) 98))
(assert (= (f3 (f4 (- 4))) (- 15)))
(assert (= (g3 (g4 (- 4))) (- 368)))
(assert (= (f4 (g1 (- 7))) 92))
(assert (= (g4 (f1 (- 4))) 150))
(assert (= (g4 (f2 (- 5))) 135))
(assert (= (f4 (f2 (- 8))) (- 20)))
(assert (= (g4 (g2 (- 8))) (- 1013)))
(assert (= (g4 (f3 (- 7))) 150))
(assert (= (f4 (f3 (- 4))) (- 15)))
(assert (= (g4 (g3 (- 4))) (- 368)))
(assert (= (f4 (f4 (- 5))) (- 20)))
(assert (= (g4 (g4 (- 5))) (- 1013)))
(check-sat)
