(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (g1 (g2 (g2 x))) (g3 (g4 x)))))
(assert (= (f1 (f1 5)) 11))
(assert (= (f1 (g1 (- 8))) 48))
(assert (= (f1 (f2 (- 3))) 8))
(assert (= (f1 (g2 5)) 28))
(assert (= (f1 (f3 3)) 11))
(assert (= (f1 (g3 (- 3))) 28))
(assert (= (g1 (f3 (- 8))) 75))
(assert (= (f1 (g4 3)) 48))
(assert (= (g1 (f4 5)) 75))
(assert (= (f2 (f1 (- 3))) 8))
(assert (= (f2 (g1 5)) (- 33)))
(assert (= (f2 (f2 3)) 8))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 8))) 50))
(assert (= (f2 (g3 3)) (- 33)))
(assert (= (g2 (f3 5)) 50))
(assert (= (g2 (f4 (- 3))) 50))
(assert (= (f2 (f4 (- 8))) (- 18)))
(assert (= (g2 (g4 (- 8))) (- 563)))
(assert (= (f3 (f1 3)) 11))
(assert (= (f3 (g1 (- 3))) 20))
(assert (= (g3 (f1 (- 8))) 105))
(assert (= (f3 (g2 3)) 20))
(assert (= (g3 (f2 5)) 75))
(assert (= (g3 (f3 (- 3))) 75))
(assert (= (f3 (f3 (- 8))) (- 18)))
(assert (= (g3 (g3 (- 8))) 750))
(assert (= (g3 (f4 3)) 105))
(assert (= (f3 (f4 5)) (- 18)))
(assert (= (g3 (g4 5)) 750))
(assert (= (f4 (g1 3)) (- 26)))
(assert (= (g4 (f1 5)) 120))
(assert (= (g4 (f2 (- 3))) 75))
(assert (= (f4 (f2 (- 8))) (- 18)))
(assert (= (g4 (g2 (- 8))) (- 563)))
(assert (= (g4 (f3 3)) 120))
(assert (= (f4 (f3 5)) (- 18)))
(assert (= (g4 (g3 5)) 750))
(assert (= (f4 (f4 (- 3))) (- 18)))
(assert (= (g4 (g4 (- 3))) (- 563)))
(check-sat)
