(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 14))
(assert (= (f1 (g1 (- 1))) 6))
(assert (= (f1 (f2 (- 3))) 8))
(assert (= (f1 (g2 8)) 43))
(assert (= (f1 (f3 3)) 14))
(assert (= (f1 (g3 (- 3))) 43))
(assert (= (g1 (f3 (- 1))) 51))
(assert (= (f1 (g4 3)) 6))
(assert (= (g1 (f4 8)) 51))
(assert (= (f2 (f1 (- 3))) 8))
(assert (= (f2 (g1 8)) (- 51)))
(assert (= (f2 (f2 3)) 8))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 1))) 15))
(assert (= (f2 (g3 3)) (- 51)))
(assert (= (g2 (f3 8)) 80))
(assert (= (g2 (f4 (- 3))) 15))
(assert (= (f2 (f4 (- 1))) (- 4)))
(assert (= (g2 (g4 (- 1))) (- 3)))
(assert (= (f3 (f1 3)) 14))
(assert (= (f3 (g1 (- 3))) 23))
(assert (= (g3 (f1 (- 1))) 56))
(assert (= (f3 (g2 3)) 23))
(assert (= (g3 (f2 8)) 168))
(assert (= (g3 (f3 (- 3))) 168))
(assert (= (f3 (f3 (- 1))) (- 17)))
(assert (= (g3 (g3 (- 1))) 128))
(assert (= (g3 (f4 3)) 56))
(assert (= (f3 (f4 8)) (- 17)))
(assert (= (g3 (g4 8)) 128))
(assert (= (f4 (g1 3)) (- 19)))
(assert (= (g4 (f1 8)) 11))
(assert (= (g4 (f2 (- 3))) 5))
(assert (= (f4 (f2 (- 1))) (- 4)))
(assert (= (g4 (g2 (- 1))) (- 3)))
(assert (= (g4 (f3 3)) 11))
(assert (= (f4 (f3 8)) (- 17)))
(assert (= (g4 (g3 8)) 128))
(assert (= (f4 (f4 (- 3))) (- 4)))
(assert (= (g4 (g4 (- 3))) (- 3)))
(check-sat)
