(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 9)) 15))
(assert (= (f1 (g1 (- 1))) 6))
(assert (= (f1 (f2 (- 2))) 6))
(assert (= (f1 (g2 9)) 30))
(assert (= (f1 (f3 3)) 15))
(assert (= (f1 (g3 (- 2))) 30))
(assert (= (g1 (f3 (- 1))) 57))
(assert (= (f1 (g4 3)) 6))
(assert (= (g1 (f4 9)) 57))
(assert (= (f2 (f1 (- 2))) 6))
(assert (= (f2 (g1 9)) (- 56)))
(assert (= (f2 (f2 3)) 6))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 (- 1))) 6))
(assert (= (f2 (g3 3)) (- 56)))
(assert (= (g2 (f3 9)) 54))
(assert (= (g2 (f4 (- 2))) 6))
(assert (= (f2 (f4 (- 1))) (- 3)))
(assert (= (g2 (g4 (- 1))) (- 2)))
(assert (= (f3 (f1 3)) 15))
(assert (= (f3 (g1 (- 2))) 18))
(assert (= (g3 (f1 (- 1))) 63))
(assert (= (f3 (g2 3)) 18))
(assert (= (g3 (f2 9)) 189))
(assert (= (g3 (f3 (- 2))) 189))
(assert (= (f3 (f3 (- 1))) (- 19)))
(assert (= (g3 (g3 (- 1))) 162))
(assert (= (g3 (f4 3)) 63))
(assert (= (f3 (f4 9)) (- 19)))
(assert (= (g3 (g4 9)) 162))
(assert (= (f4 (g1 3)) (- 19)))
(assert (= (g4 (f1 9)) 12))
(assert (= (g4 (f2 (- 2))) 3))
(assert (= (f4 (f2 (- 1))) (- 3)))
(assert (= (g4 (g2 (- 1))) (- 2)))
(assert (= (g4 (f3 3)) 12))
(assert (= (f4 (f3 9)) (- 19)))
(assert (= (g4 (g3 9)) 162))
(assert (= (f4 (f4 (- 2))) (- 3)))
(assert (= (g4 (g4 (- 2))) (- 2)))
(check-sat)
