(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 2)) 8))
(assert (= (f1 (g1 (- 8))) 48))
(assert (= (f1 (f2 (- 1))) 4))
(assert (= (f1 (g2 2)) 5))
(assert (= (f1 (f3 3)) 8))
(assert (= (f1 (g3 (- 1))) 5))
(assert (= (g1 (f3 (- 8))) 57))
(assert (= (f1 (g4 3)) 48))
(assert (= (g1 (f4 2)) 57))
(assert (= (f2 (f1 (- 1))) 4))
(assert (= (f2 (g1 2)) (- 13)))
(assert (= (f2 (f2 3)) 4))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 8))) 8))
(assert (= (f2 (g3 3)) (- 13)))
(assert (= (g2 (f3 2)) 4))
(assert (= (g2 (f4 (- 1))) 8))
(assert (= (f2 (f4 (- 8))) (- 16)))
(assert (= (g2 (g4 (- 8))) (- 113)))
(assert (= (f3 (f1 3)) 8))
(assert (= (f3 (g1 (- 1))) 5))
(assert (= (g3 (f1 (- 8))) 42))
(assert (= (f3 (g2 3)) 5))
(assert (= (g3 (f2 2)) 10))
(assert (= (g3 (f3 (- 1))) 10))
(assert (= (f3 (f3 (- 8))) (- 12)))
(assert (= (g3 (g3 (- 8))) 120))
(assert (= (g3 (f4 3)) 42))
(assert (= (f3 (f4 2)) (- 12)))
(assert (= (g3 (g4 2)) 120))
(assert (= (f4 (g1 3)) (- 26)))
(assert (= (g4 (f1 2)) 75))
(assert (= (g4 (f2 (- 1))) 15))
(assert (= (f4 (f2 (- 8))) (- 16)))
(assert (= (g4 (g2 (- 8))) (- 113)))
(assert (= (g4 (f3 3)) 75))
(assert (= (f4 (f3 2)) (- 12)))
(assert (= (g4 (g3 2)) 120))
(assert (= (f4 (f4 (- 1))) (- 16)))
(assert (= (g4 (g4 (- 1))) (- 113)))
(check-sat)
