(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 7))) (- 13)))
(assert (= (f1 (g1 (- 3))) 18))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 (- 7))) 81))
(assert (= (f1 (f3 3)) (- 13)))
(assert (= (f1 (g3 6)) 81))
(assert (= (g1 (f3 (- 3))) 54))
(assert (= (f1 (g4 3)) 18))
(assert (= (g1 (f4 (- 7))) 54))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 (- 7))) 45))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 3))) 102))
(assert (= (f2 (g3 3)) 45))
(assert (= (g2 (f3 (- 7))) 156))
(assert (= (g2 (f4 6)) 102))
(assert (= (f2 (f4 (- 3))) 11))
(assert (= (g2 (g4 (- 3))) 150))
(assert (= (f3 (f1 3)) (- 13)))
(assert (= (f3 (g1 6)) (- 43)))
(assert (= (g3 (f1 (- 3))) (- 72)))
(assert (= (f3 (g2 3)) (- 43)))
(assert (= (g3 (f2 (- 7))) (- 163)))
(assert (= (g3 (f3 6)) (- 163)))
(assert (= (f3 (f3 (- 3))) (- 16)))
(assert (= (g3 (g3 (- 3))) (- 423)))
(assert (= (g3 (f4 3)) (- 72)))
(assert (= (f3 (f4 (- 7))) (- 16)))
(assert (= (g3 (g4 (- 7))) (- 423)))
(assert (= (f4 (g1 3)) (- 21)))
(assert (= (g4 (f1 (- 7))) (- 48)))
(assert (= (g4 (f2 6)) 60))
(assert (= (f4 (f2 (- 3))) 11))
(assert (= (g4 (g2 (- 3))) 150))
(assert (= (g4 (f3 3)) (- 48)))
(assert (= (f4 (f3 (- 7))) (- 16)))
(assert (= (g4 (g3 (- 7))) (- 423)))
(assert (= (f4 (f4 6)) 11))
(assert (= (g4 (g4 6)) 150))
(check-sat)
