(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 11)))
(assert (= (f1 (g1 (- 4))) 24))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 (- 5))) 57))
(assert (= (f1 (f3 3)) (- 11)))
(assert (= (f1 (g3 6)) 57))
(assert (= (g1 (f3 (- 4))) 48))
(assert (= (f1 (g4 3)) 24))
(assert (= (g1 (f4 (- 5))) 48))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 (- 5))) 33))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 4))) 114))
(assert (= (f2 (g3 3)) 33))
(assert (= (g2 (f3 (- 5))) 108))
(assert (= (g2 (f4 6)) 114))
(assert (= (f2 (f4 (- 4))) 13))
(assert (= (g2 (g4 (- 4))) 294))
(assert (= (f3 (f1 3)) (- 11)))
(assert (= (f3 (g1 6)) (- 41)))
(assert (= (g3 (f1 (- 4))) (- 59)))
(assert (= (f3 (g2 3)) (- 41)))
(assert (= (g3 (f2 (- 5))) (- 95)))
(assert (= (g3 (f3 6)) (- 95)))
(assert (= (f3 (f3 (- 4))) (- 13)))
(assert (= (g3 (g3 (- 4))) (- 284)))
(assert (= (g3 (f4 3)) (- 59)))
(assert (= (f3 (f4 (- 5))) (- 13)))
(assert (= (g3 (g4 (- 5))) (- 284)))
(assert (= (f4 (g1 3)) (- 22)))
(assert (= (g4 (f1 (- 5))) (- 53)))
(assert (= (g4 (f2 6)) 84))
(assert (= (f4 (f2 (- 4))) 13))
(assert (= (g4 (g2 (- 4))) 294))
(assert (= (g4 (f3 3)) (- 53)))
(assert (= (f4 (f3 (- 5))) (- 13)))
(assert (= (g4 (g3 (- 5))) (- 284)))
(assert (= (f4 (f4 6)) 13))
(assert (= (g4 (g4 6)) 294))
(check-sat)
