(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 2) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 2) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (g1 (g1 x)) (g2 (g3 x)))))
(assert (= (f1 (f1 (- 2))) (- 8)))
(assert (= (f1 (g1 9)) 57))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 (- 2))) 21))
(assert (= (f1 (f3 3)) (- 8)))
(assert (= (f1 (g3 6)) 21))
(assert (= (g1 (f3 9)) 63))
(assert (= (f1 (g4 3)) 57))
(assert (= (g1 (f4 (- 2))) 63))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 (- 2))) 15))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 9)) 180))
(assert (= (f2 (g3 3)) 15))
(assert (= (g2 (f3 (- 2))) 36))
(assert (= (g2 (f4 6)) 180))
(assert (= (f2 (f4 9)) 24))
(assert (= (g2 (g4 9)) 1944))
(assert (= (f3 (f1 3)) (- 8)))
(assert (= (f3 (g1 6)) (- 38)))
(assert (= (g3 (f1 9)) 36))
(assert (= (f3 (g2 3)) (- 38)))
(assert (= (g3 (f2 (- 2))) (- 23)))
(assert (= (g3 (f3 6)) (- 23)))
(assert (= (f3 (f3 9)) 12))
(assert (= (g3 (g3 9)) 81))
(assert (= (g3 (f4 3)) 36))
(assert (= (f3 (f4 (- 2))) 12))
(assert (= (g3 (g4 (- 2))) 81))
(assert (= (f4 (g1 3)) 27))
(assert (= (g4 (f1 (- 2))) 81))
(assert (= (g4 (f2 6)) 216))
(assert (= (f4 (f2 9)) 24))
(assert (= (g4 (g2 9)) 1944))
(assert (= (g4 (f3 3)) 81))
(assert (= (f4 (f3 (- 2))) 12))
(assert (= (g4 (g3 (- 2))) 81))
(assert (= (f4 (f4 6)) 24))
(assert (= (g4 (g4 6)) 1944))
(check-sat)
