(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (g1 (g1 (g1 x))) (g2 (g3 x)))))
(assert (= (f1 (f1 9)) 15))
(assert (= (f1 (g1 (- 9))) 54))
(assert (= (f1 (f2 6)) 15))
(assert (= (f1 (g2 9)) 111))
(assert (= (f1 (f3 3)) 15))
(assert (= (f1 (g3 6)) 111))
(assert (= (g1 (f3 (- 9))) 105))
(assert (= (f1 (g4 3)) 54))
(assert (= (g1 (f4 9)) 105))
(assert (= (f2 (f1 6)) 15))
(assert (= (f2 (g1 9)) 60))
(assert (= (f2 (f2 3)) 15))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 9))) 174))
(assert (= (f2 (g3 3)) 60))
(assert (= (g2 (f3 9)) 216))
(assert (= (g2 (f4 6)) 174))
(assert (= (f2 (f4 (- 9))) 23))
(assert (= (g2 (g4 (- 9))) 1734))
(assert (= (f3 (f1 3)) 15))
(assert (= (f3 (g1 6)) 45))
(assert (= (g3 (f1 (- 9))) 207))
(assert (= (f3 (g2 3)) 45))
(assert (= (g3 (f2 9)) 270))
(assert (= (g3 (f3 6)) 270))
(assert (= (f3 (f3 (- 9))) (- 27)))
(assert (= (g3 (g3 (- 9))) 2754))
(assert (= (g3 (f4 3)) 207))
(assert (= (f3 (f4 9)) (- 27)))
(assert (= (g3 (g4 9)) 2754))
(assert (= (f4 (g1 3)) (- 27)))
(assert (= (g4 (f1 9)) 204))
(assert (= (g4 (f2 6)) 204))
(assert (= (f4 (f2 (- 9))) 23))
(assert (= (g4 (g2 (- 9))) 1734))
(assert (= (g4 (f3 3)) 204))
(assert (= (f4 (f3 9)) (- 27)))
(assert (= (g4 (g3 9)) 2754))
(assert (= (f4 (f4 6)) 23))
(assert (= (g4 (g4 6)) 1734))
(check-sat)
