(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 3 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 3 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 11))
(assert (= (f1 (g1 7)) 45))
(assert (= (f1 (f2 9)) 21))
(assert (= (f1 (g2 5)) 93))
(assert (= (f1 (f3 3)) 11))
(assert (= (f1 (g3 9)) 93))
(assert (= (g1 (f3 7)) 72))
(assert (= (f1 (g4 3)) 45))
(assert (= (g1 (f4 5)) 72))
(assert (= (f2 (f1 9)) 21))
(assert (= (f2 (g1 5)) 39))
(assert (= (f2 (f2 3)) 21))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 7)) 288))
(assert (= (f2 (g3 3)) 39))
(assert (= (g2 (f3 5)) 180))
(assert (= (g2 (f4 9)) 288))
(assert (= (f2 (f4 7)) 23))
(assert (= (g2 (g4 7)) 1764))
(assert (= (f3 (f1 3)) 11))
(assert (= (f3 (g1 9)) 59))
(assert (= (g3 (f1 7)) 100))
(assert (= (f3 (g2 3)) 59))
(assert (= (g3 (f2 5)) 140))
(assert (= (g3 (f3 9)) 140))
(assert (= (f3 (f3 7)) 17))
(assert (= (g3 (g3 7)) 700))
(assert (= (g3 (f4 3)) 100))
(assert (= (f3 (f4 5)) 17))
(assert (= (g3 (g4 5)) 700))
(assert (= (f4 (g1 3)) 25))
(assert (= (g4 (f1 5)) 112))
(assert (= (g4 (f2 9)) 252))
(assert (= (f4 (f2 7)) 23))
(assert (= (g4 (g2 7)) 1764))
(assert (= (g4 (f3 3)) 112))
(assert (= (f4 (f3 5)) 17))
(assert (= (g4 (g3 5)) 700))
(assert (= (f4 (f4 9)) 23))
(assert (= (g4 (g4 9)) 1764))
(check-sat)
