(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 13))
(assert (= (f1 (g1 (- 8))) 64))
(assert (= (f1 (f2 (- 9))) 21))
(assert (= (f1 (g2 5)) 89))
(assert (= (f1 (f3 4)) 13))
(assert (= (f1 (g3 (- 9))) 89))
(assert (= (g1 (f3 (- 8))) 100))
(assert (= (f1 (g4 4)) 64))
(assert (= (g1 (f4 5)) 100))
(assert (= (f2 (f1 (- 9))) 21))
(assert (= (f2 (g1 5)) (- 49)))
(assert (= (f2 (f2 4)) 21))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 8))) 272))
(assert (= (f2 (g3 4)) (- 49)))
(assert (= (g2 (f3 5)) 170))
(assert (= (g2 (f4 (- 9))) 272))
(assert (= (f2 (f4 (- 8))) (- 24)))
(assert (= (g2 (g4 (- 8))) (- 1913)))
(assert (= (f3 (f1 4)) 13))
(assert (= (f3 (g1 (- 9))) 73))
(assert (= (g3 (f1 (- 8))) 115))
(assert (= (f3 (g2 4)) 73))
(assert (= (g3 (f2 5)) 135))
(assert (= (g3 (f3 (- 9))) 135))
(assert (= (f3 (f3 (- 8))) (- 18)))
(assert (= (g3 (g3 (- 8))) 750))
(assert (= (g3 (f4 4)) 115))
(assert (= (f3 (f4 5)) (- 18)))
(assert (= (g3 (g4 5)) 750))
(assert (= (f4 (g1 4)) (- 40)))
(assert (= (g4 (f1 5)) 135))
(assert (= (g4 (f2 (- 9))) 255))
(assert (= (f4 (f2 (- 8))) (- 24)))
(assert (= (g4 (g2 (- 8))) (- 1913)))
(assert (= (g4 (f3 4)) 135))
(assert (= (f4 (f3 5)) (- 18)))
(assert (= (g4 (g3 5)) 750))
(assert (= (f4 (f4 (- 9))) (- 24)))
(assert (= (g4 (g4 (- 9))) (- 1913)))
(check-sat)
