(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 11)))
(assert (= (f1 (g1 9)) 76))
(assert (= (f1 (f2 (- 8))) 19))
(assert (= (f1 (g2 (- 3))) (- 42)))
(assert (= (f1 (f3 4)) (- 11)))
(assert (= (f1 (g3 (- 8))) (- 42)))
(assert (= (g1 (f3 9)) 92))
(assert (= (f1 (g4 4)) 76))
(assert (= (g1 (f4 (- 3))) 92))
(assert (= (f2 (f1 (- 8))) 19))
(assert (= (f2 (g1 (- 3))) (- 28)))
(assert (= (f2 (f2 4)) 19))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 9)) (- 248)))
(assert (= (f2 (g3 4)) (- 28)))
(assert (= (g2 (f3 (- 3))) 75))
(assert (= (g2 (f4 (- 8))) (- 248)))
(assert (= (f2 (f4 9)) (- 26)))
(assert (= (g2 (g4 9)) 2430))
(assert (= (f3 (f1 4)) (- 11)))
(assert (= (f3 (g1 (- 8))) (- 63)))
(assert (= (g3 (f1 9)) 65))
(assert (= (f3 (g2 4)) (- 63)))
(assert (= (g3 (f2 (- 3))) 50))
(assert (= (g3 (f3 (- 8))) 50))
(assert (= (f3 (f3 9)) 14))
(assert (= (g3 (g3 9)) 225))
(assert (= (g3 (f4 4)) 65))
(assert (= (f3 (f4 (- 3))) 14))
(assert (= (g3 (g4 (- 3))) 225))
(assert (= (f4 (g1 4)) 41))
(assert (= (g4 (f1 (- 3))) 117))
(assert (= (g4 (f2 (- 8))) 270))
(assert (= (f4 (f2 9)) (- 26)))
(assert (= (g4 (g2 9)) 2430))
(assert (= (g4 (f3 4)) 117))
(assert (= (f4 (f3 (- 3))) 14))
(assert (= (g4 (g3 (- 3))) 225))
(assert (= (f4 (f4 (- 8))) (- 26)))
(assert (= (g4 (g4 (- 8))) 2430))
(check-sat)
