(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 0 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 0 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 0)) 8))
(assert (= (f1 (g1 (- 9))) 72))
(assert (= (f1 (f2 (- 5))) 13))
(assert (= (f1 (g2 0)) 4))
(assert (= (f1 (f3 4)) 8))
(assert (= (f1 (g3 (- 5))) 4))
(assert (= (g1 (f3 (- 9))) 68))
(assert (= (f1 (g4 4)) 72))
(assert (= (g1 (f4 0)) 68))
(assert (= (f2 (f1 (- 5))) 13))
(assert (= (f2 (g1 0)) (- 5)))
(assert (= (f2 (f2 4)) 13))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 9))) 117))
(assert (= (f2 (g3 4)) (- 5)))
(assert (= (g2 (f3 0)) 0))
(assert (= (g2 (f4 (- 5))) 117))
(assert (= (f2 (f4 (- 9))) (- 22)))
(assert (= (g2 (g4 (- 9))) (- 1301)))
(assert (= (f3 (f1 4)) 8))
(assert (= (f3 (g1 (- 5))) 36))
(assert (= (g3 (f1 (- 9))) 0))
(assert (= (f3 (g2 4)) 36))
(assert (= (g3 (f2 0)) 0))
(assert (= (g3 (f3 (- 5))) 0))
(assert (= (f3 (f3 (- 9))) (- 9)))
(assert (= (g3 (g3 (- 9))) 0))
(assert (= (g3 (f4 4)) 0))
(assert (= (f3 (f4 0)) (- 9)))
(assert (= (g3 (g4 0)) 0))
(assert (= (f4 (g1 4)) (- 41)))
(assert (= (g4 (f1 0)) 68))
(assert (= (g4 (f2 (- 5))) 153))
(assert (= (f4 (f2 (- 9))) (- 22)))
(assert (= (g4 (g2 (- 9))) (- 1301)))
(assert (= (g4 (f3 4)) 68))
(assert (= (f4 (f3 0)) (- 9)))
(assert (= (g4 (g3 0)) 0))
(assert (= (f4 (f4 (- 5))) (- 22)))
(assert (= (g4 (g4 (- 5))) (- 1301)))
(check-sat)
