(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 16)))
(assert (= (f1 (g1 (- 2))) 16))
(assert (= (f1 (f2 (- 3))) 9))
(assert (= (f1 (g2 (- 8))) (- 42)))
(assert (= (f1 (f3 4)) (- 16)))
(assert (= (f1 (g3 (- 3))) (- 42)))
(assert (= (g1 (f3 (- 2))) 72))
(assert (= (f1 (g4 4)) 16))
(assert (= (g1 (f4 (- 8))) 72))
(assert (= (f2 (f1 (- 3))) 9))
(assert (= (f2 (g1 (- 8))) (- 63)))
(assert (= (f2 (f2 4)) 9))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 2))) 20))
(assert (= (f2 (g3 4)) (- 63)))
(assert (= (g2 (f3 (- 8))) 75))
(assert (= (g2 (f4 (- 3))) 20))
(assert (= (f2 (f4 (- 2))) (- 6)))
(assert (= (g2 (g4 (- 2))) (- 23)))
(assert (= (f3 (f1 4)) (- 16)))
(assert (= (f3 (g1 (- 3))) (- 28)))
(assert (= (g3 (f1 (- 2))) (- 83)))
(assert (= (f3 (g2 4)) (- 28)))
(assert (= (g3 (f2 (- 8))) 150))
(assert (= (g3 (f3 (- 3))) 150))
(assert (= (f3 (f3 (- 2))) (- 17)))
(assert (= (g3 (g3 (- 2))) (- 338)))
(assert (= (g3 (f4 4)) (- 83)))
(assert (= (f3 (f4 (- 8))) (- 17)))
(assert (= (g3 (g4 (- 8))) (- 338)))
(assert (= (f4 (g1 4)) (- 34)))
(assert (= (g4 (f1 (- 8))) (- 35)))
(assert (= (g4 (f2 (- 3))) 15))
(assert (= (f4 (f2 (- 2))) (- 6)))
(assert (= (g4 (g2 (- 2))) (- 23)))
(assert (= (g4 (f3 4)) (- 35)))
(assert (= (f4 (f3 (- 8))) (- 17)))
(assert (= (g4 (g3 (- 8))) (- 338)))
(assert (= (f4 (f4 (- 3))) (- 6)))
(assert (= (g4 (g4 (- 3))) (- 23)))
(check-sat)
