(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 14)))
(assert (= (f1 (g1 3)) 28))
(assert (= (f1 (f2 (- 1))) 5))
(assert (= (f1 (g2 (- 6))) (- 10)))
(assert (= (f1 (f3 4)) (- 14)))
(assert (= (f1 (g3 (- 1))) (- 10)))
(assert (= (g1 (f3 3)) 68))
(assert (= (f1 (g4 4)) 28))
(assert (= (g1 (f4 (- 6))) 68))
(assert (= (f2 (f1 (- 1))) 5))
(assert (= (f2 (g1 (- 6))) (- 45)))
(assert (= (f2 (f2 4)) 5))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 3)) (- 4)))
(assert (= (f2 (g3 4)) (- 45)))
(assert (= (g2 (f3 (- 6))) 11))
(assert (= (g2 (f4 (- 1))) (- 4)))
(assert (= (f2 (f4 3)) (- 7)))
(assert (= (g2 (g4 3)) 18))
(assert (= (f3 (f1 4)) (- 14)))
(assert (= (f3 (g1 (- 1))) (- 10)))
(assert (= (g3 (f1 3)) 77))
(assert (= (f3 (g2 4)) (- 10)))
(assert (= (g3 (f2 (- 6))) 66))
(assert (= (g3 (f3 (- 1))) 66))
(assert (= (f3 (f3 3)) 14))
(assert (= (g3 (g3 3)) 363))
(assert (= (g3 (f4 4)) 77))
(assert (= (f3 (f4 (- 6))) 14))
(assert (= (g3 (g4 (- 6))) 363))
(assert (= (f4 (g1 4)) 35))
(assert (= (g4 (f1 (- 6))) 57))
(assert (= (g4 (f2 (- 1))) 6))
(assert (= (f4 (f2 3)) (- 7)))
(assert (= (g4 (g2 3)) 18))
(assert (= (g4 (f3 4)) 57))
(assert (= (f4 (f3 (- 6))) 14))
(assert (= (g4 (g3 (- 6))) 363))
(assert (= (f4 (f4 (- 1))) (- 7)))
(assert (= (g4 (g4 (- 1))) 18))
(check-sat)
