(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 3)) 11))
(assert (= (f1 (g1 7)) 60))
(assert (= (f1 (f2 1)) 6))
(assert (= (f1 (g2 3)) 10))
(assert (= (f1 (f3 4)) 11))
(assert (= (f1 (g3 1)) 10))
(assert (= (g1 (f3 7)) 80))
(assert (= (f1 (g4 4)) 60))
(assert (= (g1 (f4 3)) 80))
(assert (= (f2 (f1 1)) 6))
(assert (= (f2 (g1 3)) 25))
(assert (= (f2 (f2 4)) 6))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 7)) 16))
(assert (= (f2 (g3 4)) 25))
(assert (= (g2 (f3 3)) 12))
(assert (= (g2 (f4 1)) 16))
(assert (= (f2 (f4 7)) 15))
(assert (= (g2 (g4 7)) 196))
(assert (= (f3 (f1 4)) 11))
(assert (= (f3 (g1 1)) 11))
(assert (= (g3 (f1 7)) 66))
(assert (= (f3 (g2 4)) 11))
(assert (= (g3 (f2 3)) 24))
(assert (= (g3 (f3 1)) 24))
(assert (= (f3 (f3 7)) 13))
(assert (= (g3 (g3 7)) 252))
(assert (= (g3 (f4 4)) 66))
(assert (= (f3 (f4 3)) 13))
(assert (= (g3 (g4 3)) 252))
(assert (= (f4 (g1 4)) 39))
(assert (= (g4 (f1 3)) 98))
(assert (= (g4 (f2 1)) 28))
(assert (= (f4 (f2 7)) 15))
(assert (= (g4 (g2 7)) 196))
(assert (= (g4 (f3 4)) 98))
(assert (= (f4 (f3 3)) 13))
(assert (= (g4 (g3 3)) 252))
(assert (= (f4 (f4 1)) 15))
(assert (= (g4 (g4 1)) 196))
(check-sat)
