(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 6)) 14))
(assert (= (f1 (g1 (- 6))) 48))
(assert (= (f1 (f2 2)) 8))
(assert (= (f1 (g2 6)) 28))
(assert (= (f1 (f3 4)) 14))
(assert (= (f1 (g3 2)) 28))
(assert (= (g1 (f3 (- 6))) 92))
(assert (= (f1 (g4 4)) 48))
(assert (= (g1 (f4 6)) 92))
(assert (= (f2 (f1 2)) 8))
(assert (= (f2 (g1 6)) 50))
(assert (= (f2 (f2 4)) 8))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 6))) 30))
(assert (= (f2 (g3 4)) 50))
(assert (= (g2 (f3 6)) 48))
(assert (= (g2 (f4 2)) 30))
(assert (= (f2 (f4 (- 6))) 13))
(assert (= (g2 (g4 (- 6))) 242))
(assert (= (f3 (f1 4)) 14))
(assert (= (f3 (g1 2)) 22))
(assert (= (g3 (f1 (- 6))) 114))
(assert (= (f3 (g2 4)) 22))
(assert (= (g3 (f2 6)) 96))
(assert (= (g3 (f3 2)) 96))
(assert (= (f3 (f3 (- 6))) (- 18)))
(assert (= (g3 (g3 (- 6))) 792))
(assert (= (g3 (f4 4)) 114))
(assert (= (f3 (f4 6)) (- 18)))
(assert (= (g3 (g4 6)) 792))
(assert (= (f4 (g1 4)) (- 38)))
(assert (= (g4 (f1 6)) 110))
(assert (= (g4 (f2 2)) 44))
(assert (= (f4 (f2 (- 6))) 13))
(assert (= (g4 (g2 (- 6))) 242))
(assert (= (g4 (f3 4)) 110))
(assert (= (f4 (f3 6)) (- 18)))
(assert (= (g4 (g3 6)) 792))
(assert (= (f4 (f4 2)) 13))
(assert (= (g4 (g4 2)) 242))
(check-sat)
