(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 3))) (- 11)))
(assert (= (f1 (g1 (- 7))) 56))
(assert (= (f1 (f2 6)) 16))
(assert (= (f1 (g2 (- 3))) 34))
(assert (= (f1 (f3 4)) (- 11)))
(assert (= (f1 (g3 6)) 34))
(assert (= (g1 (f3 (- 7))) 72))
(assert (= (f1 (g4 4)) 56))
(assert (= (g1 (f4 (- 3))) 72))
(assert (= (f2 (f1 6)) 16))
(assert (= (f2 (g1 (- 3))) 26))
(assert (= (f2 (f2 4)) 16))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 7))) 150))
(assert (= (f2 (g3 4)) 26))
(assert (= (g2 (f3 (- 3))) 60))
(assert (= (g2 (f4 6)) 150))
(assert (= (f2 (f4 (- 7))) 19))
(assert (= (g2 (g4 (- 7))) 1014))
(assert (= (f3 (f1 4)) (- 11)))
(assert (= (f3 (g1 6)) (- 51)))
(assert (= (g3 (f1 (- 7))) (- 53)))
(assert (= (f3 (g2 4)) (- 51)))
(assert (= (g3 (f2 (- 3))) (- 43)))
(assert (= (g3 (f3 6)) (- 43)))
(assert (= (f3 (f3 (- 7))) (- 12)))
(assert (= (g3 (g3 (- 7))) (- 163)))
(assert (= (g3 (f4 4)) (- 53)))
(assert (= (f3 (f4 (- 3))) (- 12)))
(assert (= (g3 (g4 (- 3))) (- 163)))
(assert (= (f4 (g1 4)) (- 39)))
(assert (= (g4 (f1 (- 3))) (- 85)))
(assert (= (g4 (f2 6)) 156))
(assert (= (f4 (f2 (- 7))) 19))
(assert (= (g4 (g2 (- 7))) 1014))
(assert (= (g4 (f3 4)) (- 85)))
(assert (= (f4 (f3 (- 3))) (- 12)))
(assert (= (g4 (g3 (- 3))) (- 163)))
(assert (= (f4 (f4 6)) 19))
(assert (= (g4 (g4 6)) 1014))
(check-sat)
