(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 9)) 17))
(assert (= (f1 (g1 (- 3))) 24))
(assert (= (f1 (f2 6)) 16))
(assert (= (f1 (g2 9)) 112))
(assert (= (f1 (f3 4)) 17))
(assert (= (f1 (g3 6)) 112))
(assert (= (g1 (f3 (- 3))) 92))
(assert (= (f1 (g4 4)) 24))
(assert (= (g1 (f4 9)) 92))
(assert (= (f2 (f1 6)) 16))
(assert (= (f2 (g1 9)) 78))
(assert (= (f2 (f2 4)) 16))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 3))) 102))
(assert (= (f2 (g3 4)) 78))
(assert (= (g2 (f3 9)) 216))
(assert (= (g2 (f4 6)) 102))
(assert (= (f2 (f4 (- 3))) 11))
(assert (= (g2 (g4 (- 3))) 150))
(assert (= (f3 (f1 4)) 17))
(assert (= (f3 (g1 6)) 57))
(assert (= (g3 (f1 (- 3))) 117))
(assert (= (f3 (g2 4)) 57))
(assert (= (g3 (f2 9)) 270))
(assert (= (g3 (f3 6)) 270))
(assert (= (f3 (f3 (- 3))) (- 21)))
(assert (= (g3 (g3 (- 3))) 810))
(assert (= (g3 (f4 4)) 117))
(assert (= (f3 (f4 9)) (- 21)))
(assert (= (g3 (g4 9)) 810))
(assert (= (f4 (g1 4)) (- 35)))
(assert (= (g4 (f1 9)) 65))
(assert (= (g4 (f2 6)) 60))
(assert (= (f4 (f2 (- 3))) 11))
(assert (= (g4 (g2 (- 3))) 150))
(assert (= (g4 (f3 4)) 65))
(assert (= (f4 (f3 9)) (- 21)))
(assert (= (g4 (g3 9)) 810))
(assert (= (f4 (f4 6)) 11))
(assert (= (g4 (g4 6)) 150))
(check-sat)
