(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 14))
(assert (= (f1 (g1 5)) 44))
(assert (= (f1 (f2 7)) 18))
(assert (= (f1 (g2 6)) 88))
(assert (= (f1 (f3 4)) 14))
(assert (= (f1 (g3 7)) 88))
(assert (= (g1 (f3 5)) 88))
(assert (= (f1 (g4 4)) 44))
(assert (= (g1 (f4 6)) 88))
(assert (= (f2 (f1 7)) 18))
(assert (= (f2 (g1 6)) 55))
(assert (= (f2 (f2 4)) 18))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 5)) 168))
(assert (= (f2 (g3 4)) 55))
(assert (= (g2 (f3 6)) 168))
(assert (= (g2 (f4 7)) 168))
(assert (= (f2 (f4 5)) 17))
(assert (= (g2 (g4 5)) 700))
(assert (= (f3 (f1 4)) 14))
(assert (= (f3 (g1 7)) 62))
(assert (= (g3 (f1 5)) 108))
(assert (= (f3 (g2 4)) 62))
(assert (= (g3 (f2 6)) 156))
(assert (= (g3 (f3 7)) 156))
(assert (= (f3 (f3 5)) 17))
(assert (= (g3 (g3 5)) 720))
(assert (= (g3 (f4 4)) 108))
(assert (= (f3 (f4 6)) 17))
(assert (= (g3 (g4 6)) 720))
(assert (= (f4 (g1 4)) 37))
(assert (= (g4 (f1 6)) 100))
(assert (= (g4 (f2 7)) 140))
(assert (= (f4 (f2 5)) 17))
(assert (= (g4 (g2 5)) 700))
(assert (= (g4 (f3 4)) 100))
(assert (= (f4 (f3 6)) 17))
(assert (= (g4 (g3 6)) 720))
(assert (= (f4 (f4 7)) 17))
(assert (= (g4 (g4 7)) 700))
(check-sat)
