(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 4 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 4 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 6)) 14))
(assert (= (f1 (g1 (- 3))) 24))
(assert (= (f1 (f2 8)) 20))
(assert (= (f1 (g2 6)) 100))
(assert (= (f1 (f3 4)) 14))
(assert (= (f1 (g3 8)) 100))
(assert (= (g1 (f3 (- 3))) 68))
(assert (= (f1 (g4 4)) 24))
(assert (= (g1 (f4 6)) 68))
(assert (= (f2 (f1 8)) 20))
(assert (= (f2 (g1 6)) 56))
(assert (= (f2 (f2 4)) 20))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 3))) 168))
(assert (= (f2 (g3 4)) 56))
(assert (= (g2 (f3 6)) 192))
(assert (= (g2 (f4 8)) 168))
(assert (= (f2 (f4 (- 3))) 13))
(assert (= (g2 (g4 (- 3))) 200))
(assert (= (f3 (f1 4)) 14))
(assert (= (f3 (g1 8)) 70))
(assert (= (g3 (f1 (- 3))) 78))
(assert (= (f3 (g2 4)) 70))
(assert (= (g3 (f2 6)) 168))
(assert (= (g3 (f3 8)) 168))
(assert (= (f3 (f3 (- 3))) (- 15)))
(assert (= (g3 (g3 (- 3))) 360))
(assert (= (g3 (f4 4)) 78))
(assert (= (f3 (f4 6)) (- 15)))
(assert (= (g3 (g4 6)) 360))
(assert (= (f4 (g1 4)) (- 35)))
(assert (= (g4 (f1 6)) 50))
(assert (= (g4 (f2 8)) 80))
(assert (= (f4 (f2 (- 3))) 13))
(assert (= (g4 (g2 (- 3))) 200))
(assert (= (g4 (f3 4)) 50))
(assert (= (f4 (f3 6)) (- 15)))
(assert (= (g4 (g3 6)) 360))
(assert (= (f4 (f4 8)) 13))
(assert (= (g4 (g4 8)) 200))
(check-sat)
