(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 9))) (- 19)))
(assert (= (f1 (g1 (- 3))) 30))
(assert (= (f1 (f2 (- 8))) 20))
(assert (= (f1 (g2 (- 9))) (- 133)))
(assert (= (f1 (f3 5)) (- 19)))
(assert (= (f1 (g3 (- 8))) (- 133)))
(assert (= (g1 (f3 (- 3))) 110))
(assert (= (f1 (g4 5)) 30))
(assert (= (g1 (f4 (- 9))) 110))
(assert (= (f2 (f1 (- 8))) 20))
(assert (= (f2 (g1 (- 9))) (- 93)))
(assert (= (f2 (f2 5)) 20))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 3))) 150))
(assert (= (f2 (g3 5)) (- 93)))
(assert (= (g2 (f3 (- 9))) 255))
(assert (= (g2 (f4 (- 8))) 150))
(assert (= (f2 (f4 (- 3))) (- 13)))
(assert (= (g2 (g4 (- 3))) (- 188)))
(assert (= (f3 (f1 5)) (- 19)))
(assert (= (f3 (g1 (- 8))) (- 84)))
(assert (= (g3 (f1 (- 3))) (- 128)))
(assert (= (f3 (g2 5)) (- 84)))
(assert (= (g3 (f2 (- 9))) 272))
(assert (= (g3 (f3 (- 8))) 272))
(assert (= (f3 (f3 (- 3))) (- 20)))
(assert (= (g3 (g3 (- 3))) (- 723)))
(assert (= (g3 (f4 5)) (- 128)))
(assert (= (f3 (f4 (- 9))) (- 20)))
(assert (= (g3 (g4 (- 9))) (- 723)))
(assert (= (f4 (g1 5)) (- 53)))
(assert (= (g4 (f1 (- 9))) (- 68)))
(assert (= (g4 (f2 (- 8))) 75))
(assert (= (f4 (f2 (- 3))) (- 13)))
(assert (= (g4 (g2 (- 3))) (- 188)))
(assert (= (g4 (f3 5)) (- 68)))
(assert (= (f4 (f3 (- 9))) (- 20)))
(assert (= (g4 (g3 (- 9))) (- 723)))
(assert (= (f4 (f4 (- 8))) (- 13)))
(assert (= (g4 (g4 (- 8))) (- 188)))
(check-sat)
