(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 18))
(assert (= (f1 (g1 (- 3))) 39))
(assert (= (f1 (f2 1)) (- 9)))
(assert (= (f1 (g2 5)) (- 17)))
(assert (= (f1 (f3 (- 7))) 18))
(assert (= (f1 (g3 1)) (- 17)))
(assert (= (g1 (f3 (- 3))) (- 98)))
(assert (= (f1 (g4 (- 7))) 39))
(assert (= (g1 (f4 5)) (- 98)))
(assert (= (f2 (f1 1)) (- 9)))
(assert (= (f2 (g1 5)) 66))
(assert (= (f2 (f2 (- 7))) (- 9)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 3))) 7))
(assert (= (f2 (g3 (- 7))) 66))
(assert (= (g2 (f3 5)) 20))
(assert (= (g2 (f4 1)) 7))
(assert (= (f2 (f4 (- 3))) 6))
(assert (= (g2 (g4 (- 3))) 25))
(assert (= (f3 (f1 (- 7))) 18))
(assert (= (f3 (g1 1)) 18))
(assert (= (g3 (f1 (- 3))) 90))
(assert (= (f3 (g2 (- 7))) 18))
(assert (= (g3 (f2 5)) 60))
(assert (= (g3 (f3 1)) 60))
(assert (= (f3 (f3 (- 3))) (- 13)))
(assert (= (g3 (g3 (- 3))) 250))
(assert (= (g3 (f4 (- 7))) 90))
(assert (= (f3 (f4 5)) (- 13)))
(assert (= (g3 (g4 5)) 250))
(assert (= (f4 (g1 (- 7))) 87))
(assert (= (g4 (f1 5)) (- 58)))
(assert (= (g4 (f2 1)) 10))
(assert (= (f4 (f2 (- 3))) 6))
(assert (= (g4 (g2 (- 3))) 25))
(assert (= (g4 (f3 (- 7))) (- 58)))
(assert (= (f4 (f3 5)) (- 13)))
(assert (= (g4 (g3 5)) 250))
(assert (= (f4 (f4 1)) 6))
(assert (= (g4 (g4 1)) 25))
(check-sat)
