(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 1) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 1) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 (- 1))) (- 11)))
(assert (= (f1 (g1 (- 9))) 90))
(assert (= (f1 (f2 (- 8))) 20))
(assert (= (f1 (g2 (- 1))) (- 13)))
(assert (= (f1 (f3 5)) (- 11)))
(assert (= (f1 (g3 (- 8))) (- 13)))
(assert (= (g1 (f3 (- 9))) 90))
(assert (= (f1 (g4 5)) 90))
(assert (= (g1 (f4 (- 1))) 90))
(assert (= (f2 (f1 (- 8))) 20))
(assert (= (f2 (g1 (- 1))) (- 13)))
(assert (= (f2 (f2 5)) 20))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 9))) 240))
(assert (= (f2 (g3 5)) (- 13)))
(assert (= (g2 (f3 (- 1))) 15))
(assert (= (g2 (f4 (- 8))) 240))
(assert (= (f2 (f4 (- 9))) (- 25)))
(assert (= (g2 (g4 (- 9))) (- 2168)))
(assert (= (f3 (f1 5)) (- 11)))
(assert (= (f3 (g1 (- 8))) (- 76)))
(assert (= (g3 (f1 (- 9))) (- 14)))
(assert (= (f3 (g2 5)) (- 76)))
(assert (= (g3 (f2 (- 1))) 8))
(assert (= (g3 (f3 (- 8))) 8))
(assert (= (f3 (f3 (- 9))) (- 10)))
(assert (= (g3 (g3 (- 9))) (- 9)))
(assert (= (g3 (f4 5)) (- 14)))
(assert (= (f3 (f4 (- 1))) (- 10)))
(assert (= (g3 (g4 (- 1))) (- 9)))
(assert (= (f4 (g1 5)) (- 59)))
(assert (= (g4 (f1 (- 1))) (- 94)))
(assert (= (g4 (f2 (- 8))) 255))
(assert (= (f4 (f2 (- 9))) (- 25)))
(assert (= (g4 (g2 (- 9))) (- 2168)))
(assert (= (g4 (f3 5)) (- 94)))
(assert (= (f4 (f3 (- 1))) (- 10)))
(assert (= (g4 (g3 (- 1))) (- 9)))
(assert (= (f4 (f4 (- 8))) (- 25)))
(assert (= (g4 (g4 (- 8))) (- 2168)))
(check-sat)
