(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 17))
(assert (= (f1 (g1 1)) 15))
(assert (= (f1 (f2 (- 5))) 14))
(assert (= (f1 (g2 7)) 68))
(assert (= (f1 (f3 5)) 17))
(assert (= (f1 (g3 (- 5))) 68))
(assert (= (g1 (f3 1)) 80))
(assert (= (f1 (g4 5)) 15))
(assert (= (g1 (f4 7)) 80))
(assert (= (f2 (f1 (- 5))) 14))
(assert (= (f2 (g1 7)) (- 75)))
(assert (= (f2 (f2 5)) 14))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 1)) (- 50)))
(assert (= (f2 (g3 5)) (- 75)))
(assert (= (g2 (f3 7)) 126))
(assert (= (g2 (f4 (- 5))) (- 50)))
(assert (= (f2 (f4 1)) (- 7)))
(assert (= (g2 (g4 1)) 18))
(assert (= (f3 (f1 5)) 17))
(assert (= (f3 (g1 (- 5))) 52))
(assert (= (g3 (f1 1)) 84))
(assert (= (f3 (g2 5)) 52))
(assert (= (g3 (f2 7)) 161))
(assert (= (g3 (f3 (- 5))) 161))
(assert (= (f3 (f3 1)) 15))
(assert (= (g3 (g3 1)) 196))
(assert (= (g3 (f4 5)) 84))
(assert (= (f3 (f4 7)) 15))
(assert (= (g3 (g4 7)) 196))
(assert (= (f4 (g1 5)) 51))
(assert (= (g4 (f1 7)) 24))
(assert (= (g4 (f2 (- 5))) 18))
(assert (= (f4 (f2 1)) (- 7)))
(assert (= (g4 (g2 1)) 18))
(assert (= (g4 (f3 5)) 24))
(assert (= (f4 (f3 7)) 15))
(assert (= (g4 (g3 7)) 196))
(assert (= (f4 (f4 (- 5))) (- 7)))
(assert (= (g4 (g4 (- 5))) 18))
(check-sat)
