(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 17)))
(assert (= (f1 (g1 (- 5))) 50))
(assert (= (f1 (f2 (- 4))) 12))
(assert (= (f1 (g2 (- 7))) (- 51)))
(assert (= (f1 (f3 5)) (- 17)))
(assert (= (f1 (g3 (- 4))) (- 51)))
(assert (= (g1 (f3 (- 5))) 110))
(assert (= (f1 (g4 5)) 50))
(assert (= (g1 (f4 (- 7))) 110))
(assert (= (f2 (f1 (- 4))) 12))
(assert (= (f2 (g1 (- 7))) (- 69)))
(assert (= (f2 (f2 5)) 12))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 5))) 56))
(assert (= (f2 (g3 5)) (- 69)))
(assert (= (g2 (f3 (- 7))) 91))
(assert (= (g2 (f4 (- 4))) 56))
(assert (= (f2 (f4 (- 5))) (- 13)))
(assert (= (g2 (g4 (- 5))) (- 284)))
(assert (= (f3 (f1 5)) (- 17)))
(assert (= (f3 (g1 (- 4))) (- 42)))
(assert (= (g3 (f1 (- 5))) (- 124)))
(assert (= (f3 (g2 5)) (- 42)))
(assert (= (g3 (f2 (- 7))) 130))
(assert (= (g3 (f3 (- 4))) 130))
(assert (= (f3 (f3 (- 5))) (- 18)))
(assert (= (g3 (g3 (- 5))) (- 761)))
(assert (= (g3 (f4 5)) (- 124)))
(assert (= (f3 (f4 (- 7))) (- 18)))
(assert (= (g3 (g4 (- 7))) (- 761)))
(assert (= (f4 (g1 5)) (- 55)))
(assert (= (g4 (f1 (- 7))) (- 104)))
(assert (= (g4 (f2 (- 4))) 63))
(assert (= (f4 (f2 (- 5))) (- 13)))
(assert (= (g4 (g2 (- 5))) (- 284)))
(assert (= (g4 (f3 5)) (- 104)))
(assert (= (f4 (f3 (- 7))) (- 18)))
(assert (= (g4 (g3 (- 7))) (- 761)))
(assert (= (f4 (f4 (- 4))) (- 13)))
(assert (= (g4 (g4 (- 4))) (- 284)))
(check-sat)
