(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 4) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 4) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 4))) (- 14)))
(assert (= (f1 (g1 9)) 95))
(assert (= (f1 (f2 (- 3))) 10))
(assert (= (f1 (g2 (- 4))) (- 23)))
(assert (= (f1 (f3 5)) (- 14)))
(assert (= (f1 (g3 (- 3))) (- 23)))
(assert (= (g1 (f3 9)) 125))
(assert (= (f1 (g4 5)) 95))
(assert (= (g1 (f4 (- 4))) 125))
(assert (= (f2 (f1 (- 3))) 10))
(assert (= (f2 (g1 (- 4))) (- 38)))
(assert (= (f2 (f2 5)) 10))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 9)) (- 58)))
(assert (= (f2 (g3 5)) (- 38)))
(assert (= (g2 (f3 (- 4))) 35))
(assert (= (g2 (f4 (- 3))) (- 58)))
(assert (= (f2 (f4 9)) (- 21)))
(assert (= (g2 (g4 9)) 810))
(assert (= (f3 (f1 5)) (- 14)))
(assert (= (f3 (g1 (- 3))) (- 29)))
(assert (= (g3 (f1 9)) 98))
(assert (= (f3 (g2 5)) (- 29)))
(assert (= (g3 (f2 (- 4))) 42))
(assert (= (g3 (f3 (- 3))) 42))
(assert (= (f3 (f3 9)) 16))
(assert (= (g3 (g3 9)) 441))
(assert (= (g3 (f4 5)) 98))
(assert (= (f3 (f4 (- 4))) 16))
(assert (= (g3 (g4 (- 4))) 441))
(assert (= (f4 (g1 5)) 59))
(assert (= (g4 (f1 (- 4))) 153))
(assert (= (g4 (f2 (- 3))) 90))
(assert (= (f4 (f2 9)) (- 21)))
(assert (= (g4 (g2 9)) 810))
(assert (= (g4 (f3 5)) 153))
(assert (= (f4 (f3 (- 4))) 16))
(assert (= (g4 (g3 (- 4))) 441))
(assert (= (f4 (f4 (- 3))) (- 21)))
(assert (= (g4 (g4 (- 3))) 810))
(check-sat)
