(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua 0 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num 0 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 0)) 10))
(assert (= (f1 (g1 (- 6))) 60))
(assert (= (f1 (f2 (- 1))) 6))
(assert (= (f1 (g2 0)) 5))
(assert (= (f1 (f3 5)) 10))
(assert (= (f1 (g3 (- 1))) 5))
(assert (= (g1 (f3 (- 6))) 55))
(assert (= (f1 (g4 5)) 60))
(assert (= (g1 (f4 0)) 55))
(assert (= (f2 (f1 (- 1))) 6))
(assert (= (f2 (g1 0)) (- 1)))
(assert (= (f2 (f2 5)) 6))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 6))) 6))
(assert (= (f2 (g3 5)) (- 1)))
(assert (= (g2 (f3 0)) 0))
(assert (= (g2 (f4 (- 1))) 6))
(assert (= (f2 (f4 (- 6))) (- 12)))
(assert (= (g2 (g4 (- 6))) (- 61)))
(assert (= (f3 (f1 5)) 10))
(assert (= (f3 (g1 (- 1))) 5))
(assert (= (g3 (f1 (- 6))) 0))
(assert (= (f3 (g2 5)) 5))
(assert (= (g3 (f2 0)) 0))
(assert (= (g3 (f3 (- 1))) 0))
(assert (= (f3 (f3 (- 6))) (- 6)))
(assert (= (g3 (g3 (- 6))) 0))
(assert (= (g3 (f4 5)) 0))
(assert (= (f3 (f4 0)) (- 6)))
(assert (= (g3 (g4 0)) 0))
(assert (= (f4 (g1 5)) (- 56)))
(assert (= (g4 (f1 0)) 55))
(assert (= (g4 (f2 (- 1))) 11))
(assert (= (f4 (f2 (- 6))) (- 12)))
(assert (= (g4 (g2 (- 6))) (- 61)))
(assert (= (g4 (f3 5)) 55))
(assert (= (f4 (f3 0)) (- 6)))
(assert (= (g4 (g3 0)) 0))
(assert (= (f4 (f4 (- 1))) (- 12)))
(assert (= (g4 (g4 (- 1))) (- 61)))
(check-sat)
