(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 16)))
(assert (= (f1 (g1 7)) (- 98)))
(assert (= (f1 (f2 3)) (- 13)))
(assert (= (f1 (g2 (- 3))) (- 22)))
(assert (= (f1 (f3 (- 7))) (- 16)))
(assert (= (f1 (g3 3)) (- 22)))
(assert (= (g1 (f3 7)) (- 124)))
(assert (= (f1 (g4 (- 7))) (- 98)))
(assert (= (g1 (f4 (- 3))) (- 124)))
(assert (= (f2 (f1 3)) (- 13)))
(assert (= (f2 (g1 (- 3))) (- 36)))
(assert (= (f2 (f2 (- 7))) (- 13)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 7)) 60))
(assert (= (f2 (g3 (- 7))) (- 36)))
(assert (= (g2 (f3 (- 3))) 30))
(assert (= (g2 (f4 3)) 60))
(assert (= (f2 (f4 7)) 17))
(assert (= (g2 (g4 7)) 588))
(assert (= (f3 (f1 (- 7))) (- 16)))
(assert (= (f3 (g1 3)) (- 42)))
(assert (= (g3 (f1 7)) (- 68)))
(assert (= (f3 (g2 (- 7))) (- 42)))
(assert (= (g3 (f2 (- 3))) (- 28)))
(assert (= (g3 (f3 3)) (- 28)))
(assert (= (f3 (f3 7)) 12))
(assert (= (g3 (g3 7)) 175))
(assert (= (g3 (f4 (- 7))) (- 68)))
(assert (= (f3 (f4 (- 3))) 12))
(assert (= (g3 (g4 (- 3))) 175))
(assert (= (f4 (g1 (- 7))) (- 92)))
(assert (= (g4 (f1 (- 3))) 126))
(assert (= (g4 (f2 3)) 84))
(assert (= (f4 (f2 7)) 17))
(assert (= (g4 (g2 7)) 588))
(assert (= (g4 (f3 (- 7))) 126))
(assert (= (f4 (f3 (- 3))) 12))
(assert (= (g4 (g3 (- 3))) 175))
(assert (= (f4 (f4 3)) 17))
(assert (= (g4 (g4 3)) 588))
(check-sat)
