(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 18))
(assert (= (f1 (g1 (- 5))) 65))
(assert (= (f1 (f2 3)) (- 13)))
(assert (= (f1 (g2 5)) (- 37)))
(assert (= (f1 (f3 (- 7))) 18))
(assert (= (f1 (g3 3)) (- 37)))
(assert (= (g1 (f3 (- 5))) (- 124)))
(assert (= (f1 (g4 (- 7))) 65))
(assert (= (g1 (f4 5)) (- 124)))
(assert (= (f2 (f1 3)) (- 13)))
(assert (= (f2 (g1 5)) 68))
(assert (= (f2 (f2 (- 7))) (- 13)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 5))) 45))
(assert (= (f2 (g3 (- 7))) 68))
(assert (= (g2 (f3 5)) 60))
(assert (= (g2 (f4 3)) 45))
(assert (= (f2 (f4 (- 5))) 12))
(assert (= (g2 (g4 (- 5))) 243))
(assert (= (f3 (f1 (- 7))) 18))
(assert (= (f3 (g1 3)) 44))
(assert (= (g3 (f1 (- 5))) 110))
(assert (= (f3 (g2 (- 7))) 44))
(assert (= (g3 (f2 5)) 80))
(assert (= (g3 (f3 3)) 80))
(assert (= (f3 (f3 (- 5))) (- 15)))
(assert (= (g3 (g3 (- 5))) 450))
(assert (= (g3 (f4 (- 7))) 110))
(assert (= (f3 (f4 5)) (- 15)))
(assert (= (g3 (g4 5)) 450))
(assert (= (f4 (g1 (- 7))) 89))
(assert (= (g4 (f1 5)) (- 104)))
(assert (= (g4 (f2 3)) 54))
(assert (= (f4 (f2 (- 5))) 12))
(assert (= (g4 (g2 (- 5))) 243))
(assert (= (g4 (f3 (- 7))) (- 104)))
(assert (= (f4 (f3 5)) (- 15)))
(assert (= (g4 (g3 5)) 450))
(assert (= (f4 (f4 3)) 12))
(assert (= (g4 (g4 3)) 243))
(check-sat)
