(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 18)))
(assert (= (f1 (g1 (- 4))) 40))
(assert (= (f1 (f2 6)) 17))
(assert (= (f1 (g2 (- 8))) 95))
(assert (= (f1 (f3 5)) (- 18)))
(assert (= (f1 (g3 6)) 95))
(assert (= (g1 (f3 (- 4))) 110))
(assert (= (f1 (g4 5)) 40))
(assert (= (g1 (f4 (- 8))) 110))
(assert (= (f2 (f1 6)) 17))
(assert (= (f2 (g1 (- 8))) 81))
(assert (= (f2 (f2 5)) 17))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 4))) 114))
(assert (= (f2 (g3 5)) 81))
(assert (= (g2 (f3 (- 8))) 180))
(assert (= (g2 (f4 6)) 114))
(assert (= (f2 (f4 (- 4))) 13))
(assert (= (g2 (g4 (- 4))) 294))
(assert (= (f3 (f1 5)) (- 18)))
(assert (= (f3 (g1 6)) (- 68)))
(assert (= (g3 (f1 (- 4))) (- 128)))
(assert (= (f3 (g2 5)) (- 68)))
(assert (= (g3 (f2 (- 8))) (- 203)))
(assert (= (g3 (f3 6)) (- 203)))
(assert (= (f3 (f3 (- 4))) (- 19)))
(assert (= (g3 (g3 (- 4))) (- 788)))
(assert (= (g3 (f4 5)) (- 128)))
(assert (= (f3 (f4 (- 8))) (- 19)))
(assert (= (g3 (g4 (- 8))) (- 788)))
(assert (= (f4 (g1 5)) (- 54)))
(assert (= (g4 (f1 (- 8))) (- 88)))
(assert (= (g4 (f2 6)) 84))
(assert (= (f4 (f2 (- 4))) 13))
(assert (= (g4 (g2 (- 4))) 294))
(assert (= (g4 (f3 5)) (- 88)))
(assert (= (f4 (f3 (- 8))) (- 19)))
(assert (= (g4 (g3 (- 8))) (- 788)))
(assert (= (f4 (f4 6)) 13))
(assert (= (g4 (g4 6)) 294))
(check-sat)
