(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 18))
(assert (= (f1 (g1 (- 3))) 30))
(assert (= (f1 (f2 6)) 17))
(assert (= (f1 (g2 8)) 101))
(assert (= (f1 (f3 5)) 18))
(assert (= (f1 (g3 6)) 101))
(assert (= (g1 (f3 (- 3))) 105))
(assert (= (f1 (g4 5)) 30))
(assert (= (g1 (f4 8)) 105))
(assert (= (f2 (f1 6)) 17))
(assert (= (f2 (g1 8)) 86))
(assert (= (f2 (f2 5)) 17))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 (- 3))) 102))
(assert (= (f2 (g3 5)) 86))
(assert (= (g2 (f3 8)) 192))
(assert (= (g2 (f4 6)) 102))
(assert (= (f2 (f4 (- 3))) 11))
(assert (= (g2 (g4 (- 3))) 150))
(assert (= (f3 (f1 5)) 18))
(assert (= (f3 (g1 6)) 68))
(assert (= (g3 (f1 (- 3))) 120))
(assert (= (f3 (g2 5)) 68))
(assert (= (g3 (f2 8)) 224))
(assert (= (g3 (f3 6)) 224))
(assert (= (f3 (f3 (- 3))) (- 19)))
(assert (= (g3 (g3 (- 3))) 640))
(assert (= (g3 (f4 5)) 120))
(assert (= (f3 (f4 8)) (- 19)))
(assert (= (g3 (g4 8)) 640))
(assert (= (f4 (g1 5)) (- 53)))
(assert (= (g4 (f1 8)) 65))
(assert (= (g4 (f2 6)) 60))
(assert (= (f4 (f2 (- 3))) 11))
(assert (= (g4 (g2 (- 3))) 150))
(assert (= (g4 (f3 5)) 65))
(assert (= (f4 (f3 8)) (- 19)))
(assert (= (g4 (g3 8)) 640))
(assert (= (f4 (f4 6)) 11))
(assert (= (g4 (g4 6)) 150))
(check-sat)
