(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 9)) 22))
(assert (= (f1 (g1 (- 1))) 13))
(assert (= (f1 (f2 3)) (- 13)))
(assert (= (f1 (g2 9)) (- 61)))
(assert (= (f1 (f3 (- 7))) 22))
(assert (= (f1 (g3 3)) (- 61)))
(assert (= (g1 (f3 (- 1))) (- 124)))
(assert (= (f1 (g4 (- 7))) 13))
(assert (= (g1 (f4 9)) (- 124)))
(assert (= (f2 (f1 3)) (- 13)))
(assert (= (f2 (g1 9)) 120))
(assert (= (f2 (f2 (- 7))) (- 13)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 1))) 21))
(assert (= (f2 (g3 (- 7))) 120))
(assert (= (g2 (f3 9)) 108))
(assert (= (g2 (f4 3)) 21))
(assert (= (f2 (f4 (- 1))) 4))
(assert (= (g2 (g4 (- 1))) 3))
(assert (= (f3 (f1 (- 7))) 22))
(assert (= (f3 (g1 3)) 48))
(assert (= (g3 (f1 (- 1))) 126))
(assert (= (f3 (g2 (- 7))) 48))
(assert (= (g3 (f2 9)) 216))
(assert (= (g3 (f3 3)) 216))
(assert (= (f3 (f3 (- 1))) (- 19)))
(assert (= (g3 (g3 (- 1))) 162))
(assert (= (g3 (f4 (- 7))) 126))
(assert (= (f3 (f4 9)) (- 19)))
(assert (= (g3 (g4 9)) 162))
(assert (= (f4 (g1 (- 7))) 85))
(assert (= (g4 (f1 9)) (- 16)))
(assert (= (g4 (f2 3)) 6))
(assert (= (f4 (f2 (- 1))) 4))
(assert (= (g4 (g2 (- 1))) 3))
(assert (= (g4 (f3 (- 7))) (- 16)))
(assert (= (f4 (f3 9)) (- 19)))
(assert (= (g4 (g3 9)) 162))
(assert (= (f4 (f4 3)) 4))
(assert (= (g4 (g4 3)) 3))
(check-sat)
