(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 3)) 13))
(assert (= (f1 (g1 2)) 25))
(assert (= (f1 (f2 7)) 19))
(assert (= (f1 (g2 3)) 47))
(assert (= (f1 (f3 5)) 13))
(assert (= (f1 (g3 7)) 47))
(assert (= (g1 (f3 2)) 50))
(assert (= (f1 (g4 5)) 25))
(assert (= (g1 (f4 3)) 50))
(assert (= (f2 (f1 7)) 19))
(assert (= (f2 (g1 3)) 37))
(assert (= (f2 (f2 5)) 19))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 2)) 126))
(assert (= (f2 (g3 5)) 37))
(assert (= (g2 (f3 3)) 84))
(assert (= (g2 (f4 7)) 126))
(assert (= (f2 (f4 2)) 11))
(assert (= (g2 (g4 2)) 112))
(assert (= (f3 (f1 5)) 13))
(assert (= (f3 (g1 7)) 73))
(assert (= (g3 (f1 2)) 42))
(assert (= (f3 (g2 5)) 73))
(assert (= (g3 (f2 3)) 60))
(assert (= (g3 (f3 7)) 60))
(assert (= (f3 (f3 2)) 8))
(assert (= (g3 (g3 2)) 72))
(assert (= (g3 (f4 5)) 42))
(assert (= (f3 (f4 3)) 8))
(assert (= (g3 (g4 3)) 72))
(assert (= (f4 (g1 5)) 52))
(assert (= (g4 (f1 3)) 32))
(assert (= (g4 (f2 7)) 56))
(assert (= (f4 (f2 2)) 11))
(assert (= (g4 (g2 2)) 112))
(assert (= (g4 (f3 5)) 32))
(assert (= (f4 (f3 3)) 8))
(assert (= (g4 (g3 3)) 72))
(assert (= (f4 (f4 7)) 11))
(assert (= (g4 (g4 7)) 112))
(check-sat)
