(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 18)))
(assert (= (f1 (g1 (- 6))) 60))
(assert (= (f1 (f2 8)) 21))
(assert (= (f1 (g2 (- 8))) 125))
(assert (= (f1 (f3 5)) (- 18)))
(assert (= (f1 (g3 8)) 125))
(assert (= (g1 (f3 (- 6))) 130))
(assert (= (f1 (g4 5)) 60))
(assert (= (g1 (f4 (- 8))) 130))
(assert (= (f2 (f1 8)) 21))
(assert (= (f2 (g1 (- 8))) 83))
(assert (= (f2 (f2 5)) 21))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 6))) 216))
(assert (= (f2 (g3 5)) 83))
(assert (= (g2 (f3 (- 8))) 240))
(assert (= (g2 (f4 8)) 216))
(assert (= (f2 (f4 (- 6))) 19))
(assert (= (g2 (g4 (- 6))) 968))
(assert (= (f3 (f1 5)) (- 18)))
(assert (= (f3 (g1 8)) (- 88)))
(assert (= (g3 (f1 (- 6))) (- 158)))
(assert (= (f3 (g2 5)) (- 88)))
(assert (= (g3 (f2 (- 8))) (- 233)))
(assert (= (g3 (f3 8)) (- 233)))
(assert (= (f3 (f3 (- 6))) (- 21)))
(assert (= (g3 (g3 (- 6))) (- 1238)))
(assert (= (g3 (f4 5)) (- 158)))
(assert (= (f3 (f4 (- 8))) (- 21)))
(assert (= (g3 (g4 (- 8))) (- 1238)))
(assert (= (f4 (g1 5)) (- 56)))
(assert (= (g4 (f1 (- 8))) (- 138)))
(assert (= (g4 (f2 8)) 176))
(assert (= (f4 (f2 (- 6))) 19))
(assert (= (g4 (g2 (- 6))) 968))
(assert (= (g4 (f3 5)) (- 138)))
(assert (= (f4 (f3 (- 8))) (- 21)))
(assert (= (g4 (g3 (- 8))) (- 1238)))
(assert (= (f4 (f4 8)) 19))
(assert (= (g4 (g4 8)) 968))
(check-sat)
