(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 5 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 5 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 17)))
(assert (= (f1 (g1 6)) 65))
(assert (= (f1 (f2 8)) 21))
(assert (= (f1 (g2 (- 7))) 109))
(assert (= (f1 (f3 5)) (- 17)))
(assert (= (f1 (g3 8)) 109))
(assert (= (g1 (f3 6)) 125))
(assert (= (f1 (g4 5)) 65))
(assert (= (g1 (f4 (- 7))) 125))
(assert (= (f2 (f1 8)) 21))
(assert (= (f2 (g1 (- 7))) 73))
(assert (= (f2 (f2 5)) 21))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 6)) 224))
(assert (= (f2 (g3 5)) 73))
(assert (= (g2 (f3 (- 7))) 208))
(assert (= (g2 (f4 8)) 224))
(assert (= (f2 (f4 6)) 20))
(assert (= (g2 (g4 6)) 1152))
(assert (= (f3 (f1 5)) (- 17)))
(assert (= (f3 (g1 8)) (- 87)))
(assert (= (g3 (f1 6)) 143))
(assert (= (f3 (g2 5)) (- 87)))
(assert (= (g3 (f2 (- 7))) (- 189)))
(assert (= (g3 (f3 8)) (- 189)))
(assert (= (f3 (f3 6)) 19))
(assert (= (g3 (g3 6)) 1014))
(assert (= (g3 (f4 5)) 143))
(assert (= (f3 (f4 (- 7))) 19))
(assert (= (g3 (g4 (- 7))) 1014))
(assert (= (f4 (g1 5)) 56))
(assert (= (g4 (f1 (- 7))) 138))
(assert (= (g4 (f2 8)) 192))
(assert (= (f4 (f2 6)) 20))
(assert (= (g4 (g2 6)) 1152))
(assert (= (g4 (f3 5)) 138))
(assert (= (f4 (f3 (- 7))) 19))
(assert (= (g4 (g3 (- 7))) 1014))
(assert (= (f4 (f4 8)) 20))
(assert (= (g4 (g4 8)) 1152))
(check-sat)
