(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (g1 (g1 x)) (g2 (g3 x)))))
(assert (= (f1 (f1 8)) 20))
(assert (= (f1 (g1 3)) 42))
(assert (= (f1 (f2 (- 5))) 15))
(assert (= (f1 (g2 8)) 78))
(assert (= (f1 (f3 6)) 20))
(assert (= (f1 (g3 (- 5))) 78))
(assert (= (g1 (f3 3)) 132))
(assert (= (f1 (g4 6)) 42))
(assert (= (g1 (f4 8)) 132))
(assert (= (f2 (f1 (- 5))) 15))
(assert (= (f2 (g1 8)) (- 101)))
(assert (= (f2 (f2 6)) 15))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 3)) (- 68)))
(assert (= (f2 (g3 6)) (- 101)))
(assert (= (g2 (f3 8)) 144))
(assert (= (g2 (f4 (- 5))) (- 68)))
(assert (= (f2 (f4 3)) (- 11)))
(assert (= (g2 (g4 3)) 162))
(assert (= (f3 (f1 6)) 20))
(assert (= (f3 (g1 (- 5))) 62))
(assert (= (g3 (f1 3)) 144))
(assert (= (f3 (g2 6)) 62))
(assert (= (g3 (f2 8)) 200))
(assert (= (g3 (f3 (- 5))) 200))
(assert (= (f3 (f3 3)) 19))
(assert (= (g3 (g3 3)) 768))
(assert (= (g3 (f4 6)) 144))
(assert (= (f3 (f4 8)) 19))
(assert (= (g3 (g4 8)) 768))
(assert (= (f4 (g1 6)) 75))
(assert (= (g4 (f1 8)) 84))
(assert (= (g4 (f2 (- 5))) 54))
(assert (= (f4 (f2 3)) (- 11)))
(assert (= (g4 (g2 3)) 162))
(assert (= (g4 (f3 6)) 84))
(assert (= (f4 (f3 8)) 19))
(assert (= (g4 (g3 8)) 768))
(assert (= (f4 (f4 (- 5))) (- 11)))
(assert (= (g4 (g4 (- 5))) 162))
(check-sat)
