(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 15)))
(assert (= (f1 (g1 7)) 90))
(assert (= (f1 (f2 (- 4))) 13))
(assert (= (f1 (g2 (- 3))) (- 24)))
(assert (= (f1 (f3 6)) (- 15)))
(assert (= (f1 (g3 (- 4))) (- 24)))
(assert (= (g1 (f3 7)) 114))
(assert (= (f1 (g4 6)) 90))
(assert (= (g1 (f4 (- 3))) 114))
(assert (= (f2 (f1 (- 4))) 13))
(assert (= (f2 (g1 (- 3))) (- 34)))
(assert (= (f2 (f2 6)) 13))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 7)) (- 74)))
(assert (= (f2 (g3 6)) (- 34)))
(assert (= (g2 (f3 (- 3))) 35))
(assert (= (g2 (f4 (- 4))) (- 74)))
(assert (= (f2 (f4 7)) (- 18)))
(assert (= (g2 (g4 7)) 686))
(assert (= (f3 (f1 6)) (- 15)))
(assert (= (f3 (g1 (- 4))) (- 45)))
(assert (= (g3 (f1 7)) 65))
(assert (= (f3 (g2 6)) (- 45)))
(assert (= (g3 (f2 (- 3))) 30))
(assert (= (g3 (f3 (- 4))) 30))
(assert (= (f3 (f3 7)) 12))
(assert (= (g3 (g3 7)) 175))
(assert (= (g3 (f4 6)) 65))
(assert (= (f3 (f4 (- 3))) 12))
(assert (= (g3 (g4 (- 3))) 175))
(assert (= (f4 (g1 6)) 79))
(assert (= (g4 (f1 (- 3))) 119))
(assert (= (g4 (f2 (- 4))) 98))
(assert (= (f4 (f2 7)) (- 18)))
(assert (= (g4 (g2 7)) 686))
(assert (= (g4 (f3 6)) 119))
(assert (= (f4 (f3 (- 3))) 12))
(assert (= (g4 (g3 (- 3))) 175))
(assert (= (f4 (f4 (- 4))) (- 18)))
(assert (= (g4 (g4 (- 4))) 686))
(check-sat)
