(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 18)))
(assert (= (f1 (g1 (- 4))) 48))
(assert (= (f1 (f2 (- 3))) 11))
(assert (= (f1 (g2 (- 6))) (- 34)))
(assert (= (f1 (f3 6)) (- 18)))
(assert (= (f1 (g3 (- 3))) (- 34)))
(assert (= (g1 (f3 (- 4))) 108))
(assert (= (f1 (g4 6)) 48))
(assert (= (g1 (f4 (- 6))) 108))
(assert (= (f2 (f1 (- 3))) 11))
(assert (= (f2 (g1 (- 6))) (- 69)))
(assert (= (f2 (f2 6)) 11))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 4))) 30))
(assert (= (f2 (g3 6)) (- 69)))
(assert (= (g2 (f3 (- 6))) 55))
(assert (= (g2 (f4 (- 3))) 30))
(assert (= (f2 (f4 (- 4))) (- 10)))
(assert (= (g2 (g4 (- 4))) (- 123)))
(assert (= (f3 (f1 6)) (- 18)))
(assert (= (f3 (g1 (- 3))) (- 36)))
(assert (= (g3 (f1 (- 4))) (- 105)))
(assert (= (f3 (g2 6)) (- 36)))
(assert (= (g3 (f2 (- 6))) 88))
(assert (= (g3 (f3 (- 3))) 88))
(assert (= (f3 (f3 (- 4))) (- 15)))
(assert (= (g3 (g3 (- 4))) (- 424)))
(assert (= (g3 (f4 6)) (- 105)))
(assert (= (f3 (f4 (- 6))) (- 15)))
(assert (= (g3 (g4 (- 6))) (- 424)))
(assert (= (f4 (g1 6)) (- 76)))
(assert (= (g4 (f1 (- 6))) (- 81)))
(assert (= (g4 (f2 (- 3))) 35))
(assert (= (f4 (f2 (- 4))) (- 10)))
(assert (= (g4 (g2 (- 4))) (- 123)))
(assert (= (g4 (f3 6)) (- 81)))
(assert (= (f4 (f3 (- 6))) (- 15)))
(assert (= (g4 (g3 (- 6))) (- 424)))
(assert (= (f4 (f4 (- 3))) (- 10)))
(assert (= (g4 (g4 (- 3))) (- 123)))
(check-sat)
