(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 5)) 17))
(assert (= (f1 (g1 3)) 42))
(assert (= (f1 (f2 (- 3))) 11))
(assert (= (f1 (g2 5)) 31))
(assert (= (f1 (f3 6)) 17))
(assert (= (f1 (g3 (- 3))) 31))
(assert (= (g1 (f3 3)) 96))
(assert (= (f1 (g4 6)) 42))
(assert (= (g1 (f4 5)) 96))
(assert (= (f2 (f1 (- 3))) 11))
(assert (= (f2 (g1 5)) (- 63)))
(assert (= (f2 (f2 6)) 11))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 3)) (- 28)))
(assert (= (f2 (g3 6)) (- 63)))
(assert (= (g2 (f3 5)) 50))
(assert (= (g2 (f4 (- 3))) (- 28)))
(assert (= (f2 (f4 3)) (- 9)))
(assert (= (g2 (g4 3)) 90))
(assert (= (f3 (f1 6)) 17))
(assert (= (f3 (g1 (- 3))) 35))
(assert (= (g3 (f1 3)) 90))
(assert (= (f3 (g2 6)) 35))
(assert (= (g3 (f2 5)) 75))
(assert (= (g3 (f3 (- 3))) 75))
(assert (= (f3 (f3 3)) 13))
(assert (= (g3 (g3 3)) 300))
(assert (= (g3 (f4 6)) 90))
(assert (= (f3 (f4 5)) 13))
(assert (= (g3 (g4 5)) 300))
(assert (= (f4 (g1 6)) 75))
(assert (= (g4 (f1 5)) 66))
(assert (= (g4 (f2 (- 3))) 30))
(assert (= (f4 (f2 3)) (- 9)))
(assert (= (g4 (g2 3)) 90))
(assert (= (g4 (f3 6)) 66))
(assert (= (f4 (f3 5)) 13))
(assert (= (g4 (g3 5)) 300))
(assert (= (f4 (f4 (- 3))) (- 9)))
(assert (= (g4 (g4 (- 3))) 90))
(check-sat)
