(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 18)))
(assert (= (f1 (g1 2)) 30))
(assert (= (f1 (f2 (- 2))) 9))
(assert (= (f1 (g2 (- 6))) (- 23)))
(assert (= (f1 (f3 6)) (- 18)))
(assert (= (f1 (g3 (- 2))) (- 23)))
(assert (= (g1 (f3 2)) 90))
(assert (= (f1 (g4 6)) 30))
(assert (= (g1 (f4 (- 6))) 90))
(assert (= (f2 (f1 (- 2))) 9))
(assert (= (f2 (g1 (- 6))) (- 68)))
(assert (= (f2 (f2 6)) 9))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 2)) (- 11)))
(assert (= (f2 (g3 6)) (- 68)))
(assert (= (g2 (f3 (- 6))) 33))
(assert (= (g2 (f4 (- 2))) (- 11)))
(assert (= (f2 (f4 2)) (- 6)))
(assert (= (g2 (g4 2)) 24))
(assert (= (f3 (f1 6)) (- 18)))
(assert (= (f3 (g1 (- 2))) (- 24)))
(assert (= (g3 (f1 2)) 88))
(assert (= (f3 (g2 6)) (- 24)))
(assert (= (g3 (f2 (- 6))) 77))
(assert (= (g3 (f3 (- 2))) 77))
(assert (= (f3 (f3 2)) 13))
(assert (= (g3 (g3 2)) 242))
(assert (= (g3 (f4 6)) 88))
(assert (= (f3 (f4 (- 6))) 13))
(assert (= (g3 (g4 (- 6))) 242))
(assert (= (f4 (g1 6)) 74))
(assert (= (g4 (f1 (- 6))) 46))
(assert (= (g4 (f2 (- 2))) 12))
(assert (= (f4 (f2 2)) (- 6)))
(assert (= (g4 (g2 2)) 24))
(assert (= (g4 (f3 6)) 46))
(assert (= (f4 (f3 (- 6))) 13))
(assert (= (g4 (g3 (- 6))) 242))
(assert (= (f4 (f4 (- 2))) (- 6)))
(assert (= (g4 (g4 (- 2))) 24))
(check-sat)
