(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 21)))
(assert (= (f1 (g1 5)) (- 72)))
(assert (= (f1 (f2 6)) (- 19)))
(assert (= (f1 (g2 (- 8))) (- 97)))
(assert (= (f1 (f3 (- 7))) (- 21)))
(assert (= (f1 (g3 6)) (- 97)))
(assert (= (g1 (f3 5)) (- 163)))
(assert (= (f1 (g4 (- 7))) (- 72)))
(assert (= (g1 (f4 (- 8))) (- 163)))
(assert (= (f2 (f1 6)) (- 19)))
(assert (= (f2 (g1 (- 8))) (- 104)))
(assert (= (f2 (f2 (- 7))) (- 19)))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 5)) 132))
(assert (= (f2 (g3 (- 7))) (- 104)))
(assert (= (g2 (f3 (- 8))) 180))
(assert (= (g2 (f4 6)) 132))
(assert (= (f2 (f4 5)) 16))
(assert (= (g2 (g4 5)) 600))
(assert (= (f3 (f1 (- 7))) (- 21)))
(assert (= (f3 (g1 6)) (- 86)))
(assert (= (g3 (f1 5)) (- 173)))
(assert (= (f3 (g2 (- 7))) (- 86)))
(assert (= (g3 (f2 (- 8))) (- 203)))
(assert (= (g3 (f3 6)) (- 203)))
(assert (= (f3 (f3 5)) 20))
(assert (= (g3 (g3 5)) 1125))
(assert (= (g3 (f4 (- 7))) (- 173)))
(assert (= (f3 (f4 (- 8))) 20))
(assert (= (g3 (g4 (- 8))) 1125))
(assert (= (f4 (g1 (- 7))) (- 90)))
(assert (= (g4 (f1 (- 8))) 140))
(assert (= (g4 (f2 6)) 120))
(assert (= (f4 (f2 5)) 16))
(assert (= (g4 (g2 5)) 600))
(assert (= (g4 (f3 (- 7))) 140))
(assert (= (f4 (f3 (- 8))) 20))
(assert (= (g4 (g3 (- 8))) 1125))
(assert (= (f4 (f4 6)) 16))
(assert (= (g4 (g4 6)) 600))
(check-sat)
