(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 0 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 0 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 5)) 17))
(assert (= (f1 (g1 0)) 6))
(assert (= (f1 (f2 7)) 20))
(assert (= (f1 (g2 5)) 76))
(assert (= (f1 (f3 6)) 17))
(assert (= (f1 (g3 7)) 76))
(assert (= (g1 (f3 0)) 60))
(assert (= (f1 (g4 6)) 6))
(assert (= (g1 (f4 5)) 60))
(assert (= (f2 (f1 7)) 20))
(assert (= (f2 (g1 5)) 67))
(assert (= (f2 (f2 6)) 20))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 0)) 98))
(assert (= (f2 (g3 6)) 67))
(assert (= (g2 (f3 5)) 140))
(assert (= (g2 (f4 7)) 98))
(assert (= (f2 (f4 0)) 7))
(assert (= (g2 (g4 0)) 0))
(assert (= (f3 (f1 6)) 17))
(assert (= (f3 (g1 7)) 89))
(assert (= (g3 (f1 0)) 60))
(assert (= (f3 (g2 6)) 89))
(assert (= (g3 (f2 5)) 120))
(assert (= (g3 (f3 7)) 120))
(assert (= (f3 (f3 0)) 10))
(assert (= (g3 (g3 0)) 0))
(assert (= (g3 (f4 6)) 60))
(assert (= (f3 (f4 5)) 10))
(assert (= (g3 (g4 5)) 0))
(assert (= (f4 (g1 6)) 72))
(assert (= (g4 (f1 5)) 0))
(assert (= (g4 (f2 7)) 0))
(assert (= (f4 (f2 0)) 7))
(assert (= (g4 (g2 0)) 0))
(assert (= (g4 (f3 6)) 0))
(assert (= (f4 (f3 5)) 10))
(assert (= (g4 (g3 5)) 0))
(assert (= (f4 (f4 7)) 7))
(assert (= (g4 (g4 7)) 0))
(check-sat)
