(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 17))
(assert (= (f1 (g1 9)) 114))
(assert (= (f1 (f2 8)) 22))
(assert (= (f1 (g2 5)) 86))
(assert (= (f1 (f3 6)) 17))
(assert (= (f1 (g3 8)) 86))
(assert (= (g1 (f3 9)) 168))
(assert (= (f1 (g4 6)) 114))
(assert (= (g1 (f4 5)) 168))
(assert (= (f2 (f1 8)) 22))
(assert (= (f2 (g1 5)) 68))
(assert (= (f2 (f2 6)) 22))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 9)) 272))
(assert (= (f2 (g3 6)) 68))
(assert (= (g2 (f3 5)) 160))
(assert (= (g2 (f4 8)) 272))
(assert (= (f2 (f4 9)) 26))
(assert (= (g2 (g4 9)) 2592))
(assert (= (f3 (f1 6)) 17))
(assert (= (f3 (g1 8)) 101))
(assert (= (g3 (f1 9)) 150))
(assert (= (f3 (g2 6)) 101))
(assert (= (g3 (f2 5)) 130))
(assert (= (g3 (f3 8)) 130))
(assert (= (f3 (f3 9)) 19))
(assert (= (g3 (g3 9)) 900))
(assert (= (g3 (f4 6)) 150))
(assert (= (f3 (f4 5)) 19))
(assert (= (g3 (g4 5)) 900))
(assert (= (f4 (g1 6)) 81))
(assert (= (g4 (f1 5)) 198))
(assert (= (g4 (f2 8)) 288))
(assert (= (f4 (f2 9)) 26))
(assert (= (g4 (g2 9)) 2592))
(assert (= (g4 (f3 6)) 198))
(assert (= (f4 (f3 5)) 19))
(assert (= (g4 (g3 5)) 900))
(assert (= (f4 (f4 8)) 26))
(assert (= (g4 (g4 8)) 2592))
(check-sat)
