(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 1)) 13))
(assert (= (f1 (g1 4)) 54))
(assert (= (f1 (f2 9)) 24))
(assert (= (f1 (g2 1)) 24))
(assert (= (f1 (f3 6)) 13))
(assert (= (f1 (g3 9)) 24))
(assert (= (g1 (f3 4)) 60))
(assert (= (f1 (g4 6)) 54))
(assert (= (g1 (f4 1)) 60))
(assert (= (f2 (f1 9)) 24))
(assert (= (f2 (g1 1)) 21))
(assert (= (f2 (f2 6)) 24))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 4)) 234))
(assert (= (f2 (g3 6)) 21))
(assert (= (g2 (f3 1)) 36))
(assert (= (g2 (f4 9)) 234))
(assert (= (f2 (f4 4)) 17))
(assert (= (g2 (g4 4)) 576))
(assert (= (f3 (f1 6)) 13))
(assert (= (f3 (g1 9)) 109))
(assert (= (g3 (f1 4)) 20))
(assert (= (f3 (g2 6)) 109))
(assert (= (g3 (f2 1)) 20))
(assert (= (g3 (f3 9)) 20))
(assert (= (f3 (f3 4)) 6))
(assert (= (g3 (g3 4)) 16))
(assert (= (g3 (f4 6)) 20))
(assert (= (f3 (f4 1)) 6))
(assert (= (g3 (g4 1)) 16))
(assert (= (f4 (g1 6)) 76))
(assert (= (g4 (f1 1)) 56))
(assert (= (g4 (f2 9)) 144))
(assert (= (f4 (f2 4)) 17))
(assert (= (g4 (g2 4)) 576))
(assert (= (g4 (f3 6)) 56))
(assert (= (f4 (f3 1)) 6))
(assert (= (g4 (g3 1)) 16))
(assert (= (f4 (f4 9)) 17))
(assert (= (g4 (g4 9)) 576))
(check-sat)
