(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 6 x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 6 x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f2 x)))))
(assert (= (f1 (f1 8)) 20))
(assert (= (f1 (g1 (- 5))) 60))
(assert (= (f1 (f2 9)) 24))
(assert (= (f1 (g2 8)) 150))
(assert (= (f1 (f3 6)) 20))
(assert (= (f1 (g3 9)) 150))
(assert (= (g1 (f3 (- 5))) 150))
(assert (= (f1 (g4 6)) 60))
(assert (= (g1 (f4 8)) 150))
(assert (= (f2 (f1 9)) 24))
(assert (= (f2 (g1 8)) 105))
(assert (= (f2 (f2 6)) 24))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 5))) 243))
(assert (= (f2 (g3 6)) 105))
(assert (= (g2 (f3 8)) 288))
(assert (= (g2 (f4 9)) 243))
(assert (= (f2 (f4 (- 5))) 18))
(assert (= (g2 (g4 (- 5))) 729))
(assert (= (f3 (f1 6)) 20))
(assert (= (f3 (g1 9)) 116))
(assert (= (g3 (f1 (- 5))) 168))
(assert (= (f3 (g2 6)) 116))
(assert (= (g3 (f2 8)) 272))
(assert (= (g3 (f3 9)) 272))
(assert (= (f3 (f3 (- 5))) (- 21)))
(assert (= (g3 (g3 (- 5))) 1152))
(assert (= (g3 (f4 6)) 168))
(assert (= (f3 (f4 8)) (- 21)))
(assert (= (g3 (g4 8)) 1152))
(assert (= (f4 (g1 6)) (- 77)))
(assert (= (g4 (f1 8)) 126))
(assert (= (g4 (f2 9)) 162))
(assert (= (f4 (f2 (- 5))) 18))
(assert (= (g4 (g2 (- 5))) 729))
(assert (= (g4 (f3 6)) 126))
(assert (= (f4 (f3 8)) (- 21)))
(assert (= (g4 (g3 8)) 1152))
(assert (= (f4 (f4 9)) 18))
(assert (= (g4 (g4 9)) 729))
(check-sat)
