(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 20)))
(assert (= (f1 (g1 (- 7))) 98))
(assert (= (f1 (f2 (- 9))) 24))
(assert (= (f1 (g2 (- 6))) (- 101)))
(assert (= (f1 (f3 7)) (- 20)))
(assert (= (f1 (g3 (- 9))) (- 101)))
(assert (= (g1 (f3 (- 7))) 168))
(assert (= (f1 (g4 7)) 98))
(assert (= (g1 (f4 (- 6))) 168))
(assert (= (f2 (f1 (- 9))) 24))
(assert (= (f2 (g1 (- 6))) (- 86)))
(assert (= (f2 (f2 7)) 24))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 7))) 255))
(assert (= (f2 (g3 7)) (- 86)))
(assert (= (g2 (f3 (- 6))) 187))
(assert (= (g2 (f4 (- 9))) 255))
(assert (= (f2 (f4 (- 7))) (- 22)))
(assert (= (g2 (g4 (- 7))) (- 1437)))
(assert (= (f3 (f1 7)) (- 20)))
(assert (= (f3 (g1 (- 9))) (- 125)))
(assert (= (g3 (f1 (- 7))) (- 149)))
(assert (= (f3 (g2 7)) (- 125)))
(assert (= (g3 (f2 (- 6))) 154))
(assert (= (g3 (f3 (- 9))) 154))
(assert (= (f3 (f3 (- 7))) (- 18)))
(assert (= (g3 (g3 (- 7))) (- 787)))
(assert (= (g3 (f4 7)) (- 149)))
(assert (= (f3 (f4 (- 6))) (- 18)))
(assert (= (g3 (g4 (- 6))) (- 787)))
(assert (= (f4 (g1 7)) (- 105)))
(assert (= (g4 (f1 (- 6))) (- 163)))
(assert (= (g4 (f2 (- 9))) 221))
(assert (= (f4 (f2 (- 7))) (- 22)))
(assert (= (g4 (g2 (- 7))) (- 1437)))
(assert (= (g4 (f3 7)) (- 163)))
(assert (= (f4 (f3 (- 6))) (- 18)))
(assert (= (g4 (g3 (- 6))) (- 787)))
(assert (= (f4 (f4 (- 9))) (- 22)))
(assert (= (g4 (g4 (- 9))) (- 1437)))
(check-sat)
