(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 6)) 19))
(assert (= (f1 (g1 (- 5))) 65))
(assert (= (f1 (f2 7)) (- 21)))
(assert (= (f1 (g2 6)) (- 91)))
(assert (= (f1 (f3 (- 7))) 19))
(assert (= (f1 (g3 7)) (- 91)))
(assert (= (g1 (f3 (- 5))) (- 137)))
(assert (= (f1 (g4 (- 7))) 65))
(assert (= (g1 (f4 6)) (- 137)))
(assert (= (f2 (f1 7)) (- 21)))
(assert (= (f2 (g1 6)) 85))
(assert (= (f2 (f2 (- 7))) (- 21)))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 5))) 161))
(assert (= (f2 (g3 (- 7))) 85))
(assert (= (g2 (f3 6)) 168))
(assert (= (g2 (f4 7)) 161))
(assert (= (f2 (f4 (- 5))) 16))
(assert (= (g2 (g4 (- 5))) 567))
(assert (= (f3 (f1 (- 7))) 19))
(assert (= (f3 (g1 7)) 97))
(assert (= (g3 (f1 (- 5))) 132))
(assert (= (f3 (g2 (- 7))) 97))
(assert (= (g3 (f2 6)) 156))
(assert (= (g3 (f3 7)) 156))
(assert (= (f3 (f3 (- 5))) (- 17)))
(assert (= (g3 (g3 (- 5))) 648))
(assert (= (g3 (f4 (- 7))) 132))
(assert (= (f3 (f4 6)) (- 17)))
(assert (= (g3 (g4 6)) 648))
(assert (= (f4 (g1 (- 7))) 89))
(assert (= (g4 (f1 6)) (- 113)))
(assert (= (g4 (f2 7)) 126))
(assert (= (f4 (f2 (- 5))) 16))
(assert (= (g4 (g2 (- 5))) 567))
(assert (= (g4 (f3 (- 7))) (- 113)))
(assert (= (f4 (f3 6)) (- 17)))
(assert (= (g4 (g3 6)) 648))
(assert (= (f4 (f4 7)) 16))
(assert (= (g4 (g4 7)) 567))
(check-sat)
