(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 5)) 18))
(assert (= (f1 (g1 2)) (- 33)))
(assert (= (f1 (f2 8)) (- 23)))
(assert (= (f1 (g2 5)) (- 87)))
(assert (= (f1 (f3 (- 7))) 18))
(assert (= (f1 (g3 8)) (- 87)))
(assert (= (g1 (f3 2)) 91))
(assert (= (f1 (g4 (- 7))) (- 33)))
(assert (= (g1 (f4 5)) 91))
(assert (= (f2 (f1 8)) (- 23)))
(assert (= (f2 (g1 5)) 73))
(assert (= (f2 (f2 (- 7))) (- 23)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 2)) 160))
(assert (= (f2 (g3 (- 7))) 73))
(assert (= (g2 (f3 5)) 160))
(assert (= (g2 (f4 8)) 160))
(assert (= (f2 (f4 2)) 12))
(assert (= (g2 (g4 2)) 128))
(assert (= (f3 (f1 (- 7))) 18))
(assert (= (f3 (g1 8)) 109))
(assert (= (g3 (f1 2)) 85))
(assert (= (f3 (g2 (- 7))) 109))
(assert (= (g3 (f2 5)) 130))
(assert (= (g3 (f3 8)) 130))
(assert (= (f3 (f3 2)) 12))
(assert (= (g3 (g3 2)) 200))
(assert (= (g3 (f4 (- 7))) 85))
(assert (= (f3 (f4 5)) 12))
(assert (= (g3 (g4 5)) 200))
(assert (= (f4 (g1 (- 7))) (- 87)))
(assert (= (g4 (f1 5)) 46))
(assert (= (g4 (f2 8)) 64))
(assert (= (f4 (f2 2)) 12))
(assert (= (g4 (g2 2)) 128))
(assert (= (g4 (f3 (- 7))) 46))
(assert (= (f4 (f3 5)) 12))
(assert (= (g4 (g3 5)) 200))
(assert (= (f4 (f4 8)) 12))
(assert (= (g4 (g4 8)) 128))
(check-sat)
