(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 19)))
(assert (= (f1 (g1 (- 3))) 42))
(assert (= (f1 (f2 2)) 11))
(assert (= (f1 (g2 (- 5))) 25))
(assert (= (f1 (f3 7)) (- 19)))
(assert (= (f1 (g3 2)) 25))
(assert (= (g1 (f3 (- 3))) 98))
(assert (= (f1 (g4 7)) 42))
(assert (= (g1 (f4 (- 5))) 98))
(assert (= (f2 (f1 2)) 11))
(assert (= (f2 (g1 (- 5))) 65))
(assert (= (f2 (f2 7)) 11))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 3))) 18))
(assert (= (f2 (g3 7)) 65))
(assert (= (g2 (f3 (- 5))) 36))
(assert (= (g2 (f4 2)) 18))
(assert (= (f2 (f4 (- 3))) 7))
(assert (= (g2 (g4 (- 3))) 50))
(assert (= (f3 (f1 7)) (- 19)))
(assert (= (f3 (g1 2)) (- 33)))
(assert (= (g3 (f1 (- 3))) (- 86)))
(assert (= (f3 (g2 7)) (- 33)))
(assert (= (g3 (f2 (- 5))) (- 59)))
(assert (= (g3 (f3 2)) (- 59)))
(assert (= (f3 (f3 (- 3))) (- 12)))
(assert (= (g3 (g3 (- 3))) (- 203)))
(assert (= (g3 (f4 7)) (- 86)))
(assert (= (f3 (f4 (- 5))) (- 12)))
(assert (= (g3 (g4 (- 5))) (- 203)))
(assert (= (f4 (g1 7)) (- 101)))
(assert (= (g4 (f1 (- 5))) (- 58)))
(assert (= (g4 (f2 2)) 20))
(assert (= (f4 (f2 (- 3))) 7))
(assert (= (g4 (g2 (- 3))) 50))
(assert (= (g4 (f3 7)) (- 58)))
(assert (= (f4 (f3 (- 5))) (- 12)))
(assert (= (g4 (g3 (- 5))) (- 203)))
(assert (= (f4 (f4 2)) 7))
(assert (= (g4 (g4 2)) 50))
(check-sat)
