(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 7) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 7) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 4)) 17))
(assert (= (f1 (g1 (- 3))) 39))
(assert (= (f1 (f2 9)) (- 25)))
(assert (= (f1 (g2 4)) (- 79)))
(assert (= (f1 (f3 (- 7))) 17))
(assert (= (f1 (g3 9)) (- 79)))
(assert (= (g1 (f3 (- 3))) (- 85)))
(assert (= (f1 (g4 (- 7))) 39))
(assert (= (g1 (f4 4)) (- 85)))
(assert (= (f2 (f1 9)) (- 25)))
(assert (= (f2 (g1 4)) 61))
(assert (= (f2 (f2 (- 7))) (- 25)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 3))) 207))
(assert (= (f2 (g3 (- 7))) 61))
(assert (= (g2 (f3 4)) 144))
(assert (= (g2 (f4 9)) 207))
(assert (= (f2 (f4 (- 3))) 14))
(assert (= (g2 (g4 (- 3))) 225))
(assert (= (f3 (f1 (- 7))) 17))
(assert (= (f3 (g1 9)) 121))
(assert (= (g3 (f1 (- 3))) 72))
(assert (= (f3 (g2 (- 7))) 121))
(assert (= (g3 (f2 4)) 104))
(assert (= (g3 (f3 9)) 104))
(assert (= (f3 (f3 (- 3))) (- 11)))
(assert (= (g3 (g3 (- 3))) 160))
(assert (= (g3 (f4 (- 7))) 72))
(assert (= (f3 (f4 4)) (- 11)))
(assert (= (g3 (g4 4)) 160))
(assert (= (f4 (g1 (- 7))) 87))
(assert (= (g4 (f1 4)) (- 53)))
(assert (= (g4 (f2 9)) 90))
(assert (= (f4 (f2 (- 3))) 14))
(assert (= (g4 (g2 (- 3))) 225))
(assert (= (g4 (f3 (- 7))) (- 53)))
(assert (= (f4 (f3 4)) (- 11)))
(assert (= (g4 (g3 4)) 160))
(assert (= (f4 (f4 9)) 14))
(assert (= (g4 (g4 9)) 225))
(check-sat)
