(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 17))
(assert (= (f1 (g1 9)) 133))
(assert (= (f1 (f2 5)) 17))
(assert (= (f1 (g2 3)) 37))
(assert (= (f1 (f3 7)) 17))
(assert (= (f1 (g3 5)) 37))
(assert (= (g1 (f3 9)) 168))
(assert (= (f1 (g4 7)) 133))
(assert (= (g1 (f4 3)) 168))
(assert (= (f2 (f1 5)) 17))
(assert (= (f2 (g1 3)) 47))
(assert (= (f2 (f2 7)) 17))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 9)) 140))
(assert (= (f2 (g3 7)) 47))
(assert (= (g2 (f3 3)) 60))
(assert (= (g2 (f4 5)) 140))
(assert (= (f2 (f4 9)) 23))
(assert (= (g2 (g4 9)) 1620))
(assert (= (f3 (f1 7)) 17))
(assert (= (f3 (g1 5)) 73))
(assert (= (g3 (f1 9)) 96))
(assert (= (f3 (g2 7)) 73))
(assert (= (g3 (f2 3)) 48))
(assert (= (g3 (f3 5)) 48))
(assert (= (f3 (f3 9)) 15))
(assert (= (g3 (g3 9)) 324))
(assert (= (g3 (f4 7)) 96))
(assert (= (f3 (f4 3)) 15))
(assert (= (g3 (g4 3)) 324))
(assert (= (f4 (g1 7)) 107))
(assert (= (g4 (f1 3)) 180))
(assert (= (g4 (f2 5)) 180))
(assert (= (f4 (f2 9)) 23))
(assert (= (g4 (g2 9)) 1620))
(assert (= (g4 (f3 7)) 180))
(assert (= (f4 (f3 3)) 15))
(assert (= (g4 (g3 3)) 324))
(assert (= (f4 (f4 5)) 23))
(assert (= (g4 (g4 5)) 1620))
(check-sat)
