(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 6)) 20))
(assert (= (f1 (g1 (- 8))) 112))
(assert (= (f1 (f2 5)) 17))
(assert (= (f1 (g2 6)) 67))
(assert (= (f1 (f3 7)) 20))
(assert (= (f1 (g3 5)) 67))
(assert (= (g1 (f3 (- 8))) 189))
(assert (= (f1 (g4 7)) 112))
(assert (= (g1 (f4 6)) 189))
(assert (= (f2 (f1 5)) 17))
(assert (= (f2 (g1 6)) 89))
(assert (= (f2 (f2 7)) 17))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 8))) 125))
(assert (= (f2 (g3 7)) 89))
(assert (= (g2 (f3 6)) 120))
(assert (= (g2 (f4 5)) 125))
(assert (= (f2 (f4 (- 8))) 20))
(assert (= (g2 (g4 (- 8))) 1125))
(assert (= (f3 (f1 7)) 20))
(assert (= (f3 (g1 5)) 76))
(assert (= (g3 (f1 (- 8))) 174))
(assert (= (f3 (g2 7)) 76))
(assert (= (g3 (f2 6)) 132))
(assert (= (g3 (f3 5)) 132))
(assert (= (f3 (f3 (- 8))) (- 20)))
(assert (= (g3 (g3 (- 8))) 1080))
(assert (= (g3 (f4 7)) 174))
(assert (= (f3 (f4 6)) (- 20)))
(assert (= (g3 (g4 6)) 1080))
(assert (= (f4 (g1 7)) (- 106)))
(assert (= (g4 (f1 6)) 195))
(assert (= (g4 (f2 5)) 150))
(assert (= (f4 (f2 (- 8))) 20))
(assert (= (g4 (g2 (- 8))) 1125))
(assert (= (g4 (f3 7)) 195))
(assert (= (f4 (f3 6)) (- 20)))
(assert (= (g4 (g3 6)) 1080))
(assert (= (f4 (f4 5)) 20))
(assert (= (g4 (g4 5)) 1125))
(check-sat)
