(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 7 x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua 9 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 7 x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num 9 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 9)) 23))
(assert (= (f1 (g1 4)) 63))
(assert (= (f1 (f2 6)) 19))
(assert (= (f1 (g2 9)) 115))
(assert (= (f1 (f3 7)) 23))
(assert (= (f1 (g3 6)) 115))
(assert (= (g1 (f3 4)) 182))
(assert (= (f1 (g4 7)) 63))
(assert (= (g1 (f4 9)) 182))
(assert (= (f2 (f1 6)) 19))
(assert (= (f2 (g1 9)) 132))
(assert (= (f2 (f2 7)) 19))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 4)) 120))
(assert (= (f2 (g3 7)) 132))
(assert (= (g2 (f3 9)) 216))
(assert (= (g2 (f4 6)) 120))
(assert (= (f2 (f4 4)) 14))
(assert (= (g2 (g4 4)) 384))
(assert (= (f3 (f1 7)) 23))
(assert (= (f3 (g1 6)) 93))
(assert (= (g3 (f1 4)) 198))
(assert (= (f3 (g2 7)) 93))
(assert (= (g3 (f2 9)) 270))
(assert (= (g3 (f3 6)) 270))
(assert (= (f3 (f3 4)) 22))
(assert (= (g3 (g3 4)) 1296))
(assert (= (g3 (f4 7)) 198))
(assert (= (f3 (f4 9)) 22))
(assert (= (g3 (g4 9)) 1296))
(assert (= (f4 (g1 7)) 102))
(assert (= (g4 (f1 9)) 128))
(assert (= (g4 (f2 6)) 96))
(assert (= (f4 (f2 4)) 14))
(assert (= (g4 (g2 4)) 384))
(assert (= (g4 (f3 7)) 128))
(assert (= (f4 (f3 9)) 22))
(assert (= (g4 (g3 9)) 1296))
(assert (= (f4 (f4 6)) 14))
(assert (= (g4 (g4 6)) 384))
(check-sat)
