(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 20))
(assert (= (f1 (g1 (- 7))) 112))
(assert (= (f1 (f2 (- 3))) 13))
(assert (= (f1 (g2 4)) 28))
(assert (= (f1 (f3 8)) 20))
(assert (= (f1 (g3 (- 3))) 28))
(assert (= (g1 (f3 (- 7))) 168))
(assert (= (f1 (g4 8)) 112))
(assert (= (g1 (f4 4)) 168))
(assert (= (f2 (f1 (- 3))) 13))
(assert (= (f2 (g1 4)) (- 67)))
(assert (= (f2 (f2 8)) 13))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 7))) 45))
(assert (= (f2 (g3 8)) (- 67)))
(assert (= (g2 (f3 4)) 40))
(assert (= (g2 (f4 (- 3))) 45))
(assert (= (f2 (f4 (- 7))) (- 16)))
(assert (= (g2 (g4 (- 7))) (- 423)))
(assert (= (f3 (f1 8)) 20))
(assert (= (f3 (g1 (- 3))) 44))
(assert (= (g3 (f1 (- 7))) 116))
(assert (= (f3 (g2 8)) 44))
(assert (= (g3 (f2 4)) 52))
(assert (= (g3 (f3 (- 3))) 52))
(assert (= (f3 (f3 (- 7))) (- 15)))
(assert (= (g3 (g3 (- 7))) 416))
(assert (= (g3 (f4 8)) 116))
(assert (= (f3 (f4 4)) (- 15)))
(assert (= (g3 (g4 4)) 416))
(assert (= (f4 (g1 8)) (- 135)))
(assert (= (g4 (f1 4)) 156))
(assert (= (g4 (f2 (- 3))) 65))
(assert (= (f4 (f2 (- 7))) (- 16)))
(assert (= (g4 (g2 (- 7))) (- 423)))
(assert (= (g4 (f3 8)) 156))
(assert (= (f4 (f3 4)) (- 15)))
(assert (= (g4 (g3 4)) 416))
(assert (= (f4 (f4 (- 3))) (- 16)))
(assert (= (g4 (g4 (- 3))) (- 423)))
(check-sat)
