(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 21)))
(assert (= (f1 (g1 (- 4))) 64))
(assert (= (f1 (f2 1)) 10))
(assert (= (f1 (g2 (- 5))) 17))
(assert (= (f1 (f3 8)) (- 21)))
(assert (= (f1 (g3 1)) 17))
(assert (= (g1 (f3 (- 4))) 128))
(assert (= (f1 (g4 8)) 64))
(assert (= (g1 (f4 (- 5))) 128))
(assert (= (f2 (f1 1)) 10))
(assert (= (f2 (g1 (- 5))) 73))
(assert (= (f2 (f2 8)) 10))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 4))) 9))
(assert (= (f2 (g3 8)) 73))
(assert (= (g2 (f3 (- 5))) 18))
(assert (= (g2 (f4 1)) 9))
(assert (= (f2 (f4 (- 4))) 8))
(assert (= (g2 (g4 (- 4))) 49))
(assert (= (f3 (f1 8)) (- 21)))
(assert (= (f3 (g1 1)) (- 21)))
(assert (= (g3 (f1 (- 4))) (- 104)))
(assert (= (f3 (g2 8)) (- 21)))
(assert (= (g3 (f2 (- 5))) (- 50)))
(assert (= (g3 (f3 1)) (- 50)))
(assert (= (f3 (f3 (- 4))) (- 13)))
(assert (= (g3 (g3 (- 4))) (- 284)))
(assert (= (g3 (f4 8)) (- 104)))
(assert (= (f3 (f4 (- 5))) (- 13)))
(assert (= (g3 (g4 (- 5))) (- 284)))
(assert (= (f4 (g1 8)) (- 132)))
(assert (= (g4 (f1 (- 5))) (- 88)))
(assert (= (g4 (f2 1)) 14))
(assert (= (f4 (f2 (- 4))) 8))
(assert (= (g4 (g2 (- 4))) 49))
(assert (= (g4 (f3 8)) (- 88)))
(assert (= (f4 (f3 (- 5))) (- 13)))
(assert (= (g4 (g3 (- 5))) (- 284)))
(assert (= (f4 (f4 1)) 8))
(assert (= (g4 (g4 1)) 49))
(check-sat)
