(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 21)))
(assert (= (f1 (g1 7)) 120))
(assert (= (f1 (f2 1)) 10))
(assert (= (f1 (g2 (- 5))) 17))
(assert (= (f1 (f3 8)) (- 21)))
(assert (= (f1 (g3 1)) 17))
(assert (= (g1 (f3 7)) 184))
(assert (= (f1 (g4 8)) 120))
(assert (= (g1 (f4 (- 5))) 184))
(assert (= (f2 (f1 1)) 10))
(assert (= (f2 (g1 (- 5))) 73))
(assert (= (f2 (f2 8)) 10))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 7)) 16))
(assert (= (f2 (g3 8)) 73))
(assert (= (g2 (f3 (- 5))) 18))
(assert (= (g2 (f4 1)) 16))
(assert (= (f2 (f4 7)) 15))
(assert (= (g2 (g4 7)) 196))
(assert (= (f3 (f1 8)) (- 21)))
(assert (= (f3 (g1 1)) (- 21)))
(assert (= (g3 (f1 7)) 135))
(assert (= (f3 (g2 8)) (- 21)))
(assert (= (g3 (f2 (- 5))) (- 50)))
(assert (= (g3 (f3 1)) (- 50)))
(assert (= (f3 (f3 7)) 16))
(assert (= (g3 (g3 7)) 567))
(assert (= (g3 (f4 8)) 135))
(assert (= (f3 (f4 (- 5))) 16))
(assert (= (g3 (g4 (- 5))) 567))
(assert (= (f4 (g1 8)) 135))
(assert (= (g4 (f1 (- 5))) 175))
(assert (= (g4 (f2 1)) 28))
(assert (= (f4 (f2 7)) 15))
(assert (= (g4 (g2 7)) 196))
(assert (= (g4 (f3 8)) 175))
(assert (= (f4 (f3 (- 5))) 16))
(assert (= (g4 (g3 (- 5))) 567))
(assert (= (f4 (f4 1)) 15))
(assert (= (g4 (g4 1)) 196))
(check-sat)
