(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 5 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 5 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 18)))
(assert (= (f1 (g1 5)) (- 61)))
(assert (= (f1 (f2 (- 8))) (- 21)))
(assert (= (f1 (g2 (- 7))) 103))
(assert (= (f1 (f3 (- 6))) (- 18)))
(assert (= (f1 (g3 (- 8))) 103))
(assert (= (g1 (f3 5)) (- 127)))
(assert (= (f1 (g4 (- 6))) (- 61)))
(assert (= (g1 (f4 (- 7))) (- 127)))
(assert (= (f2 (f1 (- 8))) (- 21)))
(assert (= (f2 (g1 (- 7))) 79))
(assert (= (f2 (f2 (- 6))) (- 21)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 5)) (- 188)))
(assert (= (f2 (g3 (- 6))) 79))
(assert (= (g2 (f3 (- 7))) 195))
(assert (= (g2 (f4 (- 8))) (- 188)))
(assert (= (f2 (f4 5)) (- 18)))
(assert (= (g2 (g4 5)) 750))
(assert (= (f3 (f1 (- 6))) (- 18)))
(assert (= (f3 (g1 (- 8))) 89))
(assert (= (g3 (f1 5)) (- 137)))
(assert (= (f3 (g2 (- 6))) 89))
(assert (= (g3 (f2 (- 7))) 182))
(assert (= (g3 (f3 (- 8))) 182))
(assert (= (f3 (f3 5)) 18))
(assert (= (g3 (g3 5)) 845))
(assert (= (g3 (f4 (- 6))) (- 137)))
(assert (= (f3 (f4 (- 7))) 18))
(assert (= (g3 (g4 (- 7))) 845))
(assert (= (f4 (g1 (- 6))) (- 66)))
(assert (= (g4 (f1 (- 7))) 120))
(assert (= (g4 (f2 (- 8))) 150))
(assert (= (f4 (f2 5)) (- 18)))
(assert (= (g4 (g2 5)) 750))
(assert (= (g4 (f3 (- 6))) 120))
(assert (= (f4 (f3 (- 7))) 18))
(assert (= (g4 (g3 (- 7))) 845))
(assert (= (f4 (f4 (- 8))) (- 18)))
(assert (= (g4 (g4 (- 8))) 750))
(check-sat)
