(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 21))
(assert (= (f1 (g1 6)) 104))
(assert (= (f1 (f2 3)) 14))
(assert (= (f1 (g2 5)) 38))
(assert (= (f1 (f3 8)) 21))
(assert (= (f1 (g3 3)) 38))
(assert (= (g1 (f3 6)) 176))
(assert (= (f1 (g4 8)) 104))
(assert (= (g1 (f4 5)) 176))
(assert (= (f2 (f1 3)) 14))
(assert (= (f2 (g1 5)) 83))
(assert (= (f2 (f2 8)) 14))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 6)) 54))
(assert (= (f2 (g3 8)) 83))
(assert (= (g2 (f3 5)) 60))
(assert (= (g2 (f4 3)) 54))
(assert (= (f2 (f4 6)) 15))
(assert (= (g2 (g4 6)) 432))
(assert (= (f3 (f1 8)) 21))
(assert (= (f3 (g1 3)) 53))
(assert (= (g3 (f1 6)) 140))
(assert (= (f3 (g2 8)) 53))
(assert (= (g3 (f2 5)) 80))
(assert (= (g3 (f3 3)) 80))
(assert (= (f3 (f3 6)) 16))
(assert (= (g3 (g3 6)) 600))
(assert (= (g3 (f4 8)) 140))
(assert (= (f3 (f4 5)) 16))
(assert (= (g3 (g4 5)) 600))
(assert (= (f4 (g1 8)) 134))
(assert (= (g4 (f1 5)) 156))
(assert (= (g4 (f2 3)) 72))
(assert (= (f4 (f2 6)) 15))
(assert (= (g4 (g2 6)) 432))
(assert (= (g4 (f3 8)) 156))
(assert (= (f4 (f3 5)) 16))
(assert (= (g4 (g3 5)) 600))
(assert (= (f4 (f4 3)) 15))
(assert (= (g4 (g4 3)) 432))
(check-sat)
