(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 23)))
(assert (= (f1 (g1 (- 9))) 144))
(assert (= (f1 (f2 5)) 18))
(assert (= (f1 (g2 (- 7))) 73))
(assert (= (f1 (f3 8)) (- 23)))
(assert (= (f1 (g3 5)) 73))
(assert (= (g1 (f3 (- 9))) 240))
(assert (= (f1 (g4 8)) 144))
(assert (= (g1 (f4 (- 7))) 240))
(assert (= (f2 (f1 5)) 18))
(assert (= (f2 (g1 (- 7))) 109))
(assert (= (f2 (f2 8)) 18))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 9))) 135))
(assert (= (f2 (g3 8)) 109))
(assert (= (g2 (f3 (- 7))) 130))
(assert (= (g2 (f4 5)) 135))
(assert (= (f2 (f4 (- 9))) 22))
(assert (= (g2 (g4 (- 9))) 1445))
(assert (= (f3 (f1 8)) (- 23)))
(assert (= (f3 (g1 5)) (- 87)))
(assert (= (g3 (f1 (- 9))) (- 215)))
(assert (= (f3 (g2 8)) (- 87)))
(assert (= (g3 (f2 (- 7))) (- 150)))
(assert (= (g3 (f3 5)) (- 150)))
(assert (= (f3 (f3 (- 9))) (- 22)))
(assert (= (g3 (g3 (- 9))) (- 1437)))
(assert (= (g3 (f4 8)) (- 215)))
(assert (= (f3 (f4 (- 7))) (- 22)))
(assert (= (g3 (g4 (- 7))) (- 1437)))
(assert (= (f4 (g1 8)) (- 137)))
(assert (= (g4 (f1 (- 7))) (- 247)))
(assert (= (g4 (f2 5)) 170))
(assert (= (f4 (f2 (- 9))) 22))
(assert (= (g4 (g2 (- 9))) 1445))
(assert (= (g4 (f3 8)) (- 247)))
(assert (= (f4 (f3 (- 7))) (- 22)))
(assert (= (g4 (g3 (- 7))) (- 1437)))
(assert (= (f4 (f4 5)) 22))
(assert (= (g4 (g4 5)) 1445))
(check-sat)
