(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 8 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num 8 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 22))
(assert (= (f1 (g1 7)) 120))
(assert (= (f1 (f2 5)) 18))
(assert (= (f1 (g2 6)) 68))
(assert (= (f1 (f3 8)) 22))
(assert (= (f1 (g3 5)) 68))
(assert (= (g1 (f3 7)) 208))
(assert (= (f1 (g4 8)) 120))
(assert (= (g1 (f4 6)) 208))
(assert (= (f2 (f1 5)) 18))
(assert (= (f2 (g1 6)) 101))
(assert (= (f2 (f2 8)) 18))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 7)) 120))
(assert (= (f2 (g3 8)) 101))
(assert (= (g2 (f3 6)) 120))
(assert (= (g2 (f4 5)) 120))
(assert (= (f2 (f4 7)) 19))
(assert (= (g2 (g4 7)) 980))
(assert (= (f3 (f1 8)) 22))
(assert (= (f3 (g1 5)) 86))
(assert (= (g3 (f1 7)) 180))
(assert (= (f3 (g2 8)) 86))
(assert (= (g3 (f2 6)) 132))
(assert (= (g3 (f3 5)) 132))
(assert (= (f3 (f3 7)) 19))
(assert (= (g3 (g3 7)) 1008))
(assert (= (g3 (f4 8)) 180))
(assert (= (f3 (f4 6)) 19))
(assert (= (g3 (g4 6)) 1008))
(assert (= (f4 (g1 8)) 135))
(assert (= (g4 (f1 6)) 196))
(assert (= (g4 (f2 5)) 140))
(assert (= (f4 (f2 7)) 19))
(assert (= (g4 (g2 7)) 980))
(assert (= (g4 (f3 8)) 196))
(assert (= (f4 (f3 6)) 19))
(assert (= (g4 (g3 6)) 1008))
(assert (= (f4 (f4 5)) 19))
(assert (= (g4 (g4 5)) 980))
(check-sat)
