(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 27)))
(assert (= (f1 (g1 8)) 153))
(assert (= (f1 (f2 (- 8))) 24))
(assert (= (f1 (g2 (- 9))) (- 137)))
(assert (= (f1 (f3 9)) (- 27)))
(assert (= (f1 (g3 (- 8))) (- 137)))
(assert (= (g1 (f3 8)) 297))
(assert (= (f1 (g4 9)) 153))
(assert (= (g1 (f4 (- 9))) 297))
(assert (= (f2 (f1 (- 8))) 24))
(assert (= (f2 (g1 (- 9))) (- 161)))
(assert (= (f2 (f2 9)) 24))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 8)) (- 233)))
(assert (= (f2 (g3 9)) (- 161)))
(assert (= (g2 (f3 (- 9))) 255))
(assert (= (g2 (f4 (- 8))) (- 233)))
(assert (= (f2 (f4 8)) (- 24)))
(assert (= (g2 (g4 8)) 1920))
(assert (= (f3 (f1 9)) (- 27)))
(assert (= (f3 (g1 (- 8))) (- 144)))
(assert (= (g3 (f1 8)) 289))
(assert (= (f3 (g2 9)) (- 144)))
(assert (= (g3 (f2 (- 9))) 272))
(assert (= (g3 (f3 (- 8))) 272))
(assert (= (f3 (f3 8)) 25))
(assert (= (g3 (g3 8)) 2312))
(assert (= (g3 (f4 9)) 289))
(assert (= (f3 (f4 (- 9))) 25))
(assert (= (g3 (g4 (- 9))) 2312))
(assert (= (f4 (g1 9)) 170))
(assert (= (g4 (f1 (- 9))) 280))
(assert (= (g4 (f2 (- 8))) 240))
(assert (= (f4 (f2 8)) (- 24)))
(assert (= (g4 (g2 8)) 1920))
(assert (= (g4 (f3 9)) 280))
(assert (= (f4 (f3 (- 9))) 25))
(assert (= (g4 (g3 (- 9))) 2312))
(assert (= (f4 (f4 (- 8))) (- 24)))
(assert (= (g4 (g4 (- 8))) 1920))
(check-sat)
