(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 27)))
(assert (= (f1 (g1 4)) 81))
(assert (= (f1 (f2 (- 4))) 16))
(assert (= (f1 (g2 (- 9))) (- 69)))
(assert (= (f1 (f3 9)) (- 27)))
(assert (= (f1 (g3 (- 4))) (- 69)))
(assert (= (g1 (f3 4)) 225))
(assert (= (f1 (g4 9)) 81))
(assert (= (g1 (f4 (- 9))) 225))
(assert (= (f2 (f1 (- 4))) 16))
(assert (= (f2 (g1 (- 9))) (- 157)))
(assert (= (f2 (f2 9)) 16))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 4)) (- 53)))
(assert (= (f2 (g3 9)) (- 157)))
(assert (= (g2 (f3 (- 9))) 119))
(assert (= (g2 (f4 (- 4))) (- 53)))
(assert (= (f2 (f4 4)) (- 12)))
(assert (= (g2 (g4 4)) 224))
(assert (= (f3 (f1 9)) (- 27)))
(assert (= (f3 (g1 (- 4))) (- 72)))
(assert (= (g3 (f1 4)) 221))
(assert (= (f3 (g2 9)) (- 72)))
(assert (= (g3 (f2 (- 9))) 204))
(assert (= (g3 (f3 (- 4))) 204))
(assert (= (f3 (f3 4)) 21))
(assert (= (g3 (g3 4)) 1156))
(assert (= (g3 (f4 9)) 221))
(assert (= (f3 (f4 (- 9))) 21))
(assert (= (g3 (g4 (- 9))) 1156))
(assert (= (f4 (g1 9)) 166))
(assert (= (g4 (f1 (- 9))) 140))
(assert (= (g4 (f2 (- 4))) 56))
(assert (= (f4 (f2 4)) (- 12)))
(assert (= (g4 (g2 4)) 224))
(assert (= (g4 (f3 9)) 140))
(assert (= (f4 (f3 (- 9))) 21))
(assert (= (g4 (g3 (- 9))) 1156))
(assert (= (f4 (f4 (- 4))) (- 12)))
(assert (= (g4 (g4 (- 4))) 224))
(check-sat)
