(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 23))
(assert (= (f1 (g1 (- 8))) 144))
(assert (= (f1 (f2 (- 4))) 16))
(assert (= (f1 (g2 5)) 44))
(assert (= (f1 (f3 9)) 23))
(assert (= (f1 (g3 (- 4))) 44))
(assert (= (g1 (f3 (- 8))) 225))
(assert (= (f1 (g4 9)) 144))
(assert (= (g1 (f4 5)) 225))
(assert (= (f2 (f1 (- 4))) 16))
(assert (= (f2 (g1 5)) (- 94)))
(assert (= (f2 (f2 9)) 16))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 8))) 77))
(assert (= (f2 (g3 9)) (- 94)))
(assert (= (g2 (f3 5)) 70))
(assert (= (g2 (f4 (- 4))) 77))
(assert (= (f2 (f4 (- 8))) (- 19)))
(assert (= (g2 (g4 (- 8))) (- 788)))
(assert (= (f3 (f1 9)) 23))
(assert (= (f3 (g1 (- 4))) 68))
(assert (= (g3 (f1 (- 8))) 165))
(assert (= (f3 (g2 9)) 68))
(assert (= (g3 (f2 5)) 85))
(assert (= (g3 (f3 (- 4))) 85))
(assert (= (f3 (f3 (- 8))) (- 18)))
(assert (= (g3 (g3 (- 8))) 750))
(assert (= (g3 (f4 9)) 165))
(assert (= (f3 (f4 5)) (- 18)))
(assert (= (g3 (g4 5)) 750))
(assert (= (f4 (g1 9)) (- 170)))
(assert (= (g4 (f1 5)) 210))
(assert (= (g4 (f2 (- 4))) 105))
(assert (= (f4 (f2 (- 8))) (- 19)))
(assert (= (g4 (g2 (- 8))) (- 788)))
(assert (= (g4 (f3 9)) 210))
(assert (= (f4 (f3 5)) (- 18)))
(assert (= (g4 (g3 5)) 750))
(assert (= (f4 (f4 (- 4))) (- 19)))
(assert (= (g4 (g4 (- 4))) (- 788)))
(check-sat)
