(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 26))
(assert (= (f1 (g1 1)) 27))
(assert (= (f1 (f2 (- 4))) 16))
(assert (= (f1 (g2 8)) 65))
(assert (= (f1 (f3 9)) 26))
(assert (= (f1 (g3 (- 4))) 65))
(assert (= (g1 (f3 1)) 162))
(assert (= (f1 (g4 9)) 27))
(assert (= (g1 (f4 8)) 162))
(assert (= (f2 (f1 (- 4))) 16))
(assert (= (f2 (g1 8)) (- 148)))
(assert (= (f2 (f2 9)) 16))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 1)) (- 32)))
(assert (= (f2 (g3 9)) (- 148)))
(assert (= (g2 (f3 8)) 112))
(assert (= (g2 (f4 (- 4))) (- 32)))
(assert (= (f2 (f4 1)) (- 6)))
(assert (= (g2 (g4 1)) 14))
(assert (= (f3 (f1 9)) 26))
(assert (= (f3 (g1 (- 4))) 71))
(assert (= (g3 (f1 1)) 160))
(assert (= (f3 (g2 9)) 71))
(assert (= (g3 (f2 8)) 184))
(assert (= (g3 (f3 (- 4))) 184))
(assert (= (f3 (f3 1)) 17))
(assert (= (g3 (g3 1)) 256))
(assert (= (g3 (f4 9)) 160))
(assert (= (f3 (f4 8)) 17))
(assert (= (g3 (g4 8)) 256))
(assert (= (f4 (g1 9)) 163))
(assert (= (g4 (f1 8)) 34))
(assert (= (g4 (f2 (- 4))) 14))
(assert (= (f4 (f2 1)) (- 6)))
(assert (= (g4 (g2 1)) 14))
(assert (= (g4 (f3 9)) 34))
(assert (= (f4 (f3 8)) 17))
(assert (= (g4 (g3 8)) 256))
(assert (= (f4 (f4 (- 4))) (- 6)))
(assert (= (g4 (g4 (- 4))) 14))
(check-sat)
