(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 21))
(assert (= (f1 (g1 (- 9))) 162))
(assert (= (f1 (f2 (- 3))) 14))
(assert (= (f1 (g2 3)) 24))
(assert (= (f1 (f3 9)) 21))
(assert (= (f1 (g3 (- 3))) 24))
(assert (= (g1 (f3 (- 9))) 207))
(assert (= (f1 (g4 9)) 162))
(assert (= (g1 (f4 3)) 207))
(assert (= (f2 (f1 (- 3))) 14))
(assert (= (f2 (g1 3)) (- 57)))
(assert (= (f2 (f2 9)) 14))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 9))) 55))
(assert (= (f2 (g3 9)) (- 57)))
(assert (= (g2 (f3 3)) 30))
(assert (= (g2 (f4 (- 3))) 55))
(assert (= (f2 (f4 (- 9))) (- 20)))
(assert (= (g2 (g4 (- 9))) (- 723)))
(assert (= (f3 (f1 9)) 21))
(assert (= (f3 (g1 (- 3))) 48))
(assert (= (g3 (f1 (- 9))) 105))
(assert (= (f3 (g2 9)) 48))
(assert (= (g3 (f2 3)) 33))
(assert (= (g3 (f3 (- 3))) 33))
(assert (= (f3 (f3 (- 9))) (- 15)))
(assert (= (g3 (g3 (- 9))) 306))
(assert (= (g3 (f4 9)) 105))
(assert (= (f3 (f4 3)) (- 15)))
(assert (= (g3 (g4 3)) 306))
(assert (= (f4 (g1 9)) (- 171)))
(assert (= (g4 (f1 3)) 204))
(assert (= (g4 (f2 (- 3))) 85))
(assert (= (f4 (f2 (- 9))) (- 20)))
(assert (= (g4 (g2 (- 9))) (- 723)))
(assert (= (g4 (f3 9)) 204))
(assert (= (f4 (f3 3)) (- 15)))
(assert (= (g4 (g3 3)) 306))
(assert (= (f4 (f4 (- 3))) (- 20)))
(assert (= (g4 (g4 (- 3))) (- 723)))
(check-sat)
