(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 27)))
(assert (= (f1 (g1 2)) 45))
(assert (= (f1 (f2 (- 2))) 12))
(assert (= (f1 (g2 (- 9))) (- 35)))
(assert (= (f1 (f3 9)) (- 27)))
(assert (= (f1 (g3 (- 2))) (- 35)))
(assert (= (g1 (f3 2)) 189))
(assert (= (f1 (g4 9)) 45))
(assert (= (g1 (f4 (- 9))) 189))
(assert (= (f2 (f1 (- 2))) 12))
(assert (= (f2 (g1 (- 9))) (- 155)))
(assert (= (f2 (f2 9)) 12))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 2)) (- 11)))
(assert (= (f2 (g3 9)) (- 155)))
(assert (= (g2 (f3 (- 9))) 51))
(assert (= (g2 (f4 (- 2))) (- 11)))
(assert (= (f2 (f4 2)) (- 6)))
(assert (= (g2 (g4 2)) 24))
(assert (= (f3 (f1 9)) (- 27)))
(assert (= (f3 (g1 (- 2))) (- 36)))
(assert (= (g3 (f1 2)) 187))
(assert (= (f3 (g2 9)) (- 36)))
(assert (= (g3 (f2 (- 9))) 170))
(assert (= (g3 (f3 (- 2))) 170))
(assert (= (f3 (f3 2)) 19))
(assert (= (g3 (g3 2)) 578))
(assert (= (g3 (f4 9)) 187))
(assert (= (f3 (f4 (- 9))) 19))
(assert (= (g3 (g4 (- 9))) 578))
(assert (= (f4 (g1 9)) 164))
(assert (= (g4 (f1 (- 9))) 70))
(assert (= (g4 (f2 (- 2))) 12))
(assert (= (f4 (f2 2)) (- 6)))
(assert (= (g4 (g2 2)) 24))
(assert (= (g4 (f3 9)) 70))
(assert (= (f4 (f3 (- 9))) 19))
(assert (= (g4 (g3 (- 9))) 578))
(assert (= (f4 (f4 (- 2))) (- 6)))
(assert (= (g4 (g4 (- 2))) 24))
(check-sat)
