(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 1 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 1 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 27)))
(assert (= (f1 (g1 1)) 27))
(assert (= (f1 (f2 (- 1))) 10))
(assert (= (f1 (g2 (- 9))) (- 18)))
(assert (= (f1 (f3 9)) (- 27)))
(assert (= (f1 (g3 (- 1))) (- 18)))
(assert (= (g1 (f3 1)) 171))
(assert (= (f1 (g4 9)) 27))
(assert (= (g1 (f4 (- 9))) 171))
(assert (= (f2 (f1 (- 1))) 10))
(assert (= (f2 (g1 (- 9))) (- 154)))
(assert (= (f2 (f2 9)) 10))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 1)) (- 2)))
(assert (= (f2 (g3 9)) (- 154)))
(assert (= (g2 (f3 (- 9))) 17))
(assert (= (g2 (f4 (- 1))) (- 2)))
(assert (= (f2 (f4 1)) (- 3)))
(assert (= (g2 (g4 1)) 2))
(assert (= (f3 (f1 9)) (- 27)))
(assert (= (f3 (g1 (- 1))) (- 18)))
(assert (= (g3 (f1 1)) 170))
(assert (= (f3 (g2 9)) (- 18)))
(assert (= (g3 (f2 (- 9))) 153))
(assert (= (g3 (f3 (- 1))) 153))
(assert (= (f3 (f3 1)) 18))
(assert (= (g3 (g3 1)) 289))
(assert (= (g3 (f4 9)) 170))
(assert (= (f3 (f4 (- 9))) 18))
(assert (= (g3 (g4 (- 9))) 289))
(assert (= (f4 (g1 9)) 163))
(assert (= (g4 (f1 (- 9))) 35))
(assert (= (g4 (f2 (- 1))) 2))
(assert (= (f4 (f2 1)) (- 3)))
(assert (= (g4 (g2 1)) 2))
(assert (= (g4 (f3 9)) 35))
(assert (= (f4 (f3 (- 9))) 18))
(assert (= (g4 (g3 (- 9))) 289))
(assert (= (f4 (f4 (- 1))) (- 3)))
(assert (= (g4 (g4 (- 1))) 2))
(check-sat)
