(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 23))
(assert (= (f1 (g1 (- 7))) 126))
(assert (= (f1 (f2 1)) 11))
(assert (= (f1 (g2 5)) 19))
(assert (= (f1 (f3 9)) 23))
(assert (= (f1 (g3 1)) 19))
(assert (= (g1 (f3 (- 7))) 207))
(assert (= (f1 (g4 9)) 126))
(assert (= (g1 (f4 5)) 207))
(assert (= (f2 (f1 1)) 11))
(assert (= (f2 (g1 5)) 91))
(assert (= (f2 (f2 9)) 11))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 7))) 15))
(assert (= (f2 (g3 9)) 91))
(assert (= (g2 (f3 5)) 20))
(assert (= (g2 (f4 1)) 15))
(assert (= (f2 (f4 (- 7))) 14))
(assert (= (g2 (g4 (- 7))) 169))
(assert (= (f3 (f1 9)) 23))
(assert (= (f3 (g1 1)) 23))
(assert (= (g3 (f1 (- 7))) 155))
(assert (= (f3 (g2 9)) 23))
(assert (= (g3 (f2 5)) 60))
(assert (= (g3 (f3 1)) 60))
(assert (= (f3 (f3 (- 7))) (- 17)))
(assert (= (g3 (g3 (- 7))) 650))
(assert (= (g3 (f4 9)) 155))
(assert (= (f3 (f4 5)) (- 17)))
(assert (= (g3 (g4 5)) 650))
(assert (= (f4 (g1 9)) (- 169)))
(assert (= (g4 (f1 5)) 182))
(assert (= (g4 (f2 1)) 26))
(assert (= (f4 (f2 (- 7))) 14))
(assert (= (g4 (g2 (- 7))) 169))
(assert (= (g4 (f3 9)) 182))
(assert (= (f4 (f3 5)) (- 17)))
(assert (= (g4 (g3 5)) 650))
(assert (= (f4 (f4 1)) 14))
(assert (= (g4 (g4 1)) 169))
(check-sat)
