(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 24)))
(assert (= (f1 (g1 (- 5))) 90))
(assert (= (f1 (f2 2)) 13))
(assert (= (f1 (g2 (- 6))) 31))
(assert (= (f1 (f3 9)) (- 24)))
(assert (= (f1 (g3 2)) 31))
(assert (= (g1 (f3 (- 5))) 180))
(assert (= (f1 (g4 9)) 90))
(assert (= (g1 (f4 (- 6))) 180))
(assert (= (f2 (f1 2)) 13))
(assert (= (f2 (g1 (- 6))) 101))
(assert (= (f2 (f2 9)) 13))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 5))) 26))
(assert (= (f2 (g3 9)) 101))
(assert (= (g2 (f3 (- 6))) 44))
(assert (= (g2 (f4 2)) 26))
(assert (= (f2 (f4 (- 5))) 11))
(assert (= (g2 (g4 (- 5))) 162))
(assert (= (f3 (f1 9)) (- 24)))
(assert (= (f3 (g1 2)) (- 42)))
(assert (= (g3 (f1 (- 5))) (- 149)))
(assert (= (f3 (g2 9)) (- 42)))
(assert (= (g3 (f2 (- 6))) (- 83)))
(assert (= (g3 (f3 2)) (- 83)))
(assert (= (f3 (f3 (- 5))) (- 16)))
(assert (= (g3 (g3 (- 5))) (- 545)))
(assert (= (g3 (f4 9)) (- 149)))
(assert (= (f3 (f4 (- 6))) (- 16)))
(assert (= (g3 (g4 (- 6))) (- 545)))
(assert (= (f4 (g1 9)) (- 167)))
(assert (= (g4 (f1 (- 6))) (- 131)))
(assert (= (g4 (f2 2)) 36))
(assert (= (f4 (f2 (- 5))) 11))
(assert (= (g4 (g2 (- 5))) 162))
(assert (= (g4 (f3 9)) (- 131)))
(assert (= (f4 (f3 (- 6))) (- 16)))
(assert (= (g4 (g3 (- 6))) (- 545)))
(assert (= (f4 (f4 2)) 11))
(assert (= (g4 (g4 2)) 162))
(check-sat)
