(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 (- 5))) (- 23)))
(assert (= (f1 (g1 6)) 117))
(assert (= (f1 (f2 3)) 15))
(assert (= (f1 (g2 (- 5))) 36))
(assert (= (f1 (f3 9)) (- 23)))
(assert (= (f1 (g3 3)) 36))
(assert (= (g1 (f3 6)) 189))
(assert (= (f1 (g4 9)) 117))
(assert (= (g1 (f4 (- 5))) 189))
(assert (= (f2 (f1 3)) 15))
(assert (= (f2 (g1 (- 5))) 84))
(assert (= (f2 (f2 9)) 15))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 6)) 54))
(assert (= (f2 (g3 9)) 84))
(assert (= (g2 (f3 (- 5))) 54))
(assert (= (g2 (f4 3)) 54))
(assert (= (f2 (f4 6)) 15))
(assert (= (g2 (g4 6)) 432))
(assert (= (f3 (f1 9)) (- 23)))
(assert (= (f3 (g1 3)) (- 59)))
(assert (= (g3 (f1 6)) 135))
(assert (= (f3 (g2 9)) (- 59)))
(assert (= (g3 (f2 (- 5))) (- 68)))
(assert (= (g3 (f3 3)) (- 68)))
(assert (= (f3 (f3 6)) 15))
(assert (= (g3 (g3 6)) 486))
(assert (= (g3 (f4 9)) 135))
(assert (= (f3 (f4 (- 5))) 15))
(assert (= (g3 (g4 (- 5))) 486))
(assert (= (f4 (g1 9)) 168))
(assert (= (g4 (f1 (- 5))) 162))
(assert (= (g4 (f2 3)) 72))
(assert (= (f4 (f2 6)) 15))
(assert (= (g4 (g2 6)) 432))
(assert (= (g4 (f3 9)) 162))
(assert (= (f4 (f3 (- 5))) 15))
(assert (= (g4 (g3 (- 5))) 486))
(assert (= (f4 (f4 3)) 15))
(assert (= (g4 (g4 3)) 432))
(check-sat)
