(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 5)) 23))
(assert (= (f1 (g1 8)) 153))
(assert (= (f1 (f2 4)) 17))
(assert (= (f1 (g2 5)) 49))
(assert (= (f1 (f3 9)) 23))
(assert (= (f1 (g3 4)) 49))
(assert (= (g1 (f3 8)) 234))
(assert (= (f1 (g4 9)) 153))
(assert (= (g1 (f4 5)) 234))
(assert (= (f2 (f1 4)) 17))
(assert (= (f2 (g1 5)) 94))
(assert (= (f2 (f2 9)) 17))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 8)) 96))
(assert (= (f2 (g3 9)) 94))
(assert (= (g2 (f3 5)) 80))
(assert (= (g2 (f4 4)) 96))
(assert (= (f2 (f4 8)) 20))
(assert (= (g2 (g4 8)) 1024))
(assert (= (f3 (f1 9)) 23))
(assert (= (f3 (g1 4)) 77))
(assert (= (g3 (f1 8)) 170))
(assert (= (f3 (g2 9)) 77))
(assert (= (g3 (f2 5)) 90))
(assert (= (g3 (f3 4)) 90))
(assert (= (f3 (f3 8)) 18))
(assert (= (g3 (g3 8)) 800))
(assert (= (g3 (f4 9)) 170))
(assert (= (f3 (f4 5)) 18))
(assert (= (g3 (g4 5)) 800))
(assert (= (f4 (g1 9)) 170))
(assert (= (g4 (f1 5)) 224))
(assert (= (g4 (f2 4)) 128))
(assert (= (f4 (f2 8)) 20))
(assert (= (g4 (g2 8)) 1024))
(assert (= (g4 (f3 9)) 224))
(assert (= (f4 (f3 5)) 18))
(assert (= (g4 (g3 5)) 800))
(assert (= (f4 (f4 4)) 20))
(assert (= (g4 (g4 4)) 1024))
(check-sat)
