(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 9 x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num 9 x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 25))
(assert (= (f1 (g1 (- 4))) 72))
(assert (= (f1 (f2 5)) 19))
(assert (= (f1 (g2 7)) 79))
(assert (= (f1 (f3 9)) 25))
(assert (= (f1 (g3 5)) 79))
(assert (= (g1 (f3 (- 4))) 189))
(assert (= (f1 (g4 9)) 72))
(assert (= (g1 (f4 7)) 189))
(assert (= (f2 (f1 5)) 19))
(assert (= (f2 (g1 7)) 131))
(assert (= (f2 (f2 9)) 19))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 4))) 85))
(assert (= (f2 (g3 9)) 131))
(assert (= (g2 (f3 7)) 140))
(assert (= (g2 (f4 5)) 85))
(assert (= (f2 (f4 (- 4))) 12))
(assert (= (g2 (g4 (- 4))) 245))
(assert (= (f3 (f1 9)) 25))
(assert (= (f3 (g1 5)) 97))
(assert (= (g3 (f1 (- 4))) 175))
(assert (= (f3 (g2 9)) 97))
(assert (= (g3 (f2 7)) 168))
(assert (= (g3 (f3 5)) 168))
(assert (= (f3 (f3 (- 4))) (- 18)))
(assert (= (g3 (g3 (- 4))) 686))
(assert (= (g3 (f4 9)) 175))
(assert (= (f3 (f4 7)) (- 18)))
(assert (= (g3 (g4 7)) 686))
(assert (= (f4 (g1 9)) (- 166)))
(assert (= (g4 (f1 7)) 112))
(assert (= (g4 (f2 5)) 70))
(assert (= (f4 (f2 (- 4))) 12))
(assert (= (g4 (g2 (- 4))) 245))
(assert (= (g4 (f3 9)) 112))
(assert (= (f4 (f3 7)) (- 18)))
(assert (= (g4 (g3 7)) 686))
(assert (= (f4 (f4 5)) 12))
(assert (= (g4 (g4 5)) 245))
(check-sat)
