(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 19)))
(assert (= (f1 (g1 (- 3))) 33))
(assert (= (f1 (f2 (- 5))) (- 15)))
(assert (= (f1 (g2 (- 8))) 73))
(assert (= (f1 (f3 (- 6))) (- 19)))
(assert (= (f1 (g3 (- 5))) 73))
(assert (= (g1 (f3 (- 3))) 110))
(assert (= (f1 (g4 (- 6))) 33))
(assert (= (g1 (f4 (- 8))) 110))
(assert (= (f2 (f1 (- 5))) (- 15)))
(assert (= (f2 (g1 (- 8))) 87))
(assert (= (f2 (f2 (- 6))) (- 15)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 3))) 63))
(assert (= (f2 (g3 (- 6))) 87))
(assert (= (g2 (f3 (- 8))) 135))
(assert (= (g2 (f4 (- 5))) 63))
(assert (= (f2 (f4 (- 3))) (- 10)))
(assert (= (g2 (g4 (- 3))) (- 113)))
(assert (= (f3 (f1 (- 6))) (- 19)))
(assert (= (f3 (g1 (- 5))) 57))
(assert (= (g3 (f1 (- 3))) 120))
(assert (= (f3 (g2 (- 6))) 57))
(assert (= (g3 (f2 (- 8))) 180))
(assert (= (g3 (f3 (- 5))) 180))
(assert (= (f3 (f3 (- 3))) (- 18)))
(assert (= (g3 (g3 (- 3))) (- 563)))
(assert (= (g3 (f4 (- 6))) 120))
(assert (= (f3 (f4 (- 8))) (- 18)))
(assert (= (g3 (g4 (- 8))) (- 563)))
(assert (= (f4 (g1 (- 6))) 63))
(assert (= (g4 (f1 (- 8))) 65))
(assert (= (g4 (f2 (- 5))) 45))
(assert (= (f4 (f2 (- 3))) (- 10)))
(assert (= (g4 (g2 (- 3))) (- 113)))
(assert (= (g4 (f3 (- 6))) 65))
(assert (= (f4 (f3 (- 8))) (- 18)))
(assert (= (g4 (g3 (- 8))) (- 563)))
(assert (= (f4 (f4 (- 5))) (- 10)))
(assert (= (g4 (g4 (- 5))) (- 113)))
(check-sat)
