(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 3 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 3 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 17))
(assert (= (f1 (g1 3)) (- 39)))
(assert (= (f1 (f2 (- 4))) (- 13)))
(assert (= (f1 (g2 6)) (- 48)))
(assert (= (f1 (f3 (- 6))) 17))
(assert (= (f1 (g3 (- 4))) (- 48)))
(assert (= (g1 (f3 3)) 99))
(assert (= (f1 (g4 (- 6))) (- 39)))
(assert (= (g1 (f4 6)) 99))
(assert (= (f2 (f1 (- 4))) (- 13)))
(assert (= (f2 (g1 6)) (- 70)))
(assert (= (f2 (f2 (- 6))) (- 13)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 3)) (- 46)))
(assert (= (f2 (g3 (- 6))) (- 70)))
(assert (= (g2 (f3 6)) 84))
(assert (= (g2 (f4 (- 4))) (- 46)))
(assert (= (f2 (f4 3)) (- 10)))
(assert (= (g2 (g4 3)) 126))
(assert (= (f3 (f1 (- 6))) 17))
(assert (= (f3 (g1 (- 4))) (- 45)))
(assert (= (g3 (f1 3)) 102))
(assert (= (f3 (g2 (- 6))) (- 45)))
(assert (= (g3 (f2 6)) 114))
(assert (= (g3 (f3 (- 4))) 114))
(assert (= (f3 (f3 3)) 15))
(assert (= (g3 (g3 3)) 432))
(assert (= (g3 (f4 (- 6))) 102))
(assert (= (f3 (f4 6)) 15))
(assert (= (g3 (g4 6)) 432))
(assert (= (f4 (g1 (- 6))) (- 64)))
(assert (= (g4 (f1 6)) 69))
(assert (= (g4 (f2 (- 4))) 42))
(assert (= (f4 (f2 3)) (- 10)))
(assert (= (g4 (g2 3)) 126))
(assert (= (g4 (f3 (- 6))) 69))
(assert (= (f4 (f3 6)) 15))
(assert (= (g4 (g3 6)) 432))
(assert (= (f4 (f4 (- 4))) (- 10)))
(assert (= (g4 (g4 (- 4))) 126))
(check-sat)
