(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 22)))
(assert (= (f1 (g1 6)) (- 111)))
(assert (= (f1 (f2 (- 1))) (- 10)))
(assert (= (f1 (g2 (- 5))) 13))
(assert (= (f1 (f3 (- 9))) (- 22)))
(assert (= (f1 (g3 (- 1))) 13))
(assert (= (g1 (f3 6)) (- 179)))
(assert (= (f1 (g4 (- 9))) (- 111)))
(assert (= (g1 (f4 (- 5))) (- 179)))
(assert (= (f2 (f1 (- 1))) (- 10)))
(assert (= (f2 (g1 (- 5))) 77))
(assert (= (f2 (f2 (- 9))) (- 10)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 6)) (- 7)))
(assert (= (f2 (g3 (- 9))) 77))
(assert (= (g2 (f3 (- 5))) 9))
(assert (= (g2 (f4 (- 1))) (- 7)))
(assert (= (f2 (f4 6)) (- 13)))
(assert (= (g2 (g4 6)) 72))
(assert (= (f3 (f1 (- 9))) (- 22)))
(assert (= (f3 (g1 (- 1))) 13))
(assert (= (g3 (f1 6)) (- 131)))
(assert (= (f3 (g2 (- 9))) 13))
(assert (= (g3 (f2 (- 5))) 45))
(assert (= (g3 (f3 (- 1))) 45))
(assert (= (f3 (f3 6)) 15))
(assert (= (g3 (g3 6)) 486))
(assert (= (g3 (f4 (- 9))) (- 131)))
(assert (= (f3 (f4 (- 5))) 15))
(assert (= (g3 (g4 (- 5))) 486))
(assert (= (f4 (g1 (- 9))) (- 151)))
(assert (= (g4 (f1 (- 5))) 156))
(assert (= (g4 (f2 (- 1))) 12))
(assert (= (f4 (f2 6)) (- 13)))
(assert (= (g4 (g2 6)) 72))
(assert (= (g4 (f3 (- 9))) 156))
(assert (= (f4 (f3 (- 5))) 15))
(assert (= (g4 (g3 (- 5))) 486))
(assert (= (f4 (f4 (- 1))) (- 13)))
(assert (= (g4 (g4 (- 1))) 72))
(check-sat)
