(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 8)) 19))
(assert (= (f1 (g1 7)) (- 83)))
(assert (= (f1 (f2 3)) (- 12)))
(assert (= (f1 (g2 8)) (- 54)))
(assert (= (f1 (f3 (- 6))) 19))
(assert (= (f1 (g3 3)) (- 54)))
(assert (= (g1 (f3 7)) 165))
(assert (= (f1 (g4 (- 6))) (- 83)))
(assert (= (g1 (f4 8)) 165))
(assert (= (f2 (f1 3)) (- 12)))
(assert (= (f2 (g1 8)) 91))
(assert (= (f2 (f2 (- 6))) (- 12)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 7)) 60))
(assert (= (f2 (g3 (- 6))) 91))
(assert (= (g2 (f3 8)) 96))
(assert (= (g2 (f4 3)) 60))
(assert (= (f2 (f4 7)) 17))
(assert (= (g2 (g4 7)) 588))
(assert (= (f3 (f1 (- 6))) 19))
(assert (= (f3 (g1 3)) 41))
(assert (= (g3 (f1 7)) 200))
(assert (= (f3 (g2 (- 6))) 41))
(assert (= (g3 (f2 8)) 176))
(assert (= (g3 (f3 3)) 176))
(assert (= (f3 (f3 7)) 23))
(assert (= (g3 (g3 7)) 1792))
(assert (= (g3 (f4 (- 6))) 200))
(assert (= (f3 (f4 8)) 23))
(assert (= (g3 (g4 8)) 1792))
(assert (= (f4 (g1 (- 6))) (- 68)))
(assert (= (g4 (f1 8)) 189))
(assert (= (g4 (f2 3)) 84))
(assert (= (f4 (f2 7)) 17))
(assert (= (g4 (g2 7)) 588))
(assert (= (g4 (f3 (- 6))) 189))
(assert (= (f4 (f3 8)) 23))
(assert (= (g4 (g3 8)) 1792))
(assert (= (f4 (f4 3)) 17))
(assert (= (g4 (g4 3)) 588))
(check-sat)
