(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 14))
(assert (= (f1 (g1 (- 8))) 88))
(assert (= (f1 (f2 5)) (- 16)))
(assert (= (f1 (g2 3)) (- 36)))
(assert (= (f1 (f3 (- 6))) 14))
(assert (= (f1 (g3 5)) (- 36)))
(assert (= (g1 (f3 (- 8))) (- 116)))
(assert (= (f1 (g4 (- 6))) 88))
(assert (= (g1 (f4 3)) (- 116)))
(assert (= (f2 (f1 5)) (- 16)))
(assert (= (f2 (g1 3)) 38))
(assert (= (f2 (f2 (- 6))) (- 16)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 8))) 125))
(assert (= (f2 (g3 (- 6))) 38))
(assert (= (g2 (f3 3)) 60))
(assert (= (g2 (f4 5)) 125))
(assert (= (f2 (f4 (- 8))) 20))
(assert (= (g2 (g4 (- 8))) 1125))
(assert (= (f3 (f1 (- 6))) 14))
(assert (= (f3 (g1 5)) 58))
(assert (= (g3 (f1 (- 8))) 78))
(assert (= (f3 (g2 (- 6))) 58))
(assert (= (g3 (f2 3)) 48))
(assert (= (g3 (f3 5)) 48))
(assert (= (f3 (f3 (- 8))) (- 14)))
(assert (= (g3 (g3 (- 8))) 270))
(assert (= (g3 (f4 (- 6))) 78))
(assert (= (f3 (f4 3)) (- 14)))
(assert (= (g3 (g4 3)) 270))
(assert (= (f4 (g1 (- 6))) 68))
(assert (= (g4 (f1 3)) (- 128)))
(assert (= (g4 (f2 5)) 150))
(assert (= (f4 (f2 (- 8))) 20))
(assert (= (g4 (g2 (- 8))) 1125))
(assert (= (g4 (f3 (- 6))) (- 128)))
(assert (= (f4 (f3 3)) (- 14)))
(assert (= (g4 (g3 3)) 270))
(assert (= (f4 (f4 5)) 20))
(assert (= (g4 (g4 5)) 1125))
(check-sat)
