(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 6)) 17))
(assert (= (f1 (g1 (- 3))) 33))
(assert (= (f1 (f2 5)) (- 16)))
(assert (= (f1 (g2 6)) (- 66)))
(assert (= (f1 (f3 (- 6))) 17))
(assert (= (f1 (g3 5)) (- 66)))
(assert (= (g1 (f3 (- 3))) (- 94)))
(assert (= (f1 (g4 (- 6))) 33))
(assert (= (g1 (f4 6)) (- 94)))
(assert (= (f2 (f1 5)) (- 16)))
(assert (= (f2 (g1 6)) 71))
(assert (= (f2 (f2 (- 6))) (- 16)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 3))) 75))
(assert (= (f2 (g3 (- 6))) 71))
(assert (= (g2 (f3 6)) 120))
(assert (= (g2 (f4 5)) 75))
(assert (= (f2 (f4 (- 3))) 10))
(assert (= (g2 (g4 (- 3))) 125))
(assert (= (f3 (f1 (- 6))) 17))
(assert (= (f3 (g1 5)) 61))
(assert (= (g3 (f1 (- 3))) 96))
(assert (= (f3 (g2 (- 6))) 61))
(assert (= (g3 (f2 6)) 132))
(assert (= (g3 (f3 5)) 132))
(assert (= (f3 (f3 (- 3))) (- 15)))
(assert (= (g3 (g3 (- 3))) 360))
(assert (= (g3 (f4 (- 6))) 96))
(assert (= (f3 (f4 6)) (- 15)))
(assert (= (g3 (g4 6)) 360))
(assert (= (f4 (g1 (- 6))) 63))
(assert (= (g4 (f1 6)) (- 58)))
(assert (= (g4 (f2 5)) 50))
(assert (= (f4 (f2 (- 3))) 10))
(assert (= (g4 (g2 (- 3))) 125))
(assert (= (g4 (f3 (- 6))) (- 58)))
(assert (= (f4 (f3 6)) (- 15)))
(assert (= (g4 (g3 6)) 360))
(assert (= (f4 (f4 5)) 10))
(assert (= (g4 (g4 5)) 125))
(check-sat)
