(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 14)))
(assert (= (f1 (g1 9)) (- 105)))
(assert (= (f1 (f2 6)) (- 18)))
(assert (= (f1 (g2 (- 3))) (- 36)))
(assert (= (f1 (f3 (- 6))) (- 14)))
(assert (= (f1 (g3 6)) (- 36)))
(assert (= (g1 (f3 9)) (- 127)))
(assert (= (f1 (g4 (- 6))) (- 105)))
(assert (= (g1 (f4 (- 3))) (- 127)))
(assert (= (f2 (f1 6)) (- 18)))
(assert (= (f2 (g1 (- 3))) (- 34)))
(assert (= (f2 (f2 (- 6))) (- 18)))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 9)) 180))
(assert (= (f2 (g3 (- 6))) (- 34)))
(assert (= (g2 (f3 (- 3))) 60))
(assert (= (g2 (f4 6)) 180))
(assert (= (f2 (f4 9)) 24))
(assert (= (g2 (g4 9)) 1944))
(assert (= (f3 (f1 (- 6))) (- 14)))
(assert (= (f3 (g1 6)) (- 69)))
(assert (= (g3 (f1 9)) (- 73)))
(assert (= (f3 (g2 (- 6))) (- 69)))
(assert (= (g3 (f2 (- 3))) (- 43)))
(assert (= (g3 (f3 6)) (- 43)))
(assert (= (f3 (f3 9)) 14))
(assert (= (g3 (g3 9)) 225))
(assert (= (g3 (f4 (- 6))) (- 73)))
(assert (= (f3 (f4 (- 3))) 14))
(assert (= (g3 (g4 (- 3))) 225))
(assert (= (f4 (g1 (- 6))) (- 70)))
(assert (= (g4 (f1 (- 3))) 144))
(assert (= (g4 (f2 6)) 216))
(assert (= (f4 (f2 9)) 24))
(assert (= (g4 (g2 9)) 1944))
(assert (= (g4 (f3 (- 6))) 144))
(assert (= (f4 (f3 (- 3))) 14))
(assert (= (g4 (g3 (- 3))) 225))
(assert (= (f4 (f4 6)) 24))
(assert (= (g4 (g4 6)) 1944))
(check-sat)
