(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 3)) 14))
(assert (= (f1 (g1 (- 4))) 44))
(assert (= (f1 (f2 8)) (- 22)))
(assert (= (f1 (g2 3)) (- 54)))
(assert (= (f1 (f3 (- 6))) 14))
(assert (= (f1 (g3 8)) (- 54)))
(assert (= (g1 (f3 (- 4))) (- 72)))
(assert (= (f1 (g4 (- 6))) 44))
(assert (= (g1 (f4 3)) (- 72)))
(assert (= (f2 (f1 8)) (- 22)))
(assert (= (f2 (g1 3)) 41))
(assert (= (f2 (f2 (- 6))) (- 22)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 4))) 184))
(assert (= (f2 (g3 (- 6))) 41))
(assert (= (g2 (f3 3)) 96))
(assert (= (g2 (f4 8)) 184))
(assert (= (f2 (f4 (- 4))) 15))
(assert (= (g2 (g4 (- 4))) 392))
(assert (= (f3 (f1 (- 6))) 14))
(assert (= (f3 (g1 8)) 91))
(assert (= (g3 (f1 (- 4))) 54))
(assert (= (f3 (g2 (- 6))) 91))
(assert (= (g3 (f2 3)) 66))
(assert (= (g3 (f3 8)) 66))
(assert (= (f3 (f3 (- 4))) (- 10)))
(assert (= (g3 (g3 (- 4))) 126))
(assert (= (g3 (f4 (- 6))) 54))
(assert (= (f3 (f4 3)) (- 10)))
(assert (= (g3 (g4 3)) 126))
(assert (= (f4 (g1 (- 6))) 64))
(assert (= (g4 (f1 3)) (- 60)))
(assert (= (g4 (f2 8)) 112))
(assert (= (f4 (f2 (- 4))) 15))
(assert (= (g4 (g2 (- 4))) 392))
(assert (= (g4 (f3 (- 6))) (- 60)))
(assert (= (f4 (f3 3)) (- 10)))
(assert (= (g4 (g3 3)) 126))
(assert (= (f4 (f4 8)) 15))
(assert (= (g4 (g4 8)) 392))
(check-sat)
