(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 6) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 6) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 20)))
(assert (= (f1 (g1 6)) (- 72)))
(assert (= (f1 (f2 9)) (- 24)))
(assert (= (f1 (g2 (- 9))) (- 159)))
(assert (= (f1 (f3 (- 6))) (- 20)))
(assert (= (f1 (g3 9)) (- 159)))
(assert (= (g1 (f3 6)) (- 160)))
(assert (= (f1 (g4 (- 6))) (- 72)))
(assert (= (g1 (f4 (- 9))) (- 160)))
(assert (= (f2 (f1 9)) (- 24)))
(assert (= (f2 (g1 (- 9))) (- 103)))
(assert (= (f2 (f2 (- 6))) (- 24)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 6)) 270))
(assert (= (f2 (g3 (- 6))) (- 103)))
(assert (= (g2 (f3 (- 9))) 306))
(assert (= (g2 (f4 9)) 270))
(assert (= (f2 (f4 6)) 21))
(assert (= (g2 (g4 6)) 1296))
(assert (= (f3 (f1 (- 6))) (- 20)))
(assert (= (f3 (g1 9)) (- 108)))
(assert (= (g3 (f1 6)) (- 196)))
(assert (= (f3 (g2 (- 6))) (- 108)))
(assert (= (g3 (f2 (- 9))) (- 298)))
(assert (= (g3 (f3 9)) (- 298)))
(assert (= (f3 (f3 6)) 23))
(assert (= (g3 (g3 6)) 1734))
(assert (= (g3 (f4 (- 6))) (- 196)))
(assert (= (f3 (f4 (- 9))) 23))
(assert (= (g3 (g4 (- 9))) 1734))
(assert (= (f4 (g1 (- 6))) (- 67)))
(assert (= (g4 (f1 (- 9))) 168))
(assert (= (g4 (f2 9)) 216))
(assert (= (f4 (f2 6)) 21))
(assert (= (g4 (g2 6)) 1296))
(assert (= (g4 (f3 (- 6))) 168))
(assert (= (f4 (f3 (- 9))) 23))
(assert (= (g4 (g3 (- 9))) 1734))
(assert (= (f4 (f4 9)) 21))
(assert (= (g4 (g4 9)) 1296))
(check-sat)
