(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 13))
(assert (= (f1 (g1 9)) (- 86)))
(assert (= (f1 (f2 (- 9))) (- 22)))
(assert (= (f1 (g2 4)) (- 73)))
(assert (= (f1 (f3 (- 5))) 13))
(assert (= (f1 (g3 (- 9))) (- 73)))
(assert (= (g1 (f3 9)) 117))
(assert (= (f1 (g4 (- 5))) (- 86)))
(assert (= (g1 (f4 4)) 117))
(assert (= (f2 (f1 (- 9))) (- 22)))
(assert (= (f2 (g1 4)) (- 45)))
(assert (= (f2 (f2 (- 5))) (- 22)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 9)) (- 298)))
(assert (= (f2 (g3 (- 5))) (- 45)))
(assert (= (g2 (f3 4)) 136))
(assert (= (g2 (f4 (- 9))) (- 298)))
(assert (= (f2 (f4 9)) (- 27)))
(assert (= (g2 (g4 9)) 2754))
(assert (= (f3 (f1 (- 5))) 13))
(assert (= (f3 (g1 (- 9))) (- 81)))
(assert (= (g3 (f1 9)) 108))
(assert (= (f3 (g2 (- 5))) (- 81)))
(assert (= (g3 (f2 4)) 100))
(assert (= (g3 (f3 (- 9))) 100))
(assert (= (f3 (f3 9)) 17))
(assert (= (g3 (g3 9)) 576))
(assert (= (g3 (f4 (- 5))) 108))
(assert (= (f3 (f4 4)) 17))
(assert (= (g3 (g4 4)) 576))
(assert (= (f4 (g1 (- 5))) (- 50)))
(assert (= (g4 (f1 4)) 153))
(assert (= (g4 (f2 (- 9))) 306))
(assert (= (f4 (f2 9)) (- 27)))
(assert (= (g4 (g2 9)) 2754))
(assert (= (g4 (f3 (- 5))) 153))
(assert (= (f4 (f3 4)) 17))
(assert (= (g4 (g3 4)) 576))
(assert (= (f4 (f4 (- 9))) (- 27)))
(assert (= (g4 (g4 (- 9))) 2754))
(check-sat)
