(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 5)) 14))
(assert (= (f1 (g1 (- 6))) 54))
(assert (= (f1 (f2 (- 9))) (- 22)))
(assert (= (f1 (g2 5)) (- 90)))
(assert (= (f1 (f3 (- 5))) 14))
(assert (= (f1 (g3 (- 9))) (- 90)))
(assert (= (g1 (f3 (- 6))) (- 95)))
(assert (= (f1 (g4 (- 5))) 54))
(assert (= (g1 (f4 5)) (- 95)))
(assert (= (f2 (f1 (- 9))) (- 22)))
(assert (= (f2 (g1 5)) (- 54)))
(assert (= (f2 (f2 (- 5))) (- 22)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 6))) 238))
(assert (= (f2 (g3 (- 5))) (- 54)))
(assert (= (g2 (f3 5)) 170))
(assert (= (g2 (f4 (- 9))) 238))
(assert (= (f2 (f4 (- 6))) (- 20)))
(assert (= (g2 (g4 (- 6))) (- 1029)))
(assert (= (f3 (f1 (- 5))) 14))
(assert (= (f3 (g1 (- 9))) (- 82)))
(assert (= (g3 (f1 (- 6))) 100))
(assert (= (f3 (g2 (- 5))) (- 82)))
(assert (= (g3 (f2 5)) 135))
(assert (= (g3 (f3 (- 9))) 135))
(assert (= (f3 (f3 (- 6))) (- 16)))
(assert (= (g3 (g3 (- 6))) 550))
(assert (= (g3 (f4 (- 5))) 100))
(assert (= (f3 (f4 5)) (- 16)))
(assert (= (g3 (g4 5)) 550))
(assert (= (f4 (g1 (- 5))) 46))
(assert (= (g4 (f1 5)) (- 105)))
(assert (= (g4 (f2 (- 9))) 187))
(assert (= (f4 (f2 (- 6))) (- 20)))
(assert (= (g4 (g2 (- 6))) (- 1029)))
(assert (= (g4 (f3 (- 5))) (- 105)))
(assert (= (f4 (f3 5)) (- 16)))
(assert (= (g4 (g3 5)) 550))
(assert (= (f4 (f4 (- 9))) (- 20)))
(assert (= (g4 (g4 (- 9))) (- 1029)))
(check-sat)
