(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 1)) 10))
(assert (= (f1 (g1 6)) (- 59)))
(assert (= (f1 (f2 (- 7))) (- 18)))
(assert (= (f1 (g2 1)) (- 18)))
(assert (= (f1 (f3 (- 5))) 10))
(assert (= (f1 (g3 (- 7))) (- 18)))
(assert (= (g1 (f3 6)) 63))
(assert (= (f1 (g4 (- 5))) (- 59)))
(assert (= (g1 (f4 1)) 63))
(assert (= (f2 (f1 (- 7))) (- 18)))
(assert (= (f2 (g1 1)) (- 16)))
(assert (= (f2 (f2 (- 5))) (- 18)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 6)) (- 163)))
(assert (= (f2 (g3 (- 5))) (- 16)))
(assert (= (g2 (f3 1)) 26))
(assert (= (g2 (f4 (- 7))) (- 163)))
(assert (= (f2 (f4 6)) (- 19)))
(assert (= (g2 (g4 6)) 936))
(assert (= (f3 (f1 (- 5))) 10))
(assert (= (f3 (g1 (- 7))) (- 60)))
(assert (= (g3 (f1 6)) 21))
(assert (= (f3 (g2 (- 5))) (- 60)))
(assert (= (g3 (f2 1)) 15))
(assert (= (g3 (f3 (- 7))) 15))
(assert (= (f3 (f3 6)) 8))
(assert (= (g3 (g3 6)) 24))
(assert (= (g3 (f4 (- 5))) 21))
(assert (= (f3 (f4 1)) 8))
(assert (= (g3 (g4 1)) 24))
(assert (= (f4 (g1 (- 5))) (- 47)))
(assert (= (g4 (f1 1)) 66))
(assert (= (g4 (f2 (- 7))) 156))
(assert (= (f4 (f2 6)) (- 19)))
(assert (= (g4 (g2 6)) 936))
(assert (= (g4 (f3 (- 5))) 66))
(assert (= (f4 (f3 1)) 8))
(assert (= (g4 (g3 1)) 24))
(assert (= (f4 (f4 (- 7))) (- 19)))
(assert (= (g4 (g4 (- 7))) 936))
(check-sat)
