(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 23)))
(assert (= (f1 (g1 (- 8))) 136))
(assert (= (f1 (f2 1)) (- 11)))
(assert (= (f1 (g2 (- 6))) (- 20)))
(assert (= (f1 (f3 (- 9))) (- 23)))
(assert (= (f1 (g3 1)) (- 20)))
(assert (= (g1 (f3 (- 8))) 221))
(assert (= (f1 (g4 (- 9))) 136))
(assert (= (g1 (f4 (- 6))) 221))
(assert (= (f2 (f1 1)) (- 11)))
(assert (= (f2 (g1 (- 6))) (- 95)))
(assert (= (f2 (f2 (- 9))) (- 11)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 8))) 17))
(assert (= (f2 (g3 (- 9))) (- 95)))
(assert (= (g2 (f3 (- 6))) 22))
(assert (= (g2 (f4 1)) 17))
(assert (= (f2 (f4 (- 8))) 16))
(assert (= (g2 (g4 (- 8))) 225))
(assert (= (f3 (f1 (- 9))) (- 23)))
(assert (= (f3 (g1 1)) (- 23)))
(assert (= (g3 (f1 (- 8))) 176))
(assert (= (f3 (g2 (- 9))) (- 23)))
(assert (= (g3 (f2 (- 6))) (- 72)))
(assert (= (g3 (f3 1)) (- 72)))
(assert (= (f3 (f3 (- 8))) (- 19)))
(assert (= (g3 (g3 (- 8))) (- 908)))
(assert (= (g3 (f4 (- 9))) 176))
(assert (= (f3 (f4 (- 6))) (- 19)))
(assert (= (g3 (g4 (- 6))) (- 908)))
(assert (= (f4 (g1 (- 9))) 152))
(assert (= (g4 (f1 (- 6))) 210))
(assert (= (g4 (f2 1)) 30))
(assert (= (f4 (f2 (- 8))) 16))
(assert (= (g4 (g2 (- 8))) 225))
(assert (= (g4 (f3 (- 9))) 210))
(assert (= (f4 (f3 (- 6))) (- 19)))
(assert (= (g4 (g3 (- 6))) (- 908)))
(assert (= (f4 (f4 1)) 16))
(assert (= (g4 (g4 1)) 225))
(check-sat)
