(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 7)) 16))
(assert (= (f1 (g1 (- 1))) 9))
(assert (= (f1 (f2 (- 7))) (- 18)))
(assert (= (f1 (g2 7)) (- 96)))
(assert (= (f1 (f3 (- 5))) 16))
(assert (= (f1 (g3 (- 7))) (- 96)))
(assert (= (g1 (f3 (- 1))) (- 68)))
(assert (= (f1 (g4 (- 5))) 9))
(assert (= (g1 (f4 7)) (- 68)))
(assert (= (f2 (f1 (- 7))) (- 18)))
(assert (= (f2 (g1 7)) (- 70)))
(assert (= (f2 (f2 (- 5))) (- 18)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 1))) 91))
(assert (= (f2 (g3 (- 5))) (- 70)))
(assert (= (g2 (f3 7)) 182))
(assert (= (g2 (f4 (- 7))) 91))
(assert (= (f2 (f4 (- 1))) (- 8)))
(assert (= (g2 (g4 (- 1))) (- 7)))
(assert (= (f3 (f1 (- 5))) 16))
(assert (= (f3 (g1 (- 7))) (- 66)))
(assert (= (g3 (f1 (- 1))) 70))
(assert (= (f3 (g2 (- 5))) (- 66)))
(assert (= (g3 (f2 7)) 189))
(assert (= (g3 (f3 (- 7))) 189))
(assert (= (f3 (f3 (- 1))) (- 15)))
(assert (= (g3 (g3 (- 1))) 98))
(assert (= (g3 (f4 (- 5))) 70))
(assert (= (f3 (f4 7)) (- 15)))
(assert (= (g3 (g4 7)) 98))
(assert (= (f4 (g1 (- 5))) 41))
(assert (= (g4 (f1 7)) (- 12)))
(assert (= (g4 (f2 (- 7))) 13))
(assert (= (f4 (f2 (- 1))) (- 8)))
(assert (= (g4 (g2 (- 1))) (- 7)))
(assert (= (g4 (f3 (- 5))) (- 12)))
(assert (= (f4 (f3 7)) (- 15)))
(assert (= (g4 (g3 7)) 98))
(assert (= (f4 (f4 (- 7))) (- 8)))
(assert (= (g4 (g4 (- 7))) (- 7)))
(check-sat)
