(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 15))
(assert (= (f1 (g1 4)) (- 41)))
(assert (= (f1 (f2 (- 6))) (- 16)))
(assert (= (f1 (g2 6)) (- 71)))
(assert (= (f1 (f3 (- 5))) 15))
(assert (= (f1 (g3 (- 6))) (- 71)))
(assert (= (g1 (f3 4)) 90))
(assert (= (f1 (g4 (- 5))) (- 41)))
(assert (= (g1 (f4 6)) 90))
(assert (= (f2 (f1 (- 6))) (- 16)))
(assert (= (f2 (g1 6)) (- 60)))
(assert (= (f2 (f2 (- 5))) (- 16)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 4)) (- 105)))
(assert (= (f2 (g3 (- 5))) (- 60)))
(assert (= (g2 (f3 6)) 132))
(assert (= (g2 (f4 (- 6))) (- 105)))
(assert (= (f2 (f4 4)) (- 14)))
(assert (= (g2 (g4 4)) 352))
(assert (= (f3 (f1 (- 5))) 15))
(assert (= (f3 (g1 (- 6))) (- 56)))
(assert (= (g3 (f1 4)) 102))
(assert (= (f3 (g2 (- 5))) (- 56)))
(assert (= (g3 (f2 6)) 138))
(assert (= (g3 (f3 (- 6))) 138))
(assert (= (f3 (f3 4)) 16))
(assert (= (g3 (g3 4)) 576))
(assert (= (g3 (f4 (- 5))) 102))
(assert (= (f3 (f4 6)) 16))
(assert (= (g3 (g4 6)) 576))
(assert (= (f4 (g1 (- 5))) (- 45)))
(assert (= (g4 (f1 6)) 84))
(assert (= (g4 (f2 (- 6))) 88))
(assert (= (f4 (f2 4)) (- 14)))
(assert (= (g4 (g2 4)) 352))
(assert (= (g4 (f3 (- 5))) 84))
(assert (= (f4 (f3 6)) 16))
(assert (= (g4 (g3 6)) 576))
(assert (= (f4 (f4 (- 6))) (- 14)))
(assert (= (g4 (g4 (- 6))) 352))
(check-sat)
