(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 20)))
(assert (= (f1 (g1 7)) (- 128)))
(assert (= (f1 (f2 1)) (- 11)))
(assert (= (f1 (g2 (- 3))) (- 14)))
(assert (= (f1 (f3 (- 9))) (- 20)))
(assert (= (f1 (g3 1)) (- 14)))
(assert (= (g1 (f3 7)) (- 162)))
(assert (= (f1 (g4 (- 9))) (- 128)))
(assert (= (g1 (f4 (- 3))) (- 162)))
(assert (= (f2 (f1 1)) (- 11)))
(assert (= (f2 (g1 (- 3))) (- 44)))
(assert (= (f2 (f2 (- 9))) (- 11)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 7)) 16))
(assert (= (f2 (g3 (- 9))) (- 44)))
(assert (= (g2 (f3 (- 3))) 10))
(assert (= (g2 (f4 1)) 16))
(assert (= (f2 (f4 7)) 15))
(assert (= (g2 (g4 7)) 196))
(assert (= (f3 (f1 (- 9))) (- 20)))
(assert (= (f3 (g1 1)) (- 20)))
(assert (= (g3 (f1 7)) (- 78)))
(assert (= (f3 (g2 (- 9))) (- 20)))
(assert (= (g3 (f2 (- 3))) (- 18)))
(assert (= (g3 (f3 1)) (- 18)))
(assert (= (f3 (f3 7)) 12))
(assert (= (g3 (g3 7)) 175))
(assert (= (g3 (f4 (- 9))) (- 78)))
(assert (= (f3 (f4 (- 3))) 12))
(assert (= (g3 (g4 (- 3))) 175))
(assert (= (f4 (g1 (- 9))) (- 152)))
(assert (= (g4 (f1 (- 3))) 154))
(assert (= (g4 (f2 1)) 28))
(assert (= (f4 (f2 7)) 15))
(assert (= (g4 (g2 7)) 196))
(assert (= (g4 (f3 (- 9))) 154))
(assert (= (f4 (f3 (- 3))) 12))
(assert (= (g4 (g3 (- 3))) 175))
(assert (= (f4 (f4 1)) 15))
(assert (= (g4 (g4 1)) 196))
(check-sat)
