(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 15)))
(assert (= (f1 (g1 9)) (- 86)))
(assert (= (f1 (f2 (- 4))) (- 12)))
(assert (= (f1 (g2 (- 6))) 43))
(assert (= (f1 (f3 (- 5))) (- 15)))
(assert (= (f1 (g3 (- 4))) 43))
(assert (= (g1 (f3 9)) (- 131)))
(assert (= (f1 (g4 (- 5))) (- 86)))
(assert (= (g1 (f4 (- 6))) (- 131)))
(assert (= (f2 (f1 (- 4))) (- 12)))
(assert (= (f2 (g1 (- 6))) 53))
(assert (= (f2 (f2 (- 5))) (- 12)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 9)) (- 88)))
(assert (= (f2 (g3 (- 5))) 53))
(assert (= (g2 (f3 (- 6))) 77))
(assert (= (g2 (f4 (- 4))) (- 88)))
(assert (= (f2 (f4 9)) (- 22)))
(assert (= (g2 (g4 9)) 1134))
(assert (= (f3 (f1 (- 5))) (- 15)))
(assert (= (f3 (g1 (- 4))) 37))
(assert (= (g3 (f1 9)) (- 149)))
(assert (= (f3 (g2 (- 5))) 37))
(assert (= (g3 (f2 (- 6))) 99))
(assert (= (g3 (f3 (- 4))) 99))
(assert (= (f3 (f3 9)) 20))
(assert (= (g3 (g3 9)) 1089))
(assert (= (g3 (f4 (- 5))) (- 149)))
(assert (= (f3 (f4 (- 6))) 20))
(assert (= (g3 (g4 (- 6))) 1089))
(assert (= (f4 (g1 (- 5))) (- 50)))
(assert (= (g4 (f1 (- 6))) 180))
(assert (= (g4 (f2 (- 4))) 126))
(assert (= (f4 (f2 9)) (- 22)))
(assert (= (g4 (g2 9)) 1134))
(assert (= (g4 (f3 (- 5))) 180))
(assert (= (f4 (f3 (- 6))) 20))
(assert (= (g4 (g3 (- 6))) 1089))
(assert (= (f4 (f4 (- 4))) (- 22)))
(assert (= (g4 (g4 (- 4))) 1134))
(check-sat)
