(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 16)))
(assert (= (f1 (g1 8)) (- 77)))
(assert (= (f1 (f2 (- 3))) (- 10)))
(assert (= (f1 (g2 (- 7))) 37))
(assert (= (f1 (f3 (- 5))) (- 16)))
(assert (= (f1 (g3 (- 3))) 37))
(assert (= (g1 (f3 8)) (- 131)))
(assert (= (f1 (g4 (- 5))) (- 77)))
(assert (= (g1 (f4 (- 7))) (- 131)))
(assert (= (f2 (f1 (- 3))) (- 10)))
(assert (= (f2 (g1 (- 7))) 61))
(assert (= (f2 (f2 (- 5))) (- 10)))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 8)) (- 53)))
(assert (= (f2 (g3 (- 5))) 61))
(assert (= (g2 (f3 (- 7))) 65))
(assert (= (g2 (f4 (- 3))) (- 53)))
(assert (= (f2 (f4 8)) (- 19)))
(assert (= (g2 (g4 8)) 640))
(assert (= (f3 (f1 (- 5))) (- 16)))
(assert (= (f3 (g1 (- 3))) 29))
(assert (= (g3 (f1 8)) (- 163)))
(assert (= (f3 (g2 (- 5))) 29))
(assert (= (g3 (f2 (- 7))) 117))
(assert (= (g3 (f3 (- 3))) 117))
(assert (= (f3 (f3 8)) 21))
(assert (= (g3 (g3 8)) 1352))
(assert (= (g3 (f4 (- 5))) (- 163)))
(assert (= (f3 (f4 (- 7))) 21))
(assert (= (g3 (g4 (- 7))) 1352))
(assert (= (f4 (g1 (- 5))) (- 49)))
(assert (= (g4 (f1 (- 7))) 176))
(assert (= (g4 (f2 (- 3))) 80))
(assert (= (f4 (f2 8)) (- 19)))
(assert (= (g4 (g2 8)) 640))
(assert (= (g4 (f3 (- 5))) 176))
(assert (= (f4 (f3 (- 7))) 21))
(assert (= (g4 (g3 (- 7))) 1352))
(assert (= (f4 (f4 (- 3))) (- 19)))
(assert (= (g4 (g4 (- 3))) 640))
(check-sat)
