(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 9))) (- 18)))
(assert (= (f1 (g1 (- 8))) 72))
(assert (= (f1 (f2 (- 1))) (- 6)))
(assert (= (f1 (g2 (- 9))) 13))
(assert (= (f1 (f3 (- 5))) (- 18)))
(assert (= (f1 (g3 (- 1))) 13))
(assert (= (g1 (f3 (- 8))) 144))
(assert (= (f1 (g4 (- 5))) 72))
(assert (= (g1 (f4 (- 9))) 144))
(assert (= (f2 (f1 (- 1))) (- 6)))
(assert (= (f2 (g1 (- 9))) 77))
(assert (= (f2 (f2 (- 5))) (- 6)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 (- 8))) 8))
(assert (= (f2 (g3 (- 5))) 77))
(assert (= (g2 (f3 (- 9))) 17))
(assert (= (g2 (f4 (- 1))) 8))
(assert (= (f2 (f4 (- 8))) (- 16)))
(assert (= (g2 (g4 (- 8))) (- 113)))
(assert (= (f3 (f1 (- 5))) (- 18)))
(assert (= (f3 (g1 (- 1))) 13))
(assert (= (g3 (f1 (- 8))) 204))
(assert (= (f3 (g2 (- 5))) 13))
(assert (= (g3 (f2 (- 9))) 153))
(assert (= (g3 (f3 (- 1))) 153))
(assert (= (f3 (f3 (- 8))) (- 25)))
(assert (= (g3 (g3 (- 8))) (- 2168)))
(assert (= (g3 (f4 (- 5))) 204))
(assert (= (f3 (f4 (- 9))) (- 25)))
(assert (= (g3 (g4 (- 9))) (- 2168)))
(assert (= (f4 (g1 (- 5))) 48))
(assert (= (g4 (f1 (- 9))) 195))
(assert (= (g4 (f2 (- 1))) 15))
(assert (= (f4 (f2 (- 8))) (- 16)))
(assert (= (g4 (g2 (- 8))) (- 113)))
(assert (= (g4 (f3 (- 5))) 195))
(assert (= (f4 (f3 (- 9))) (- 25)))
(assert (= (g4 (g3 (- 9))) (- 2168)))
(assert (= (f4 (f4 (- 1))) (- 16)))
(assert (= (g4 (g4 (- 1))) (- 113)))
(check-sat)
