(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 16)))
(assert (= (f1 (g1 (- 6))) 54))
(assert (= (f1 (f2 4)) (- 13)))
(assert (= (f1 (g2 (- 7))) (- 57)))
(assert (= (f1 (f3 (- 5))) (- 16)))
(assert (= (f1 (g3 4)) (- 57)))
(assert (= (g1 (f3 (- 6))) 108))
(assert (= (f1 (g4 (- 5))) 54))
(assert (= (g1 (f4 (- 7))) 108))
(assert (= (f2 (f1 4)) (- 13)))
(assert (= (f2 (g1 (- 7))) (- 63)))
(assert (= (f2 (f2 (- 5))) (- 13)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 6))) 76))
(assert (= (f2 (g3 (- 5))) (- 63)))
(assert (= (g2 (f3 (- 7))) 104))
(assert (= (g2 (f4 4)) 76))
(assert (= (f2 (f4 (- 6))) 15))
(assert (= (g2 (g4 (- 6))) 484))
(assert (= (f3 (f1 (- 5))) (- 16)))
(assert (= (f3 (g1 4)) (- 43)))
(assert (= (g3 (f1 (- 6))) 130))
(assert (= (f3 (g2 (- 5))) (- 43)))
(assert (= (g3 (f2 (- 7))) (- 137)))
(assert (= (g3 (f3 4)) (- 137)))
(assert (= (f3 (f3 (- 6))) (- 19)))
(assert (= (g3 (g3 (- 6))) (- 930)))
(assert (= (g3 (f4 (- 5))) 130))
(assert (= (f3 (f4 (- 7))) (- 19)))
(assert (= (g3 (g4 (- 7))) (- 930)))
(assert (= (f4 (g1 (- 5))) 46))
(assert (= (g4 (f1 (- 7))) 121))
(assert (= (g4 (f2 4)) 88))
(assert (= (f4 (f2 (- 6))) 15))
(assert (= (g4 (g2 (- 6))) 484))
(assert (= (g4 (f3 (- 5))) 121))
(assert (= (f4 (f3 (- 7))) (- 19)))
(assert (= (g4 (g3 (- 7))) (- 930)))
(assert (= (f4 (f4 4)) 15))
(assert (= (g4 (g4 4)) 484))
(check-sat)
