(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua 2 x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num 2 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 16))
(assert (= (f1 (g1 2)) (- 23)))
(assert (= (f1 (f2 5)) (- 15)))
(assert (= (f1 (g2 7)) (- 75)))
(assert (= (f1 (f3 (- 5))) 16))
(assert (= (f1 (g3 5)) (- 75)))
(assert (= (g1 (f3 2)) 81))
(assert (= (f1 (g4 (- 5))) (- 23)))
(assert (= (g1 (f4 7)) 81))
(assert (= (f2 (f1 5)) (- 15)))
(assert (= (f2 (g1 7)) 68))
(assert (= (f2 (f2 (- 5))) (- 15)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 2)) 70))
(assert (= (f2 (g3 (- 5))) 68))
(assert (= (g2 (f3 7)) 140))
(assert (= (g2 (f4 5)) 70))
(assert (= (f2 (f4 2)) 9))
(assert (= (g2 (g4 2)) 80))
(assert (= (f3 (f1 (- 5))) 16))
(assert (= (f3 (g1 5)) 52))
(assert (= (g3 (f1 2)) 91))
(assert (= (f3 (g2 (- 5))) 52))
(assert (= (g3 (f2 7)) 168))
(assert (= (g3 (f3 5)) 168))
(assert (= (f3 (f3 2)) 16))
(assert (= (g3 (g3 2)) 392))
(assert (= (g3 (f4 (- 5))) 91))
(assert (= (f3 (f4 7)) 16))
(assert (= (g3 (g4 7)) 392))
(assert (= (f4 (g1 (- 5))) (- 43)))
(assert (= (g4 (f1 7)) 46))
(assert (= (g4 (f2 5)) 40))
(assert (= (f4 (f2 2)) 9))
(assert (= (g4 (g2 2)) 80))
(assert (= (g4 (f3 (- 5))) 46))
(assert (= (f4 (f3 7)) 16))
(assert (= (g4 (g3 7)) 392))
(assert (= (f4 (f4 5)) 9))
(assert (= (g4 (g4 5)) 80))
(check-sat)
