(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 2)) 11))
(assert (= (f1 (g1 (- 9))) 81))
(assert (= (f1 (f2 7)) (- 19)))
(assert (= (f1 (g2 2)) (- 33)))
(assert (= (f1 (f3 (- 5))) 11))
(assert (= (f1 (g3 7)) (- 33)))
(assert (= (g1 (f3 (- 9))) (- 95)))
(assert (= (f1 (g4 (- 5))) 81))
(assert (= (g1 (f4 2)) (- 95)))
(assert (= (f2 (f1 7)) (- 19)))
(assert (= (f2 (g1 2)) 25))
(assert (= (f2 (f2 (- 5))) (- 19)))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 9))) 217))
(assert (= (f2 (g3 (- 5))) 25))
(assert (= (g2 (f3 2)) 56))
(assert (= (g2 (f4 7)) 217))
(assert (= (f2 (f4 (- 9))) 24))
(assert (= (g2 (g4 (- 9))) 2023))
(assert (= (f3 (f1 (- 5))) 11))
(assert (= (f3 (g1 7)) 65))
(assert (= (g3 (f1 (- 9))) 52))
(assert (= (f3 (g2 (- 5))) 65))
(assert (= (g3 (f2 2)) 36))
(assert (= (g3 (f3 7)) 36))
(assert (= (f3 (f3 (- 9))) (- 13)))
(assert (= (g3 (g3 (- 9))) 136))
(assert (= (g3 (f4 (- 5))) 52))
(assert (= (f3 (f4 2)) (- 13)))
(assert (= (g3 (g4 2)) 136))
(assert (= (f4 (g1 (- 5))) 49))
(assert (= (g4 (f1 2)) (- 111)))
(assert (= (g4 (f2 7)) 238))
(assert (= (f4 (f2 (- 9))) 24))
(assert (= (g4 (g2 (- 9))) 2023))
(assert (= (g4 (f3 (- 5))) (- 111)))
(assert (= (f4 (f3 2)) (- 13)))
(assert (= (g4 (g3 2)) 136))
(assert (= (f4 (f4 7)) 24))
(assert (= (g4 (g4 7)) 2023))
(check-sat)
