(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 25))
(assert (= (f1 (g1 (- 6))) 102))
(assert (= (f1 (f2 (- 8))) (- 24)))
(assert (= (f1 (g2 8)) (- 129)))
(assert (= (f1 (f3 (- 9))) 25))
(assert (= (f1 (g3 (- 8))) (- 129)))
(assert (= (g1 (f3 (- 6))) (- 230)))
(assert (= (f1 (g4 (- 9))) 102))
(assert (= (g1 (f4 8)) (- 230)))
(assert (= (f2 (f1 (- 8))) (- 24)))
(assert (= (f2 (g1 8)) (- 144)))
(assert (= (f2 (f2 (- 9))) (- 24)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 (- 6))) 195))
(assert (= (f2 (g3 (- 9))) (- 144)))
(assert (= (g2 (f3 8)) 240))
(assert (= (g2 (f4 (- 8))) 195))
(assert (= (f2 (f4 (- 6))) (- 19)))
(assert (= (g2 (g4 (- 6))) (- 908)))
(assert (= (f3 (f1 (- 9))) 25))
(assert (= (f3 (g1 (- 8))) (- 136)))
(assert (= (g3 (f1 (- 6))) 224))
(assert (= (f3 (g2 (- 9))) (- 136)))
(assert (= (g3 (f2 8)) 248))
(assert (= (g3 (f3 (- 8))) 248))
(assert (= (f3 (f3 (- 6))) (- 22)))
(assert (= (g3 (g3 (- 6))) 1408))
(assert (= (g3 (f4 (- 9))) 224))
(assert (= (f3 (f4 8)) (- 22)))
(assert (= (g3 (g4 8)) 1408))
(assert (= (f4 (g1 (- 9))) 150))
(assert (= (g4 (f1 8)) (- 182)))
(assert (= (g4 (f2 (- 8))) 165))
(assert (= (f4 (f2 (- 6))) (- 19)))
(assert (= (g4 (g2 (- 6))) (- 908)))
(assert (= (g4 (f3 (- 9))) (- 182)))
(assert (= (f4 (f3 8)) (- 22)))
(assert (= (g4 (g3 8)) 1408))
(assert (= (f4 (f4 (- 8))) (- 19)))
(assert (= (g4 (g4 (- 8))) (- 908)))
(check-sat)
