(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 5) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 5) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 4)) 13))
(assert (= (f1 (g1 (- 9))) 81))
(assert (= (f1 (f2 8)) (- 21)))
(assert (= (f1 (g2 4)) (- 69)))
(assert (= (f1 (f3 (- 5))) 13))
(assert (= (f1 (g3 8)) (- 69)))
(assert (= (g1 (f3 (- 9))) (- 113)))
(assert (= (f1 (g4 (- 5))) 81))
(assert (= (g1 (f4 4)) (- 113)))
(assert (= (f2 (f1 8)) (- 21)))
(assert (= (f2 (g1 4)) 44))
(assert (= (f2 (f2 (- 5))) (- 21)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 9))) 264))
(assert (= (f2 (g3 (- 5))) 44))
(assert (= (g2 (f3 4)) 128))
(assert (= (g2 (f4 8)) 264))
(assert (= (f2 (f4 (- 9))) 25))
(assert (= (g2 (g4 (- 9))) 2312))
(assert (= (f3 (f1 (- 5))) 13))
(assert (= (f3 (g1 8)) 76))
(assert (= (g3 (f1 (- 9))) 104))
(assert (= (f3 (g2 (- 5))) 76))
(assert (= (g3 (f2 4)) 96))
(assert (= (g3 (f3 8)) 96))
(assert (= (f3 (f3 (- 9))) (- 17)))
(assert (= (g3 (g3 (- 9))) 544))
(assert (= (g3 (f4 (- 5))) 104))
(assert (= (f3 (f4 4)) (- 17)))
(assert (= (g3 (g4 4)) 544))
(assert (= (f4 (g1 (- 5))) 49))
(assert (= (g4 (f1 4)) (- 145)))
(assert (= (g4 (f2 8)) 272))
(assert (= (f4 (f2 (- 9))) 25))
(assert (= (g4 (g2 (- 9))) 2312))
(assert (= (g4 (f3 (- 5))) (- 145)))
(assert (= (f4 (f3 4)) (- 17)))
(assert (= (g4 (g3 4)) 544))
(assert (= (f4 (f4 8)) 25))
(assert (= (g4 (g4 8)) 2312))
(check-sat)
