(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 25))
(assert (= (f1 (g1 (- 5))) 85))
(assert (= (f1 (f2 4)) (- 17)))
(assert (= (f1 (g2 8)) (- 73)))
(assert (= (f1 (f3 (- 9))) 25))
(assert (= (f1 (g3 4)) (- 73)))
(assert (= (g1 (f3 (- 5))) (- 213)))
(assert (= (f1 (g4 (- 9))) 85))
(assert (= (g1 (f4 8)) (- 213)))
(assert (= (f2 (f1 4)) (- 17)))
(assert (= (f2 (g1 8)) 140))
(assert (= (f2 (f2 (- 9))) (- 17)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 5))) 68))
(assert (= (f2 (g3 (- 9))) 140))
(assert (= (g2 (f3 8)) 128))
(assert (= (g2 (f4 4)) 68))
(assert (= (f2 (f4 (- 5))) 13))
(assert (= (g2 (g4 (- 5))) 324))
(assert (= (f3 (f1 (- 9))) 25))
(assert (= (f3 (g1 4)) 76))
(assert (= (g3 (f1 (- 5))) 208))
(assert (= (f3 (g2 (- 9))) 76))
(assert (= (g3 (f2 8)) 192))
(assert (= (g3 (f3 4)) 192))
(assert (= (f3 (f3 (- 5))) (- 21)))
(assert (= (g3 (g3 (- 5))) 1152))
(assert (= (g3 (f4 (- 9))) 208))
(assert (= (f3 (f4 8)) (- 21)))
(assert (= (g3 (g4 8)) 1152))
(assert (= (f4 (g1 (- 9))) 149))
(assert (= (g4 (f1 8)) (- 149)))
(assert (= (g4 (f2 4)) 72))
(assert (= (f4 (f2 (- 5))) 13))
(assert (= (g4 (g2 (- 5))) 324))
(assert (= (g4 (f3 (- 9))) (- 149)))
(assert (= (f4 (f3 8)) (- 21)))
(assert (= (g4 (g3 8)) 1152))
(assert (= (f4 (f4 4)) 13))
(assert (= (g4 (g4 4)) 324))
(check-sat)
