(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 7) x))
(define-fun f3 ((x Int)) Int (nua (- 9) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 7) x))
(define-fun g3 ((x Int)) Int (num (- 9) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 9))) (- 16)))
(assert (= (f1 (g1 (- 2))) 14))
(assert (= (f1 (f2 (- 7))) (- 17)))
(assert (= (f1 (g2 (- 9))) 114))
(assert (= (f1 (f3 (- 4))) (- 16)))
(assert (= (f1 (g3 (- 7))) 114))
(assert (= (g1 (f3 (- 2))) 70))
(assert (= (f1 (g4 (- 4))) 14))
(assert (= (g1 (f4 (- 9))) 70))
(assert (= (f2 (f1 (- 7))) (- 17)))
(assert (= (f2 (g1 (- 9))) 66))
(assert (= (f2 (f2 (- 4))) (- 17)))
(assert (= (f2 (g2 (- 7))) 91))
(assert (= (g2 (f2 (- 2))) 104))
(assert (= (f2 (g3 (- 4))) 66))
(assert (= (g2 (f3 (- 9))) 221))
(assert (= (g2 (f4 (- 7))) 104))
(assert (= (f2 (f4 (- 2))) (- 10)))
(assert (= (g2 (g4 (- 2))) (- 59)))
(assert (= (f3 (f1 (- 4))) (- 16)))
(assert (= (f3 (g1 (- 7))) 54))
(assert (= (g3 (f1 (- 2))) 85))
(assert (= (f3 (g2 (- 4))) 54))
(assert (= (g3 (f2 (- 9))) 255))
(assert (= (g3 (f3 (- 7))) 255))
(assert (= (f3 (f3 (- 2))) (- 19)))
(assert (= (g3 (g3 (- 2))) (- 434)))
(assert (= (g3 (f4 (- 4))) 85))
(assert (= (f3 (f4 (- 9))) (- 19)))
(assert (= (g3 (g4 (- 9))) (- 434)))
(assert (= (f4 (g1 (- 4))) 26))
(assert (= (g4 (f1 (- 9))) 36))
(assert (= (g4 (f2 (- 7))) 39))
(assert (= (f4 (f2 (- 2))) (- 10)))
(assert (= (g4 (g2 (- 2))) (- 59)))
(assert (= (g4 (f3 (- 4))) 36))
(assert (= (f4 (f3 (- 9))) (- 19)))
(assert (= (g4 (g3 (- 9))) (- 434)))
(assert (= (f4 (f4 (- 7))) (- 10)))
(assert (= (g4 (g4 (- 7))) (- 59)))
(check-sat)
