(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 12)))
(assert (= (f1 (g1 (- 1))) 7))
(assert (= (f1 (f2 (- 6))) (- 15)))
(assert (= (f1 (g2 (- 5))) 53))
(assert (= (f1 (f3 (- 4))) (- 12)))
(assert (= (f1 (g3 (- 6))) 53))
(assert (= (g1 (f3 (- 1))) 35))
(assert (= (f1 (g4 (- 4))) 7))
(assert (= (g1 (f4 (- 5))) 35))
(assert (= (f2 (f1 (- 6))) (- 15)))
(assert (= (f2 (g1 (- 5))) 37))
(assert (= (f2 (f2 (- 4))) (- 15)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 1))) 66))
(assert (= (f2 (g3 (- 4))) 37))
(assert (= (g2 (f3 (- 5))) 99))
(assert (= (g2 (f4 (- 6))) 66))
(assert (= (f2 (f4 (- 1))) (- 7)))
(assert (= (g2 (g4 (- 1))) (- 6)))
(assert (= (f3 (f1 (- 4))) (- 12)))
(assert (= (f3 (g1 (- 6))) 43))
(assert (= (g3 (f1 (- 1))) 36))
(assert (= (f3 (g2 (- 4))) 43))
(assert (= (g3 (f2 (- 5))) 90))
(assert (= (g3 (f3 (- 6))) 90))
(assert (= (f3 (f3 (- 1))) (- 10)))
(assert (= (g3 (g3 (- 1))) (- 41)))
(assert (= (g3 (f4 (- 4))) 36))
(assert (= (f3 (f4 (- 5))) (- 10)))
(assert (= (g3 (g4 (- 5))) (- 41)))
(assert (= (f4 (g1 (- 4))) 25))
(assert (= (g4 (f1 (- 5))) 8))
(assert (= (g4 (f2 (- 6))) 11))
(assert (= (f4 (f2 (- 1))) (- 7)))
(assert (= (g4 (g2 (- 1))) (- 6)))
(assert (= (g4 (f3 (- 4))) 8))
(assert (= (f4 (f3 (- 5))) (- 10)))
(assert (= (g4 (g3 (- 5))) (- 41)))
(assert (= (f4 (f4 (- 6))) (- 7)))
(assert (= (g4 (g4 (- 6))) (- 6)))
(check-sat)
