(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua (- 1) x))
(define-fun f3 ((x Int)) Int (nua (- 7) x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num (- 1) x))
(define-fun g3 ((x Int)) Int (num (- 7) x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 7))) (- 14)))
(assert (= (f1 (g1 6)) (- 46)))
(assert (= (f1 (f2 (- 1))) (- 5)))
(assert (= (f1 (g2 (- 7))) 10))
(assert (= (f1 (f3 (- 4))) (- 14)))
(assert (= (f1 (g3 (- 1))) 10))
(assert (= (g1 (f3 6)) (- 88)))
(assert (= (f1 (g4 (- 4))) (- 46)))
(assert (= (g1 (f4 (- 7))) (- 88)))
(assert (= (f2 (f1 (- 1))) (- 5)))
(assert (= (f2 (g1 (- 7))) 46))
(assert (= (f2 (f2 (- 4))) (- 5)))
(assert (= (f2 (g2 (- 1))) 1))
(assert (= (g2 (f2 6)) (- 7)))
(assert (= (f2 (g3 (- 4))) 46))
(assert (= (g2 (f3 (- 7))) 13))
(assert (= (g2 (f4 (- 1))) (- 7)))
(assert (= (f2 (f4 6)) (- 13)))
(assert (= (g2 (g4 6)) 72))
(assert (= (f3 (f1 (- 4))) (- 14)))
(assert (= (f3 (g1 (- 1))) 10))
(assert (= (g3 (f1 6)) (- 124)))
(assert (= (f3 (g2 (- 4))) 10))
(assert (= (g3 (f2 (- 7))) 91))
(assert (= (g3 (f3 (- 1))) 91))
(assert (= (f3 (f3 6)) 19))
(assert (= (g3 (g3 6)) 1014))
(assert (= (g3 (f4 (- 4))) (- 124)))
(assert (= (f3 (f4 (- 7))) 19))
(assert (= (g3 (g4 (- 7))) 1014))
(assert (= (f4 (g1 (- 4))) (- 31)))
(assert (= (g4 (f1 (- 7))) 120))
(assert (= (g4 (f2 (- 1))) 12))
(assert (= (f4 (f2 6)) (- 13)))
(assert (= (g4 (g2 6)) 72))
(assert (= (g4 (f3 (- 4))) 120))
(assert (= (f4 (f3 (- 7))) 19))
(assert (= (g4 (g3 (- 7))) 1014))
(assert (= (f4 (f4 (- 1))) (- 13)))
(assert (= (g4 (g4 (- 1))) 72))
(check-sat)
