(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 5)) 12))
(assert (= (f1 (g1 9)) (- 67)))
(assert (= (f1 (f2 2)) (- 8)))
(assert (= (f1 (g2 5)) (- 24)))
(assert (= (f1 (f3 (- 4))) 12))
(assert (= (f1 (g3 2)) (- 24)))
(assert (= (g1 (f3 9)) 98))
(assert (= (f1 (g4 (- 4))) (- 67)))
(assert (= (g1 (f4 5)) 98))
(assert (= (f2 (f1 2)) (- 8)))
(assert (= (f2 (g1 5)) 37))
(assert (= (f2 (f2 (- 4))) (- 8)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 9)) 44))
(assert (= (f2 (g3 (- 4))) 37))
(assert (= (g2 (f3 5)) 40))
(assert (= (g2 (f4 2)) 44))
(assert (= (f2 (f4 9)) 20))
(assert (= (g2 (g4 9)) 648))
(assert (= (f3 (f1 (- 4))) 12))
(assert (= (f3 (g1 2)) 19))
(assert (= (g3 (f1 9)) 125))
(assert (= (f3 (g2 (- 4))) 19))
(assert (= (g3 (f2 5)) 70))
(assert (= (g3 (f3 2)) 70))
(assert (= (f3 (f3 9)) 19))
(assert (= (g3 (g3 9)) 900))
(assert (= (g3 (f4 (- 4))) 125))
(assert (= (f3 (f4 5)) 19))
(assert (= (g3 (g4 5)) 900))
(assert (= (f4 (g1 (- 4))) (- 34)))
(assert (= (g4 (f1 5)) 153))
(assert (= (g4 (f2 2)) 72))
(assert (= (f4 (f2 9)) 20))
(assert (= (g4 (g2 9)) 648))
(assert (= (g4 (f3 (- 4))) 153))
(assert (= (f4 (f3 5)) 19))
(assert (= (g4 (g3 5)) 900))
(assert (= (f4 (f4 2)) 20))
(assert (= (g4 (g4 2)) 648))
(check-sat)
