(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 3 x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 3 x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 1)) 8))
(assert (= (f1 (g1 (- 6))) 42))
(assert (= (f1 (f2 3)) (- 10)))
(assert (= (f1 (g2 1)) (- 10)))
(assert (= (f1 (f3 (- 4))) 8))
(assert (= (f1 (g3 3)) (- 10)))
(assert (= (g1 (f3 (- 6))) (- 46)))
(assert (= (f1 (g4 (- 4))) 42))
(assert (= (g1 (f4 1)) (- 46)))
(assert (= (f2 (f1 3)) (- 10)))
(assert (= (f2 (g1 1)) 10))
(assert (= (f2 (f2 (- 4))) (- 10)))
(assert (= (f2 (g2 3)) 21))
(assert (= (g2 (f2 (- 6))) 51))
(assert (= (f2 (g3 (- 4))) 10))
(assert (= (g2 (f3 1)) 12))
(assert (= (g2 (f4 3)) 51))
(assert (= (f2 (f4 (- 6))) 14))
(assert (= (g2 (g4 (- 6))) 363))
(assert (= (f3 (f1 (- 4))) 8))
(assert (= (f3 (g1 3)) 22))
(assert (= (g3 (f1 (- 6))) 18))
(assert (= (f3 (g2 (- 4))) 22))
(assert (= (g3 (f2 1)) 8))
(assert (= (g3 (f3 3)) 8))
(assert (= (f3 (f3 (- 6))) (- 8)))
(assert (= (g3 (g3 (- 6))) 22))
(assert (= (g3 (f4 (- 4))) 18))
(assert (= (f3 (f4 1)) (- 8)))
(assert (= (g3 (g4 1)) 22))
(assert (= (f4 (g1 (- 4))) 30))
(assert (= (g4 (f1 1)) (- 50)))
(assert (= (g4 (f2 3)) 66))
(assert (= (f4 (f2 (- 6))) 14))
(assert (= (g4 (g2 (- 6))) 363))
(assert (= (g4 (f3 (- 4))) (- 50)))
(assert (= (f4 (f3 1)) (- 8)))
(assert (= (g4 (g3 1)) 22))
(assert (= (f4 (f4 3)) 14))
(assert (= (g4 (g4 3)) 363))
(check-sat)
