(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 4 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 4 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 13)))
(assert (= (f1 (g1 (- 3))) 21))
(assert (= (f1 (f2 4)) (- 12)))
(assert (= (f1 (g2 (- 6))) (- 48)))
(assert (= (f1 (f3 (- 4))) (- 13)))
(assert (= (f1 (g3 4)) (- 48)))
(assert (= (g1 (f3 (- 3))) 56))
(assert (= (f1 (g4 (- 4))) 21))
(assert (= (g1 (f4 (- 6))) 56))
(assert (= (f2 (f1 4)) (- 12)))
(assert (= (f2 (g1 (- 6))) (- 43)))
(assert (= (f2 (f2 (- 4))) (- 12)))
(assert (= (f2 (g2 4)) 36))
(assert (= (g2 (f2 (- 3))) 52))
(assert (= (f2 (g3 (- 4))) (- 43)))
(assert (= (g2 (f3 (- 6))) 88))
(assert (= (g2 (f4 4)) 52))
(assert (= (f2 (f4 (- 3))) 9))
(assert (= (g2 (g4 (- 3))) 100))
(assert (= (f3 (f1 (- 4))) (- 13)))
(assert (= (f3 (g1 4)) (- 34)))
(assert (= (g3 (f1 (- 3))) 66))
(assert (= (f3 (g2 (- 4))) (- 34)))
(assert (= (g3 (f2 (- 6))) (- 105)))
(assert (= (g3 (f3 4)) (- 105)))
(assert (= (f3 (f3 (- 3))) (- 14)))
(assert (= (g3 (g3 (- 3))) (- 303)))
(assert (= (g3 (f4 (- 4))) 66))
(assert (= (f3 (f4 (- 6))) (- 14)))
(assert (= (g3 (g4 (- 6))) (- 303)))
(assert (= (f4 (g1 (- 4))) 27))
(assert (= (g4 (f1 (- 6))) 45))
(assert (= (g4 (f2 4)) 40))
(assert (= (f4 (f2 (- 3))) 9))
(assert (= (g4 (g2 (- 3))) 100))
(assert (= (g4 (f3 (- 4))) 45))
(assert (= (f4 (f3 (- 6))) (- 14)))
(assert (= (g4 (g3 (- 6))) (- 303)))
(assert (= (f4 (f4 4)) 9))
(assert (= (g4 (g4 4)) 100))
(check-sat)
