(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 2) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 2) x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 13)))
(assert (= (f1 (g1 (- 2))) 14))
(assert (= (f1 (f2 5)) (- 14)))
(assert (= (f1 (g2 (- 6))) (- 59)))
(assert (= (f1 (f3 (- 4))) (- 13)))
(assert (= (f1 (g3 5)) (- 59)))
(assert (= (g1 (f3 (- 2))) 49))
(assert (= (f1 (g4 (- 4))) 14))
(assert (= (g1 (f4 (- 6))) 49))
(assert (= (f2 (f1 5)) (- 14)))
(assert (= (f2 (g1 (- 6))) (- 44)))
(assert (= (f2 (f2 (- 4))) (- 14)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 2))) 65))
(assert (= (f2 (g3 (- 4))) (- 44)))
(assert (= (g2 (f3 (- 6))) 110))
(assert (= (g2 (f4 5)) 65))
(assert (= (f2 (f4 (- 2))) 8))
(assert (= (g2 (g4 (- 2))) 45))
(assert (= (f3 (f1 (- 4))) (- 13)))
(assert (= (f3 (g1 5)) (- 41)))
(assert (= (g3 (f1 (- 2))) 55))
(assert (= (f3 (g2 (- 4))) (- 41)))
(assert (= (g3 (f2 (- 6))) (- 116)))
(assert (= (g3 (f3 5)) (- 116)))
(assert (= (f3 (f3 (- 2))) (- 13)))
(assert (= (g3 (g3 (- 2))) (- 182)))
(assert (= (g3 (f4 (- 4))) 55))
(assert (= (f3 (f4 (- 6))) (- 13)))
(assert (= (g3 (g4 (- 6))) (- 182)))
(assert (= (f4 (g1 (- 4))) 26))
(assert (= (g4 (f1 (- 6))) 27))
(assert (= (g4 (f2 5)) 30))
(assert (= (f4 (f2 (- 2))) 8))
(assert (= (g4 (g2 (- 2))) 45))
(assert (= (g4 (f3 (- 4))) 27))
(assert (= (f4 (f3 (- 6))) (- 13)))
(assert (= (g4 (g3 (- 6))) (- 182)))
(assert (= (f4 (f4 5)) 8))
(assert (= (g4 (g4 5)) 45))
(check-sat)
