(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 4) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 4) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 10)))
(assert (= (f1 (g1 (- 6))) 42))
(assert (= (f1 (f2 5)) (- 14)))
(assert (= (f1 (g2 (- 3))) (- 29)))
(assert (= (f1 (f3 (- 4))) (- 10)))
(assert (= (f1 (g3 5)) (- 29)))
(assert (= (g1 (f3 (- 6))) 56))
(assert (= (f1 (g4 (- 4))) 42))
(assert (= (g1 (f4 (- 3))) 56))
(assert (= (f2 (f1 5)) (- 14)))
(assert (= (f2 (g1 (- 3))) (- 23)))
(assert (= (f2 (f2 (- 4))) (- 14)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 (- 6))) 105))
(assert (= (f2 (g3 (- 4))) (- 23)))
(assert (= (g2 (f3 (- 3))) 50))
(assert (= (g2 (f4 5)) 105))
(assert (= (f2 (f4 (- 6))) 16))
(assert (= (g2 (g4 (- 6))) 605))
(assert (= (f3 (f1 (- 4))) (- 10)))
(assert (= (f3 (g1 5)) (- 38)))
(assert (= (g3 (f1 (- 6))) 45))
(assert (= (f3 (g2 (- 4))) (- 38)))
(assert (= (g3 (f2 (- 3))) (- 38)))
(assert (= (g3 (f3 5)) (- 38)))
(assert (= (f3 (f3 (- 6))) (- 11)))
(assert (= (g3 (g3 (- 6))) (- 138)))
(assert (= (g3 (f4 (- 4))) 45))
(assert (= (f3 (f4 (- 3))) (- 11)))
(assert (= (g3 (g4 (- 3))) (- 138)))
(assert (= (f4 (g1 (- 4))) 30))
(assert (= (g4 (f1 (- 3))) 66))
(assert (= (g4 (f2 5)) 110))
(assert (= (f4 (f2 (- 6))) 16))
(assert (= (g4 (g2 (- 6))) 605))
(assert (= (g4 (f3 (- 4))) 66))
(assert (= (f4 (f3 (- 3))) (- 11)))
(assert (= (g4 (g3 (- 3))) (- 138)))
(assert (= (f4 (f4 5)) 16))
(assert (= (g4 (g4 5)) 605))
(check-sat)
