(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 9) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 7 x))
(define-fun f4 ((x Int)) Int (nua (- 8) x))
(define-fun g1 ((x Int)) Int (num (- 9) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 7 x))
(define-fun g4 ((x Int)) Int (num (- 8) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 7)) 24))
(assert (= (f1 (g1 (- 8))) 136))
(assert (= (f1 (f2 (- 6))) (- 20)))
(assert (= (f1 (g2 7)) (- 86)))
(assert (= (f1 (f3 (- 9))) 24))
(assert (= (f1 (g3 (- 6))) (- 86)))
(assert (= (g1 (f3 (- 8))) (- 247)))
(assert (= (f1 (g4 (- 9))) 136))
(assert (= (g1 (f4 7)) (- 247)))
(assert (= (f2 (f1 (- 6))) (- 20)))
(assert (= (f2 (g1 7)) (- 125)))
(assert (= (f2 (f2 (- 9))) (- 20)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 8))) 143))
(assert (= (f2 (g3 (- 9))) (- 125)))
(assert (= (g2 (f3 7)) 154))
(assert (= (g2 (f4 (- 6))) 143))
(assert (= (f2 (f4 (- 8))) (- 21)))
(assert (= (g2 (g4 (- 8))) (- 1238)))
(assert (= (f3 (f1 (- 9))) 24))
(assert (= (f3 (g1 (- 6))) (- 101)))
(assert (= (g3 (f1 (- 8))) 224))
(assert (= (f3 (g2 (- 9))) (- 101)))
(assert (= (g3 (f2 7)) 175))
(assert (= (g3 (f3 (- 6))) 175))
(assert (= (f3 (f3 (- 8))) (- 22)))
(assert (= (g3 (g3 (- 8))) 1470))
(assert (= (g3 (f4 (- 9))) 224))
(assert (= (f3 (f4 7)) (- 22)))
(assert (= (g3 (g4 7)) 1470))
(assert (= (f4 (g1 (- 9))) 152))
(assert (= (g4 (f1 7)) (- 233)))
(assert (= (g4 (f2 (- 6))) 165))
(assert (= (f4 (f2 (- 8))) (- 21)))
(assert (= (g4 (g2 (- 8))) (- 1238)))
(assert (= (g4 (f3 (- 9))) (- 233)))
(assert (= (f4 (f3 7)) (- 22)))
(assert (= (g4 (g3 7)) 1470))
(assert (= (f4 (f4 (- 6))) (- 21)))
(assert (= (g4 (g4 (- 6))) (- 1238)))
(check-sat)
