(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 11))
(assert (= (f1 (g1 4)) (- 23)))
(assert (= (f1 (f2 (- 8))) (- 18)))
(assert (= (f1 (g2 6)) (- 93)))
(assert (= (f1 (f3 (- 3))) 11))
(assert (= (f1 (g3 (- 8))) (- 93)))
(assert (= (g1 (f3 4)) 50))
(assert (= (f1 (g4 (- 3))) (- 23)))
(assert (= (g1 (f4 6)) 50))
(assert (= (f2 (f1 (- 8))) (- 18)))
(assert (= (f2 (g1 6)) (- 38)))
(assert (= (f2 (f2 (- 3))) (- 18)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 4)) (- 173)))
(assert (= (f2 (g3 (- 3))) (- 38)))
(assert (= (g2 (f3 6)) 180))
(assert (= (g2 (f4 (- 8))) (- 173)))
(assert (= (f2 (f4 4)) (- 16)))
(assert (= (g2 (g4 4)) 480))
(assert (= (f3 (f1 (- 3))) 11))
(assert (= (f3 (g1 (- 8))) (- 44)))
(assert (= (g3 (f1 4)) 78))
(assert (= (f3 (g2 (- 3))) (- 44)))
(assert (= (g3 (f2 6)) 162))
(assert (= (g3 (f3 (- 8))) 162))
(assert (= (f3 (f3 4)) 16))
(assert (= (g3 (g3 4)) 576))
(assert (= (g3 (f4 (- 3))) 78))
(assert (= (f3 (f4 6)) 16))
(assert (= (g3 (g4 6)) 576))
(assert (= (f4 (g1 (- 3))) (- 17)))
(assert (= (g4 (f1 6)) 68))
(assert (= (g4 (f2 (- 8))) 120))
(assert (= (f4 (f2 4)) (- 16)))
(assert (= (g4 (g2 4)) 480))
(assert (= (g4 (f3 (- 3))) 68))
(assert (= (f4 (f3 6)) 16))
(assert (= (g4 (g3 6)) 576))
(assert (= (f4 (f4 (- 8))) (- 16)))
(assert (= (g4 (g4 (- 8))) 480))
(check-sat)
