(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua (- 1) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num (- 1) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 13)))
(assert (= (f1 (g1 (- 1))) 5))
(assert (= (f1 (f2 (- 6))) (- 14)))
(assert (= (f1 (g2 (- 8))) 85))
(assert (= (f1 (f3 (- 3))) (- 13)))
(assert (= (f1 (g3 (- 6))) 85))
(assert (= (g1 (f3 (- 1))) 40))
(assert (= (f1 (g4 (- 3))) 5))
(assert (= (g1 (f4 (- 8))) 40))
(assert (= (f2 (f1 (- 6))) (- 14)))
(assert (= (f2 (g1 (- 8))) 43))
(assert (= (f2 (f2 (- 3))) (- 14)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 1))) 66))
(assert (= (f2 (g3 (- 3))) 43))
(assert (= (g2 (f3 (- 8))) 165))
(assert (= (g2 (f4 (- 6))) 66))
(assert (= (f2 (f4 (- 1))) (- 7)))
(assert (= (g2 (g4 (- 1))) (- 6)))
(assert (= (f3 (f1 (- 3))) (- 13)))
(assert (= (f3 (g1 (- 6))) 35))
(assert (= (g3 (f1 (- 1))) 45))
(assert (= (f3 (g2 (- 3))) 35))
(assert (= (g3 (f2 (- 8))) 195))
(assert (= (g3 (f3 (- 6))) 195))
(assert (= (f3 (f3 (- 1))) (- 16)))
(assert (= (g3 (g3 (- 1))) (- 113)))
(assert (= (g3 (f4 (- 3))) 45))
(assert (= (f3 (f4 (- 8))) (- 16)))
(assert (= (g3 (g4 (- 8))) (- 113)))
(assert (= (f4 (g1 (- 3))) 13))
(assert (= (g4 (f1 (- 8))) 10))
(assert (= (g4 (f2 (- 6))) 11))
(assert (= (f4 (f2 (- 1))) (- 7)))
(assert (= (g4 (g2 (- 1))) (- 6)))
(assert (= (g4 (f3 (- 3))) 10))
(assert (= (f4 (f3 (- 8))) (- 16)))
(assert (= (g4 (g3 (- 8))) (- 113)))
(assert (= (f4 (f4 (- 6))) (- 7)))
(assert (= (g4 (g4 (- 6))) (- 6)))
(check-sat)
