(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua 4 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num 4 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 4)) 9))
(assert (= (f1 (g1 7)) (- 38)))
(assert (= (f1 (f2 (- 6))) (- 14)))
(assert (= (f1 (g2 4)) (- 47)))
(assert (= (f1 (f3 (- 3))) 9))
(assert (= (f1 (g3 (- 6))) (- 47)))
(assert (= (g1 (f3 7)) 55))
(assert (= (f1 (g4 (- 3))) (- 38)))
(assert (= (g1 (f4 4)) 55))
(assert (= (f2 (f1 (- 6))) (- 14)))
(assert (= (f2 (g1 4)) (- 26)))
(assert (= (f2 (f2 (- 3))) (- 14)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 7)) (- 138)))
(assert (= (f2 (g3 (- 3))) (- 26)))
(assert (= (g2 (f3 4)) 88))
(assert (= (g2 (f4 (- 6))) (- 138)))
(assert (= (f2 (f4 7)) (- 20)))
(assert (= (g2 (g4 7)) 1078))
(assert (= (f3 (f1 (- 3))) 9))
(assert (= (f3 (g1 (- 6))) (- 32)))
(assert (= (g3 (f1 7)) 76))
(assert (= (f3 (g2 (- 3))) (- 32)))
(assert (= (g3 (f2 4)) 76))
(assert (= (g3 (f3 (- 6))) 76))
(assert (= (f3 (f3 7)) 15))
(assert (= (g3 (g3 7)) 448))
(assert (= (g3 (f4 (- 3))) 76))
(assert (= (f3 (f4 4)) 15))
(assert (= (g3 (g4 4)) 448))
(assert (= (f4 (g1 (- 3))) (- 20)))
(assert (= (g4 (f1 4)) 91))
(assert (= (g4 (f2 (- 6))) 154))
(assert (= (f4 (f2 7)) (- 20)))
(assert (= (g4 (g2 7)) 1078))
(assert (= (g4 (f3 (- 3))) 91))
(assert (= (f4 (f3 4)) 15))
(assert (= (g4 (g3 4)) 448))
(assert (= (f4 (f4 (- 6))) (- 20)))
(assert (= (g4 (g4 (- 6))) 1078))
(check-sat)
