(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua (- 4) x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num (- 4) x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 3)) 8))
(assert (= (f1 (g1 (- 9))) 45))
(assert (= (f1 (f2 (- 4))) (- 10)))
(assert (= (f1 (g2 3)) (- 24)))
(assert (= (f1 (f3 (- 3))) 8))
(assert (= (f1 (g3 (- 4))) (- 24)))
(assert (= (g1 (f3 (- 9))) (- 58)))
(assert (= (f1 (g4 (- 3))) 45))
(assert (= (g1 (f4 3)) (- 58)))
(assert (= (f2 (f1 (- 4))) (- 10)))
(assert (= (f2 (g1 3)) (- 19)))
(assert (= (f2 (f2 (- 3))) (- 10)))
(assert (= (f2 (g2 (- 4))) 28))
(assert (= (g2 (f2 (- 9))) 84))
(assert (= (f2 (g3 (- 3))) (- 19)))
(assert (= (g2 (f3 3)) 42))
(assert (= (g2 (f4 (- 4))) 84))
(assert (= (f2 (f4 (- 9))) (- 21)))
(assert (= (g2 (g4 (- 9))) (- 1012)))
(assert (= (f3 (f1 (- 3))) 8))
(assert (= (f3 (g1 (- 4))) (- 21)))
(assert (= (g3 (f1 (- 9))) 66))
(assert (= (f3 (g2 (- 3))) (- 21)))
(assert (= (g3 (f2 3)) 39))
(assert (= (g3 (f3 (- 4))) 39))
(assert (= (f3 (f3 (- 9))) (- 15)))
(assert (= (g3 (g3 (- 9))) 306))
(assert (= (g3 (f4 (- 3))) 66))
(assert (= (f3 (f4 3)) (- 15)))
(assert (= (g3 (g4 3)) 306))
(assert (= (f4 (g1 (- 3))) 21))
(assert (= (g4 (f1 3)) (- 94)))
(assert (= (g4 (f2 (- 4))) 119))
(assert (= (f4 (f2 (- 9))) (- 21)))
(assert (= (g4 (g2 (- 9))) (- 1012)))
(assert (= (g4 (f3 (- 3))) (- 94)))
(assert (= (f4 (f3 3)) (- 15)))
(assert (= (g4 (g3 3)) 306))
(assert (= (f4 (f4 (- 4))) (- 21)))
(assert (= (g4 (g4 (- 4))) (- 1012)))
(check-sat)
