(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua (- 6) x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num (- 6) x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 20)))
(assert (= (f1 (g1 (- 9))) 135))
(assert (= (f1 (f2 (- 6))) (- 19)))
(assert (= (f1 (g2 (- 5))) 57))
(assert (= (f1 (f3 (- 8))) (- 20)))
(assert (= (f1 (g3 (- 6))) 57))
(assert (= (g1 (f3 (- 9))) 195))
(assert (= (f1 (g4 (- 8))) 135))
(assert (= (g1 (f4 (- 5))) 195))
(assert (= (f2 (f1 (- 6))) (- 19)))
(assert (= (f2 (g1 (- 5))) 73))
(assert (= (f2 (f2 (- 8))) (- 19)))
(assert (= (f2 (g2 (- 6))) 66))
(assert (= (g2 (f2 (- 9))) 154))
(assert (= (f2 (g3 (- 8))) 73))
(assert (= (g2 (f3 (- 5))) 99))
(assert (= (g2 (f4 (- 6))) 154))
(assert (= (f2 (f4 (- 9))) (- 23)))
(assert (= (g2 (g4 (- 9))) (- 1590)))
(assert (= (f3 (f1 (- 8))) (- 20)))
(assert (= (f3 (g1 (- 6))) 87))
(assert (= (g3 (f1 (- 9))) 144))
(assert (= (f3 (g2 (- 8))) 87))
(assert (= (g3 (f2 (- 5))) 90))
(assert (= (g3 (f3 (- 6))) 90))
(assert (= (f3 (f3 (- 9))) (- 18)))
(assert (= (g3 (g3 (- 9))) (- 689)))
(assert (= (g3 (f4 (- 8))) 144))
(assert (= (f3 (f4 (- 5))) (- 18)))
(assert (= (g3 (g4 (- 5))) (- 689)))
(assert (= (f4 (g1 (- 8))) 121))
(assert (= (g4 (f1 (- 5))) 204))
(assert (= (g4 (f2 (- 6))) 187))
(assert (= (f4 (f2 (- 9))) (- 23)))
(assert (= (g4 (g2 (- 9))) (- 1590)))
(assert (= (g4 (f3 (- 8))) 204))
(assert (= (f4 (f3 (- 5))) (- 18)))
(assert (= (g4 (g3 (- 5))) (- 689)))
(assert (= (f4 (f4 (- 6))) (- 23)))
(assert (= (g4 (g4 (- 6))) (- 1590)))
(check-sat)
