(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 3)) 8))
(assert (= (f1 (g1 (- 6))) 30))
(assert (= (f1 (f2 1)) (- 5)))
(assert (= (f1 (g2 3)) (- 9)))
(assert (= (f1 (f3 (- 3))) 8))
(assert (= (f1 (g3 1)) (- 9)))
(assert (= (g1 (f3 (- 6))) (- 43)))
(assert (= (f1 (g4 (- 3))) 30))
(assert (= (g1 (f4 3)) (- 43)))
(assert (= (f2 (f1 1)) (- 5)))
(assert (= (f2 (g1 3)) 16))
(assert (= (f2 (f2 (- 3))) (- 5)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 6))) 13))
(assert (= (f2 (g3 (- 3))) 16))
(assert (= (g2 (f3 3)) 12))
(assert (= (g2 (f4 1)) 13))
(assert (= (f2 (f4 (- 6))) 12))
(assert (= (g2 (g4 (- 6))) 121))
(assert (= (f3 (f1 (- 3))) 8))
(assert (= (f3 (g1 1)) 8))
(assert (= (g3 (f1 (- 6))) 48))
(assert (= (f3 (g2 (- 3))) 8))
(assert (= (g3 (f2 3)) 24))
(assert (= (g3 (f3 1)) 24))
(assert (= (f3 (f3 (- 6))) (- 12)))
(assert (= (g3 (g3 (- 6))) 198))
(assert (= (g3 (f4 (- 3))) 48))
(assert (= (f3 (f4 3)) (- 12)))
(assert (= (g3 (g4 3)) 198))
(assert (= (f4 (g1 (- 3))) 18))
(assert (= (g4 (f1 3)) (- 61)))
(assert (= (g4 (f2 1)) 22))
(assert (= (f4 (f2 (- 6))) 12))
(assert (= (g4 (g2 (- 6))) 121))
(assert (= (g4 (f3 (- 3))) (- 61)))
(assert (= (f4 (f3 3)) (- 12)))
(assert (= (g4 (g3 3)) 198))
(assert (= (f4 (f4 1)) 12))
(assert (= (g4 (g4 1)) 121))
(check-sat)
