(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f1 (f1 x))) (f2 (f3 x)))))
(assert (= (f1 (f1 (- 6))) (- 11)))
(assert (= (f1 (g1 4)) (- 23)))
(assert (= (f1 (f2 2)) (- 7)))
(assert (= (f1 (g2 (- 6))) (- 25)))
(assert (= (f1 (f3 (- 3))) (- 11)))
(assert (= (f1 (g3 2)) (- 25)))
(assert (= (g1 (f3 4)) (- 48)))
(assert (= (f1 (g4 (- 3))) (- 23)))
(assert (= (g1 (f4 (- 6))) (- 48)))
(assert (= (f2 (f1 2)) (- 7)))
(assert (= (f2 (g1 (- 6))) (- 30)))
(assert (= (f2 (f2 (- 3))) (- 7)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 4)) 24))
(assert (= (f2 (g3 (- 3))) (- 30)))
(assert (= (g2 (f3 (- 6))) 44))
(assert (= (g2 (f4 2)) 24))
(assert (= (f2 (f4 4)) 10))
(assert (= (g2 (g4 4)) 128))
(assert (= (f3 (f1 (- 3))) (- 11)))
(assert (= (f3 (g1 2)) (- 16)))
(assert (= (g3 (f1 4)) (- 72)))
(assert (= (f3 (g2 (- 3))) (- 16)))
(assert (= (g3 (f2 (- 6))) (- 83)))
(assert (= (g3 (f3 2)) (- 83)))
(assert (= (f3 (f3 4)) 15))
(assert (= (g3 (g3 4)) 484))
(assert (= (g3 (f4 (- 3))) (- 72)))
(assert (= (f3 (f4 (- 6))) 15))
(assert (= (g3 (g4 (- 6))) 484))
(assert (= (f4 (g1 (- 3))) (- 17)))
(assert (= (g4 (f1 (- 6))) 64))
(assert (= (g4 (f2 2)) 32))
(assert (= (f4 (f2 4)) 10))
(assert (= (g4 (g2 4)) 128))
(assert (= (g4 (f3 (- 3))) 64))
(assert (= (f4 (f3 (- 6))) 15))
(assert (= (g4 (g3 (- 6))) 484))
(assert (= (f4 (f4 2)) 10))
(assert (= (g4 (g4 2)) 128))
(check-sat)
