(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 7))
(assert (= (f1 (g1 (- 9))) 45))
(assert (= (f1 (f2 8)) (- 19)))
(assert (= (f1 (g2 2)) (- 35)))
(assert (= (f1 (f3 (- 3))) 7))
(assert (= (f1 (g3 8)) (- 35)))
(assert (= (g1 (f3 (- 9))) (- 53)))
(assert (= (f1 (g4 (- 3))) 45))
(assert (= (g1 (f4 2)) (- 53)))
(assert (= (f2 (f1 8)) (- 19)))
(assert (= (f2 (g1 2)) 18))
(assert (= (f2 (f2 (- 3))) (- 19)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 9))) 264))
(assert (= (f2 (g3 (- 3))) 18))
(assert (= (g2 (f3 2)) 64))
(assert (= (g2 (f4 8)) 264))
(assert (= (f2 (f4 (- 9))) 25))
(assert (= (g2 (g4 (- 9))) 2312))
(assert (= (f3 (f1 (- 3))) 7))
(assert (= (f3 (g1 8)) 42))
(assert (= (g3 (f1 (- 9))) 44))
(assert (= (f3 (g2 (- 3))) 42))
(assert (= (g3 (f2 2)) 40))
(assert (= (g3 (f3 8)) 40))
(assert (= (f3 (f3 (- 9))) (- 13)))
(assert (= (g3 (g3 (- 9))) 136))
(assert (= (g3 (f4 (- 3))) 44))
(assert (= (f3 (f4 2)) (- 13)))
(assert (= (g3 (g4 2)) 136))
(assert (= (f4 (g1 (- 3))) 21))
(assert (= (g4 (f1 2)) (- 77)))
(assert (= (g4 (f2 8)) 272))
(assert (= (f4 (f2 (- 9))) 25))
(assert (= (g4 (g2 (- 9))) 2312))
(assert (= (g4 (f3 (- 3))) (- 77)))
(assert (= (f4 (f3 2)) (- 13)))
(assert (= (g4 (g3 2)) 136))
(assert (= (f4 (f4 8)) 25))
(assert (= (g4 (g4 8)) 2312))
(check-sat)
