(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 8 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 8 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 11))
(assert (= (f1 (g1 (- 5))) 25))
(assert (= (f1 (f2 8)) (- 19)))
(assert (= (f1 (g2 6)) (- 99)))
(assert (= (f1 (f3 (- 3))) 11))
(assert (= (f1 (g3 8)) (- 99)))
(assert (= (g1 (f3 (- 5))) (- 53)))
(assert (= (f1 (g4 (- 3))) 25))
(assert (= (g1 (f4 6)) (- 53)))
(assert (= (f2 (f1 8)) (- 19)))
(assert (= (f2 (g1 6)) 38))
(assert (= (f2 (f2 (- 3))) (- 19)))
(assert (= (f2 (g2 8)) 136))
(assert (= (g2 (f2 (- 5))) 200))
(assert (= (f2 (g3 (- 3))) 38))
(assert (= (g2 (f3 6)) 192))
(assert (= (g2 (f4 8)) 200))
(assert (= (f2 (f4 (- 5))) 17))
(assert (= (g2 (g4 (- 5))) 648))
(assert (= (f3 (f1 (- 3))) 11))
(assert (= (f3 (g1 8)) 46))
(assert (= (g3 (f1 (- 5))) 84))
(assert (= (f3 (g2 (- 3))) 46))
(assert (= (g3 (f2 6)) 168))
(assert (= (g3 (f3 8)) 168))
(assert (= (f3 (f3 (- 5))) (- 17)))
(assert (= (g3 (g3 (- 5))) 648))
(assert (= (g3 (f4 (- 3))) 84))
(assert (= (f3 (f4 6)) (- 17)))
(assert (= (g3 (g4 6)) 648))
(assert (= (f4 (g1 (- 3))) 17))
(assert (= (g4 (f1 6)) (- 77)))
(assert (= (g4 (f2 8)) 144))
(assert (= (f4 (f2 (- 5))) 17))
(assert (= (g4 (g2 (- 5))) 648))
(assert (= (g4 (f3 (- 3))) (- 77)))
(assert (= (f4 (f3 6)) (- 17)))
(assert (= (g4 (g3 6)) 648))
(assert (= (f4 (f4 8)) 17))
(assert (= (g4 (g4 8)) 648))
(check-sat)
