(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 8) x))
(define-fun f4 ((x Int)) Int (nua 4 x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 8) x))
(define-fun g4 ((x Int)) Int (num 4 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 8))) (- 13)))
(assert (= (f1 (g1 4)) (- 23)))
(assert (= (f1 (f2 9)) (- 21)))
(assert (= (f1 (g2 (- 8))) (- 138)))
(assert (= (f1 (f3 (- 3))) (- 13)))
(assert (= (f1 (g3 9)) (- 138)))
(assert (= (g1 (f3 4)) (- 58)))
(assert (= (f1 (g4 (- 3))) (- 23)))
(assert (= (g1 (f4 (- 8))) (- 58)))
(assert (= (f2 (f1 9)) (- 21)))
(assert (= (f2 (g1 (- 8))) (- 47)))
(assert (= (f2 (f2 (- 3))) (- 21)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 4)) 234))
(assert (= (f2 (g3 (- 3))) (- 47)))
(assert (= (g2 (f3 (- 8))) 270))
(assert (= (g2 (f4 9)) 234))
(assert (= (f2 (f4 4)) 17))
(assert (= (g2 (g4 4)) 576))
(assert (= (f3 (f1 (- 3))) (- 13)))
(assert (= (f3 (g1 9)) (- 53)))
(assert (= (g3 (f1 4)) (- 98)))
(assert (= (f3 (g2 (- 3))) (- 53)))
(assert (= (g3 (f2 (- 8))) (- 248)))
(assert (= (g3 (f3 9)) (- 248)))
(assert (= (f3 (f3 4)) 19))
(assert (= (g3 (g3 4)) 900))
(assert (= (g3 (f4 (- 3))) (- 98)))
(assert (= (f3 (f4 (- 8))) 19))
(assert (= (g3 (g4 (- 8))) 900))
(assert (= (f4 (g1 (- 3))) (- 17)))
(assert (= (g4 (f1 (- 8))) 80))
(assert (= (g4 (f2 9)) 144))
(assert (= (f4 (f2 4)) 17))
(assert (= (g4 (g2 4)) 576))
(assert (= (g4 (f3 (- 3))) 80))
(assert (= (f4 (f3 (- 8))) 19))
(assert (= (g4 (g3 (- 8))) 900))
(assert (= (f4 (f4 9)) 17))
(assert (= (g4 (g4 9)) 576))
(check-sat)
