(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 3) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num (- 3) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (g1 (g2 x)) (g3 (g4 x)))))
(assert (= (f1 (f1 5)) 10))
(assert (= (f1 (g1 (- 5))) 25))
(assert (= (f1 (f2 9)) (- 21)))
(assert (= (f1 (g2 5)) (- 93)))
(assert (= (f1 (f3 (- 3))) 10))
(assert (= (f1 (g3 9)) (- 93)))
(assert (= (g1 (f3 (- 5))) (- 48)))
(assert (= (f1 (g4 (- 3))) 25))
(assert (= (g1 (f4 5)) (- 48)))
(assert (= (f2 (f1 9)) (- 21)))
(assert (= (f2 (g1 5)) 34))
(assert (= (f2 (f2 (- 3))) (- 21)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 5))) 243))
(assert (= (f2 (g3 (- 3))) 34))
(assert (= (g2 (f3 5)) 180))
(assert (= (g2 (f4 9)) 243))
(assert (= (f2 (f4 (- 5))) 18))
(assert (= (g2 (g4 (- 5))) 729))
(assert (= (f3 (f1 (- 3))) 10))
(assert (= (f3 (g1 9)) 50))
(assert (= (g3 (f1 (- 5))) 70))
(assert (= (f3 (g2 (- 3))) 50))
(assert (= (g3 (f2 5)) 140))
(assert (= (g3 (f3 9)) 140))
(assert (= (f3 (f3 (- 5))) (- 15)))
(assert (= (g3 (g3 (- 5))) 450))
(assert (= (g3 (f4 (- 3))) 70))
(assert (= (f3 (f4 5)) (- 15)))
(assert (= (g3 (g4 5)) 450))
(assert (= (f4 (g1 (- 3))) 17))
(assert (= (g4 (f1 5)) (- 68)))
(assert (= (g4 (f2 9)) 162))
(assert (= (f4 (f2 (- 5))) 18))
(assert (= (g4 (g2 (- 5))) 729))
(assert (= (g4 (f3 (- 3))) (- 68)))
(assert (= (f4 (f3 5)) (- 15)))
(assert (= (g4 (g3 5)) 450))
(assert (= (f4 (f4 9)) 18))
(assert (= (g4 (g4 9)) 729))
(check-sat)
