(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 5 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 5 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f3 x)))))
(assert (= (f1 (f1 5)) 8))
(assert (= (f1 (g1 7)) (- 23)))
(assert (= (f1 (f2 (- 9))) (- 19)))
(assert (= (f1 (g2 5)) (- 87)))
(assert (= (f1 (f3 (- 2))) 8))
(assert (= (f1 (g3 (- 9))) (- 87)))
(assert (= (g1 (f3 7)) 36))
(assert (= (f1 (g4 (- 2))) (- 23)))
(assert (= (g1 (f4 5)) 36))
(assert (= (f2 (f1 (- 9))) (- 19)))
(assert (= (f2 (g1 5)) (- 24)))
(assert (= (f2 (f2 (- 2))) (- 19)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 7)) (- 264)))
(assert (= (f2 (g3 (- 2))) (- 24)))
(assert (= (g2 (f3 5)) 170))
(assert (= (g2 (f4 (- 9))) (- 264)))
(assert (= (f2 (f4 7)) (- 23)))
(assert (= (g2 (g4 7)) 1666))
(assert (= (f3 (f1 (- 2))) 8))
(assert (= (f3 (g1 (- 9))) (- 31)))
(assert (= (g3 (f1 7)) 85))
(assert (= (f3 (g2 (- 2))) (- 31)))
(assert (= (g3 (f2 5)) 135))
(assert (= (g3 (f3 (- 9))) 135))
(assert (= (f3 (f3 7)) 17))
(assert (= (g3 (g3 7)) 700))
(assert (= (g3 (f4 (- 2))) 85))
(assert (= (f3 (f4 5)) 17))
(assert (= (g3 (g4 5)) 700))
(assert (= (f4 (g1 (- 2))) (- 12)))
(assert (= (g4 (f1 5)) 91))
(assert (= (g4 (f2 (- 9))) 238))
(assert (= (f4 (f2 7)) (- 23)))
(assert (= (g4 (g2 7)) 1666))
(assert (= (g4 (f3 (- 2))) 91))
(assert (= (f4 (f3 5)) 17))
(assert (= (g4 (g3 5)) 700))
(assert (= (f4 (f4 (- 9))) (- 23)))
(assert (= (g4 (g4 (- 9))) 1666))
(check-sat)
