(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua (- 5) x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua (- 3) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num (- 5) x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num (- 3) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 8)) 11))
(assert (= (f1 (g1 (- 3))) 9))
(assert (= (f1 (f2 (- 5))) (- 11)))
(assert (= (f1 (g2 8)) (- 74)))
(assert (= (f1 (f3 (- 2))) 11))
(assert (= (f1 (g3 (- 5))) (- 74)))
(assert (= (g1 (f3 (- 3))) (- 32)))
(assert (= (f1 (g4 (- 2))) 9))
(assert (= (g1 (f4 8)) (- 32)))
(assert (= (f2 (f1 (- 5))) (- 11)))
(assert (= (f2 (g1 8)) (- 29)))
(assert (= (f2 (f2 (- 2))) (- 11)))
(assert (= (f2 (g2 (- 5))) 45))
(assert (= (g2 (f2 (- 3))) 63))
(assert (= (f2 (g3 (- 2))) (- 29)))
(assert (= (g2 (f3 8)) 144))
(assert (= (g2 (f4 (- 5))) 63))
(assert (= (f2 (f4 (- 3))) (- 10)))
(assert (= (g2 (g4 (- 3))) (- 113)))
(assert (= (f3 (f1 (- 2))) 11))
(assert (= (f3 (g1 (- 5))) (- 22)))
(assert (= (g3 (f1 (- 3))) 64))
(assert (= (f3 (g2 (- 2))) (- 22)))
(assert (= (g3 (f2 8)) 200))
(assert (= (g3 (f3 (- 5))) 200))
(assert (= (f3 (f3 (- 3))) (- 19)))
(assert (= (g3 (g3 (- 3))) 640))
(assert (= (g3 (f4 (- 2))) 64))
(assert (= (f3 (f4 8)) (- 19)))
(assert (= (g3 (g4 8)) 640))
(assert (= (f4 (g1 (- 2))) 7))
(assert (= (g4 (f1 8)) (- 48)))
(assert (= (g4 (f2 (- 5))) 45))
(assert (= (f4 (f2 (- 3))) (- 10)))
(assert (= (g4 (g2 (- 3))) (- 113)))
(assert (= (g4 (f3 (- 2))) (- 48)))
(assert (= (f4 (f3 8)) (- 19)))
(assert (= (g4 (g3 8)) 640))
(assert (= (f4 (f4 (- 5))) (- 10)))
(assert (= (g4 (g4 (- 5))) (- 113)))
(check-sat)
