(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 0 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 9) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 0 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 9) x))
(assert (forall ((x Int)) (= (f1 (f1 x)) (f2 (f3 x)))))
(assert (= (f1 (f1 3)) 6))
(assert (= (f1 (g1 (- 9))) 27))
(assert (= (f1 (f2 0)) (- 2)))
(assert (= (f1 (g2 3)) (- 2)))
(assert (= (f1 (f3 (- 2))) 6))
(assert (= (f1 (g3 0)) (- 2)))
(assert (= (g1 (f3 (- 9))) (- 35)))
(assert (= (f1 (g4 (- 2))) 27))
(assert (= (g1 (f4 3)) (- 35)))
(assert (= (f2 (f1 0)) (- 2)))
(assert (= (f2 (g1 3)) 9))
(assert (= (f2 (f2 (- 2))) (- 2)))
(assert (= (f2 (g2 0)) 0))
(assert (= (g2 (f2 (- 9))) 0))
(assert (= (f2 (g3 (- 2))) 9))
(assert (= (g2 (f3 3)) 0))
(assert (= (g2 (f4 0)) 0))
(assert (= (f2 (f4 (- 9))) 17))
(assert (= (g2 (g4 (- 9))) 0))
(assert (= (f3 (f1 (- 2))) 6))
(assert (= (f3 (g1 0)) 3))
(assert (= (g3 (f1 (- 9))) 60))
(assert (= (f3 (g2 (- 2))) 3))
(assert (= (g3 (f2 3)) 18))
(assert (= (g3 (f3 0)) 18))
(assert (= (f3 (f3 (- 9))) (- 15)))
(assert (= (g3 (g3 (- 9))) 306))
(assert (= (g3 (f4 (- 2))) 60))
(assert (= (f3 (f4 3)) (- 15)))
(assert (= (g3 (g4 3)) 306))
(assert (= (f4 (g1 (- 2))) 13))
(assert (= (g4 (f1 3)) (- 77)))
(assert (= (g4 (f2 0)) 0))
(assert (= (f4 (f2 (- 9))) 17))
(assert (= (g4 (g2 (- 9))) 0))
(assert (= (g4 (f3 (- 2))) (- 77)))
(assert (= (f4 (f3 3)) (- 15)))
(assert (= (g4 (g3 3)) 306))
(assert (= (f4 (f4 0)) 17))
(assert (= (g4 (g4 0)) 0))
(check-sat)
