(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 8 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 8 x))
(assert (forall ((x Int)) (= (g1 (g1 (g2 x))) (g3 (g3 x)))))
(assert (= (f1 (f1 3)) 6))
(assert (= (f1 (g1 8)) (- 26)))
(assert (= (f1 (f2 2)) (- 6)))
(assert (= (f1 (g2 3)) (- 14)))
(assert (= (f1 (f3 (- 2))) 6))
(assert (= (f1 (g3 2)) (- 14)))
(assert (= (g1 (f3 8)) 33))
(assert (= (f1 (g4 (- 2))) (- 26)))
(assert (= (g1 (f4 3)) 33))
(assert (= (f2 (f1 2)) (- 6)))
(assert (= (f2 (g1 3)) 11))
(assert (= (f2 (f2 (- 2))) (- 6)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 8)) 40))
(assert (= (f2 (g3 (- 2))) 11))
(assert (= (g2 (f3 3)) 24))
(assert (= (g2 (f4 2)) 40))
(assert (= (f2 (f4 8)) 18))
(assert (= (g2 (g4 8)) 512))
(assert (= (f3 (f1 (- 2))) 6))
(assert (= (f3 (g1 2)) 9))
(assert (= (g3 (f1 8)) 57))
(assert (= (f3 (g2 (- 2))) 9))
(assert (= (g3 (f2 3)) 30))
(assert (= (g3 (f3 2)) 30))
(assert (= (f3 (f3 8)) 14))
(assert (= (g3 (g3 8)) 288))
(assert (= (g3 (f4 (- 2))) 57))
(assert (= (f3 (f4 3)) 14))
(assert (= (g3 (g4 3)) 288))
(assert (= (f4 (g1 (- 2))) (- 13)))
(assert (= (g4 (f1 3)) 72))
(assert (= (g4 (f2 2)) 64))
(assert (= (f4 (f2 8)) 18))
(assert (= (g4 (g2 8)) 512))
(assert (= (g4 (f3 (- 2))) 72))
(assert (= (f4 (f3 3)) 14))
(assert (= (g4 (g3 3)) 288))
(assert (= (f4 (f4 2)) 18))
(assert (= (g4 (g4 2)) 512))
(check-sat)
