(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua (- 2) x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num (- 2) x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 17))
(assert (= (f1 (g1 7)) (- 113)))
(assert (= (f1 (f2 (- 2))) (- 11)))
(assert (= (f1 (g2 2)) (- 14)))
(assert (= (f1 (f3 (- 8))) 17))
(assert (= (f1 (g3 (- 2))) (- 14)))
(assert (= (g1 (f3 7)) 135))
(assert (= (f1 (g4 (- 8))) (- 113)))
(assert (= (g1 (f4 2)) 135))
(assert (= (f2 (f1 (- 2))) (- 11)))
(assert (= (f2 (g1 2)) (- 32)))
(assert (= (f2 (f2 (- 8))) (- 11)))
(assert (= (f2 (g2 (- 2))) 6))
(assert (= (g2 (f2 7)) (- 26)))
(assert (= (f2 (g3 (- 8))) (- 32)))
(assert (= (g2 (f3 2)) 12))
(assert (= (g2 (f4 (- 2))) (- 26)))
(assert (= (f2 (f4 7)) (- 16)))
(assert (= (g2 (g4 7)) 294))
(assert (= (f3 (f1 (- 8))) 17))
(assert (= (f3 (g1 (- 2))) (- 25)))
(assert (= (g3 (f1 7)) 58))
(assert (= (f3 (g2 (- 8))) (- 25)))
(assert (= (g3 (f2 2)) 14))
(assert (= (g3 (f3 (- 2))) 14))
(assert (= (f3 (f3 7)) 11))
(assert (= (g3 (g3 7)) 112))
(assert (= (g3 (f4 (- 8))) 58))
(assert (= (f3 (f4 2)) 11))
(assert (= (g3 (g4 2)) 112))
(assert (= (f4 (g1 (- 8))) (- 120)))
(assert (= (g4 (f1 2)) 133))
(assert (= (g4 (f2 (- 2))) 42))
(assert (= (f4 (f2 7)) (- 16)))
(assert (= (g4 (g2 7)) 294))
(assert (= (g4 (f3 (- 8))) 133))
(assert (= (f4 (f3 2)) 11))
(assert (= (g4 (g3 2)) 112))
(assert (= (f4 (f4 (- 2))) (- 16)))
(assert (= (g4 (g4 (- 2))) 294))
(check-sat)
