(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 6 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 6 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 (- 5))) (- 8)))
(assert (= (f1 (g1 7)) (- 23)))
(assert (= (f1 (f2 6)) (- 14)))
(assert (= (f1 (g2 (- 5))) (- 56)))
(assert (= (f1 (f3 (- 2))) (- 8)))
(assert (= (f1 (g3 6)) (- 56)))
(assert (= (g1 (f3 7)) (- 35)))
(assert (= (f1 (g4 (- 2))) (- 23)))
(assert (= (g1 (f4 (- 5))) (- 35)))
(assert (= (f2 (f1 6)) (- 14)))
(assert (= (f2 (g1 (- 5))) (- 20)))
(assert (= (f2 (f2 (- 2))) (- 14)))
(assert (= (f2 (g2 6)) 78))
(assert (= (g2 (f2 7)) 156))
(assert (= (f2 (g3 (- 2))) (- 20)))
(assert (= (g2 (f3 (- 5))) 108))
(assert (= (g2 (f4 6)) 156))
(assert (= (f2 (f4 7)) 20))
(assert (= (g2 (g4 7)) 1176))
(assert (= (f3 (f1 (- 2))) (- 8)))
(assert (= (f3 (g1 6)) (- 23)))
(assert (= (g3 (f1 7)) (- 77)))
(assert (= (f3 (g2 (- 2))) (- 23)))
(assert (= (g3 (f2 (- 5))) (- 95)))
(assert (= (g3 (f3 6)) (- 95)))
(assert (= (f3 (f3 7)) 16))
(assert (= (g3 (g3 7)) 567))
(assert (= (g3 (f4 (- 2))) (- 77)))
(assert (= (f3 (f4 (- 5))) 16))
(assert (= (g3 (g4 (- 5))) 567))
(assert (= (f4 (g1 (- 2))) (- 12)))
(assert (= (g4 (f1 (- 5))) 84))
(assert (= (g4 (f2 6)) 168))
(assert (= (f4 (f2 7)) 20))
(assert (= (g4 (g2 7)) 1176))
(assert (= (g4 (f3 (- 2))) 84))
(assert (= (f4 (f3 (- 5))) 16))
(assert (= (g4 (g3 (- 5))) 567))
(assert (= (f4 (f4 6)) 20))
(assert (= (g4 (g4 6)) 1176))
(check-sat)
