(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 7 x))
(define-fun f3 ((x Int)) Int (nua (- 5) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 7 x))
(define-fun g3 ((x Int)) Int (num (- 5) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 5))) (- 8)))
(assert (= (f1 (g1 (- 6))) 18))
(assert (= (f1 (f2 7)) (- 16)))
(assert (= (f1 (g2 (- 5))) (- 65)))
(assert (= (f1 (f3 (- 2))) (- 8)))
(assert (= (f1 (g3 7)) (- 65)))
(assert (= (g1 (f3 (- 6))) 30))
(assert (= (f1 (g4 (- 2))) 18))
(assert (= (g1 (f4 (- 5))) 30))
(assert (= (f2 (f1 7)) (- 16)))
(assert (= (f2 (g1 (- 5))) (- 21)))
(assert (= (f2 (f2 (- 2))) (- 16)))
(assert (= (f2 (g2 7)) 105))
(assert (= (g2 (f2 (- 6))) 175))
(assert (= (f2 (g3 (- 2))) (- 21)))
(assert (= (g2 (f3 (- 5))) 126))
(assert (= (g2 (f4 7)) 175))
(assert (= (f2 (f4 (- 6))) 18))
(assert (= (g2 (g4 (- 6))) 847))
(assert (= (f3 (f1 (- 2))) (- 8)))
(assert (= (f3 (g1 7)) (- 26)))
(assert (= (g3 (f1 (- 6))) 63))
(assert (= (f3 (g2 (- 2))) (- 26)))
(assert (= (g3 (f2 (- 5))) (- 104)))
(assert (= (g3 (f3 7)) (- 104)))
(assert (= (f3 (f3 (- 6))) (- 15)))
(assert (= (g3 (g3 (- 6))) (- 446)))
(assert (= (g3 (f4 (- 2))) 63))
(assert (= (f3 (f4 (- 5))) (- 15)))
(assert (= (g3 (g4 (- 5))) (- 446)))
(assert (= (f4 (g1 (- 2))) 10))
(assert (= (g4 (f1 (- 5))) 66))
(assert (= (g4 (f2 7)) 154))
(assert (= (f4 (f2 (- 6))) 18))
(assert (= (g4 (g2 (- 6))) 847))
(assert (= (g4 (f3 (- 2))) 66))
(assert (= (f4 (f3 (- 5))) (- 15)))
(assert (= (g4 (g3 (- 5))) (- 446)))
(assert (= (f4 (f4 7)) 18))
(assert (= (g4 (g4 7)) 847))
(check-sat)
