(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 2) x))
(define-fun f2 ((x Int)) Int (nua 9 x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 2) x))
(define-fun g2 ((x Int)) Int (num 9 x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 9)))
(assert (= (f1 (g1 (- 7))) 21))
(assert (= (f1 (f2 9)) (- 20)))
(assert (= (f1 (g2 (- 6))) (- 101)))
(assert (= (f1 (f3 (- 2))) (- 9)))
(assert (= (f1 (g3 9)) (- 101)))
(assert (= (g1 (f3 (- 7))) 36))
(assert (= (f1 (g4 (- 2))) 21))
(assert (= (g1 (f4 (- 6))) 36))
(assert (= (f2 (f1 9)) (- 20)))
(assert (= (f2 (g1 (- 6))) (- 26)))
(assert (= (f2 (f2 (- 2))) (- 20)))
(assert (= (f2 (g2 9)) 171))
(assert (= (g2 (f2 (- 7))) 279))
(assert (= (f2 (g3 (- 2))) (- 26)))
(assert (= (g2 (f3 (- 6))) 198))
(assert (= (g2 (f4 9)) 279))
(assert (= (f2 (f4 (- 7))) 22))
(assert (= (g2 (g4 (- 7))) 1521))
(assert (= (f3 (f1 (- 2))) (- 9)))
(assert (= (f3 (g1 9)) (- 33)))
(assert (= (g3 (f1 (- 7))) 88))
(assert (= (f3 (g2 (- 2))) (- 33)))
(assert (= (g3 (f2 (- 6))) (- 160)))
(assert (= (g3 (f3 9)) (- 160)))
(assert (= (f3 (f3 (- 7))) (- 18)))
(assert (= (g3 (g3 (- 7))) (- 787)))
(assert (= (g3 (f4 (- 2))) 88))
(assert (= (f3 (f4 (- 6))) (- 18)))
(assert (= (g3 (g4 (- 6))) (- 787)))
(assert (= (f4 (g1 (- 2))) 11))
(assert (= (g4 (f1 (- 6))) 91))
(assert (= (g4 (f2 9)) 234))
(assert (= (f4 (f2 (- 7))) 22))
(assert (= (g4 (g2 (- 7))) 1521))
(assert (= (g4 (f3 (- 2))) 91))
(assert (= (f4 (f3 (- 6))) (- 18)))
(assert (= (g4 (g3 (- 6))) (- 787)))
(assert (= (f4 (f4 9)) 22))
(assert (= (g4 (g4 9)) 1521))
(check-sat)
