(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua 2 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num 2 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 2)) 3))
(assert (= (f1 (g1 7)) (- 8)))
(assert (= (f1 (f2 (- 9))) (- 18)))
(assert (= (f1 (g2 2)) (- 35)))
(assert (= (f1 (f3 (- 1))) 3))
(assert (= (f1 (g3 (- 9))) (- 35)))
(assert (= (g1 (f3 7)) 9))
(assert (= (f1 (g4 (- 1))) (- 8)))
(assert (= (g1 (f4 2)) 9))
(assert (= (f2 (f1 (- 9))) (- 18)))
(assert (= (f2 (g1 2)) (- 11)))
(assert (= (f2 (f2 (- 1))) (- 18)))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 7)) (- 264)))
(assert (= (f2 (g3 (- 1))) (- 11)))
(assert (= (g2 (f3 2)) 68))
(assert (= (g2 (f4 (- 9))) (- 264)))
(assert (= (f2 (f4 7)) (- 23)))
(assert (= (g2 (g4 7)) 1666))
(assert (= (f3 (f1 (- 1))) 3))
(assert (= (f3 (g1 (- 9))) (- 11)))
(assert (= (g3 (f1 7)) 30))
(assert (= (f3 (g2 (- 1))) (- 11)))
(assert (= (g3 (f2 2)) 42))
(assert (= (g3 (f3 (- 9))) 42))
(assert (= (f3 (f3 7)) 11))
(assert (= (g3 (g3 7)) 112))
(assert (= (g3 (f4 (- 1))) 30))
(assert (= (f3 (f4 2)) 11))
(assert (= (g3 (g4 2)) 112))
(assert (= (f4 (g1 (- 1))) (- 8)))
(assert (= (g4 (f1 2)) 35))
(assert (= (g4 (f2 (- 9))) 238))
(assert (= (f4 (f2 7)) (- 23)))
(assert (= (g4 (g2 7)) 1666))
(assert (= (g4 (f3 (- 1))) 35))
(assert (= (f4 (f3 2)) 11))
(assert (= (g4 (g3 2)) 112))
(assert (= (f4 (f4 (- 9))) (- 23)))
(assert (= (g4 (g4 (- 9))) 1666))
(check-sat)
