(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua (- 8) x))
(define-fun f3 ((x Int)) Int (nua 1 x))
(define-fun f4 ((x Int)) Int (nua 7 x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num (- 8) x))
(define-fun g3 ((x Int)) Int (num 1 x))
(define-fun g4 ((x Int)) Int (num 7 x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 1)) 2))
(assert (= (f1 (g1 7)) (- 8)))
(assert (= (f1 (f2 (- 8))) (- 16)))
(assert (= (f1 (g2 1)) (- 16)))
(assert (= (f1 (f3 (- 1))) 2))
(assert (= (f1 (g3 (- 8))) (- 16)))
(assert (= (g1 (f3 7)) 8))
(assert (= (f1 (g4 (- 1))) (- 8)))
(assert (= (g1 (f4 1)) 8))
(assert (= (f2 (f1 (- 8))) (- 16)))
(assert (= (f2 (g1 1)) (- 9)))
(assert (= (f2 (f2 (- 1))) (- 16)))
(assert (= (f2 (g2 (- 8))) 120))
(assert (= (g2 (f2 7)) (- 218)))
(assert (= (f2 (g3 (- 1))) (- 9)))
(assert (= (g2 (f3 1)) 30))
(assert (= (g2 (f4 (- 8))) (- 218)))
(assert (= (f2 (f4 7)) (- 22)))
(assert (= (g2 (g4 7)) 1470))
(assert (= (f3 (f1 (- 1))) 2))
(assert (= (f3 (g1 (- 8))) (- 9)))
(assert (= (g3 (f1 7)) 15))
(assert (= (f3 (g2 (- 1))) (- 9)))
(assert (= (g3 (f2 1)) 17))
(assert (= (g3 (f3 (- 8))) 17))
(assert (= (f3 (f3 7)) 9))
(assert (= (g3 (g3 7)) 28))
(assert (= (g3 (f4 (- 1))) 15))
(assert (= (f3 (f4 1)) 9))
(assert (= (g3 (g4 1)) 28))
(assert (= (f4 (g1 (- 1))) (- 8)))
(assert (= (g4 (f1 1)) 21))
(assert (= (g4 (f2 (- 8))) 210))
(assert (= (f4 (f2 7)) (- 22)))
(assert (= (g4 (g2 7)) 1470))
(assert (= (g4 (f3 (- 1))) 21))
(assert (= (f4 (f3 1)) 9))
(assert (= (g4 (g3 1)) 28))
(assert (= (f4 (f4 (- 8))) (- 22)))
(assert (= (g4 (g4 (- 8))) 1470))
(check-sat)
