(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 1) x))
(define-fun f2 ((x Int)) Int (nua 5 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua 9 x))
(define-fun g1 ((x Int)) Int (num (- 1) x))
(define-fun g2 ((x Int)) Int (num 5 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num 9 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 3)) 4))
(assert (= (f1 (g1 9)) (- 10)))
(assert (= (f1 (f2 5)) (- 11)))
(assert (= (f1 (g2 3)) (- 31)))
(assert (= (f1 (f3 (- 1))) 4))
(assert (= (f1 (g3 5)) (- 31)))
(assert (= (g1 (f3 9)) 12))
(assert (= (f1 (g4 (- 1))) (- 10)))
(assert (= (g1 (f4 3)) 12))
(assert (= (f2 (f1 5)) (- 11)))
(assert (= (f2 (g1 3)) 8))
(assert (= (f2 (f2 (- 1))) (- 11)))
(assert (= (f2 (g2 5)) 55))
(assert (= (g2 (f2 9)) 140))
(assert (= (f2 (g3 (- 1))) 8))
(assert (= (g2 (f3 3)) 60))
(assert (= (g2 (f4 5)) 140))
(assert (= (f2 (f4 9)) 23))
(assert (= (g2 (g4 9)) 1620))
(assert (= (f3 (f1 (- 1))) 4))
(assert (= (f3 (g1 5)) 8))
(assert (= (g3 (f1 9)) 57))
(assert (= (f3 (g2 (- 1))) 8))
(assert (= (g3 (f2 3)) 48))
(assert (= (g3 (f3 5)) 48))
(assert (= (f3 (f3 9)) 15))
(assert (= (g3 (g3 9)) 324))
(assert (= (g3 (f4 (- 1))) 57))
(assert (= (f3 (f4 3)) 15))
(assert (= (g3 (g4 3)) 324))
(assert (= (f4 (g1 (- 1))) (- 10)))
(assert (= (g4 (f1 3)) 63))
(assert (= (g4 (f2 5)) 180))
(assert (= (f4 (f2 9)) 23))
(assert (= (g4 (g2 9)) 1620))
(assert (= (g4 (f3 (- 1))) 63))
(assert (= (f4 (f3 3)) 15))
(assert (= (g4 (g3 3)) 324))
(assert (= (f4 (f4 5)) 23))
(assert (= (g4 (g4 5)) 1620))
(check-sat)
