(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 0 x))
(define-fun f2 ((x Int)) Int (nua (- 9) x))
(define-fun f3 ((x Int)) Int (nua (- 3) x))
(define-fun f4 ((x Int)) Int (nua (- 6) x))
(define-fun g1 ((x Int)) Int (num 0 x))
(define-fun g2 ((x Int)) Int (num (- 9) x))
(define-fun g3 ((x Int)) Int (num (- 3) x))
(define-fun g4 ((x Int)) Int (num (- 6) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 3))) (- 3)))
(assert (= (f1 (g1 (- 6))) 0))
(assert (= (f1 (f2 (- 9))) 17))
(assert (= (f1 (g2 (- 3))) (- 43)))
(assert (= (f1 (f3 0)) (- 3)))
(assert (= (f1 (g3 (- 9))) (- 43)))
(assert (= (g1 (f3 (- 6))) 0))
(assert (= (f1 (g4 0)) 0))
(assert (= (g1 (f4 (- 3))) 0))
(assert (= (f2 (f1 (- 9))) 17))
(assert (= (f2 (g1 (- 3))) (- 9)))
(assert (= (f2 (f2 0)) 17))
(assert (= (f2 (g2 (- 9))) 153))
(assert (= (g2 (f2 (- 6))) 238))
(assert (= (f2 (g3 0)) (- 9)))
(assert (= (g2 (f3 (- 3))) 85))
(assert (= (g2 (f4 (- 9))) 238))
(assert (= (f2 (f4 (- 6))) (- 20)))
(assert (= (g2 (g4 (- 6))) (- 1029)))
(assert (= (f3 (f1 0)) (- 3)))
(assert (= (f3 (g1 (- 9))) (- 3)))
(assert (= (g3 (f1 (- 6))) (- 28)))
(assert (= (f3 (g2 0)) (- 3)))
(assert (= (g3 (f2 (- 3))) 55))
(assert (= (g3 (f3 (- 9))) 55))
(assert (= (f3 (f3 (- 6))) (- 11)))
(assert (= (g3 (g3 (- 6))) (- 138)))
(assert (= (g3 (f4 0)) (- 28)))
(assert (= (f3 (f4 (- 3))) (- 11)))
(assert (= (g3 (g4 (- 3))) (- 138)))
(assert (= (f4 (g1 0)) (- 6)))
(assert (= (g4 (f1 (- 3))) (- 28)))
(assert (= (g4 (f2 (- 9))) 187))
(assert (= (f4 (f2 (- 6))) (- 20)))
(assert (= (g4 (g2 (- 6))) (- 1029)))
(assert (= (g4 (f3 0)) (- 28)))
(assert (= (f4 (f3 (- 3))) (- 11)))
(assert (= (g4 (g3 (- 3))) (- 138)))
(assert (= (f4 (f4 (- 9))) (- 20)))
(assert (= (g4 (g4 (- 9))) (- 1029)))
(check-sat)
