(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 3 x))
(define-fun f4 ((x Int)) Int (nua (- 7) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 3 x))
(define-fun g4 ((x Int)) Int (num (- 7) x))
(assert (forall ((x Int)) (= (f1 (f2 (f2 x))) (f3 (f4 x)))))
(assert (= (f1 (f1 3)) 18))
(assert (= (f1 (g1 (- 7))) 105))
(assert (= (f1 (f2 1)) (- 10)))
(assert (= (f1 (g2 3)) (- 14)))
(assert (= (f1 (f3 (- 8))) 18))
(assert (= (f1 (g3 1)) (- 14)))
(assert (= (g1 (f3 (- 7))) (- 143)))
(assert (= (f1 (g4 (- 8))) 105))
(assert (= (g1 (f4 3)) (- 143)))
(assert (= (f2 (f1 1)) (- 10)))
(assert (= (f2 (g1 3)) 46))
(assert (= (f2 (f2 (- 8))) (- 10)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 (- 7))) 15))
(assert (= (f2 (g3 (- 8))) 46))
(assert (= (g2 (f3 3)) 12))
(assert (= (g2 (f4 1)) 15))
(assert (= (f2 (f4 (- 7))) 14))
(assert (= (g2 (g4 (- 7))) 169))
(assert (= (f3 (f1 (- 8))) 18))
(assert (= (f3 (g1 1)) 18))
(assert (= (g3 (f1 (- 7))) 84))
(assert (= (f3 (g2 (- 8))) 18))
(assert (= (g3 (f2 3)) 24))
(assert (= (g3 (f3 1)) 24))
(assert (= (f3 (f3 (- 7))) (- 13)))
(assert (= (g3 (g3 (- 7))) 234))
(assert (= (g3 (f4 (- 8))) 84))
(assert (= (f3 (f4 3)) (- 13)))
(assert (= (g3 (g4 3)) 234))
(assert (= (f4 (g1 (- 8))) 119))
(assert (= (g4 (f1 3)) (- 137)))
(assert (= (g4 (f2 1)) 26))
(assert (= (f4 (f2 (- 7))) 14))
(assert (= (g4 (g2 (- 7))) 169))
(assert (= (g4 (f3 (- 8))) (- 137)))
(assert (= (f4 (f3 3)) (- 13)))
(assert (= (g4 (g3 3)) 234))
(assert (= (f4 (f4 1)) 14))
(assert (= (g4 (g4 1)) 169))
(check-sat)
