(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 1 x))
(define-fun f3 ((x Int)) Int (nua 8 x))
(define-fun f4 ((x Int)) Int (nua 6 x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 1 x))
(define-fun g3 ((x Int)) Int (num 8 x))
(define-fun g4 ((x Int)) Int (num 6 x))
(assert (forall ((x Int)) (= (f1 (f1 (f2 x))) (f3 (f3 x)))))
(assert (= (f1 (f1 8)) 23))
(assert (= (f1 (g1 6)) (- 98)))
(assert (= (f1 (f2 1)) (- 10)))
(assert (= (f1 (g2 8)) (- 24)))
(assert (= (f1 (f3 (- 8))) 23))
(assert (= (f1 (g3 1)) (- 24)))
(assert (= (g1 (f3 6)) 210))
(assert (= (f1 (g4 (- 8))) (- 98)))
(assert (= (g1 (f4 8)) 210))
(assert (= (f2 (f1 1)) (- 10)))
(assert (= (f2 (g1 8)) 121))
(assert (= (f2 (f2 (- 8))) (- 10)))
(assert (= (f2 (g2 1)) 3))
(assert (= (g2 (f2 6)) 14))
(assert (= (f2 (g3 (- 8))) 121))
(assert (= (g2 (f3 8)) 32))
(assert (= (g2 (f4 1)) 14))
(assert (= (f2 (f4 6)) 13))
(assert (= (g2 (g4 6)) 144))
(assert (= (f3 (f1 (- 8))) 23))
(assert (= (f3 (g1 1)) 23))
(assert (= (g3 (f1 6)) 216))
(assert (= (f3 (g2 (- 8))) 23))
(assert (= (g3 (f2 8)) 144))
(assert (= (g3 (f3 1)) 144))
(assert (= (f3 (f3 6)) 22))
(assert (= (g3 (g3 6)) 1536))
(assert (= (g3 (f4 (- 8))) 216))
(assert (= (f3 (f4 8)) 22))
(assert (= (g3 (g4 8)) 1536))
(assert (= (f4 (g1 (- 8))) (- 119)))
(assert (= (g4 (f1 8)) 186))
(assert (= (g4 (f2 1)) 24))
(assert (= (f4 (f2 6)) 13))
(assert (= (g4 (g2 6)) 144))
(assert (= (g4 (f3 (- 8))) 186))
(assert (= (f4 (f3 8)) 22))
(assert (= (g4 (g3 8)) 1536))
(assert (= (f4 (f4 1)) 13))
(assert (= (g4 (g4 1)) 144))
(check-sat)
