(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua (- 8) x))
(define-fun f2 ((x Int)) Int (nua 2 x))
(define-fun f3 ((x Int)) Int (nua 6 x))
(define-fun f4 ((x Int)) Int (nua (- 4) x))
(define-fun g1 ((x Int)) Int (num (- 8) x))
(define-fun g2 ((x Int)) Int (num 2 x))
(define-fun g3 ((x Int)) Int (num 6 x))
(define-fun g4 ((x Int)) Int (num (- 4) x))
(assert (forall ((x Int)) (= (f1 (f2 x)) (f3 (f4 x)))))
(assert (= (f1 (f1 6)) 21))
(assert (= (f1 (g1 (- 4))) 60))
(assert (= (f1 (f2 2)) (- 12)))
(assert (= (f1 (g2 6)) (- 32)))
(assert (= (f1 (f3 (- 8))) 21))
(assert (= (f1 (g3 2)) (- 32)))
(assert (= (g1 (f3 (- 4))) (- 143)))
(assert (= (f1 (g4 (- 8))) 60))
(assert (= (g1 (f4 6)) (- 143)))
(assert (= (f2 (f1 2)) (- 12)))
(assert (= (f2 (g1 6)) 92))
(assert (= (f2 (f2 (- 8))) (- 12)))
(assert (= (f2 (g2 2)) 10))
(assert (= (g2 (f2 (- 4))) 22))
(assert (= (f2 (g3 (- 8))) 92))
(assert (= (g2 (f3 6)) 48))
(assert (= (g2 (f4 2)) 22))
(assert (= (f2 (f4 (- 4))) 9))
(assert (= (g2 (g4 (- 4))) 98))
(assert (= (f3 (f1 (- 8))) 21))
(assert (= (f3 (g1 2)) 36))
(assert (= (g3 (f1 (- 4))) 132))
(assert (= (f3 (g2 (- 8))) 36))
(assert (= (g3 (f2 6)) 96))
(assert (= (g3 (f3 2)) 96))
(assert (= (f3 (f3 (- 4))) (- 16)))
(assert (= (g3 (g3 (- 4))) 504))
(assert (= (g3 (f4 (- 8))) 132))
(assert (= (f3 (f4 6)) (- 16)))
(assert (= (g3 (g4 6)) 504))
(assert (= (f4 (g1 (- 8))) 116))
(assert (= (g4 (f1 6)) (- 95)))
(assert (= (g4 (f2 2)) 28))
(assert (= (f4 (f2 (- 4))) 9))
(assert (= (g4 (g2 (- 4))) 98))
(assert (= (g4 (f3 (- 8))) (- 95)))
(assert (= (f4 (f3 6)) (- 16)))
(assert (= (g4 (g3 6)) 504))
(assert (= (f4 (f4 2)) 9))
(assert (= (g4 (g4 2)) 98))
(check-sat)
