(set-logic UFLIA)

(define-fun nu ((x Int)) Int (ite (>= x 0) (* 2 x) (- (+ (* 2 x) 1))))
(define-fun nuinv ((x Int)) Int (ite (exists ((N Int)) (= (* 2 N) x)) (div x 2) (- (div (+ x 1) 2))))
(define-fun nua ((x Int) (y Int)) Int (nuinv (+ (nu x) (nu y))))
(define-fun num ((x Int) (y Int)) Int (nuinv (* (nu x) (nu y))))
(define-fun f1 ((x Int)) Int (nua 1 x))
(define-fun f2 ((x Int)) Int (nua (- 3) x))
(define-fun f3 ((x Int)) Int (nua (- 6) x))
(define-fun f4 ((x Int)) Int (nua (- 5) x))
(define-fun g1 ((x Int)) Int (num 1 x))
(define-fun g2 ((x Int)) Int (num (- 3) x))
(define-fun g3 ((x Int)) Int (num (- 6) x))
(define-fun g4 ((x Int)) Int (num (- 5) x))
(assert (forall ((x Int)) (= (f1 (f2 (f3 x))) (f4 (f4 x)))))
(assert (= (f1 (f1 (- 6))) (- 8)))
(assert (= (f1 (g1 (- 5))) 10))
(assert (= (f1 (f2 (- 3))) 6))
(assert (= (f1 (g2 (- 6))) (- 29)))
(assert (= (f1 (f3 1)) (- 8)))
(assert (= (f1 (g3 (- 3))) (- 29)))
(assert (= (g1 (f3 (- 5))) 20))
(assert (= (f1 (g4 1)) 10))
(assert (= (g1 (f4 (- 6))) 20))
(assert (= (f2 (f1 (- 3))) 6))
(assert (= (f2 (g1 (- 6))) (- 14)))
(assert (= (f2 (f2 1)) 6))
(assert (= (f2 (g2 (- 3))) 15))
(assert (= (g2 (f2 (- 5))) 35))
(assert (= (f2 (g3 1)) (- 14)))
(assert (= (g2 (f3 (- 6))) 55))
(assert (= (g2 (f4 (- 3))) 35))
(assert (= (f2 (f4 (- 5))) (- 12)))
(assert (= (g2 (g4 (- 5))) (- 203)))
(assert (= (f3 (f1 1)) (- 8)))
(assert (= (f3 (g1 (- 3))) (- 11)))
(assert (= (g3 (f1 (- 5))) (- 61)))
(assert (= (f3 (g2 1)) (- 11)))
(assert (= (g3 (f2 (- 6))) 88))
(assert (= (g3 (f3 (- 3))) 88))
(assert (= (f3 (f3 (- 5))) (- 16)))
(assert (= (g3 (g3 (- 5))) (- 545)))
(assert (= (g3 (f4 1)) (- 61)))
(assert (= (f3 (f4 (- 6))) (- 16)))
(assert (= (g3 (g4 (- 6))) (- 545)))
(assert (= (f4 (g1 1)) (- 7)))
(assert (= (g4 (f1 (- 6))) (- 59)))
(assert (= (g4 (f2 (- 3))) 45))
(assert (= (f4 (f2 (- 5))) (- 12)))
(assert (= (g4 (g2 (- 5))) (- 203)))
(assert (= (g4 (f3 1)) (- 59)))
(assert (= (f4 (f3 (- 6))) (- 16)))
(assert (= (g4 (g3 (- 6))) (- 545)))
(assert (= (f4 (f4 (- 3))) (- 12)))
(assert (= (g4 (g4 (- 3))) (- 203)))
(check-sat)
